/*
 * bcloader.c - 
 */

/*
 * $Id: bcloader.c,v 1.6 2014/10/28 02:22:55 komiya Exp $
 *
 * -------- BYTE CODE LOADER --------
 * 
 * File Name : bcloader.c
 * 
 * first version: M.Yamamoto  1990.3 second version: M.Yamamoto 1990.10
 * 
 */

static char *RCSid="$Id: bcloader.c,v 1.6 2014/10/28 02:22:55 komiya Exp $";

#include "scheme.h"

#ifdef THINK_C
#include <string.h>
#else
#include <strings.h>
#endif


#define DEFINE 0
#define MACRO 1

#define BCEVAL_END  0
#define EXEC_PROGRAM    1
#define EXEC_PROGRAM2   2

/* constant table address for compiled function */
unsigned *const_vec;

int constsize;

bc_eval(lamcons)             /* By A243 Nov, 1992 */
int lamcons;
{
    SOBJ            arginfo;
    int firstsym;
    SOBJ            closure;

    if (GETtag(bcraw.obj) != LTAG_CONS) {
        /* for debug */
        print_con("Not cons object exist in byte code file.\n");
        return (BCEVAL_END);
    }
    bcraw2.obj = CDRobj(bcraw.obj);

    if (CARobj(bcraw.obj) == definesym.obj)
        firstsym = DEFINE;
    else if (CARobj(bcraw.obj) == macrosym.obj)
        firstsym = MACRO;
    else if (CARobj(bcraw.obj) == l_t_e_sym.obj) {
    bcbody.obj = CARobj(CDRobj(CARobj(CDRobj(bcraw.obj))));
        /* bcraw2.obj = bctran(trans_arginfo(3), DEFINE, LTAG_NIL, lamcons); */
        bcraw2.obj = bctran(trans_arginfo(4), DEFINE, LTAG_NIL, lamcons);
        bcraw.obj = LTAG_NIL;                      /* By A243 Nov, 1992 */
        return(EXEC_PROGRAM2);
#ifdef PVM3
    } else if (CARobj(bcraw.obj) == pvm_l_t_e_sym.obj) {       /* By A243 */
        bcbody.obj = CARobj(CDRobj(CARobj(CDRobj(bcraw.obj))));
        bcraw2.obj = bctran(trans_arginfo(4), DEFINE, LTAG_NIL, lamcons);
/*        bcraw.obj = CARobj(bcraw.obj); */
	bcraw.obj = LTAG_NIL;
        set_reg(bcraw2.obj);  
        return(BCEVAL_END);
#endif
    } else {
        bcraw2.obj = bcraw.obj;
        bcraw.obj = LTAG_NIL;
        return(EXEC_PROGRAM);
    }

    bcraw.obj = CDRobj(bcraw.obj);
    if (GETtag(bcraw2.obj) != LTAG_CONS) {
        bokkan("A list in byte code file is too short.\n");
    }
    bcraw2.obj = CDRobj(bcraw2.obj);
    if (GETtag(CARobj(bcraw.obj)) != LTAG_ORDINARY) {
        if (GETtag(CARobj(bcraw.obj)) != LTAG_SPECIAL) {
            bokkan("2nd object of a list in byte code file must be ordinary-symbol.\n");
        } else {
            if (system_function_loading_flag != ON) {
                /* T.Komiya */
                print_con("Warning: ");
                printobj_con(CARobj(bcraw.obj), PRINT, 5);
                print_con(" is being redefined.\n");
            /*  bokkan("2nd object of a list in byte code file must be ordinary-symbol.\n"); */
            }
        }
    }
    if (GETtag(bcraw2.obj) != LTAG_CONS) {
        bokkan("A list in byte code file is too short.\n");
    }
    if (CDRobj(bcraw2.obj) != LTAG_NIL) {
        bokkan("A list in byte code file is too long.\n");
    }
    if (GETtag(CARobj(bcraw2.obj)) != LTAG_CONS) {
        set_sval(CARobj(bcraw.obj), CARobj(bcraw2.obj));
        return (BCEVAL_END);
    } else if (CARobj(CARobj(bcraw2.obj)) == quotesym.obj) {
        set_sval(CARobj(bcraw.obj), CARobj(CDRobj(CARobj(bcraw2.obj))));
        return (BCEVAL_END);
    } else if (CARobj(CARobj(bcraw2.obj)) == c_f_sym.obj) {
        arginfo.obj = CARobj(CDRobj(CDRobj(CARobj(bcraw2.obj))));
        bcbody.obj = CARobj(CDRobj(CARobj(CDRobj(CDRobj(CDRobj(CARobj(bcraw2.obj)))))));
        /* bcbody is global variable for GC */
        /* bcbody is used in 'bctran' */

        closure.obj = bctran(trans_arginfo(fix_to_int(arginfo.obj)),
            firstsym,
            sym_name(CARobj(bcraw.obj)),
            lamcons);  /* By A243 Nov, 1992 */
        set_sval(CARobj(bcraw.obj), closure.obj);
        set_reg(CARobj(bcraw.obj)); /* T.Komiya */
        return(BCEVAL_END);
    } else if (CARobj(CARobj(bcraw2.obj)) == l_t_e_sym.obj) {
    bcbody.obj = CARobj(CDRobj(CARobj(CDRobj(CARobj(bcraw2.obj)))));
     /* bcraw2.obj = bctran(trans_arginfo(3), DEFINE, LTAG_NIL, lamcons); */
        bcraw2.obj = bctran(trans_arginfo(4), DEFINE, LTAG_NIL,
            lamcons);     /* By A243 Nov, 1992 */
        bcraw.obj = CARobj(bcraw.obj);
        return(EXEC_PROGRAM2);
#ifdef PVM3
    } else if (CARobj(CARobj(bcraw2.obj)) == pvm_l_t_e_sym.obj) { /* By A243 */
    bcbody.obj = CARobj(CDRobj(CARobj(CDRobj(CARobj(bcraw2.obj)))));
        bcraw2.obj = bctran(trans_arginfo(4), DEFINE, LTAG_NIL,
            lamcons);     
/*        bcraw.obj = CARobj(bcraw.obj); */
        bcraw.obj = LTAG_NIL;
        set_reg(bcraw2.obj);   
        return(BCEVAL_END);
#endif
    } else {
        bcraw2.obj = CARobj(bcraw2.obj);
        bcraw.obj = CARobj(bcraw.obj);
        return(EXEC_PROGRAM);
    }
}

int var_xreturn;
int var_lreturn;
int var_xcall;
int lc;
int xfunsn;

int xreturn();
int lreturn();
int xcall();

bctran(arginfo, firstsym, symname, lamcons)      /* By A243 Nov, 1992 */
int arginfo, firstsym, symname, lamcons;
{
    void p2bctran(unsigned *);
    void cleargv();
    unsigned *code_body;

    unsigned *memget();
    int objtemp;

    ENTITYP my_obj;   /* By A243 Nov, 1992 */

    hash_bit_mask = BCHASH_B_M;
    tempp.obj = LTAG_NIL;
    cdrbody.obj = bcbody.obj;
    if ((lamcons != LTAG_NIL) && (GETtag(lamcons) == LTAG_CONS)) {
        s_push(lamcons);
    } else                               /* By A243 Nov, 1992 */
        s_push(LTAG_NIL);

    s_push(symname);

    p1bctran();     /* pass 1 */

    symname = s_pop();
    acode.obj = LTAG_NIL;
    if (firstsym == DEFINE) {
        bcfhead.obj = mk_bcc(LTAG_BCLOSURE, LTAG_NIL, symname, s_pop(),
            LTAG_NIL, LTAG_NIL, arginfo, 1);  /* By A243 Nov, 1992 */
    } else {
        bcfhead.obj = mk_bcc(LTAG_MBCLOSURE, LTAG_NIL, symname, s_pop(),
            LTAG_NIL, LTAG_NIL, arginfo, 1);  /* By A243 Nov, 1992 */
    }

    code_body = memget(lc * 4);
    *code_body = LTAG_BLOCK2 | ((lc - 1) * 4);
    if (var_xcall == 1)
        *(code_body + --lc) = (unsigned) xcall;
    if (var_lreturn == 1)
        *(code_body + --lc) = (unsigned) lreturn;
    if (var_xreturn == 1)
        *(code_body + --lc) = (unsigned) xreturn;
    bcf.obj = SSERDDA(code_body) | LTAG_STRING;

    s_push(SSERDDA(code_body) | LTAG_STRING);
    objtemp = mkconst();
    ((BCCLOS * ) ADDRESS(bcfhead.obj))->const_vec.obj = objtemp;
    code_body = (unsigned *) ADDRESS(s_pop());
    p2bctran(code_body + 1);/* pass 2 */
    ((BCCLOS * ) ADDRESS(bcfhead.obj))->body.obj = bcf.obj;

    cleargv();
    return (bcfhead.obj);
}


trans_arginfo(arginfo)
int arginfo;
{
    if (0x1 & arginfo)
        return (((arginfo >> 1) & 0x7ffffffc) | 0x00000003);
    else
        return (arginfo);
}


void cleargv()
{
    int i;

    /* clear global variable for GC */

    for (i = 0; i < bchashsize; ++i)
        *(bchash + i) = LTAG_NIL;
    hash_bit_mask = DEFAULT_HASH_B_M;
    tempp.obj = LTAG_NIL;
    cdrbody.obj = LTAG_NIL;
    acode.obj = LTAG_NIL;
    bcf.obj = LTAG_NIL;
    bcconst.obj = LTAG_NIL;
    xfunconst.obj = LTAG_NIL;
}


p1bctran()
{
    void set_bcconst(int);
    void p1_label(int);
    void set_xfuns(int);
    SOBJ            obj;
    unsigned *infp;

    unsigned *get_bcspec();

    lc = 1;
    var_xreturn = var_lreturn = var_xcall = xfunsn = 0;

    while (GETtag(cdrbody.obj) == LTAG_CONS) {
        acode.obj = CARobj(cdrbody.obj);
        if (GETtag(acode.obj) == LTAG_ORDINARY)
            p1_label(lc);
        else if (GETtag(acode.obj) == LTAG_CONS) {
            if (CARobj(acode.obj) == local_fun_sym.obj) { /* T.Komiya */
                s_push(cdrbody.obj);
                cdrbody.obj = CDRobj(acode.obj);
                while (GETtag(cdrbody.obj) == LTAG_CONS) {
                    acode.obj = CARobj(cdrbody.obj);
                    if (GETtag(acode.obj) == LTAG_ORDINARY)
                        p1_label(lc);
                    else if (GETtag(acode.obj) == LTAG_CONS) {
                        infp = get_bcspec(sym_name(CARobj(acode.obj)));
                        if ((unsigned) infp == unbound_obj.obj) {
                            print_con("Undefined byte code instruction : ");
                            printobj_con(CARobj(acode.obj), PRINT, 3);
                            print_con("\n");
                            return ((int)NULL);
                        }
                        lc += *(infp + 1);
                        if (*(infp + 2) != NON) {
                            obj.obj = nth(acode.obj, *(infp + 2));
                            if (obj.obj == xreturnsym.obj)
                                var_xreturn = 1;
                            else if (obj.obj == lreturnsym.obj)
                                var_lreturn = 1;
                            else if (obj.obj == xcallsym.obj)
                                var_xcall = 1;
                        }
                        if (*(infp + 3) != NON)
                            set_bcconst(nth(acode.obj, *(infp + 3)));
                        if (CARobj(acode.obj) == mkncsym.obj) {
                            set_xfuns(CARobj(CDRobj(CDRobj(CDRobj(acode.obj)))));
                            ++xfunsn;
                        }
                    } else {
                        if (debug1)
                            print_con("not byte code form\n");
                        return ((int)NULL);
                    }
                    cdrbody.obj = CDRobj(cdrbody.obj);
                }
                cdrbody.obj = CDRobj(s_pop());
                continue;
            } else if ((unsigned)(infp=get_bcspec(sym_name(CARobj(acode.obj))))
                       == unbound_obj.obj) {
                print_con("Undefined byte code instruction : ");
                printobj_con(CARobj(acode.obj), PRINT, 3);
                print_con("\n");
                return ((int)NULL);
            } 
            lc += *(infp + 1);
            if (*(infp + 2) != NON) {
                obj.obj = nth(acode.obj, *(infp + 2));
                if (obj.obj == xreturnsym.obj)
                    var_xreturn = 1;
                else if (obj.obj == lreturnsym.obj)
                    var_lreturn = 1;
                else if (obj.obj == xcallsym.obj)
                    var_xcall = 1;
            }
            if (*(infp + 3) != NON)
                set_bcconst(nth(acode.obj, *(infp + 3)));
            if (CARobj(acode.obj) == mkncsym.obj) {
                set_xfuns(CARobj(CDRobj(CDRobj(CDRobj(acode.obj)))));
                ++xfunsn;
            }
        } else {
            if (debug1)
                print_con("not byte code form\n");
            return ((int)NULL);
        }
        cdrbody.obj = CDRobj(cdrbody.obj);
    }

    if (var_xreturn == 1) {
        acode.obj = xreturnsym.obj;
        p1_label(lc++);
    }
    if (var_lreturn == 1) {
        acode.obj = lreturnsym.obj;
        p1_label(lc++);
    }
    if (var_xcall == 1) {
        acode.obj = xcallsym.obj;
        p1_label(lc++);
    }
}


void set_xfuns(src)
int src;
{
    SOBJ            obj;

    obj.obj = mk_bcc(LTAG_BCLOSURE, CARobj(CDRobj(CDRobj(acode.obj))),
        LTAG_NIL, src, LTAG_NIL, LTAG_NIL,
        trans_arginfo(fix_to_int(CARobj(CDRobj(acode.obj)))),
        (int)NULL);
    xfunconst.obj = mk_cons(obj.obj, xfunconst.obj);
}


int 
mkconst()
{
    int xfun, label, hashobj, constn, i, flag;

    constn = listlen(bcconst.obj);
    constsize = constn + xfunsn;
    if (constsize == 0)
        return (LTAG_NIL);
    const_vec = (unsigned *) mk_evecp(constsize);

    for (i = 1; i <= constn; i++) {
        *(const_vec + i) = CARobj(bcconst.obj);
        bcconst.obj = CDRobj(bcconst.obj);
    }
    for (; i <= constsize; ++i) {
        *(const_vec + i) = CARobj(xfunconst.obj);
        xfunconst.obj = CDRobj(xfunconst.obj);
    }
    for (i = constn + 1; i <= constsize; ++i) {
        xfun = *(const_vec + i);
        label = *(((int *) ADDRESS(xfun)) + 1);
        hashobj = *(bchash + hash(sym_name(label)));
        flag = 0;
        while (GETtag(hashobj) == LTAG_CONS) {
            if (label == CARobj(hashobj)) {
                *(((int *)ADDRESS(xfun)) + 8)
                    = fix_to_int(CARobj(CDRobj(hashobj)));
                flag = 1;
                break;
            }
            hashobj = CDRobj(hashobj);
        }
        if (flag == 0) {
            print_con("error : refer to the undefined label.\n");
            return ((int)NULL);
        }
        *(((int *) ADDRESS(xfun)) + 1) = SSERDDA(const_vec) | LTAG_VECTOR;
        *(((int *) ADDRESS(xfun)) + 5) = bcf.obj;
    }
    return (SSERDDA(const_vec) | LTAG_VECTOR);
}


int get_const();

void p2bctran(bcfp)
unsigned *bcfp;
{
    void codetran(int, int *, int *);
    unsigned *infp;
    int lfl; /* local function location */
    unsigned *get_bcspec();

    lfl = constsize;
    cdrbody.obj = bcbody.obj;
    while (GETtag(cdrbody.obj) == LTAG_CONS) {
        acode.obj = CARobj(cdrbody.obj);
        if (GETtag(acode.obj) == LTAG_CONS)
            if (CARobj(acode.obj) == mkncsym.obj) {
                *(bcfp++) = (unsigned) get_const;
                *(bcfp++) = lfl--;
            } else if (CARobj(acode.obj) == local_fun_sym.obj) { /* T.Komiya */
                s_push(cdrbody.obj);
                cdrbody.obj = CDRobj(acode.obj);
                while (GETtag(cdrbody.obj) == LTAG_CONS) {
                    acode.obj = CARobj(cdrbody.obj);
                    if (GETtag(acode.obj) == LTAG_CONS)
                        if (CARobj(acode.obj) == mkncsym.obj) {
                            *(bcfp++) = (unsigned) get_const;
                            *(bcfp++) = lfl--;
                        } else {
                            infp = get_bcspec(sym_name(CARobj(acode.obj)));
                            codetran(CDRobj(acode.obj), bcfp, infp);
                            bcfp += *(infp + 1);
                        }
                    cdrbody.obj = CDRobj(cdrbody.obj);
                }
                cdrbody.obj = CDRobj(s_pop());
                continue;
            } else {
                infp = get_bcspec(sym_name(CARobj(acode.obj)));
                codetran(CDRobj(acode.obj), bcfp, infp);
                bcfp += *(infp + 1);
            }
        cdrbody.obj = CDRobj(cdrbody.obj);
    }
}


void p1_label(lc)
int lc;
{
    unsigned *hashp;

    /* this function use 'acode' global variable */
    /* acode value must be symbol.               */
    /* tempp  : tempolary scheme object pointer  */
    /* this pointer is active pointer for GC */

    hashp = bchash + hash(sym_name(acode.obj));
    tempp.obj = *hashp;

    while (GETtag(tempp.obj) == LTAG_CONS) {
        if (CARobj(tempp.obj) == acode.obj) {
            print_con("Double definition of same byte code label\n");
            return;
        }
        if (CDRobj(tempp.obj) == LTAG_NIL)
            break;
        else
            tempp.obj = CDRobj(tempp.obj);
    }

    if (tempp.obj == LTAG_NIL) {
        tempp.obj = mk_cons(mk_fix(lc), LTAG_NIL);
        *hashp = mk_cons(acode.obj, tempp.obj);
    } else {
        unsigned tmp1, tmp2;

        tmp1 = mk_cons(mk_fix(lc), LTAG_NIL);
        s_push(tmp1);
        tmp1 = s_pop();
        tmp2 = mk_cons(acode.obj, tmp1);
        s_push(tmp2);
        set_cdr(tempp.obj, s_pop());
    }
    tempp.obj = LTAG_NIL;
}


void set_bcconst(obj)
int obj;
{
    if (bcconst.obj == LTAG_NIL) {
        bcconst.obj = mk_cons(obj, LTAG_NIL);
        return;
    }
    tempp.obj = bcconst.obj;
    while (GETtag(tempp.obj) == LTAG_CONS) {
        if (CARobj(tempp.obj) == obj)
            return;
        else if (CDRobj(tempp.obj) == LTAG_NIL) {
            unsigned tmp;

            tmp = mk_cons(obj, LTAG_NIL);
            s_push(tmp);
            set_cdr(tempp.obj, s_pop());
            return;
        }
        tempp.obj = CDRobj(tempp.obj);
    }
}


void codetran(operands, bcfp, infp)
int operands, *bcfp, *infp;
{
    void debugprint(char *, int);
    SOBJ            oper;
    int hashobj, i, j, flag;

    *bcfp++ = *(infp + 4);
    for (i = 5; i <= 8; ++i) {
        switch (*(infp + i)) {
        case NON:
            if (operands != LTAG_NIL) {
                if (debug1)
                    debugprint("Byte code operand is too long : ",
                        operands);
            }
            return;
        case OBJECT:
            oper.obj = CARobj(operands);
            for (j = 1; j <= constsize; ++j) {
                if (*(const_vec + j) == oper.obj) {
                    *(bcfp++) = j;
                    break;
                }
            }
            break;
        case NUMBER:
            *(bcfp++) = fix_to_int(CARobj(operands));
            break;
        case LABEL:
            oper.obj = CARobj(operands);
            hashobj = *(bchash + hash(sym_name(oper.obj)));
/* DEBUG *//*
            print_con("OPER : ");
            printobj_con(oper.obj, PRINT, 3);
            print_con("    HASHOBJ : ");
            printobj_con(hashobj, PRINT, 3);
            printf("%x\n", hashobj);
            *//* DEBUG END */
            flag = 0;
            while (GETtag(hashobj) == LTAG_CONS) {
                if (oper.obj == CARobj(hashobj)) {
                    *(bcfp++) = fix_to_int(CARobj(CDRobj(hashobj)));
                    flag = 1;
                    break;
                }
                hashobj = CDRobj(hashobj);
            }
            if (flag == 0) {
                print_con("error : label ga nai\n");
                /* DEBUG */
                printf("%x\n", oper.obj);
            }
            /* DEBUG END */
            break;
        case REST :
            return;
        default:
            print_con("error : at codetran ???\n");
        }
        operands = CDRobj(operands);
    }
}


void debugprint(mess, obj)
char    *mess;
int obj;
{
    print_con("(debug)");
    print_con(mess);
    printobj_con(obj, PRINT, 3);
    print_con("\n");
}


/*
 *    for Sbctran_exec_form()
 */

void bcloader2_a_exp()
{
    SOBJ            obj, sym;
    int retval;

    obj.obj = s_pop();  /* dummy for GC */
    obj.obj = s_pop();  /* redundancy */
    sym.obj = s_pop();
    if (sym.obj != LTAG_NIL) {
        set_sval(sym.obj, reg_reg);
        set_reg(sym.obj);       /* T.Komiya */
    }
    bcraw.obj = LTAG_NIL;
    bcraw2.obj = LTAG_NIL;
    bcbody.obj = LTAG_NIL;
    bcfhead.obj = LTAG_NIL;
    xreturn();
}

void bcloader2_a_exp_check()
{
    SOBJ            obj, sym;
    int retval;

    obj.obj = s_pop();  /* dummy for GC */
    obj.obj = s_pop();  /* redundancy */
    sym.obj = s_pop();
    if (sym.obj != LTAG_NIL) {
        if (GETtag(reg_reg) != LTAG_MBCLOSURE) {
            err_illegal_argument("2nd argument must be a macro-function.");
            return;
        }
        set_sval(sym.obj, reg_reg);
        set_reg(sym.obj);       /* T.Komiya */
    }
    bcraw.obj = LTAG_NIL;
    bcraw2.obj = LTAG_NIL;
    bcbody.obj = LTAG_NIL;
    bcfhead.obj = LTAG_NIL;
    xreturn();
}

#ifdef CALLIOC

void bcloader2_a_exp_ep()
{
    SOBJ            obj, sym;
    int retval;

    ((unsigned *)stack_bottom)[5]--;
    obj.obj = s_pop();  /* dummy for GC */
    obj.obj = s_pop();  /* redundancy */
    sym.obj = s_pop();
    if (sym.obj != LTAG_NIL) {
        set_sval(sym.obj, reg_reg);
        set_reg(sym.obj);       /* T.Komiya */
    }
    bcraw.obj = LTAG_NIL;
    bcraw2.obj = LTAG_NIL;
    bcbody.obj = LTAG_NIL;
    bcfhead.obj = LTAG_NIL;
    xreturn();
}

#endif

int 
prep_quasieval_a_exp(object, kind, check_macfun)
int object;
int kind;
int check_macfun;
{
    SOBJ            obj;
    int a2;

    if (kind == EXEC_PROGRAM) {
        if (GETsym_tag(object) == LTAG_SYMBOL) {
            obj.obj = get_sval(object);
            if (obj.obj == unbound_obj.obj) {
                print_con("error in bcloader: unbound symbol '");
                printobj_con(object, PRINT, 10);
                print_con("'\n");
#if defined(__CYGWIN32__) || defined(linux)
                siglongjmp(toplevel, 1);
#else
                longjmp(toplevel, 1);
#endif
            }
            return (obj.obj);
        } else if (GETtag(object) == LTAG_CONS) {
            if (CARobj(object) == quotesym.obj)
                return (CARobj(CDRobj(object)));
            else {
                s_push(bcraw.obj);
                open_frame2(bcloader2_a_exp, LTAG_NIL, 0);
                while (object != LTAG_NIL) {
                    if (GETsym_tag(CARobj(object)) == LTAG_SYMBOL) {
                        obj.obj = get_sval(CARobj(object));
                        if (obj.obj == unbound_obj.obj) {
                            print_con("error: unbound symbol '");
                            printobj_con(CARobj(object), PRINT, 10);
                            print_con("'\n");
#if defined(__CYGWIN32__) || defined(linux)
                            siglongjmp(toplevel, 1);
#else
                            longjmp(toplevel, 1);
#endif
                        }
                        s_push(obj.obj);
                    } else if (GETtag(CARobj(object)) == LTAG_CONS) {
                        if (CARobj(CARobj(object)) == quotesym.obj)
                            s_push(CARobj(CDRobj(CARobj(object))));
                        else
                            s_push(CARobj(object));
                    } else
                        s_push(CARobj(object));
                    object = CDRobj(object);
                }
                return ((int)NULL);
            }
        } else
            return (object);
    } else {
        s_push(bcraw.obj);
        if (check_macfun)
            open_frame2(bcloader2_a_exp_check, LTAG_NIL, 0);
        else
            open_frame2(bcloader2_a_exp, LTAG_NIL, 0);
        s_push(object);
        return((int)NULL);
    }
}


void bcload_with_cip_epilogue()               /* T.Komiya */
{
    s_pop();
    s_pop();
    xreturn();
}

#ifdef CALLIOC

void bcload_with_cip_epilogue_ep()               /* T.Komiya */
{
    ((unsigned *)stack_bottom)[5]--;
    s_pop();
    s_pop();
    xreturn();
}

#endif

void bcloader2()                     /* T.Komiya */
{
    SOBJ            obj, sym;
    int retval;

    obj.obj = s_pop();  /* dummy for GC */
    obj.obj = s_pop();  /* redundancy */
    sym.obj = s_pop();
    if (sym.obj != LTAG_NIL) {
        set_sval(sym.obj, reg_reg);
        set_reg(sym.obj);
    }
    if ((bcraw.obj = readexp()) != eof_obj.obj) {
        if (system_function_loading_flag == ON
            && fas_lib_loading_mess_flag == ON) {
            print_con("*");
            fflush(stdout);
        }
        open_frame2(bcload_with_cip_epilogue, LTAG_NIL, 0);
        s_push(get_sval(bcload_with_cip_sym.obj));
        s_push(bcraw.obj);
        xcall();
    } else {
        bcraw.obj = LTAG_NIL;
        bcraw2.obj = LTAG_NIL;
        bcbody.obj = LTAG_NIL;
        bcfhead.obj = LTAG_NIL;
        xreturn();
    }
}

#ifdef CALLIOC

void bcloader2_ep()                     /* T.Komiya */
{
    SOBJ            obj, sym;
    int retval;

    ((unsigned *)stack_bottom)[5]--;
    obj.obj = s_pop();  /* dummy for GC */
    obj.obj = s_pop();  /* redundancy */
    sym.obj = s_pop();
    if (sym.obj != LTAG_NIL) {
        set_sval(sym.obj, reg_reg);
        set_reg(sym.obj);
    }
    if ((bcraw.obj = readexp()) != eof_obj.obj) {
        if (system_function_loading_flag == ON
            && fas_lib_loading_mess_flag == ON) {
            print_con("*");
            fflush(stdout);
        }
        open_frame2(bcload_with_cip_epilogue, LTAG_NIL, 0);
        s_push(get_sval(bcload_with_cip_sym.obj));
        s_push(bcraw.obj);
        xcall();
    } else {
        bcraw.obj = LTAG_NIL;
        bcraw2.obj = LTAG_NIL;
        bcbody.obj = LTAG_NIL;
        bcfhead.obj = LTAG_NIL;
        xreturn();
    }
}

#endif

int 
prep_quasieval(object, kind)    /* T.Komiya */
int object;
int kind;
{
    SOBJ            obj;
    int a2;

    if (kind == EXEC_PROGRAM) {
        print_con("prep_quasieval error.\n");
#if defined(__CYGWIN32__) || defined(linux)
        siglongjmp(toplevel, 1);
#else
        longjmp(toplevel, 1);
#endif
    } else {
        s_push(bcraw.obj);
        open_frame2(bcloader2, LTAG_NIL, 0);
        s_push(object);
        return((int)NULL);
    }
}


void bcload_epilogue()               /* T.Komiya */
{
    s_pop();
    s_pop();
    closeport(c_in_port.obj);
    c_in_port.obj = s_pop();
    set_reg(LTAG_T);
    xreturn();
}

#ifdef CALLIOC

void bcload_epilogue_ep()               /* T.Komiya */
{
    ((unsigned *)stack_bottom)[5]--;
    s_pop();
    s_pop();
    closeport(c_in_port.obj);
    c_in_port.obj = s_pop();
    set_reg(LTAG_T);
    xreturn();
}

#endif

void bcload_with_cip()              /* T.Komiya */
{
    SOBJ obj;

    s_pop();
    s_pop();
    bcraw.obj = s_pop();

    if (GETtag(bcraw.obj) == LTAG_CONS
         && CARobj(bcraw.obj) == beginsym.obj) {
        obj.obj = CDRobj(bcraw.obj);
        if (obj.obj == LTAG_NIL) {
            if ((bcraw.obj = readexp()) == eof_obj.obj)
                xreturn();
            else {
                if (system_function_loading_flag == ON
                    && fas_lib_loading_mess_flag == ON) {
                    print_con("*");
                    fflush(stdout);
                }
                open_frame2(bcload_with_cip_epilogue, LTAG_NIL, 0);
                s_push(getarg(0));
                s_push(bcraw.obj);
                xcall();
            }
            return;
        } else {
            unsigned tmp;

            tmp = mk_cons(beginsym.obj, CDRobj(obj.obj));
            s_push(tmp);
        }
        open_frame2(bcload_with_cip, LTAG_NIL, 0);
        s_push(getarg(0));
        s_push(CARobj(obj.obj));
        xcall();
    } else {
        print_con("bcload_with_cip error.\n");
        bcraw.obj = LTAG_NIL;
        xreturn();
    }
}

#ifdef CALLIOC

void bcload_with_cip_ep()              /* T.Komiya */
{
    SOBJ obj;

    ((unsigned *)stack_bottom)[5]--;
    s_pop();
    s_pop();
    bcraw.obj = s_pop();

    if (GETtag(bcraw.obj) == LTAG_CONS
         && CARobj(bcraw.obj) == beginsym.obj) {
        obj.obj = CDRobj(bcraw.obj);
        if (obj.obj == LTAG_NIL) {
            if ((bcraw.obj = readexp()) == eof_obj.obj)
                xreturn();
            else {
                if (system_function_loading_flag == ON
                    && fas_lib_loading_mess_flag == ON) {
                    print_con("*");
                    fflush(stdout);
                }
                open_frame2(bcload_with_cip_epilogue, LTAG_NIL, 0);
                s_push(getarg(0));
                s_push(bcraw.obj);
                xcall();
            }
            return;
        } else {
            unsigned tmp;

            tmp = mk_cons(beginsym.obj, CDRobj(obj.obj));
            s_push(tmp);
        }
        open_frame2(bcload_with_cip, LTAG_NIL, 0);
        s_push(getarg(0));
        s_push(CARobj(obj.obj));
        xcall();
    } else {
        print_con("bcload_with_cip error.\n");
        bcraw.obj = LTAG_NIL;
        xreturn();
    }
}

#endif

void bctran_exec_form()
{
    SOBJ obj;

    s_pop();
    s_pop();
    bcraw.obj = s_pop();
    if (GETtag(bcraw.obj) == LTAG_CONS
         && CARobj(bcraw.obj) == beginsym.obj) { /* T.Komiya */
        obj.obj = CDRobj(bcraw.obj);
        if (obj.obj == LTAG_NIL) {
            bcraw.obj = LTAG_NIL;
            xreturn();
            return;
        } else {
            unsigned tmp;

            tmp = mk_cons(beginsym.obj, CDRobj(obj.obj));
            s_push(tmp);
        }
        open_frame2(bctran_exec_form, LTAG_NIL, 0);
        s_push(getarg(0));
        s_push(CARobj(obj.obj));
        s_push(getarg(2));
        xcall();
    } else {
        print_con("bcloader error.\n");
        bcraw.obj = LTAG_NIL;
        xreturn();
    }
}

#ifdef CALLIOC

void bctran_exec_form_ep()
{
    SOBJ obj;

    ((unsigned *)stack_bottom)[5]--;
    s_pop();
    s_pop();
    bcraw.obj = s_pop();
    if (GETtag(bcraw.obj) == LTAG_CONS
         && CARobj(bcraw.obj) == beginsym.obj) { /* T.Komiya */
        obj.obj = CDRobj(bcraw.obj);
        if (obj.obj == LTAG_NIL) {
            bcraw.obj = LTAG_NIL;
            xreturn();
            return;
        } else {
            unsigned tmp;

            tmp = mk_cons(beginsym.obj, CDRobj(obj.obj));
            s_push(tmp);
        }
        open_frame2(bctran_exec_form, LTAG_NIL, 0);
        s_push(getarg(0));
        s_push(CARobj(obj.obj));
        s_push(getarg(2));
        xcall();
    } else {
        print_con("bcloader error.\n");
        bcraw.obj = LTAG_NIL;
        xreturn();
    }
}

#endif

/*
 * system function concerning to byte-code-loader
 * 
 */

void Sbctran()
{
    bcbody.obj = getarg(2);
    if (getarg(3) == LTAG_NIL)
        set_reg(bctran(trans_arginfo(fix_to_int(getarg(1))), DEFINE,
            LTAG_NIL, LTAG_NIL));   /* By A243 Nov, 1992 */
    else
        set_reg(bctran(trans_arginfo(fix_to_int(getarg(1))), MACRO,
            LTAG_NIL, LTAG_NIL));   /* By A243 Nov, 1992 */
    bcbody.obj = LTAG_NIL;
}


void Sbcload_with_cip()              /* T.Komiya */
{
    SOBJ obj;
    int retval;

    if ((bcraw.obj = getarg(1)) == LTAG_NIL) {
        if ((bcraw.obj = readexp()) == eof_obj.obj) {
            set_reg(LTAG_T);
            return;
        }
        if (system_function_loading_flag == ON
            && fas_lib_loading_mess_flag == ON) {
            print_con("*");
            fflush(stdout);
        }
    }
    if (GETtag(bcraw.obj) == LTAG_CONS
         && CARobj(bcraw.obj) == beginsym.obj) {
        obj.obj = CDRobj(bcraw.obj);
        if (obj.obj == LTAG_NIL) {
            bcraw.obj = LTAG_NIL;
            set_reg(LTAG_NIL);
            return;
        } else {
            unsigned tmp;

            tmp = mk_cons(beginsym.obj, CDRobj(obj.obj));
            s_push(tmp);
        }
        open_frame2(bcload_with_cip, LTAG_NIL, 0);
        s_push(getarg(0));
        s_push(CARobj(obj.obj));
        set_up_stack();
    } else {
        retval = bc_eval(LTAG_NIL);
        if (retval == EXEC_PROGRAM || retval == EXEC_PROGRAM2)
            if (obj.obj = prep_quasieval(bcraw2.obj, retval))
                set_sval(bcraw.obj, obj.obj);
            else {
                set_up_stack();
                return;
            }
        if ((bcraw.obj = readexp()) == eof_obj.obj) {
            bcraw.obj = LTAG_NIL;
            bcraw2.obj = LTAG_NIL;
            bcbody.obj = LTAG_NIL;
            bcfhead.obj = LTAG_NIL;
        } else {
            if (system_function_loading_flag == ON
                && fas_lib_loading_mess_flag == ON) {
                print_con("*");
                fflush(stdout);
            }
            open_frame2(bcload_with_cip_epilogue, LTAG_NIL, 0);
            s_push(getarg(0));
            s_push(bcraw.obj);
            set_up_stack();
        }
    }
}


void Sbcload()                       /* T.Komiya */
{
    SOBJ            strobj, port;

    strobj.obj = getarg(1);
    if (GETstr_tag(strobj.obj) != LTAG_STRING) {
        err_illegal_argument_type(strobj.obj, "string");
        return;
    }
    s_push(c_in_port.obj);
    if ((port.obj = mkport(strobj.obj, INPUT)) == (int)NULL)
//        return (int)NULL;
        return ;
    c_in_port.obj = port.obj;

    open_frame2(bcload_epilogue, LTAG_NIL, 0);
    s_push(get_sval(bcload_with_cip_sym.obj));
    s_push(LTAG_NIL);
    set_up_stack();
}


void Sbctran_bcbody()
{
    bcbody.obj = getarg(4);
    if (getarg(1) == definesym.obj)
        set_reg(bctran(trans_arginfo(fix_to_int(getarg(3))), DEFINE,
            getarg(2), LTAG_NIL));   /* By A243 Nov, 1992 */
    else
        set_reg(bctran(trans_arginfo(fix_to_int(getarg(3))), MACRO,
            getarg(2), LTAG_NIL));   /* By A243 Nov, 1992 */
    bcbody.obj = LTAG_NIL;
}


void Sbctran_define_form()
{
    bcraw.obj = getarg(1);
    bc_eval(LTAG_NIL);      /* By A243 Nov, 1992 */
    bcraw.obj = LTAG_NIL;
    bcraw2.obj = LTAG_NIL;
    bcbody.obj = LTAG_NIL;
    bcfhead.obj = LTAG_NIL;
    set_reg(LTAG_T);
}


void Sbctran_exec_form()
{
    SOBJ obj, getobj;         /* By A243 Nov, 1992 */
    int retval;

    bcraw.obj = getarg(1);
    getobj.obj = getarg(2);       /* By A243 Nov, 1992 */
    if (GETtag(bcraw.obj) == LTAG_CONS
         && CARobj(bcraw.obj) == beginsym.obj) { /* T.Komiya */
        obj.obj = CDRobj(bcraw.obj);
        if (obj.obj == LTAG_NIL) {
            bcraw.obj = LTAG_NIL;
            set_reg(LTAG_NIL);
            return;
        } else {
            unsigned tmp;

            tmp = mk_cons(beginsym.obj, CDRobj(obj.obj));
            s_push(tmp);
        }
        open_frame2(bctran_exec_form, LTAG_NIL, 0);
        s_push(getarg(0));
        s_push(CARobj(obj.obj));
        s_push(getarg(2));
        set_up_stack();
    } else {
        int check_macfun;

        check_macfun = (GETtag(bcraw.obj) == LTAG_CONS
                        && CARobj(bcraw.obj) == macrosym.obj);
        retval = bc_eval(getobj.obj);         /* By A243 Nov, 1992 */
        if (retval == EXEC_PROGRAM || retval == EXEC_PROGRAM2)
            if (obj.obj = prep_quasieval_a_exp(bcraw2.obj,retval,check_macfun))
                set_sval(bcraw.obj, obj.obj);
            else {
                set_up_stack();
                return;
            }
        bcraw.obj = LTAG_NIL;
        bcraw2.obj = LTAG_NIL;
        bcbody.obj = LTAG_NIL;
        bcfhead.obj = LTAG_NIL;
    }
}


