/*
 * char.c - 
 */

/*
 * $Id: char.c,v 1.3 2014/10/28 02:22:55 komiya Exp $
 */
/************************************/
/*                                  */
/*  File Name : char.c              */
/*  Update    : Yass.  Jul. 25 '90  */
/*              Yass.  Jul. 18 '90  */
/*              Myama. ?            */
/*                                  */
/*    Character operations          */
/*                                  */
/************************************/

static char *RCSid="$Id: char.c,v 1.3 2014/10/28 02:22:55 komiya Exp $";

#include "scheme.h"


/********************************/
/*                              */
/*  Internal useful procedures  */
/*                              */
/********************************/

/*  Wriiten by Myama. ?  */
mkchar(ch, tag)
int ch;
int tag;
{
    if (tag == LTAG_ACHAR) {
        ch = ch << 16;
        return ( (ch & 0x00ff0000) | tag ); 
    } else {
        ch = ch << 2;
        return( (ch & 0x0003fffc) | tag ); 
    }
}


#define  KANJI_UPPER_MASK  0x00ff

/*  Written by Yass. Jul. 18 '90  */
unsigned short  obj_to_short(obj)
int obj;
{ 
    SOBJ char_obj;

    char_obj.obj = obj;
    switch (GETtag(char_obj.obj)) { 
    case LTAG_ACHAR :
        return((unsigned short)CH(char_obj.ch) & KANJI_UPPER_MASK);
    case LTAG_KCHAR :
        return((unsigned short)KCH(char_obj.kch));
    default :
        err_illegal_argument_type(char_obj.obj, "character");
	return 0;               /* never reach here */
	    /*  By N.Watanabe Nov. 04, 1992  */
        break;
    }
}


/*  Written by Yass. Jul. 18 '90  */
unsigned short  obj_to_short_ci(obj)
int obj;
{ 
    SOBJ char_obj;
    char    ch;

    char_obj.obj = obj;
    switch (GETtag(char_obj.obj)) { 
    case LTAG_ACHAR :
        ch = (char)CH(char_obj.ch);
        if ('A' <= ch && ch <= 'Z')
            ch += ('a' - 'A');
        return((unsigned short)ch & KANJI_UPPER_MASK);
    case LTAG_KCHAR :
        return((unsigned short)KCH(char_obj.kch));
    default :
        err_illegal_argument_type(char_obj.obj, "character");
	return 0;               /* never reach here */
	    /*  By N.Watanabe Nov. 04, 1992  */
        break;
    }
}


/***********************************/
/*                                 */
/*  Essential standard procedures  */
/*                                 */
/***********************************/

/*  Written by Yass. Jul. 18 '90  */
void Scharp()
{
#ifdef TOUCH_ARG
    if (GETchar_tag(touch_obj(getarg(1))) == LTAG_CHAR)
#else
    if (GETchar_tag(getarg(1)) == LTAG_CHAR)
#endif
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


/*  Written by Yass. Jul. 18 '90  */
void Schareq()
{ 
    SOBJ obj1, obj2;

#ifdef TOUCH_ARG
    obj1.obj = touch_obj(getarg(1));
    obj2.obj = touch_obj(getarg(2));
#else
    obj1.obj = getarg(1);
    obj2.obj = getarg(2);
#endif
    if (GETchar_tag(obj1.obj) != LTAG_CHAR ){
        err_illegal_argument_type(obj1.obj, "character");
	return ;
	    /*  By N.Watanabe  Nov. 04, 1992  */
    }
    if (GETchar_tag(obj2.obj) != LTAG_CHAR){
        err_illegal_argument_type(obj2.obj, "character");
	return ;
	    /*  By N.Watanabe  Nov. 04, 1992  */
    }
    if (obj_to_short(obj1.obj) == obj_to_short(obj2.obj))
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


/*  Written by Yass. Jul. 18 '90  */
void Scharlt()
{ 
    SOBJ obj1, obj2;

#ifdef TOUCH_ARG
    obj1.obj = touch_obj(getarg(1));
    obj2.obj = touch_obj(getarg(2));
#else
    obj1.obj = getarg(1);
    obj2.obj = getarg(2);
#endif
    if (GETchar_tag(obj1.obj) != LTAG_CHAR){
        err_illegal_argument_type(obj1.obj, "character");
	return ;
	    /*  By N.Watanabe  Nov. 04, 1992  */
    }
    if (GETchar_tag(obj2.obj) != LTAG_CHAR){
        err_illegal_argument_type(obj2.obj, "character");
	return ;
	    /*  By N.Watanabe  Nov. 04, 1992  */
    }
    if (obj_to_short(obj1.obj) < obj_to_short(obj2.obj))
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


/*  Written by Yass. Jul. 18 '90  */
void Schargt()
{ 
    SOBJ obj1, obj2;

#ifdef TOUCH_ARG
    obj1.obj = touch_obj(getarg(1));
    obj2.obj = touch_obj(getarg(2));
#else
    obj1.obj = getarg(1);
    obj2.obj = getarg(2);
#endif
    if (GETchar_tag(obj1.obj) != LTAG_CHAR){
        err_illegal_argument_type(obj1.obj, "character");
	return ;
	    /*  By N.Watanabe  Nov. 04, 1992  */
    }
    if (GETchar_tag(obj2.obj) != LTAG_CHAR){
        err_illegal_argument_type(obj2.obj, "character");
	return ;
	    /*  By N.Watanabe  Nov. 04, 1992  */
    }
    if (obj_to_short(obj1.obj) > obj_to_short(obj2.obj))
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


/*  Written by Yass. Jul. 18 '90  */
void Scharlte()
{ 
    SOBJ obj1, obj2;

#ifdef TOUCH_ARG
    obj1.obj = touch_obj(getarg(1));
    obj2.obj = touch_obj(getarg(2));
#else
    obj1.obj = getarg(1);
    obj2.obj = getarg(2);
#endif
    if (GETchar_tag(obj1.obj) != LTAG_CHAR){
        err_illegal_argument_type(obj1.obj, "character");
	return ;
	    /*  By N.Watanabe  Nov. 04, 1992  */
    }
    if (GETchar_tag(obj2.obj) != LTAG_CHAR){
        err_illegal_argument_type(obj2.obj, "character");
	return ;
	    /*  By N.Watanabe  Nov. 04, 1992  */
    }
    if (obj_to_short(obj1.obj) <= obj_to_short(obj2.obj))
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


/*  Written by Yass. Jul. 18 '90  */
void Schargte()
{ 
    SOBJ obj1, obj2;

#ifdef TOUCH_ARG
    obj1.obj = touch_obj(getarg(1));
    obj2.obj = touch_obj(getarg(2));
#else
    obj1.obj = getarg(1);
    obj2.obj = getarg(2);
#endif
    if (GETchar_tag(obj1.obj) != LTAG_CHAR){
        err_illegal_argument_type(obj1.obj, "character");
	return ;
	    /*  By N.Watanabe  Nov. 04, 1992  */
    }
    if (GETchar_tag(obj2.obj) != LTAG_CHAR){
        err_illegal_argument_type(obj2.obj, "character");
	return ;
	    /*  By N.Watanabe  Nov. 04, 1992  */
    }
    if (obj_to_short(obj1.obj) >= obj_to_short(obj2.obj))
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


/*  Written by Yass. Jul. 18 '90  */
void Schar_cieq()
{ 
    SOBJ obj1, obj2;

#ifdef TOUCH_ARG
    obj1.obj = touch_obj(getarg(1));
    obj2.obj = touch_obj(getarg(2));
#else
    obj1.obj = getarg(1);
    obj2.obj = getarg(2);
#endif
    if (GETchar_tag(obj1.obj) != LTAG_CHAR){
        err_illegal_argument_type(obj1.obj, "character");
	return ;
	    /*  By N.Watanabe  Nov. 04, 1992  */
    }
    if (GETchar_tag(obj2.obj) != LTAG_CHAR){
        err_illegal_argument_type(obj2.obj, "character");
	return ;
	    /*  By N.Watanabe  Nov. 04, 1992  */
    }
    if (obj_to_short_ci(obj1.obj) == obj_to_short_ci(obj2.obj))
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


/*  Written by Yass. Jul. 18 '90  */
void Schar_cilt()
{ 
    SOBJ obj1, obj2;

#ifdef TOUCH_ARG
    obj1.obj = touch_obj(getarg(1));
    obj2.obj = touch_obj(getarg(2));
#else
    obj1.obj = getarg(1);
    obj2.obj = getarg(2);
#endif
    if (GETchar_tag(obj1.obj) != LTAG_CHAR){
        err_illegal_argument_type(obj1.obj, "character");
	return ;
	    /*  By N.Watanabe  Nov. 04, 1992  */
    }
    if (GETchar_tag(obj2.obj) != LTAG_CHAR){
        err_illegal_argument_type(obj2.obj, "character");
	return ;
	    /*  By N.Watanabe  Nov. 04, 1992  */
    }
    if (obj_to_short_ci(obj1.obj) < obj_to_short_ci(obj2.obj))
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


/*  Written by Yass. Jul. 18 '90  */
void Schar_cigt()
{ 
    SOBJ obj1, obj2;

#ifdef TOUCH_ARG
    obj1.obj = touch_obj(getarg(1));
    obj2.obj = touch_obj(getarg(2));
#else
    obj1.obj = getarg(1);
    obj2.obj = getarg(2);
#endif
    if (GETchar_tag(obj1.obj) != LTAG_CHAR){
        err_illegal_argument_type(obj1.obj, "character");
	return ;
	    /*  By N.Watanabe  Nov. 04, 1992  */
    }
    if (GETchar_tag(obj2.obj) != LTAG_CHAR){
        err_illegal_argument_type(obj2.obj, "character");
	return ;
	    /*  By N.Watanabe  Nov. 04, 1992  */
    }
    if (obj_to_short_ci(obj1.obj) > obj_to_short_ci(obj2.obj))
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


/*  Written by Yass. Jul. 18 '90  */
void Schar_cilte()
{ 
    SOBJ obj1, obj2;

#ifdef TOUCH_ARG
    obj1.obj = touch_obj(getarg(1));
    obj2.obj = touch_obj(getarg(2));
#else
    obj1.obj = getarg(1);
    obj2.obj = getarg(2);
#endif
    if (GETchar_tag(obj1.obj) != LTAG_CHAR){
        err_illegal_argument_type(obj1.obj, "character");
	return ;
	    /*  By N.Watanabe  Nov. 04, 1992  */
    }
    if (GETchar_tag(obj2.obj) != LTAG_CHAR){
        err_illegal_argument_type(obj2.obj, "character");
	return ;
	    /*  By N.Watanabe  Nov. 04, 1992  */
    }
    if (obj_to_short_ci(obj1.obj) <= obj_to_short_ci(obj2.obj))
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


/*  Written by Yass. Jul. 18 '90  */
void Schar_cigte()
{ 
    SOBJ obj1, obj2;

#ifdef TOUCH_ARG
    obj1.obj = touch_obj(getarg(1));
    obj2.obj = touch_obj(getarg(2));
#else
    obj1.obj = getarg(1);
    obj2.obj = getarg(2);
#endif
    if (GETchar_tag(obj1.obj) != LTAG_CHAR){
        err_illegal_argument_type(obj1.obj, "character");
	return ;
	    /*  By N.Watanabe  Nov. 04, 1992  */
    }
    if (GETchar_tag(obj2.obj) != LTAG_CHAR){
        err_illegal_argument_type(obj2.obj, "character");
	return ;
	    /*  By N.Watanabe  Nov. 04, 1992  */
    }
    if (obj_to_short_ci(obj1.obj) >= obj_to_short_ci(obj2.obj))
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


/*  Written by Yass. Jul. 18 '90  */
void Schar_alphabetic()
{ 
    SOBJ obj;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    if (GETtag(obj.obj) == LTAG_KCHAR)
        set_reg(LTAG_FALSE);
    else
     { 
        if (GETtag(obj.obj) == LTAG_ACHAR) { 
            if (isalpha((char)(CH(obj.ch))))
                set_reg(LTAG_T);
            else
                set_reg(LTAG_FALSE);
        } 
	else {
	    err_illegal_argument_type(obj.obj, "character");
	    return ;
	        /*  By N.Watanabe  Nov. 04, 1992  */
	}
    }
}


/*  Written by Yass. Jul. 18 '90  */
void Schar_numeric()
{ 
    SOBJ obj;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    if (GETtag(obj.obj) == LTAG_KCHAR)
        set_reg(LTAG_FALSE);
    else
     { 
        if (GETtag(obj.obj) == LTAG_ACHAR) { 
            if (isdigit((char)(CH(obj.ch))))
                set_reg(LTAG_T);
            else
                set_reg(LTAG_FALSE);
        } 
	else {
	    err_illegal_argument_type(obj.obj, "character");
	    return ;
	        /*  By N.Watanabe  Nov. 04, 1992  */
	}
    }
}


/*  Written by Yass. Jul. 18 '90  */
void Schar_whitespace()
{ 
    SOBJ obj;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    if (GETtag(obj.obj) == LTAG_KCHAR)
        set_reg(LTAG_FALSE);
    else
     { 
        if (GETtag(obj.obj) == LTAG_ACHAR) { 
            if (isspace((char)(CH(obj.ch))))
                set_reg(LTAG_T);
            else
                set_reg(LTAG_FALSE);
        } 
	else {
	    err_illegal_argument_type(obj.obj, "character");
	    return ;
	        /*  By N.Watanabe  Nov. 04, 1992  */
	}
    }
}


/*  Written by Yass. Jul. 18 '90  */
void Schar_upper_case()
{ 
    SOBJ obj;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    if (GETtag(obj.obj) == LTAG_KCHAR)
        set_reg(LTAG_FALSE);
    else
     { 
        if (GETtag(obj.obj) == LTAG_ACHAR) { 
            if (isupper((char)(CH(obj.ch))))
                set_reg(LTAG_T);
            else
                set_reg(LTAG_FALSE);
        } 
	else {
	    err_illegal_argument_type(obj.obj, "character");
	    return ;
	        /*  By N.Watanabe  Nov. 04, 1992  */
	}
    }
}


/*  Written by Yass. Jul. 18 '90  */
void Schar_lower_case()
{ 
    SOBJ obj;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    if (GETtag(obj.obj) == LTAG_KCHAR)
        set_reg(LTAG_FALSE);
    else
     { 
        if (GETtag(obj.obj) == LTAG_ACHAR) { 
            if (islower((char)(CH(obj.ch))))
                set_reg(LTAG_T);
            else
                set_reg(LTAG_FALSE);
        } 
	else {
	    err_illegal_argument_type(obj.obj, "character");
	    return ;
	        /*  By N.Watanabe  Nov. 04, 1992  */
	}
    }
}


/*  Written by Yass. Jul. 18 '90  */
void Schar_to_integer()
{ 
    SOBJ obj;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    if (GETchar_tag(obj.obj) == LTAG_CHAR)
        set_reg(mk_fix((int)obj_to_short(obj.obj)));
    else {
	err_illegal_argument_type(obj.obj, "character");
	return ;
	    /*  By N.Watanabe  Nov. 04, 1992  */
    }
}

void Sinteger_to_char()              /* by T.Komiya */
{ 
    SOBJ obj;
    int c;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    if (GETtag(obj.obj) == LTAG_BIGNUM){
        err_illegal_argument("Out of range.");
	return ;
    }
    else if (GETnum_tag(obj.obj) != LTAG_NUMBER1){
	err_illegal_argument_type(obj.obj, "integer");
	return ;
	    /*  By N.Watanabe  Nov. 04, 1992  */
    }
    c = fix_to_int(obj.obj);

#ifdef NIHONGO
    if (c < 0 || c > 65535){
        err_illegal_argument("Out of range.");
	return;
    }
    set_reg(mk_ch((char)(c >> 8), (char)c));
#else
    if (c < 0 || c > 255){
        err_illegal_argument("Out of range.");
	return;
    }
    set_reg(mk_ch('\0', (char)c));
#endif /* NIHONGO */
}

/*  Written by Yass. Jul. 25 '90  */
void Schar_upcase()
{ 
    SOBJ obj;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    if (GETtag(obj.obj) == LTAG_KCHAR)
        set_reg(obj.obj);
    else
     { 
        if (GETtag(obj.obj) == LTAG_ACHAR) { 
            if (islower((char)(CH(obj.ch))))
                set_reg(mk_ch('\0', (char)(((char)(CH(obj.ch))) - ('a'-'A'))));
            else
                set_reg(obj.obj);
        } 
	else {
	    err_illegal_argument_type(obj.obj, "character");
	    return ;
	        /*  By N.Watanabe  Nov. 04, 1992  */
	}
    }
}


/*  Written by Yass. Jul. 25 '90  */
void Schar_downcase()
{ 
    SOBJ obj;

#ifdef TOUCH_ARG
    obj.obj = touch_obj(getarg(1));
#else
    obj.obj = getarg(1);
#endif
    if (GETtag(obj.obj) == LTAG_KCHAR)
        set_reg(obj.obj);
    else
     { 
        if (GETtag(obj.obj) == LTAG_ACHAR) { 
            if (isupper((char)(CH(obj.ch))))
                set_reg(mk_ch('\0', (char)(((char)(CH(obj.ch))) + ('a'-'A'))));
            else
                set_reg(obj.obj);
        } 
	else {
	    err_illegal_argument_type(obj.obj, "character");
	    return ;
	        /*  By N.Watanabe  Nov. 04, 1992  */
	}
    }
}
