/*
 * copygcunit.c - 
 */

/*
 * $Id: copygcunit.c,v 1.3 2014/10/28 02:22:55 komiya Exp $
 *
 *            Copy GC routine body
 *       By T.Komiya & T.Hayasaka (Sep. 2 ,1990)
 *       Original routine was programed by M.Yamamoto
 *
 *    Update  : T.Komiya      ??
 *                        Oct. 26 '90 (wp)
 */

static char *RCSid="$Id: copygcunit.c,v 1.3 2014/10/28 02:22:55 komiya Exp $";

#include "scheme.h"

#define GCBIT(obj)      (0x00000002 & (unsigned)(obj))

unsigned *new_gcpoint;                /* gc pointer (a2) */
unsigned *gcp_ent_add;                /* entity address pointed by gcpoint cell (a0) */

extern unsigned  *new_ent_add;         /* new allocated entity address (a3) */
#ifndef THINK_C
extern int  wp_add_dist();
#endif

void gcunit(gcpoint)
unsigned    *gcpoint;           /* a2 */
{
    void gcunit_p_o();
    /*  static immediate; */
    /*
if((int)gcpoint > 0x95000)printf("%x %x\n", (int)gcpoint, *gcpoint);
*/
    gcp_ent_add = (unsigned *)ADDRESS(*gcpoint);
    new_gcpoint = gcpoint;

    if (0xe0000000 & *gcpoint && !(0x80000000 & *gcpoint)) {
        /*      immediate++; */
        return;                 /* nil, #t, char, lostobj, fixnum, sfloat */
    }
    switch (GETtag(*gcpoint)) {
    case LTAG_CONS :
        gcunit_cons();
        break;
    case LTAG_BLOCK2 :
        /* gcunit_block2() */
/*      gcpoint += (ADDRESS(*gcpoint) >> 2); */
        gcpoint += (IMM(*gcpoint) >> 2);
        new_gcpoint = gcpoint;
        break;
    case LTAG_BLOCK1 :
        break;
        /*
    case LTAG_WEAKPAIR :
        gcunit_weakpair();
        break;
*/
#ifdef CALLIOC
    case LTAG_IOC :
	gcunit_otc();
        break;
#endif
    default :
        gcunit_p_o();
    }
}


gcunit_cons()
{
    /*    
    if (GCBIT(*gcp_ent_add))
        cons_weaklink();
    else
*/

    if (GETtag(*gcp_ent_add) == LTAG_GCFORWARD)
        /* cons_gcforward() */
#ifdef SPECIAL_CONS_TAG
        *new_gcpoint = ADDRESS(*gcp_ent_add);     /* | LTAG_CONS (= 0) */
#else
        *new_gcpoint = LTAG_CONS | SSERDDA(ADDRESS(*gcp_ent_add));
#endif
    else {
        ac_cons++;
        *new_ent_add = *gcp_ent_add;              /* copy to new area (car) */
        *(new_ent_add + 1) = *(gcp_ent_add + 1);  /* copy to new area (cdr) */
        *gcp_ent_add = LTAG_GCFORWARD | SSERDDA(new_ent_add);
#ifdef SPECIAL_CONS_TAG
        *new_gcpoint = (unsigned)new_ent_add;
        /* (| LTAG_CONS (= 0)), update pointer of gcpoint */
#else
        *new_gcpoint = LTAG_CONS | SSERDDA(new_ent_add);
#endif
        new_ent_add += 2;
    }
}

#ifdef CALLIOC

extern unsigned *marked_stack_list;

gcunit_otc()
{
    unsigned *bottom;

    if (GETtag(*gcp_ent_add) == LTAG_GCFORWARD)
        *new_gcpoint = LTAG_IOC | SSERDDA(ADDRESS(*gcp_ent_add));
    else {
        ac_block1++;
        *new_ent_add = *gcp_ent_add;
        *(new_ent_add + 1) = *(gcp_ent_add + 1);
        *(new_ent_add + 2) = *(gcp_ent_add + 2);
        *gcp_ent_add = LTAG_GCFORWARD | SSERDDA(new_ent_add);
        *new_gcpoint = LTAG_IOC | SSERDDA(new_ent_add);
        new_ent_add += 3;
    }
#ifdef SPECIAL_CONS_TAG
    bottom = (unsigned *)fix_to_int(((ENTITYP)ADDRESS(*new_gcpoint))->ioc.bottom.obj);
#else
    bottom = (unsigned *)ADDRESS(fix_to_int(((ENTITYP)ADDRESS(*new_gcpoint))->ioc.bottom.obj));
#endif
    if (!bottom[2] && bottom[5]) {
        bottom[2] = (unsigned)marked_stack_list;
        marked_stack_list = bottom;
    }
}

#endif

void gcunit_p_o()
{
    int    old_obj, new_obj, esc_word, num;
    unsigned    *gea, *nea, *start_add, *save_gcp_ent_add;
    unsigned *save_new_ent_add;

    gea = gcp_ent_add;
    nea = new_ent_add;

    old_obj = *new_gcpoint;
    new_obj = GETtag(*new_gcpoint) | SSERDDA(nea);
    *new_gcpoint =  new_obj;            /* update the obj at gc-pointer */
    /*    
    if (GCBIT(*gea)) {
        start_add = (unsigned *)ADDRESS(*gea);
        esc_word = reactive_lostobj(old_obj, new_obj, start_add);
        if (GETtag(*new_gcpoint) == LTAG_PORT)
            *gea = PORT_HEAD;
        else
            *gea = GETtag(*gea) | esc_word;
    }
*/
    /* gcunit_p_o_not_linked */
    if (GETtag(*gea) == LTAG_GCFORWARD) {
        *new_gcpoint = GETtag(*new_gcpoint) | SSERDDA(ADDRESS(*gea));
        return;
    } else if (GETtag(old_obj) == LTAG_STRING || GETtag(old_obj) == LTAG_SSTRING)
        /* strings have special structure. */
        /* p_o_string */
        if (!(*gea & 0x04000000)) {        /* depend on tagsystem(block2) */
            /* indirect string */
            *gea = LTAG_GCFORWARD | SSERDDA(nea);          /* set gcforward */
            *new_gcpoint = GETtag(*new_gcpoint) | SSERDDA(nea);
            /* change the old to the new object */
            gea = (unsigned *)ADDRESS(*(gea + 1));
            /* indirect entity address -> gcp_ent_add */
            num = IMM(*gea);
            do {
                *nea++ = *gea++;
            } while ((num -= 4) >= 0);
            new_ent_add = nea;
            gcp_ent_add = gea;
            return;
        }

    if (GETtag(*gea) == LTAG_BLOCK1)
        ac_block1++;
    else
        ac_block2++;
    /* gcunit_p_o_copy */
    save_new_ent_add = nea;
    save_gcp_ent_add = gea;
    num = IMM(*gea);
    do {
        /*
if(*gea == 0)printf("!!!!! %x -> %x\n", (int)gea, (int)nea);
*/
        *nea++ = *gea++;
    } while ((num -= 4) >= 0);
    new_ent_add = nea;
    gcp_ent_add = gea;
    *save_gcp_ent_add = LTAG_GCFORWARD | SSERDDA(save_new_ent_add);
    *new_gcpoint = GETtag(*new_gcpoint) | SSERDDA(save_new_ent_add);
}


#ifdef CALLIOC
copygc_init_stack(bottom)
unsigned *bottom;
{
    unsigned    *base_p, *stacktop;

    if (bottom == (unsigned *)stack_bottom) {
        unsigned    *top, *top1;

        base_p = base_val();
        stacktop = top_val();
        top  = (unsigned *)old_top;
        top1 = (unsigned *)old_top1;
        
        while (top != top1) {
            while (top1 != stacktop) {
                gcunit(stacktop);
                stacktop++;
            }
            top1 = (unsigned *) * top1;
            stacktop++;
        }
    } else {
        base_p = stacktop = (unsigned *)(bottom[1]);
        gcunit(bottom);
    }

    /* initialization for system stack */

    while (bottom >= stacktop) {
        while (base_p != stacktop) {
            gcunit(stacktop);
            stacktop++;
        }
        base_p = (unsigned *) * stacktop;
        stacktop += 4;
    }
}
#else
copygc_init_stack(base_p, stacktop)
unsigned    *base_p, *stacktop;
{
    unsigned    *top, *top1;

    top  = (unsigned *)old_top;
    top1 = (unsigned *)old_top1;

    while (top != top1) {
        while (top1 != stacktop) {
            gcunit(stacktop);
            stacktop++;
        }
        top1 = (unsigned *) * top1;
        stacktop++;
    }

    /* initialization for system stack */

    while ((unsigned *)stack_bottom >= stacktop) {
        while (base_p != stacktop) {
            gcunit(stacktop);
            stacktop++;
        }
        base_p = (unsigned *) * stacktop;
        stacktop += 4;
    }
}
#endif

copygc_start()
{
    unsigned    *gcp;

    gcp = entity_start;

    while (gcp != new_ent_add) {
        gcunit(gcp);
        gcp = new_gcpoint;
        gcp++;
    }
#ifdef CALLIOC
{
    unsigned *tmp;

    while ((unsigned int)marked_stack_list != LTAG_NIL) {
        tmp = marked_stack_list;
        marked_stack_list = (unsigned *)marked_stack_list[2];
        copygc_init_stack(tmp);
        while (gcp != new_ent_add) {
            gcunit(gcp);
            gcp = new_gcpoint;
            gcp++;
        }
    }
}
#endif
    wp_gc_start();
    close_garbage_port();
    free_garbage_ncc();
}


wp_gc_start()
{
    unsigned **wpl, **wp_p;
    unsigned int tmp;

    /*    wpl = &get_sval(wplist.obj); */
    /*    if ((wpl = get_sval(wplist.obj)) != LTAG_NIL)
    set_sval(wplist.obj, ADDRESS(wpl));
*/
    wpl = (unsigned **)&(((ENTITYP)ADDRESS(wplist.obj))->sym.sym_val.obj);
    /*    while (GETtag(*wpl) != LTAG_NIL) { */
    while (*wpl != (unsigned *)LTAG_NIL) {
        wp_p = (unsigned **)ADDRESS(*wpl);
        if (GETtag(*wp_p) == LTAG_GCFORWARD) {
            *wpl = (unsigned *)(LTAG_WEAKPAIR | SSERDDA(ADDRESS(*wp_p)));
            wp_p = (unsigned **)ADDRESS(*wpl);
            tmp = (unsigned)*(wp_p + 3);
            if (tmp & 0xe0000000 && !(tmp & 0x80000000))
                wpl = wp_p + 4;
            else if (GETtag(*(unsigned *)ADDRESS(tmp)) == LTAG_GCFORWARD) {
                *(wp_p + 3) = (unsigned *)(GETtag(tmp)
                                      | SSERDDA(ADDRESS(*(unsigned *)ADDRESS(tmp))));
                wpl = wp_p + 4;            /* next wpl */
            } else {
                *(wp_p + 3) = (unsigned *)(LTAG_LOSTOBJ1 | SSERDDA(ADDRESS(tmp)));
                *wpl = *(wp_p + 4);
                *(wp_p + 4) = (unsigned *)LTAG_NILVECTOR;
            }
        } else
            *wpl = *(wp_p + 4);
    }
    if ((wpl = (unsigned **)get_sval(wplist.obj)) != (unsigned **)LTAG_NIL)
        set_sval(wplist.obj, ADDRESS(wpl) | LTAG_NIL);
}



#ifdef CALLIOC
add_dist_stack(dist, bottom)
int    dist;
unsigned *bottom;
{
    unsigned *base_p, *stacktop;

    if (bottom == (unsigned *)stack_bottom) {
        unsigned    *top, *top1;

        base_p = base_val();
        stacktop = top_val();
        /* reader stack */
        
        top  = (unsigned *)old_top;
        top1 = (unsigned *)old_top1;
        
        while (top != top1) {
            while (top1 != stacktop) {
                add_dis(stacktop, dist);
                stacktop++;
            }
            top1 = (unsigned *) * top1;
            stacktop++;
        }
    } else {
        base_p = stacktop = (unsigned *)(bottom[1]);
        add_dis(bottom, dist);
    }

    /* scheme stack */

    while (bottom >= stacktop) {
        while (base_p != stacktop) {
            add_dis(stacktop, dist);
            stacktop++;
        }
        base_p = (unsigned *) * stacktop;
        stacktop += 4;
    }
}
#else
add_dist_stack(dist, base_p, stacktop)
int    dist;
unsigned *base_p, *stacktop;
{
    unsigned    *top, *top1;
    unsigned *s_bottom;

    /* reader stack */

    top  = (unsigned *)old_top;
    top1 = (unsigned *)old_top1;

    while (top != top1) {
        while (top1 != stacktop) {
            add_dis(stacktop, dist);
            stacktop++;
        }
        top1 = (unsigned *) * top1;
        stacktop++;
    }

    /* scheme stack */

    s_bottom = (unsigned *)stack_bottom;
    while (s_bottom >= stacktop) {
        while (base_p != stacktop) {
            add_dis(stacktop, dist);
            stacktop++;
        }
        base_p = (unsigned *) * stacktop;
        stacktop += 4;
    }
}
#endif

block_move(start, end, to, dist)
unsigned    *start, *end, *to;
int dist;
{
    int    content, count;

    while (start != end) {
        content = *(start++);
        if (GETtag(content) == 0 || content & 0x80000000)
            *(to++) = content - dist;
        else {
            *(to++) = content;
            if (GETtag(content) == LTAG_BLOCK2) {
                count = IMM(content);
                while ((count -= 4) >= 0) 
                    *(to++) = *(start++);
            }
        }
    }
    wp_add_dist(-dist);
}

#ifdef THINK_C
wp_add_dist(dist)
int dist;
{
    unsigned *wpl, *wp_p;
    int content;

    wpl = (unsigned *)get_sval(wplist.obj);
    while (wpl != (unsigned *)LTAG_NIL) {
        wp_p = (unsigned *)ADDRESS(wpl);
        content = *(wp_p + 3);
        if (GETtag(content) == 0 || content & 0x80000000)
            *(wp_p + 3) = content + dist;
        content = *(wp_p + 4);
        if (content != LTAG_NIL)
            *(wp_p + 4) = content + dist;
        wpl = (unsigned *) * (wp_p + 4);
    }
}
#endif
