/*
 * get-memory.c - 
 */

/*
 * $Id: get-memory.c,v 1.3 2014/10/28 02:22:55 komiya Exp $
 */

/*******************************************/
/*                                         */
/*  Memory allocation & management         */
/*      M.Yamamoto                         */
/*  File Name : get-memory.c               */
/*                                         */
/*  Update    : Yass.    Jul. 17 '90       */
/*              Yass.    Jul.  6 '90       */
/*              Myama.   ?                 */
/*              T.Komiya Dec. 10 '90       */
/*              T.Komiya Sep. 24 '91       */
/*                                         */
/*******************************************/

static char *RCSid="$Id: get-memory.c,v 1.3 2014/10/28 02:22:55 komiya Exp $";

#include "scheme.h"

#include <signal.h>


int memgettraceflag;
int bakudan = 0;
int message_level;
int t_gcp, t_gms, t_gcm;
int memget_mode = COPY_GC;

#ifdef CTHREAD
mutex_t memget_lock;
#endif

unsigned *memget();
unsigned *memget_ms();
void extend_heap(int);

extern int  act;
extern unsigned *compaction();

Smemget_trace_on()
{
    memgettraceflag = 1;
    set_reg(LTAG_T);
}


Smemget_trace_off()
{
    memgettraceflag = 0;
    set_reg(LTAG_NIL);
}

#ifdef LTC
# define select_gc()	gctype = COMPACTION; /* SEE ALSO load_img() */
#else
select_gc()
{
    /*    int act, gar; */
    int gar;
    float   x;

    /*    act = (int)(2.0*(float)ac_cons + 6.6*(float)ac_block1 + 6.2*(float)ac_block2); */
    gar = no_cons + no_block1 + no_block2;
    /*    x = (float)act / (float)(entity_area_size >> 2); */
    x = (float)act / (float)entity_area_size;

    if (gctype == COPY_GC)
        t_gcp = (int)((float)(73 * ac_cons + 173 * ac_block1 + 118 * ac_block2)
            *(1.0 - x) / (1.0 - 2.0 * x));
    /*        t_gcp = (int)((float)(33.0 * (float)ac_cons / (float)act
             + 55.0 * (float)(ac_block1 + ac_block2) / (float)act)
            *(float)(1.0 + 1.0 / (1.0 - 2.0 * x)) * (float)act);
*/
    t_gms = 56 * ac_cons + 132 * ac_block1 + 25 * ac_block2 + 790 * gar;
    /*    t_gms = 57 * ac_cons + 70 * ac_block1 + 26 * ac_block2 + 785 * gar;*/
    t_gcm = 204 * ac_cons + 510 * ac_block1 + 78 * ac_block2 + 32 * no_block2;
    /*    t_gcm = 167 * ac_cons + 210 * ac_block1 + 168 * ac_block2 + 32 * gar;*/

    /*    t_gcm = 0; */     /* make compaction */
    /*    t_gms = 0; */     /* make mark & sweep */

    if (gctype != COPY_GC)
        if (t_gms < t_gcm)
            gctype = MARK_AND_SWEEP_GC;
        else
            gctype = COMPACTION;
    else if (t_gms < t_gcm)
        if (t_gcp < t_gms)
            gctype = COPY_GC;
        else
            gctype = MARK_AND_SWEEP_GC;
    else if (t_gcp < t_gcm)
        gctype = COPY_GC;
    else
        gctype = COMPACTION;
    ac_cons = ac_block1 = ac_block2 = 0;
    no_cons = no_block1 = no_block2 = 0;
    /*    printf("x : %f\n", x);
    printf("\n%d\n", gctype); */
}
#endif

unsigned *memget(size)
int size;
{
    void goto_mark_and_sweep();
    unsigned *top;
    int vacancy;
    int quarter_vacancy;
    int i;
/*    int oldmask; */

    interrupt_enable = FALSE;
#ifdef CTHREAD
    mutex_lock(memget_lock);
#endif

AGAIN :
    if (memget_mode == COPY_GC) {
        if (((unsigned)entity_end) >= (((unsigned)last_entity) + size)) {
            top = last_entity;
            last_entity = (unsigned *)(((unsigned)last_entity) + size );
#ifdef CTHREAD
            mutex_unlock(memget_lock);
#endif
	    interrupt_enable = TRUE;
            return(top);
        }
    } else {
        top = memget_ms(size);
        if (top != NULL) {
#ifdef CTHREAD
            mutex_unlock(memget_lock);
#endif
	    interrupt_enable = TRUE;
            return(top);
	}
    }

    /* do garbage collection */

/*
#ifdef THINK_C
#else
    oldmask = sigblock(sigmask(SIGINT));
#endif
*/

    message_level = fix_to_int(get_sval(gc_message_level_sym.obj));
    if (gctype == COPY_GC) {
        if (memget_mode != COPY_GC) {
            printf("bad memget_mode (copy GC)\n");
/*
#ifdef THINK_C
#else
            sigsetmask(oldmask);
#endif
*/
	    interrupt_enable = TRUE;
            exit(1);
        }
        if (copygc(size)) {  /* copy gc is successed */
            memget_mode = COPY_GC;
            select_gc();
            top = last_entity;
            last_entity = (unsigned *)(((unsigned)last_entity) + size);
/*
#ifdef THINK_C
#else
            sigsetmask(oldmask);
#endif
*/
#ifdef CTHREAD
            mutex_unlock(memget_lock);
#endif
	    interrupt_enable = TRUE;
            return(top);
        } else { /* copy gc is failed */
            select_gc();
            if (t_gms < t_gcm)
                gctype = memget_mode = MARK_AND_SWEEP_GC;
            else
                gctype = memget_mode = COMPACTION;
            goto_mark_and_sweep();
            top = (unsigned *)memget_ms(size);
            if (top != NULL) {
/*
#ifdef THINK_C
#else
                sigsetmask(oldmask);
#endif
*/
#ifdef CTHREAD
                mutex_unlock(memget_lock);
#endif
		interrupt_enable = TRUE;
                return(top);
            } else {
                extend_heap(size);
                goto AGAIN;
            }
        }
    } else {
        if (memget_mode == COPY_GC) {
            copygc(0);
            memget_mode = gctype;
            if (entity_start != entity_base) {
                move_up_entity_area(entity_start, last_entity, entity_base);
                last_entity = last_entity - (entity_start - entity_base);
            }
            goto_mark_and_sweep();
            top = (unsigned *)memget_ms(size);
            if (top != NULL) {
/*
#ifdef THINK_C
#else
                sigsetmask(oldmask);
#endif
*/
#ifdef CTHREAD
                mutex_unlock(memget_lock);
#endif
		interrupt_enable = TRUE;
                return(top);
            } else {
                extend_heap(size);
                goto AGAIN;
            }
        }
        vacancy = mark_and_sweep_gc();
        memget_mode = gctype;

        if (message_level >= 2) {
            printf("entity_base = %x, last_entity = %x, entity_end = %x\nentity_end - last_entity = %x\n",
                (int)entity_base, (int)last_entity, (int)entity_end, (unsigned)entity_end - (unsigned)last_entity);
            printf("vacancy_size = %x\n", vacancy);
        }
        if (gctype == COMPACTION) {
            ac_cons = ac_block1 = ac_block2 = 0;
            last_entity = compaction(vacancy, size);
            select_gc();
            if (message_level >= 2) {
                printf("entity_base = %x, last_entity = %x, entity_end = %x\nentity_end - last_entity = %x\n",
                                                                 (int)entity_base, (int)last_entity, (int)entity_end,
                     (unsigned)entity_end - 
                    (unsigned)last_entity);
                printf("vacancy_size = %x\n", vacancy);
            }
        } else {
            select_gc();
            top = memget_ms(size);
            if (top != NULL) {
                clear_gc_bit();
/*
#ifdef THINK_C
#else
                sigsetmask(oldmask);
#endif
*/

                /* if vacancy area is small then extend heap */
                if ((double)vacancy / (double)entity_area_size <= 0.1) {
                    print_con("vacancy area is small.\n");
                    extend_heap(0);
                }
#ifdef CTHREAD
                mutex_unlock(memget_lock);
#endif
		interrupt_enable = TRUE;
                return(top);
            } else {
                printf("\nmark & sweep fail.\ncompaction start.\n");
                ac_cons = ac_block1 = ac_block2 = 0;
                last_entity = compaction(vacancy, size);
                memget_mode = COMPACTION;
                select_gc();
                if (message_level >= 2) {
                    printf("entity_base = %x, last_entity = %x, entity_end = %x\nentity_end - last_entity = %x\n",
                                                                         (int)entity_base, (int)last_entity,
                         (int)entity_end, (unsigned)entity_end - 
                        (unsigned)last_entity);
                    printf("vacancy_size = %x\n", vacancy);
                }
            }
        }

        for (i = 0; i < BLOCK_TABLE_SIZE; i++)
            block_table[i] = 0;
        big_block = 0;
        quarter_vacancy = vacancy / 4;
        if (quarter_vacancy >= 1)
            *last_entity = LTAG_BLOCK2 | (vacancy - 4);
        if (quarter_vacancy <= 1) {
            extend_heap(size);
            goto AGAIN;
        }

        big_block = last_entity;
        *(last_entity + 1) = 0;
        top = memget_ms(size);
        if (top != NULL) {
/*
#ifdef THINK_C
#else
            sigsetmask(oldmask);
#endif
*/
            /* if vacancy area is small then extend heap */
            if ((double)vacancy / (double)entity_area_size <= 0.1) {
                print_con("vacancy area is small.\n");
                extend_heap(0);
            }
#ifdef CTHREAD
            mutex_unlock(memget_lock);
#endif
	    interrupt_enable = TRUE;
            return(top);
        } else {
            extend_heap(size);
            goto AGAIN;
        }
    }
/*
#ifdef THINK_C
#else
    sigsetmask(oldmask);
#endif
*/
#ifdef CTHREAD
    mutex_unlock(memget_lock);
#endif
    interrupt_enable = TRUE;
}


unsigned dummy[2];

unsigned *memget_ms(size)
int size;
{
    int i;
    unsigned *top;
    unsigned *pre_top;
    int quarter_size;
    int rest_size;
    int rest_size_minus_4;
    int quarter_rest_size;

    quarter_size = size / 4;

    if (memget_mode != COMPACTION) {
        /* try to find the just fit block */
        if (quarter_size < BLOCK_TABLE_SIZE) {
            if ((top = block_table[quarter_size]) != 0 ) {
                block_table[quarter_size] = (unsigned *)* (top + 1);
                return(top);
            }
        }

        /* try to find the nealy equal block */
        for (i = quarter_size + 2; i < BLOCK_TABLE_SIZE; i++) {
            if (block_table[i] != 0) {
                top = block_table[i];
                block_table[i] = (unsigned *)* (top + 1);
                rest_size = i - quarter_size;
                if (rest_size == 1) {
                    *(top + quarter_size) = LTAG_BLOCK2;
                    return(top);
                } else {
                    *(top + quarter_size) = LTAG_BLOCK2 | ((rest_size * 4) - 4);
                    *(top +quarter_size +1) = (unsigned)block_table[rest_size];
                    block_table[rest_size] = top + quarter_size;
                    return(top);
                }
            }
        } /* for */
    }

    /* try to cut the block away from big_block */
    top = big_block;
    pre_top = dummy;
    dummy[1] = (unsigned)big_block;
    while (top) {  /* when top == 0 , quit this loop */
        if (((int)IMM(*top) + 4) >= size) {
            rest_size_minus_4 = IMM(*top) - size;
            *(pre_top + 1) = *(top + 1);
            big_block = (unsigned *)dummy[1];
            quarter_rest_size = (rest_size_minus_4 / 4) + 1;

            if (rest_size_minus_4 == -4)
                return(top);
            else if (rest_size_minus_4 == 0) {
                *(top + quarter_size) = LTAG_BLOCK2;
                return(top);
            } else {
                *(top + quarter_size) = LTAG_BLOCK2 | rest_size_minus_4;
                if (memget_mode != COMPACTION) {
                    if (quarter_rest_size < BLOCK_TABLE_SIZE) {
                        *(top + quarter_size + 1) = (unsigned)block_table[quarter_rest_size];
                        block_table[quarter_rest_size] = top + quarter_size;
                        return(top);
                    }
                }
                *(top + quarter_size + 1) = (unsigned)big_block;
                big_block = top + quarter_size;
                return(top);
            }
        }
        pre_top = top;
        top = (unsigned *) * (top + 1);

    } /* while */

    /* get memory is failed */

    return(0);
}


void goto_mark_and_sweep()
{
    int vacancy;
    int quarter_vacancy;
    int i;

    if (message_level)
        print_con("\n===== WELCOME TO MARK&SWEEP GC WORLD =====\n\n");
    entity_end = entity_fin;
    entity_area_size = max_entity_area_size;
    vacancy = (unsigned)entity_end - (unsigned)last_entity;
    quarter_vacancy = vacancy / 4;
    if (quarter_vacancy >= 1)
        *last_entity = LTAG_BLOCK2 | (vacancy - 4);
    for (i = 0; i < BLOCK_TABLE_SIZE; i++)
        block_table[i] = 0;
    big_block = 0;
    if (quarter_vacancy <= 1)
        return;
    else {
        if (gctype == MARK_AND_SWEEP_GC)
            if (quarter_vacancy < BLOCK_TABLE_SIZE) {
                *(last_entity + 1) = 0;
                block_table[quarter_vacancy] = last_entity;
                return;
            }
        *(last_entity + 1) = 0;
        big_block = last_entity;
    }
}

#if (defined(THINK_C) || defined(CTHREAD) || defined(PVM3))  /* By A243 */

void extend_heap(size)
int size;
{
    memory_exhaust();
}

#else

void extend_heap(size)
int size;
{
    void memory_exhaust();
    int quarter_size;

    if (entity_fin != (unsigned *)sbrk(0)) {
        printf("entity_fin : %x\n", entity_fin);
        printf("brk value : %x\n", sbrk(0));
        print_con("Someone allocated my memory!\n");
        memory_exhaust();
    }
    if (entity_fin != (unsigned *)sbrk((unsigned)(size + EXTRA_HEAP_SIZE)
                                  & ~(EXTRA_HEAP_SIZE-1))) { /* Feb 8, 1994 */
        print_con("Can't extend heap.\n");
        memory_exhaust();
    }
    entity_fin = (unsigned *)sbrk(0); /* sbrk() may return alignmented brk value */
    print_con("extend heap\n");
    max_entity_area_size = (char *)entity_fin - (char *)entity_base;
    quarter_size = (int)(entity_fin - entity_end);
    *entity_end = LTAG_BLOCK2 | ((quarter_size << 2) - 4);

    switch (memget_mode) {
    case MARK_AND_SWEEP_GC :
        if (quarter_size < BLOCK_TABLE_SIZE) {
            *(entity_end + 1) = (unsigned)block_table[quarter_size];
            block_table[quarter_size] = entity_end;
        } else {
            *(entity_end + 1) = (unsigned)big_block;
            big_block = entity_end;
        }
        break;
    case COMPACTION :
        if (big_block != 0 && 
            (unsigned *)((char *)big_block + IMM(*big_block) + 4) != entity_end) {
            print_con("Can't connect big_block.\n");
            exit(1);
        }
        if (big_block == 0) {
            *(entity_end + 1) = (unsigned)big_block;
            big_block = entity_end;
        } else {
            *big_block += (IMM(*entity_end) + 4);
            *(big_block + 1) = 0;
        }
        break;
    default :
        print_con("invalid memget_mode (in extend_heap)");
        exit(1);
    }
    entity_end = entity_fin;
    entity_area_size = (char *)entity_end - (char *)entity_base;
    return;
}
#endif

void memory_exhaust()
{
    print_con("memory exhaust :  THE END!!\n");
    exit(1);
}


void Sgoto_mark_and_sweep()
{
    int vacancy;
    int quarter_vacancy;
    int i;
    if (gctype == MARK_AND_SWEEP_GC) {
        if (message_level)
            print_con("already mark&sweep type\n");
        set_reg(LTAG_NIL);
        return;
    }

    if (message_level)
        print_con("\n===== WELCOME TO MARK&SWEEP GC WORLD =====\n\n");
    gctype = memget_mode = MARK_AND_SWEEP_GC;
    copygc(0);
    if (entity_start != entity_base)
        move_up_entity_area(entity_start, last_entity, entity_base);
    last_entity = (unsigned *)((unsigned)last_entity - ((unsigned)entity_start - (unsigned)entity_base));
    entity_end = entity_bottom;
    vacancy = (unsigned)entity_end - (unsigned)last_entity;
    quarter_vacancy = vacancy / 4;
    if (quarter_vacancy >= 1)
        *last_entity = LTAG_BLOCK2 | (vacancy - 4);
    for (i = 0; i < BLOCK_TABLE_SIZE; i++)
        block_table[i] = 0;
    big_block = 0;
    if (quarter_vacancy <= 1)
        ;
    else if (quarter_vacancy < BLOCK_TABLE_SIZE) {
        *(last_entity + 1) = 0;
        block_table[quarter_vacancy] = last_entity;
    } else {
        *(last_entity + 1) = 0;
        big_block = last_entity;
    }
    set_reg(LTAG_T);
#ifdef X
    cell_mon(-((unsigned)last_entity - (unsigned)entity_base), 1);
    draw_free_list();
#endif
}


void goto_copygc()
{
    int vacancy;
    int quarter_vacancy;
    int i;

    if (message_level)
        print_con("\n===== WELCOME TO COPY GC WORLD =====\n\n");
    gctype = COPY_GC;

    entity_position = HIGH;
    entity_top = entity_start = entity_base;
    /*  entity_middle = entity_end = last_entity; */
    entity_middle = entity_end = (unsigned *)((unsigned)entity_base + max_entity_area_size / 2);
    /*  entity_bottom = entity_middle + (entity_middle - entity_top); */
    entity_bottom = entity_fin;
    entity_area_size = (unsigned)entity_bottom - (unsigned)entity_top;
}


void Sgoto_copygc()
{
    int vacancy;
    int quarter_vacancy;
    int i;

    if (gctype == COPY_GC) {
        if (message_level)
            print_con("already copy type\n");
        set_reg(LTAG_NIL);
        return;
    }

    vacancy = mark_and_sweep_gc();
    last_entity = compaction(vacancy, 0);
    if (max_entity_area_size < ((unsigned)last_entity - (unsigned)entity_base) * 2) {
        if (vacancy >= 4)
            *last_entity = LTAG_BLOCK2 | (vacancy - 4);
        for (i = 0; i < BLOCK_TABLE_SIZE; i++)
            block_table[i] = 0;
        big_block = 0;
        if (quarter_vacancy <= 1) {
#ifdef X
            draw_free_list();
#endif          
            return;
        } else if (quarter_vacancy < BLOCK_TABLE_SIZE) {
            *(last_entity + 1) = 0;
            block_table[quarter_vacancy] = last_entity;
        } else {
            *(last_entity + 1) = 0;
            big_block = last_entity;
        }
        if (message_level)
            print_con("cannot go to copygc\n");
        set_reg(LTAG_NIL);
#ifdef X
        draw_free_list();
#endif          
        return;
    }
    if (message_level)
        print_con("\n===== WELCOME TO COPY GC WORLD =====\n\n");
    gctype = COPY_GC;


    entity_position = HIGH;
    entity_top = entity_start = entity_base;
    /*  entity_middle = entity_end = last_entity; */
    entity_middle = entity_end = (unsigned *)((unsigned)entity_base + max_entity_area_size / 2);
    /*  entity_bottom = entity_middle + (entity_middle - entity_top); */
    entity_bottom = entity_fin;
    entity_area_size = (unsigned)entity_bottom - (unsigned)entity_top;
    set_reg(LTAG_T);
#ifdef X
    cell_mon(-((unsigned)last_entity - (unsigned)entity_base), 1);
#endif
}


void Sgc()
{
    int i, vacancy_size;

/*
#ifdef THINK_C
#else
    oldmask = sigblock(sigmask(SIGINT));
#endif
*/

    interrupt_enable = FALSE;
    if (gctype == COPY_GC) {
        if (memget_mode != COPY_GC) {
            printf("bad memget_mode (copy GC)\n");
/*
#ifdef THINK_C
#else
            sigsetmask(oldmask);
#endif
*/
	    interrupt_enable = TRUE;
            exit(1);
        }
        copygc(0);
        memget_mode = COPY_GC;
        select_gc();
#ifdef X
        cell_mon(-((unsigned)last_entity - (unsigned)entity_start), 1);
#endif  
    } else {
        if (memget_mode == COPY_GC) {
            copygc(0);
            memget_mode = gctype;
            if (entity_start != entity_base) {
                move_up_entity_area(entity_start, last_entity, entity_base);
                last_entity = last_entity - (entity_start - entity_base);
            }
            goto_mark_and_sweep();
        }
        vacancy_size = mark_and_sweep_gc();
        memget_mode = gctype;

        if (message_level >= 2) {
            printf("entity_base = %x, last_entity = %x, entity_end = %x\nentity_end - last_entity = %x\n",
                (int)entity_base, (int)last_entity, (int)entity_end, (unsigned)entity_end - (unsigned)last_entity);
            printf("vacancy_size = %x\n", vacancy_size);
        }
        if (gctype == COMPACTION) {
            ac_cons = ac_block1 = ac_block2 = 0;
            last_entity = compaction(vacancy_size, 0);
            select_gc();
            for (i = 0; i < BLOCK_TABLE_SIZE; i++)
                block_table[i] = 0;
            big_block = 0;
            if (vacancy_size >= 4)
                *last_entity = LTAG_BLOCK2 | (vacancy_size - 4);
            if (vacancy_size > 4) {
                big_block = last_entity;
                *(last_entity + 1) = 0;

                if (message_level >= 2) {
                    printf("entity_base = %x,last_entity = %x, entity_end = %x\nentity_end - last_entity = %x\n",
                                                 (int)entity_base,
                        (int)last_entity,
                        (int)entity_end,
                        (unsigned)entity_end - (unsigned)last_entity);
                    printf("vacancy_size = %x\n", vacancy_size);
                }
            }
        } else {
            select_gc();
            clear_gc_bit();
        }
#ifdef X
        cell_mon(-(max_entity_area_size - vacancy_size), 1);
#endif  
    }

    set_reg(LTAG_T);
/*
#ifdef THINK_C
#else
    sigsetmask(oldmask);
#endif
*/
    interrupt_enable = TRUE;
}


#ifdef X

cell_mon(size, flag)
int size, flag;
{
    static int  i = 0;
    static int  active = 0;

    if (size >= 0)
        active += size;
    else
        active = abs(size);

    if (flag != 0) {
        if (i > 300) {
            draw_num_cell((int)(((double)active / (double)max_entity_area_size) * 100));
            i = 0;
        }
        i++;
    }
}


#endif
