/*
 * io.c - 
 */

/*
 * $Id: io.c,v 1.7 2014/10/28 02:22:55 komiya Exp $
 *
 *  ----
 *  PORT 
 *  ----
 *
 *  File Name : io.c
 *    written by Mikio Yamamoto
 *               1990.2 -
 *    modify to all-c-version by Mikio Yamamoto
 *               1990.10.8
 *    fair-copied by Yass. 
 *    Update  : T.Komiya  Oct. 26 '90
 *
 */

static char *RCSid="$Id: io.c,v 1.7 2014/10/28 02:22:55 komiya Exp $";

#include "scheme.h"

#ifndef THINK_C
# include <sys/types.h>
# include <sys/stat.h>
# include <sys/time.h>
# ifdef LUNA
#  include <sys/file.h>
# else
#  include <unistd.h>
# endif
#endif
#include <errno.h>

#ifdef TCPIP
#include "inet.h"
#endif
#ifndef TCPIP
#ifndef THINK_C
#include <sys/ioctl.h>
#endif
#endif


extern unsigned *PRINTstack_top, *PRINTstack_limit;	/* T.Komiya */

/*
char *expand_file_name(fname)
char *fname;
{
    int i, j;
    char home_path[80];
    char *foo;

    if (*fname == '~') {
        strcpy(home_path, getenv("HOME"));
        if (*(fname+1) != '/') {
            for (i = strlen(home_path) - 1; i >= 0; i--)
                if (home_path[i] == '/') {
                    home_path[i+1] = '\0';
                    break;
                }
        }
        foo = strcat(home_path, fname+1);
        printf("|%s|\n", foo);
        return(foo);
    } else
        return(fname);
}
*/

/* ------------------------------------
 *   x-return function
 *   for call-with-input-file
 *       call-with-output-file
 *       with-input-from-port
 *       with-output-to-port
 *
 */

void cwifend()
{
    closeport(*(base_reg - 4));
    xreturn();
}


void wifpend()
{
    c_in_port.obj = *(((unsigned *)base_val()) - 4);
    xreturn();
}


void wotpend()
{
    c_out_port.obj = *(((unsigned *)base_val()) - 4);
    xreturn();
}



/*  ------------------------------------
 *
 */

closeport(port)
int port;
{ 
    FILE * fp;

    if (GETtag(port) != LTAG_PORT){
        err_illegal_argument("Argument must be a port.");
	return NULL;
    }
    if (((PORT *)ADDRESS(port))->kind == STRING_INPUT
        || ((PORT *)ADDRESS(port))->kind == STRING_OUTPUT)
        ((PORT *)ADDRESS(port))->slot.obj = LTAG_NIL;
    else {
#ifdef TCPIP
      if (netportp (port) || boundportp (port))
	{
	  int sd;

	  sd = (int) (((PORT *) ADDRESS (port))->fp);
	  close (sd);
	} else {
#endif
        fp = ((PORT * )ADDRESS(port))->fp;
        if (fp == stdin || fp == stdout)
            bokkan("*stdin-port* or *stdout-port* may not be closed");
        fclose(fp);
#ifdef TCPIP
      }
#endif
    }
    ((PORT * )ADDRESS(port))->kind = CLOSE;
}


int inputportp(port)
int port;
{
    if (GETtag(port) != LTAG_PORT)
        return(FALSE);
    switch (((PORT * )ADDRESS(port))->kind) {
    case INPUT :
    case STRING_INPUT :
        return(TRUE);
    default :
        return(FALSE);
    }
}


int outputportp(port)
int port;
{
    if (GETtag(port) != LTAG_PORT)
        return(FALSE);
    switch (((PORT * )ADDRESS(port))->kind) {
    case OUTPUT :
    case STRING_OUTPUT :
        return(TRUE);
    default :
        return(FALSE);
    }
}


int flush_port(port)
int port;
{
    if (GETtag(port) != LTAG_PORT)
        return(LTAG_FALSE);
    if (((PORT *)ADDRESS(port))->kind == STRING_INPUT
	|| ((PORT *)ADDRESS(port))->kind == STRING_OUTPUT)
        err_illegal_argument("Argument may not be a string port.");
    if (((PORT * )ADDRESS(port))->kind == OUTPUT) { 
        fflush(((PORT * )ADDRESS(port))->fp);
        return(LTAG_T);
    } else
        err_illegal_argument("Argument must be an output port.");
}


#define TAG_AND_ADDRESS_MASK 0xfffffffc

void close_garbage_port()
{ 
    unsigned *portp, *carp, *lost_port, *lost_port_entity;

    /*  portp = &portlist.obj; */
    portp = &(((ENTITYP)ADDRESS(portlist.obj))->sym.sym_val.obj);

    while (GETtag(*portp) != LTAG_NIL) { 
        carp = (unsigned *)((unsigned *)ADDRESS(*portp) + 3);
        if (GETlo_tag(*carp) == LTAG_LOSTOBJ) { 
            lost_port = carp;
            /*      
      while(GETtag(*lost_port) == LTAG_LOSTOBJ0)
    lost_port = (unsigned *)ADDRESS(*lost_port);
*/
            lost_port_entity = (unsigned *)ADDRESS(*lost_port);
            if (*(lost_port_entity + 4) != CLOSE)
#ifdef TCPIP
	      if (*(lost_port_entity + 4) == TCP_STREAM ||
		  *(lost_port_entity + 4) == UDP_DGRAM ||
		  *(lost_port_entity + 4) == TCP_BOUND)
		close ((int) (*(((unsigned *) ADDRESS (*lost_port)) + 3)));
	      else
#endif
                fclose((FILE *)*(((unsigned *)ADDRESS(*lost_port)) + 3));
            *portp = *(carp - 2);
            *(carp - 3) = *(carp - 3) & TAG_AND_ADDRESS_MASK;
            *(carp - 1) = *(carp - 1) & TAG_AND_ADDRESS_MASK;
        } else
            portp = carp - 2;        /* cdr */
    }
}


/***********************************/
/*                                 */
/*  scheme procedures          */
/*                                 */
/***********************************/

/*  Ports  */

void Scwif()
{ 
    SOBJ strobj, proc, port;
    int tmp;  				/*  By N.Watanabe  */

#ifdef TOUCH_ARG
    strobj.obj = touch_obj(getarg(1));
#else
    strobj.obj = getarg(1);
#endif
    if (GETstr_tag(strobj.obj) != LTAG_STRING) {
        if (GETsym_tag(strobj.obj) == LTAG_SYMBOL)
            strobj.obj = ((SYMBOL * )ADDRESS(strobj.obj))->sym_name.obj;
        else {
            err_illegal_argument_type(strobj.obj, "string or symbol");
	    return ;
	}
    }
    if((tmp = mkport(strobj.obj, INPUT)) == NULL){  /* By N.Watanabe */
	return ;
    }
    else {
	port.obj = tmp;
    } 
#ifdef TOUCH_ARG
    proc.obj = touch_obj(getarg(2));
#else
    proc.obj = getarg(2);
#endif
    if (!FUNp(proc.obj)) {
        err_illegal_argument_type(proc.obj, "procedure");
	return ;
    }
    s_push(port.obj);
    s_push(0);  /* dummy for GC */
    s_push(cwifend);
    s_push(active_val());
    s_push(base_val());
    set_base(top_val());
    s_push(proc.obj);
    s_push(port.obj);

    set_up_stack();
}


void Scwof()
{ 
    SOBJ strobj, proc, port;
    int tmp;					/* By N.Watanabe */

#ifdef TOUCH_ARG
    strobj.obj = touch_obj(getarg(1));
#else
    strobj.obj = getarg(1);
#endif
    if (GETstr_tag(strobj.obj) != LTAG_STRING) { 
        if (GETsym_tag(strobj.obj) == LTAG_SYMBOL)
            strobj.obj = ((SYMBOL * )ADDRESS(strobj.obj))->sym_name.obj;
        else {
            err_illegal_argument_type(strobj.obj, "string or symbol");
	    return ;
	}
    }
    if((tmp = mkport(strobj.obj, OUTPUT)) == NULL){  /* By N.Watanabe */
	return ;
    }
    else {
	port.obj = tmp;
    } 
#ifdef TOUCH_ARG
    proc.obj = touch_obj(getarg(2));
#else
    proc.obj = getarg(2);
#endif
    if (!FUNp(proc.obj)) {
        err_illegal_argument_type(proc.obj, "procedure");
	return ;
    }
    s_push(port.obj);
    s_push(0); /* dummy for GC */
    s_push(cwifend);
    s_push(active_val());
    s_push(base_val());
    set_base(top_val());
    s_push(proc.obj);
    s_push(port.obj);

    set_up_stack();
}


void Sin_portp()
{ 
    SOBJ port;

#ifdef TOUCH_ARG
    port.obj = touch_obj(getarg(1));
#else
    port.obj = getarg(1);
#endif
#ifdef TCPIP
    set_reg (inputportp (port.obj) || netportp (port.obj)
	     ? LTAG_T : LTAG_FALSE);
#else
    if (inputportp(port.obj))
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
#endif
}


void Sout_portp()
{ 
    SOBJ port;

#ifdef TOUCH_ARG
    port.obj = touch_obj(getarg(1));
#else
    port.obj = getarg(1);
#endif
#ifdef TCPIP
    set_reg (outputportp (port.obj) || netportp (port.obj)
	     ? LTAG_T : LTAG_FALSE);
#else
    if (outputportp(port.obj))
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
#endif
}


void Scurrent_in_port()
{
    set_reg(c_in_port.obj);
}


void Sconsole_in_port()
{
    set_reg(stdin_port.obj);
}


void Scurrent_out_port()
{
    set_reg(c_out_port.obj);
}


void Sconsole_out_port()
{
    set_reg(stdout_port.obj);
}


void Swifp()
{ 
    SOBJ portobj, proc;

#ifdef TOUCH_ARG
    portobj.obj = touch_obj(getarg(1));
#else
    portobj.obj = getarg(1);
#endif
#ifdef TCPIP
    if (!inputportp (portobj.obj) && !netportp (portobj.obj)){
      err_illegal_argument_type (portobj.obj, "input or a network port");
      return ;
  }
#else
    if (!inputportp(portobj.obj)){
        err_illegal_argument_type(portobj.obj, "input port");
	return ;
    }
#endif
#ifdef TOUCH_ARG
    proc.obj = touch_obj(getarg(2));
#else
    proc.obj = getarg(2);
#endif
    if (!FUNp(proc.obj)) {
        err_illegal_argument_type(proc.obj, "procedure");
	return ;
    }
    s_push(c_in_port.obj);
    c_in_port.obj = portobj.obj;

    s_push(0);  /* dummy for GC */
    s_push(wifpend);
    s_push(active_val());
    s_push(base_val());
    set_base(top_val());
    s_push(proc.obj);

    set_up_stack();
}


void Swotp()
{ 
    SOBJ portobj, proc;

#ifdef TOUCH_ARG
    portobj.obj = touch_obj(getarg(1));
#else
    portobj.obj = getarg(1);
#endif
#ifdef TCPIP
    if (!outputportp (portobj.obj) && !netportp (portobj.obj)){
      err_illegal_argument_type (portobj.obj, "output or a network port");
      return ;
  }
#else
    if (!outputportp(portobj.obj)){
        err_illegal_argument_type(portobj.obj, "output port");
	return ;
    }
#endif
#ifdef TOUCH_ARG
    proc.obj = touch_obj(getarg(2));
#else
    proc.obj = getarg(2);
#endif
    if (!FUNp(proc.obj)) {
        err_illegal_argument_type(proc.obj, "procedure");
	return ;
    }
    s_push(c_out_port.obj);
    c_out_port.obj = portobj.obj;

    s_push(0);  /* dummy for GC */
    s_push(wotpend);
    s_push(active_val());
    s_push(base_val());
    set_base(top_val());
    s_push(proc.obj);

    set_up_stack();
}


void Sopen_in_file()
{ 
    SOBJ strobj, port;
    int tmp;					/* By N.Watanabe */

#ifdef TOUCH_ARG
    strobj.obj = touch_obj(getarg(1));
#else
    strobj.obj = getarg(1);
#endif
    if (GETstr_tag(strobj.obj) != LTAG_STRING) { 
        if (GETsym_tag(strobj.obj) == LTAG_SYMBOL)
            strobj.obj = ((SYMBOL * )ADDRESS(strobj.obj))->sym_name.obj;
        else {
            err_illegal_argument_type(strobj.obj, "string or symbol");
	    return ;
	}
    }
    if((tmp = mkport(strobj.obj, INPUT)) == NULL){  /* By N.Watanabe */
	return ;
    }
    else {
	port.obj = tmp;
    } 
    set_reg(port.obj);
}


void Sopen_out_file()
{ 
    SOBJ strobj, port;
    int tmp; 					/* By N.Watanabe */

#ifdef TOUCH_ARG
    strobj.obj = touch_obj(getarg(1));
#else
    strobj.obj = getarg(1);
#endif
    if (GETstr_tag(strobj.obj) != LTAG_STRING) { 
        if (GETsym_tag(strobj.obj) == LTAG_SYMBOL)
            strobj.obj = ((SYMBOL * )ADDRESS(strobj.obj))->sym_name.obj;
        else {
            err_illegal_argument_type(strobj.obj, "string or symbol");
	    return ;
	}
    }
    if((tmp = mkport(strobj.obj, OUTPUT)) == NULL){  /* By N.Watanabe */
	return ;
    }
    else {
	port.obj = tmp;
    } 
    set_reg(port.obj);
}


void Sclose_in_port()
{ 
    SOBJ port;

#ifdef TOUCH_ARG
    port.obj = touch_obj(getarg(1));
#else
    port.obj = getarg(1);
#endif
    if (GETtag(port.obj) != LTAG_PORT){
        err_illegal_argument_type(port.obj, "port");
	return ;
    }

    if (((PORT *)ADDRESS(port.obj))->kind == CLOSE)
        set_reg(LTAG_FALSE);
    else {
        if (!inputportp(port.obj)){
            err_illegal_argument_type(port.obj, "input port");
	    return ;
	}
        closeport(port.obj);
        set_reg(LTAG_T);
    }
}


void Sclose_out_port()
{ 
    SOBJ port;

#ifdef TOUCH_ARG
    port.obj = touch_obj(getarg(1));
#else
    port.obj = getarg(1);
#endif
    if (GETtag(port.obj) != LTAG_PORT){
        err_illegal_argument_type(port.obj, "port");
	return ;
    }

    if (((PORT *)ADDRESS(port.obj))->kind == CLOSE)
        set_reg(LTAG_FALSE);
    else {
        if (!outputportp(port.obj)){
            err_illegal_argument_type(port.obj, "output port");
	    return ;
	}
#ifdef NIHONGO
	s_push(c_out_port.obj);
	c_out_port.obj = (unsigned)ADDRESS(port.obj);
	putc2(0xffffffff);
	c_out_port.obj = s_pop();
#endif
        closeport(port.obj);
        set_reg(LTAG_T);
    }
}


void Sopen_input_string()
{
#ifdef TOUCH_ARG
    if (GETstr_tag(touch_obj(getarg(1))) != LTAG_STRING) {
        err_illegal_argument_type(touch_obj(getarg(1)), "string");
#else
    if (GETstr_tag(getarg(1)) != LTAG_STRING){
        err_illegal_argument_type(getarg(1), "string");
#endif
	return ;
    }
#ifdef TOUCH_ARG
    set_reg(mk_strport(STRING_INPUT, touch_obj(getarg(1))));
#else
    set_reg(mk_strport(STRING_INPUT, getarg(1)));
#endif
}


void Sopen_output_string()
{
    int init_size;
    int arg;
    unsigned new_string;
    switch (getargnum()) {
    case 0 : 
        init_size = 128;
        break;
    case 1 : 
#ifdef TOUCH_ARG
        arg = touch_obj(getarg(1));
#else
        arg = getarg(1);
#endif
        if (GETtag(arg) != LTAG_FIXNUM && GETtag(arg) != LTAG_FIXNUM1){
            err_illegal_argument_type(arg, "positive fixnum number");
	    return ;
	}
        init_size = fix_to_int(arg);
        if (init_size > STRLEN_MAX){
            err_illegal_argument_type(arg, "non-negative number less than 33554428");
	    return ;
	}
        break;
    default : 
        err_illegal_argument("Too many arguments.");
	return ;
    }
    new_string = SSERDDA(Pgetblock2(init_size)) | LTAG_STRING;
    set_reg(mk_strport(STRING_OUTPUT, new_string));
}


void Sget_output_string()
{
    int port;
    PORT * portobj;
#ifdef TOUCH_ARG
    port = touch_obj(getarg(1));
#else
    port = getarg(1);
#endif
    if (GETtag(port) != LTAG_PORT){
        err_illegal_argument_type(port, "string-output-port");
	return ;
    }
    portobj = (PORT * )ADDRESS(port);
    if (portobj->kind != STRING_OUTPUT){
        err_illegal_argument_type(port, "string-output-port");
	return ;
    }
    set_reg(mk_string(ORDINARY_STRING,
        (int)portobj->fp - 4,
        (char *)ADDRESS(portobj->slot.obj),
        4));
}


void Sreset_output_string()
{
    int port;
    PORT * portobj;
#ifdef TOUCH_ARG
    port = touch_obj(getarg(1));
#else
    port = getarg(1);
#endif
    if (GETtag(port) != LTAG_PORT){
        err_illegal_argument_type(port, "string-output-port");
	return ;
    }
    portobj = (PORT * )ADDRESS(port);
    if (portobj->kind != STRING_OUTPUT){
        err_illegal_argument_type(port, "string-output-port");
	return ;
    }
    portobj->fp = (FILE * )4;
    set_reg(port);
}




/*  Input  */

#ifdef CTHREAD
mutex_t read_lock;
#endif

#ifndef TCPIP
void Sread()
{ 
    int args;
    int tmp;				/*  By N.Watanabe  */

#ifdef CTHREAD
    mutex_lock(read_lock);
#endif
    args = getargnum();
    if (args == 0)
        set_reg(readexp());
    else if (args == 1) { 
#ifdef TOUCH_ARG
        if (!inputportp(touch_obj(getarg(1)))) {
#else
        if (!inputportp(getarg(1))) {
#endif
#ifdef CTHREAD
            mutex_unlock(read_lock);
#endif
#ifdef TOUCH_ARG
            err_illegal_argument_type(touch_obj(getarg(1)), "input port");
#else
            err_illegal_argument_type(getarg(1), "input port");
#endif
	    return ;
	}
        s_push(c_in_port.obj);
#ifdef TOUCH_ARG
        c_in_port.obj = touch_obj(getarg(1));
#else
        c_in_port.obj = getarg(1);
#endif
	tmp = readexp();		/*  By N.Watanabe  */
	if (tmp == NULL){
	    return ;
	}
        set_reg(tmp);
        c_in_port.obj = s_pop();
    } else {
#ifdef CTHREAD
        mutex_unlock(read_lock);
#endif
        err_illegal_argument("Too many arguments.");
	return ;
    }
#ifdef CTHREAD
    mutex_unlock(read_lock);
#endif
}


void Sreadch()
{ 
    int ch1, ch2;
    int args;

    args = getargnum();
    if (args == 0) { 
        ch1 = getc2();
        if (ch1 == EOF) {
            set_reg(eof_obj.obj);
            return;
        }
        if (ch1 & 0x80) {
            ch2 = getc2();
            if (ch2 == EOF) {
                bokkan("Incomplete KANJI character(unexpected eof).");
            }
            set_reg(mk_ch((char)ch1, (char)ch2));
        } else
            set_reg(mk_ch('\0', (char)ch1));
    } else if (args == 1) {
        s_push(c_in_port.obj);
#ifdef TOUCH_ARG
        c_in_port.obj = touch_obj(getarg(1));
#else
        c_in_port.obj = getarg(1);
#endif
        if (!inputportp(c_in_port.obj)) {
            c_in_port.obj = s_pop();
            err_illegal_argument_type(c_in_port.obj, "input port");
	    return ;
        }
        ch1 = getc2();
        if (ch1 == EOF) {
            c_in_port.obj = s_pop();
            set_reg(eof_obj.obj);
            return;
        }
        if (ch1 & 0x80) {
            ch2 = getc2();
            if (ch2 == EOF) {
                c_in_port.obj = s_pop();
                bokkan("Incomplete KANJI character(unexpected eof).");
            }
            set_reg(mk_ch((char)ch1, (char)ch2));
            c_in_port.obj = s_pop();
        } else {
            set_reg(mk_ch('\0', (char)ch1));
            c_in_port.obj = s_pop();
        }
    } else {
        c_in_port.obj = s_pop();
        err_illegal_argument("Too many arguments.");
	return ;
    }
}

void Sreadbyte()
{
    unsigned mk_fix();
    int ch;
    int args;

    args = getargnum();
    if (args == 0) { 
        ch = getc2();
        if (ch == EOF) {
            set_reg(eof_obj.obj);
            return;
        }
        set_reg(mk_fix(ch));
    } else if (args == 1) {
        s_push(c_in_port.obj);
#ifdef TOUCH_ARG
        c_in_port.obj = touch_obj(getarg(1));
#else
        c_in_port.obj = getarg(1);
#endif
        if (!inputportp(c_in_port.obj)) {
            c_in_port.obj = s_pop();
            err_illegal_argument_type(c_in_port.obj, "input port");
	    return ;
        }
        ch = getc2();
        if (ch == EOF) {
            c_in_port.obj = s_pop();
            set_reg(eof_obj.obj);
            return;
        }
        set_reg(mk_fix(ch));
        c_in_port.obj = s_pop();
    } else {
        c_in_port.obj = s_pop();
        err_illegal_argument("Too many arguments.");
	return ;
    }
}


void Speekch() 
{
    int ch1, ch2;
    int args;

    args = getargnum();
    if (args == 0) { 
        ch1 = getc2();
        if (ch1 == EOF) {
            set_reg(eof_obj.obj);
            return;
        }
        if (ch1 & 0x80) {
            ch2 = getc2();
            if (ch2 == EOF) {
                bokkan("Incomplete KANJI character(unexpected eof).");
            }
            set_reg(mk_ch((char)ch1, (char)ch2));
            ungetc2((char)ch2);
            ungetc2((char)ch1);
        } else {
            set_reg(mk_ch('\0', (char)ch1));
            ungetc2((char)ch1);
        }
    } else if (args == 1) {
        s_push(c_in_port.obj);
#ifdef TOUCH_ARG
        c_in_port.obj = touch_obj(getarg(1));
#else
        c_in_port.obj = getarg(1);
#endif
        if (!inputportp(c_in_port.obj)) {
            c_in_port.obj = s_pop();
            err_illegal_argument_type(c_in_port.obj, "input port");
	    return;
        }
        ch1 = getc2();
        if (ch1 == EOF) {
            c_in_port.obj = s_pop();
            set_reg(eof_obj.obj);
            return;
        }
        if (ch1 & 0x80) {
            ch2 = getc2();
            if (ch2 == EOF) {
                c_in_port.obj = s_pop();
                bokkan("Incomplete KANJI character(unexpected eof).");
            }
            set_reg(mk_ch((char)ch1, (char)ch2));
            ungetc2((char)ch2);
            ungetc2((char)ch1);
            c_in_port.obj = s_pop();
        } else {
            set_reg(mk_ch('\0', (char)ch1));
            ungetc2((char)ch1);
            c_in_port.obj = s_pop();
        }
    } else {
        c_in_port.obj = s_pop();
        err_illegal_argument("Too many arguments.");
	return ;
    }
}
#endif


void Seofp()
{
#ifdef TOUCH_ARG
    if (touch_obj(getarg(1)) == eof_obj.obj)
#else
    if (getarg(1) == eof_obj.obj)
#endif
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


void Sfirstcolumnp()		/* S.Ushijima */
{
    SOBJ port;

#ifdef TOUCH_ARG
    port.obj = touch_obj(getarg(1));
#else
    port.obj = getarg(1);
#endif
    if (GETtag(port.obj) != LTAG_PORT) {
	err_illegal_argument_type(port.obj, "port");
	return ;
    }

    set_reg(((PORT *)ADDRESS(port.obj))->notfirst ? LTAG_FALSE: LTAG_T);
}


#ifndef THINK_C
#ifndef __CYGWIN32__

void Schar_readyp ()		/* N.Kurabayashi */
{
  PORT *port;
  int fd;
  long readable;

  switch (getargnum ())
    {
    case 0:
      port = (PORT *) ADDRESS (c_in_port.obj);
      break;
    case 1:
#ifdef TOUCH_ARG
      if (GETtag (touch_obj(getarg (1))) != LTAG_PORT){
#else
      if (GETtag (getarg (1)) != LTAG_PORT){
#endif
#ifdef TCPIP
#ifdef TOUCH_ARG
	  err_illegal_argument_type(touch_obj(getarg(1)), "input or a network port");
#else
	  err_illegal_argument_type(getarg(1), "input or a network port");
#endif
	  return ;
#else
#ifdef TOUCH_ARG
	  err_illegal_argument_type(touch_obj(getarg(1)), "input port");
#else
	  err_illegal_argument_type(getarg(1), "input port");
#endif
	  return ;
#endif
      }
#ifdef TOUCH_ARG
      port = (PORT *) ADDRESS (touch_obj(getarg (1)));
#else
      port = (PORT *) ADDRESS (getarg (1));
#endif
      break;
    default:
      err_illegal_argument ("Too many arguments.");
      return ;
    }

  switch (port->kind)
    {
    case INPUT:
#ifndef LINUX
#if defined(MACHTEN) || defined(FREEBSD)
      if (port->bufstatus > 0 || (port->fp)->_r > 0)
#else
      if (port->bufstatus > 0 || (port->fp)->_cnt > 0)
#endif
	set_reg (LTAG_T);
      else if (feof(port->fp))
        set_reg(LTAG_T);
#ifdef SUNSOL2
      else if (port->fp->_cnt == 0)
#else
      else if (ioctl (fd = fileno (port->fp), FIONREAD, &readable) == -1)
#endif
	set_reg (LTAG_FALSE);
      else if (readable > 0)
	set_reg (LTAG_T);
      else {
          fd_set readfds;
          struct timeval timeout;
          int f = fileno(port->fp);
          
          FD_ZERO(&readfds); 
          FD_SET(f, &readfds);
          timerclear(&timeout);
          if (select(f+1, &readfds, NULL, NULL, &timeout))
              set_reg(LTAG_T);
          else
              set_reg (LTAG_FALSE);
/*	set_reg (isatty (fd) ? LTAG_FALSE : LTAG_T); */
      }
      return;
#endif
    case STRING_INPUT:
      set_reg (LTAG_T);		/* Sorry, I don't know about string port. */
      return;
#ifdef TCPIP
    case TCP_STREAM:
    case UDP_DGRAM:
      if (port->bufstatus > 0)
	set_reg (LTAG_T);
#ifdef SUNSOL2
      else if (port->fp->_cnt == 0)
#else
      else if (ioctl ((int) port->fp, FIONREAD, &readable) == -1)
#endif
	set_reg (LTAG_FALSE);
      else
	set_reg (readable > 0 ? LTAG_T : LTAG_FALSE);
      return;
#endif
    default:
#ifdef TCPIP
#ifdef TOUCH_ARG
      err_illegal_argument_type(touch_obj(getarg(1)), "input or a network port");
#else
      err_illegal_argument_type(getarg(1), "input or a network port");
#endif
      return ;
#else
#ifdef TOUCH_ARG
      err_illegal_argument_type(touch_obj(getarg(1)), "input port");
#else
      err_illegal_argument_type(getarg(1), "input port");
#endif
      return ;
#endif
    }
}

#endif
#endif

/*  Output  */

#ifdef TCPIP

char EOFchar = (char) EOF;

/*
#define putend() \
if (((PORT *) ADDRESS (c_out_port.obj))->kind == TCP_STREAM) \
  write ((int) ((PORT *) ADDRESS (c_out_port.obj))->fp, &EOFchar, 1)
*/

#if 1
#define putend() ;
#else
#define putend() \
if (netportp (c_out_port.obj)) \
  sendto ((int) ((PORT *) ADDRESS (c_out_port.obj))->fp, &EOFchar, 1, 0, \
	  (struct sockaddr *) getnetaddr (c_out_port.obj), \
	  sizeof (struct sockaddr_in))
#endif

#endif

#ifdef CTHREAD
mutex_t print_lock;
#endif

void Swrite()
{
    unsigned *p, *q;
    int args;
#ifdef CTHREAD
    int obj, touch_obj();
#endif

    args = getargnum();
    if (args == 1) {
#ifdef CTHREAD
	obj = getarg(1);
# ifndef SHE
	if (GETtag(obj) == LTAG_FUTURE
	    && ((FUTURE *)ADDRESS(obj))->status != NO_PROCESS)
# endif
	    obj = touch_obj(obj);
	mutex_lock(print_lock);
	PRINTstack_top = sp_reg; /* T.Komiya */
	if (get_sval(print_circle_sym.obj) != LTAG_FALSE) { /* T.Komiya */
	    travel_push_object(obj);
	    for (p = q = PRINTstack_top - 2; p >= sp_reg; p -= 2)
		if (p[1] != LTAG_NIL) {
		    q[0] = p[0];
		    q[1] = LTAG_NIL;
		    q -= 2;
		}
	    PRINTstack_limit = sp_reg = q + 2;
	}
#ifdef PVM3
        printobj(obj, PRINT, 100000, OFF);
#else
	printobj(obj, PRINT, 100000);
#endif

#else
	PRINTstack_top = sp_reg; /* T.Komiya */
	if (get_sval(print_circle_sym.obj) != LTAG_FALSE) { /* T.Komiya */
	    travel_push_object(getarg(1));
	    for (p = q = PRINTstack_top - 2; p >= sp_reg; p -= 2)
		if (p[1] != LTAG_NIL) {
		    q[0] = p[0];
		    q[1] = LTAG_NIL;
		    q -= 2;
		}
	    PRINTstack_limit = sp_reg = q + 2;
	}
#ifdef PVM3
        printobj(getarg(1), PRINT, 100000, OFF);
#else
        printobj(getarg(1), PRINT, 100000);	
#endif
#endif
#ifdef TCPIP
	putend ();
#endif
	sp_reg = PRINTstack_top;
        set_reg(getarg(1));
    } else if (args == 2) { 
#ifdef TCPIP
#ifdef TOUCH_ARG
        if (!outputportp (touch_obj(getarg (2)))
	    && !netportp (touch_obj(getarg (2)))) {
#else
        if (!outputportp (getarg (2)) && !netportp (getarg (2))) {
#endif
#ifdef TOUCH_ARG
	    err_illegal_argument_type (touch_obj(getarg(2)), "output or network port");
#else
	    err_illegal_argument_type (getarg(2), "output or network port");
#endif
	    return ;
	}
#else
#ifdef TOUCH_ARG
        if (!outputportp(touch_obj(getarg(2)))) {
#else
        if (!outputportp(getarg(2))) {
#endif
#ifdef TOUCH_ARG
            err_illegal_argument_type(touch_obj(getarg(2)), "output port");
#else
            err_illegal_argument_type(getarg(2), "output port");
#endif
	    return ;
	}
#endif
        s_push(c_out_port.obj);
#ifdef TOUCH_ARG
        c_out_port.obj = touch_obj(getarg(2));
#else
        c_out_port.obj = getarg(2);
#endif
#ifdef CTHREAD
	obj = getarg(1);
# ifndef SHE
	if (GETtag(obj) == LTAG_FUTURE
	    && ((FUTURE *)ADDRESS(obj))->status != NO_PROCESS)
# endif
	    obj = touch_obj(obj);
	mutex_lock(print_lock);
	PRINTstack_top = sp_reg; /* T.Komiya */
	if (get_sval(print_circle_sym.obj) != LTAG_FALSE) { /* T.Komiya */
	    travel_push_object(obj);
	    for (p = q = PRINTstack_top - 2; p >= sp_reg; p -= 2)
		if (p[1] != LTAG_NIL) {
		    q[0] = p[0];
		    q[1] = LTAG_NIL;
		    q -= 2;
		}
	    PRINTstack_limit = sp_reg = q + 2;
	}
#ifdef PVM3
        printobj(obj, PRINT, 100000,OFF);
#else
        printobj(obj, PRINT, 100000);
#endif
#else
	PRINTstack_top = sp_reg; /* T.Komiya */
	if (get_sval(print_circle_sym.obj) != LTAG_FALSE) { /* T.Komiya */
	    travel_push_object(getarg(1));
	    for (p = q = PRINTstack_top - 2; p >= sp_reg; p -= 2)
		if (p[1] != LTAG_NIL) {
		    q[0] = p[0];
		    q[1] = LTAG_NIL;
		    q -= 2;
		}
	    PRINTstack_limit = sp_reg = q + 2;
	}
#ifdef PVM3
        printobj(getarg(1), PRINT, 100000, OFF);
#else
	printobj(getarg(1), PRINT, 100000);
#endif

#endif
#ifdef TCPIP
	putend ();
#endif
	sp_reg = PRINTstack_top;
        c_out_port.obj = s_pop();
        set_reg(getarg(1));
    } else {
        err_illegal_argument("Too many arguments.");
	return ;
    }
#ifdef CTHREAD
    mutex_unlock(print_lock);
#endif
}

#ifdef PVM3
void Swrite_pvm()                                /* By A243 */
{
    unsigned *p, *q;
    int args;

    args = getargnum();
    if (args == 1) {
	PRINTstack_top = sp_reg; /* T.Komiya */
	if (get_sval(print_circle_sym.obj) != LTAG_FALSE) { /* T.Komiya */
	    travel_push_object(getarg(1));
	    for (p = q = PRINTstack_top - 2; p >= sp_reg; p -= 2)
		if (p[1] != LTAG_NIL) {
		    q[0] = p[0];
		    q[1] = LTAG_NIL;
		    q -= 2;
		}
	    PRINTstack_limit = sp_reg = q + 2;
	}
        printobj(getarg(1), PRINT, 100000, OFF); /* In #ifdef PVM3 */

#ifdef TCPIP
	putend ();
#endif
	sp_reg = PRINTstack_top;
        set_reg(getarg(1));
    } else if(args == 2) {
#ifdef TCPIP
        if (!outputportp (getarg (2)) && !netportp (getarg (2))) {
	    err_illegal_argument_type (getarg(2), "output or network port");
	    return ;
	}
#else
        if (!outputportp(getarg(2))) {
            err_illegal_argument_type(getarg(2), "output port");
	    return ;
	}
#endif
        s_push(c_out_port.obj);
        c_out_port.obj = getarg(2);

	PRINTstack_top = sp_reg; /* T.Komiya */
	if (get_sval(print_circle_sym.obj) != LTAG_FALSE) { /* T.Komiya */
	    travel_push_object_pvm(getarg(1));
	    for (p = q = PRINTstack_top - 2; p >= sp_reg; p -= 2)
		if (p[1] != LTAG_NIL) {
		    q[0] = p[0];
		    q[1] = LTAG_NIL;
		    q -= 2;
		}
	    PRINTstack_limit = sp_reg = q + 2;
	}
        printobj(getarg(1), PRINT, 100000, ON); /* In #ifdef PVM3 */
#ifdef TCPIP
	putend ();
#endif
	sp_reg = PRINTstack_top;
        c_out_port.obj = s_pop();
        set_reg(getarg(1));
    } else {
        err_illegal_argument("Too many arguments.");
	return ;
    }
}
#endif

void Sdisplay()
{ 
    int args;
    unsigned *p, *q;
#ifdef CTHREAD
    int obj, touch_obj();
#endif

    args = getargnum();
    if (args == 1) { 
#ifdef CTHREAD
	obj = getarg(1);
# ifndef SHE
	if (GETtag(obj) == LTAG_FUTURE
	    && ((FUTURE *)ADDRESS(obj))->status != NO_PROCESS)
# endif
	    obj = touch_obj(obj);
	mutex_lock(print_lock);
	PRINTstack_top = sp_reg; /* T.Komiya */
	if (get_sval(print_circle_sym.obj) != LTAG_FALSE) { /* T.Komiya */
	    travel_push_object(obj);
	    for (p = q = PRINTstack_top - 2; p >= sp_reg; p -= 2)
		if (p[1] != LTAG_NIL) {
		    q[0] = p[0];
		    q[1] = LTAG_NIL;
		    q -= 2;
		}
	    PRINTstack_limit = sp_reg = q + 2;
	}
#ifdef PVM3
        printobj(obj, PRINC, 100000, OFF);
#else 
	printobj(obj, PRINC, 100000);
#endif

#else
	PRINTstack_top = sp_reg; /* T.Komiya */
	if (get_sval(print_circle_sym.obj) != LTAG_FALSE) { /* T.Komiya */
	    travel_push_object(getarg(1));
	    for (p = q = PRINTstack_top - 2; p >= sp_reg; p -= 2)
		if (p[1] != LTAG_NIL) {
		    q[0] = p[0];
		    q[1] = LTAG_NIL;
		    q -= 2;
		}
	    PRINTstack_limit = sp_reg = q + 2;
	}
#ifdef PVM3
        printobj(getarg(1), PRINC, 100000, OFF);
#else
        printobj(getarg(1), PRINC, 100000);
#endif

#endif
#ifdef TCPIP
	putend ();
#endif
	sp_reg = PRINTstack_top;
        set_reg(getarg(1));
    } else if (args == 2) { 
#ifdef TCPIP
#ifdef TOUCH_ARG
        if (!outputportp (touch_obj(getarg (2)))
	    && !netportp (touch_obj(getarg (2)))) {
#else
        if (!outputportp (getarg (2)) && !netportp (getarg (2))) {
#endif
#ifdef TOUCH_ARG
	    err_illegal_argument_type (touch_obj(getarg(2)), "output or network port");
#else
	    err_illegal_argument_type (getarg(2), "output or network port");
#endif
	    return ;
	}
#else
#ifdef TOUCH_ARG
        if (!outputportp(touch_obj(getarg(2)))) {
#else
        if (!outputportp(getarg(2))) {
#endif
#ifdef TOUCH_ARG
            err_illegal_argument_type(touch_obj(getarg(2)), "output port");
#else
            err_illegal_argument_type(getarg(2), "output port");
#endif
	    return ;
	}
#endif
        s_push(c_out_port.obj);
#ifdef TOUCH_ARG
        c_out_port.obj = touch_obj(getarg(2));
#else
        c_out_port.obj = getarg(2);
#endif
#ifdef CTHREAD
	obj = getarg(1);
# ifndef SHE
	if (GETtag(obj) == LTAG_FUTURE
	    && ((FUTURE *)ADDRESS(obj))->status != NO_PROCESS)
# endif
	    obj = touch_obj(obj);
	mutex_lock(print_lock);
	PRINTstack_top = sp_reg; /* T.Komiya */
	if (get_sval(print_circle_sym.obj) != LTAG_FALSE) { /* T.Komiya */
	    travel_push_object(obj);
	    for (p = q = PRINTstack_top - 2; p >= sp_reg; p -= 2)
		if (p[1] != LTAG_NIL) {
		    q[0] = p[0];
		    q[1] = LTAG_NIL;
		    q -= 2;
		}
	    PRINTstack_limit = sp_reg = q + 2;
	}
#ifdef PVM3
        printobj(obj, PRINC, 100000, OFF);
#else
        printobj(obj, PRINC, 100000);
#endif
#else
	PRINTstack_top = sp_reg; /* T.Komiya */
	if (get_sval(print_circle_sym.obj) != LTAG_FALSE) { /* T.Komiya */
	    travel_push_object(getarg(1));
	    for (p = q = PRINTstack_top - 2; p >= sp_reg; p -= 2)
		if (p[1] != LTAG_NIL) {
		    q[0] = p[0];
		    q[1] = LTAG_NIL;
		    q -= 2;
		}
	    PRINTstack_limit = sp_reg = q + 2;
	}
#ifdef PVM3
        printobj(getarg(1), PRINC, 100000, OFF);
#else
        printobj(getarg(1), PRINC, 100000);
#endif

#endif
#ifdef TCPIP
	putend ();
#endif
	sp_reg = PRINTstack_top;
        c_out_port.obj = s_pop();
        set_reg(getarg(1));
    } else {
        err_illegal_argument("Too many arguments.");
	return ;
    }
#ifdef CTHREAD
    mutex_unlock(print_lock);
#endif
}


void Snewline()
{ 
    int args;

#ifdef CTHREAD
    mutex_lock(print_lock);
#endif
    args = getargnum();
    if (args == 0) { 
        printf2("\n");
        set_reg(LTAG_T);
    } else if (args == 1) { 
#ifdef TCPIP
#ifdef TOUCH_ARG
        if (!outputportp (touch_obj(getarg (1)))
	    && !netportp (touch_obj(getarg (1)))) {
#else
        if (!outputportp (getarg (1)) && !netportp (getarg (1))) {
#endif
#ifdef CTHREAD
            mutex_unlock(print_lock);
#endif
#ifdef TOUCH_ARG
	    err_illegal_argument_type (touch_obj(getarg(1)), "output or network port");
#else
	    err_illegal_argument_type (getarg(1), "output or network port");
#endif
	    return ;
	}
#else
#ifdef TOUCH_ARG
        if (!outputportp(touch_obj(getarg(1)))) {
#else
        if (!outputportp(getarg(1))) {
#endif
#ifdef CTHREAD
            mutex_unlock(print_lock);
#endif
#ifdef TOUCH_ARG
            err_illegal_argument_type(touch_obj(getarg(1)), "output port");
#else
            err_illegal_argument_type(getarg(1), "output port");
#endif
	    return ;
	}
#endif
        s_push(c_out_port.obj);
#ifdef TOUCH_ARG
        c_out_port.obj = touch_obj(getarg(1));
#else
        c_out_port.obj = getarg(1);
#endif
        printf2("\n");
        c_out_port.obj = s_pop();
        set_reg(LTAG_T);
    } else {
#ifdef CTHREAD
        mutex_unlock(print_lock);
#endif
        err_illegal_argument("Too many arguments.");
	return ;
    }
#ifdef CTHREAD
    mutex_unlock(print_lock);
#endif
}


void Swritech()
{ 
    int args;

#ifdef TOUCH_ARG
    if (GETchar_tag(touch_obj(getarg(1))) != LTAG_CHAR) {
#else
    if (GETchar_tag(getarg(1)) != LTAG_CHAR){
#endif
        err_illegal_argument_type(getarg(1), "character");
	return ;
    }
    args = getargnum();
    if (args == 1) { 
#ifdef TOUCH_ARG
#ifdef PVM3
        printobj(touch_obj(getarg(1)), PRINC, 100000, OFF);
#else
        printobj(touch_obj(getarg(1)), PRINC, 100000);
#endif
#else
#ifdef PVM3
        printobj(getarg(1), PRINC, 100000, OFF);
#else
        printobj(getarg(1), PRINC, 100000);
#endif
#endif
        set_reg(getarg(1));
    } else if (args == 2) { 
#ifdef TCPIP
#ifdef TOUCH_ARG
        if (!outputportp (touch_obj(getarg (2)))
	    && !netportp (touch_obj(getarg (2)))) {
#else
        if (!outputportp (getarg (2)) && !netportp (getarg (2))){
#endif
#ifdef TOUCH_ARG
	    err_illegal_argument_type(touch_obj(getarg(2)), "output or network port");
#else
	    err_illegal_argument_type(getarg(2), "output or network port");
#endif
	    return ;
	}
#else
#ifdef TOUCH_ARG
        if (!outputportp(touch_obj(getarg(2)))) {
#else
        if (!outputportp(getarg(2))){
#endif
#ifdef TOUCH_ARG
            err_illegal_argument_type(touch_obj(getarg(2)), "output port");
#else
            err_illegal_argument_type(getarg(2), "output port");
#endif
	    return ;
	}
#endif
        s_push(c_out_port.obj);
#ifdef TOUCH_ARG
        c_out_port.obj = touch_obj(getarg(2));
#else
        c_out_port.obj = getarg(2);
#endif
#ifdef TOUCH_ARG
#ifdef PVM3
        printobj(touch_obj(getarg(1)), PRINC, 100000, OFF);
#else
        printobj(touch_obj(getarg(1)), PRINC, 100000);
#endif
#else
#ifdef PVM3
        printobj(getarg(1), PRINC, 100000, OFF);
#else
        printobj(getarg(1), PRINC, 100000);
#endif
#endif
        c_out_port.obj = s_pop();
        set_reg(getarg(1));
    } else {
        err_illegal_argument("Too many arguments.");
	return ;
    }
}

void Swriterawch()
{ 
    int args;

#ifdef TOUCH_ARG
    if (GETchar_tag(touch_obj(getarg(1))) != LTAG_CHAR){
#else
    if (GETchar_tag(getarg(1)) != LTAG_CHAR){
#endif
#ifdef TOUCH_ARG
        err_illegal_argument_type(touch_obj(getarg(1)), "character");
#else
        err_illegal_argument_type(getarg(1), "character");
#endif
	return ;
    }
    args = getargnum();
    if (args == 1) { 
#ifdef TOUCH_ARG
#ifdef PVM3
        printobj(touch_obj(getarg(1)), PRINC, 100000, OFF);
#else
        printobj(touch_obj(getarg(1)), PRINC, 100000);
#endif
#else
#ifdef PVM3
        printobj(getarg(1), PRINC, 100000, OFF);
#else
        printobj(getarg(1), PRINC, 100000);
#endif
#endif
        set_reg(getarg(1));
    } else if (args == 2) { 
#ifdef TCPIP
#ifdef TOUCH_ARG
        if (!outputportp (touch_obj(getarg (2)))
	    && !netportp (touch_obj(getarg (2)))) {
#else
        if (!outputportp (getarg (2)) && !netportp (getarg (2))){
#endif
#ifdef TOUCH_ARG
	    err_illegal_argument_type(touch_obj(getarg(2)), "output or network port");
#else
	    err_illegal_argument_type(getarg(2), "output or network port");
#endif
	    return;
	}
#else
#ifdef TOUCH_ARG
        if (!outputportp(touch_obj(getarg(2)))){
#else
        if (!outputportp(getarg(2))){
#endif
#ifdef TOUCH_ARG
            err_illegal_argument_type(touch_obj(getarg(2)), "output port");
#else
            err_illegal_argument_type(getarg(2), "output port");
#endif
	    return ;
	}
#endif
        s_push(c_out_port.obj);
#ifdef TOUCH_ARG
        c_out_port.obj = touch_obj(getarg(2));
#else
        c_out_port.obj = getarg(2);
#endif
#ifdef TOUCH_ARG
#ifdef PVM3
        printobj(touch_obj(getarg(1)), PRINC, 100000, OFF);
#else
        printobj(touch_obj(getarg(1)), PRINC, 100000);
#endif
#else
#ifdef PVM3
        printobj(getarg(1), PRINC, 100000, OFF);
#else
        printobj(getarg(1), PRINC, 100000);
#endif
#endif
	fflush(((ENTITY *)ADDRESS(c_out_port.obj))->port.fp);
        c_out_port.obj = s_pop();
        set_reg(getarg(1));
    } else {
        err_illegal_argument("Too many arguments.");
	return;
    }
}


/*************************/
/*                       */
/*  Original procedures  */
/*                       */
/*************************/

void Sportp()
{
#ifdef TOUCH_ARG
    if (GETtag(touch_obj(getarg(1))) == LTAG_PORT)
#else
    if (GETtag(getarg(1)) == LTAG_PORT)
#endif
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}

void Sstring_portp()
{
#ifdef TOUCH_ARG
    if (GETtag(touch_obj(getarg(1))) == LTAG_PORT
        && (((PORT *)ADDRESS(getarg(1)))->kind == STRING_OUTPUT
            || ((PORT *)ADDRESS(getarg(1)))->kind == STRING_INPUT))
#else
    if (GETtag(getarg(1)) == LTAG_PORT
        && (((PORT *)ADDRESS(getarg(1)))->kind == STRING_OUTPUT
            || ((PORT *)ADDRESS(getarg(1)))->kind == STRING_INPUT))
#endif
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}


#ifdef THINK_C
void Sfile_existsp()
{ SOBJ strobj;
  FILE *stream;

  char *strobj_to_str();

#ifdef TOUCH_ARG
  strobj.obj = touch_obj(getarg(1));
#else
  strobj.obj = getarg(1);
#endif
  if(GETstr_tag(strobj.obj) != LTAG_STRING)
  { if(GETsym_tag(strobj.obj) == LTAG_SYMBOL)
      strobj.obj = ((SYMBOL *)ADDRESS(strobj.obj))->sym_name.obj;
    else {
	err_illegal_argument_type(strobj.obj, "string or symbol");
	return ;
    }
  }
  if((stream =fopen(strobj_to_str(strobj.obj), "r")) == NULL)
    set_reg(LTAG_FALSE);
  else 
  { fclose(stream);
    set_reg(LTAG_T);
  }
}

#else

void Sfile_existsp()
{
    extern int errno;
    SOBJ strobj;
    struct stat st;
    int ret;
    char    *strobj_to_str();

#ifdef TOUCH_ARG
    strobj.obj = touch_obj(getarg(1));
#else
    strobj.obj = getarg(1);
#endif
    if (GETstr_tag(strobj.obj) != LTAG_STRING) { 
        if (GETsym_tag(strobj.obj) == LTAG_SYMBOL)
            strobj.obj = ((SYMBOL * )ADDRESS(strobj.obj))->sym_name.obj;
        else{
            err_illegal_argument_type(strobj.obj, "string or symbol");
	    return ;
	}
	
    }
    if (stat(strobj_to_str(strobj.obj), &st) == 0 || errno != ENOENT)
	if (st.st_mode & S_IFDIR)
	    set_reg(LTAG_FALSE);
	else
	    set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}

void Sfile_is_directoryp()
{
    extern int errno;
    SOBJ strobj;
    struct stat st;
    int ret;
    char    *strobj_to_str();

#ifdef TOUCH_ARG
    strobj.obj = touch_obj(getarg(1));
#else
    strobj.obj = getarg(1);
#endif
    if (GETstr_tag(strobj.obj) != LTAG_STRING) { 
        if (GETsym_tag(strobj.obj) == LTAG_SYMBOL)
            strobj.obj = ((SYMBOL * )ADDRESS(strobj.obj))->sym_name.obj;
        else{
            err_illegal_argument_type(strobj.obj, "string or symbol");
	    return ;
	}
	
    }
    if (stat(strobj_to_str(strobj.obj), &st) == 0 || errno != ENOENT)
	if (st.st_mode & S_IFDIR)
	    set_reg(LTAG_T);
	else
	    set_reg(LTAG_FALSE);
    else
        set_reg(LTAG_FALSE);
}

void Sfile_is_readablep()
{
    extern int errno;
    SOBJ strobj;
    struct stat st;
    int ret;
    char    *strobj_to_str();

#ifdef TOUCH_ARG
    strobj.obj = touch_obj(getarg(1));
#else
    strobj.obj = getarg(1);
#endif
    if (GETstr_tag(strobj.obj) != LTAG_STRING) { 
        if (GETsym_tag(strobj.obj) == LTAG_SYMBOL)
            strobj.obj = ((SYMBOL * )ADDRESS(strobj.obj))->sym_name.obj;
        else{
            err_illegal_argument_type(strobj.obj, "string or symbol");
	    return ;
	}
	
    }
    if (access(strobj_to_str(strobj.obj), R_OK) == 0)
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}

void Sfile_is_writablep()
{
    extern int errno;
    SOBJ strobj;
    struct stat st;
    int ret;
    char    *strobj_to_str();

#ifdef TOUCH_ARG
    strobj.obj = touch_obj(getarg(1));
#else
    strobj.obj = getarg(1);
#endif
    if (GETstr_tag(strobj.obj) != LTAG_STRING) { 
        if (GETsym_tag(strobj.obj) == LTAG_SYMBOL)
            strobj.obj = ((SYMBOL * )ADDRESS(strobj.obj))->sym_name.obj;
        else{
            err_illegal_argument_type(strobj.obj, "string or symbol");
	    return ;
	}
	
    }
    if (access(strobj_to_str(strobj.obj), W_OK) == 0)
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}

void Sfile_is_executablep()
{
    extern int errno;
    SOBJ strobj;
    struct stat st;
    int ret;
    char    *strobj_to_str();

#ifdef TOUCH_ARG
    strobj.obj = touch_obj(getarg(1));
#else
    strobj.obj = getarg(1);
#endif
    if (GETstr_tag(strobj.obj) != LTAG_STRING) { 
        if (GETsym_tag(strobj.obj) == LTAG_SYMBOL)
            strobj.obj = ((SYMBOL * )ADDRESS(strobj.obj))->sym_name.obj;
        else{
            err_illegal_argument_type(strobj.obj, "string or symbol");
	    return ;
	}
	
    }
    if (access(strobj_to_str(strobj.obj), X_OK) == 0)
        set_reg(LTAG_T);
    else
        set_reg(LTAG_FALSE);
}

#endif

void Sflush_port()
{ 
    SOBJ port;

#ifdef TOUCH_ARG
    port.obj = touch_obj(getarg(1));
#else
    port.obj = getarg(1);
#endif
    if (!outputportp(port.obj)){
        err_illegal_argument_type(port.obj, "output port");
	return ;
    }
    set_reg(flush_port(port.obj));
}


void Sshow_port_list()
{
    printobj_con(portlist, PRINT, 5);
    print_con("\n");
    set_reg(LTAG_T);
}
