/*
 * makeobj2.c - 
 */

/*
 * $Id: makeobj2.c,v 1.2 1998/10/29 05:11:57 shige Exp $
 */

/**************************************************/
/*                                                */
/*  File Name : makeobj2.c                        */
/*    written by Yass., Myama and Komiya.         */
/*  Update    : Yass.  Sep. 18 '90                */
/*              Yass.  Sep. 10 '90                */
/*              Yass.  Aug.  8 '90                */
/*              Yass.  Jul. 27 '90                */
/*              Yass.  Jul. 25 '90                */
/*              Yass.  Jul. 24 '90                */
/*              Yass.  Jul. 18 '90                */
/*              Yass.  Jul. 17 '90                */
/*              Yass.  Jul.  9 '90                */
/*              Komiya Oct. 26 '90                */
/*                                                */
/*    modified for ATT3B2 by Mikio Yamamoto       */
/*                                                */
/*    Internal routines for making scheme object  */
/*                                                */
/**************************************************/

static char *RCSid="$Id: makeobj2.c,v 1.2 1998/10/29 05:11:57 shige Exp $";

#include "scheme.h"

/*
  make a cons object.
*/

unsigned mk_cons(car, cdr)  /*  Yass. Jul. 9 '90  */
unsigned car, cdr;
{ 
    ENTITYP new_obj;
    no_cons++;

    s_push(cdr);
    s_push(car);

    new_obj = (ENTITYP)memget(sizeof(CARCDR));
    new_obj->cell.car.obj = s_pop();
    new_obj->cell.cdr.obj = s_pop();
    return(LTAG_CONS | SSERDDA(new_obj));
}


/*
  make an entity pointer for N cons objects.
    each cons object was linked incremental.
      but entitise are empty.
        returnning pointer is for top cell.
*/

ENTITYP mk_nconsp(len)  /*  Yass. Jul. 12 '90  */
int len;
{ 
    CARCDR * new_obj, *cell1, *cell2;
    int i;

    no_cons += len;
    cell1 = cell2 = new_obj = (CARCDR * )memget(sizeof(CARCDR) * len);
    for (i = 0 ; i < len - 1 ; i++) { 
        cell2 = cell1 + 1;
        cell1->car.obj       = LTAG_NIL;
        cell1->cdr.obj       = LTAG_CONS | SSERDDA(cell2);
        cell1++;
    }
    cell1->cdr.obj = LTAG_NIL;
    return((ENTITYP)new_obj);
}

/*
  make a weakpair object.
*/

unsigned mk_wp(car, cdr)  /*  Yass. Sep. 12 '90  */
unsigned car, cdr;      /*  Komiya. Oct. 26 '90 */
{ 
    unsigned *new_obj;

    s_push(car);
    s_push(cdr);

    new_obj = (unsigned *)memget(20);
    *new_obj = LTAG_BLOCK1 | 16;
    *(new_obj + 1) = s_pop();
    *(new_obj + 2) = LTAG_BLOCK2 | 8;
    *(new_obj + 3) = s_pop();
    *(new_obj + 4) = get_sval(wplist.obj);
    set_sval(wplist.obj, LTAG_WEAKPAIR | SSERDDA(new_obj));

    return(LTAG_WEAKPAIR | SSERDDA(new_obj));
}


/*
  make a fixnum object.
*/

unsigned mk_fix(val)  /*  Yass. Jul. 9 '90  */
int val;
{
    return(LTAG_FIXNUM | IMMNUM(val << 2));
}


/*
  make an ascii or a kanji character object.
*/

unsigned mk_ch(ch1, ch2)  /*  Yass. Jul. 27 '90  */
char    ch1, ch2;
{
    if (ch1 == '\0')
        return(LTAG_ACHAR | (((int)ch2) << 16) & 0x00ff0000);
    else
        return(LTAG_KCHAR | ((((int)ch1) << 10) & 0x0003fc00) | ((((int)ch2) << 2) & 0x00003fc));
}


/*
  make an ascii or a kanji string object.
*/

unsigned mk_string(sym_str_flag, len, s_buf, offset)
unsigned sym_str_flag;
int len, offset;
char    *s_buf;
{
    unsigned mk_str_gcok();
    char    *s_buf2;
    int i;

    no_block2++;

    s_buf2 = s_buf + offset;
    for (i = 0; i < len; i++)
        if (KANJI_p(*(s_buf2++))) 
            goto kanji;
kanji:
    if (i < len)
        return(mk_str_gcok(sym_str_flag, K_STRING, len, s_buf, offset));
    else
        return(mk_str_gcok(sym_str_flag, A_STRING, len, s_buf, offset));
}


unsigned mk_str(sym_str_flag, kanji_flag, len, s_buf) /*  Yass. Jul. 25 '90  */
unsigned sym_str_flag;
int kanji_flag, len;
char    *s_buf;
{ 
    ENTITYP new_obj;
    int b_len, i, j;
    char    ch;

    no_block2++;

    b_len = 4 + sizeof(long) + sizeof(long) + 
        ((((sizeof(char) *len + 1) * ((kanji_flag == K_STRING) ? 2 : 1) + 3) >> 2) << 2);
    new_obj = (ENTITYP)memget(b_len);
    new_obj->str.head    = LTAG_BLOCK2 | (unsigned)(b_len - 4);
    new_obj->str.str_len = len;
    new_obj->str.str_kind = kanji_flag;
    if (kanji_flag == K_STRING) /* copy kanji string to scheme object area from buffer */ { 
        len *= 2;
        for (i = 0 ; i < len ; ) { 
            ch = *(s_buf++);
            if (KANJI_p(ch) || ch == '\0') {    
                (*(((char *)new_obj) + 12 + i)) = ch;
                i++;
                (*(((char *)new_obj) + 12 + i)) = *(s_buf++);
            } else
             { 
                (*(((char *)new_obj) + 12 + i)) = '\0';
                i++;
                (*(((char *)new_obj) + 12 + i)) = ch;
            }
            i++;
        }
        (*(((char *)new_obj) + 12 + len)) = '\0';
        (*(((char *)new_obj) + 12 + len + 1)) = '\0';
    } else /* copy ascii string to scheme object area from buffer */  { 
        for (i = 0 ; i < len ; i++)
            (*(((char *)new_obj) + 12 + i)) = *(s_buf++);
        (*(((char *)new_obj) + 12 + len)) = '\0';
    }
    return(LTAG_STRING | sym_str_flag | SSERDDA(new_obj));
}


unsigned mk_str_gcok(sym_str_flag, kanji_flag, len, s_buf, offset)
unsigned sym_str_flag;
int kanji_flag, len, offset;
char    *s_buf;
{
    ENTITYP new_obj;
    int b_len, i, j;
    char    ch;

    no_block2++;

    b_len = 4 + sizeof(long) + sizeof(long) + 
        ((((sizeof(char) *len + 1) * ((kanji_flag == K_STRING) ? 2 : 1) + 3) >> 2) << 2);
    if (s_buf == strbuf) {
        new_obj = (ENTITYP)memget(b_len);
        s_buf = s_buf + offset;
    } else {
        s_push(SSERDDA(s_buf) | LTAG_STRING);
        new_obj = (ENTITYP)memget(b_len);
        s_buf = ((char *)ADDRESS(s_pop())) + offset;
    }
    new_obj->str.head    = LTAG_BLOCK2 | (unsigned)(b_len - 4);
    new_obj->str.str_len = len;
    new_obj->str.str_kind = kanji_flag;
    if (kanji_flag == K_STRING) {/* copy kanji string to scheme object area from buffer */
        len *= 2;
        for (i = 0 ; i < len ; ) { 
            ch = *(s_buf++);
            if (KANJI_p(ch) || ch == '\0') {    
                (*(((char *)new_obj) + 12 + i)) = ch;
                i++;
                (*(((char *)new_obj) + 12 + i)) = *(s_buf++);
            } else
             { 
                (*(((char *)new_obj) + 12 + i)) = '\0';
                i++;
                (*(((char *)new_obj) + 12 + i)) = ch;
            }
            i++;
        }
        (*(((char *)new_obj) + 12 + len)) = '\0';
        (*(((char *)new_obj) + 12 + len + 1)) = '\0';
    } else /* copy ascii string to scheme object area from buffer */  { 
        for (i = 0 ; i < len ; i++)
            (*(((char *)new_obj) + 12 + i)) = *(s_buf++);
        (*(((char *)new_obj) + 12 + len)) = '\0';
    }
    return(LTAG_STRING | sym_str_flag | SSERDDA(new_obj));
}

/*
  make an empty string object.
*/

unsigned mk_estr(sym_str_flag, kanji_flag, len)  /*  Yass. Sep. 10 '90  */
unsigned sym_str_flag;
int kanji_flag, len;
{ 
    ENTITYP new_obj;
    int b_len, i, j;
    char    ch;

    no_block2++;

    b_len = 4 + sizeof(long) + sizeof(long) + 
        ((((sizeof(char) *len + 1) * ((kanji_flag == K_STRING) ? 2 : 1) + 3) >> 2) << 2);
    new_obj = (ENTITYP)memget(b_len);
    new_obj->str.head    = LTAG_BLOCK2 | (unsigned)(b_len - 4);
    new_obj->str.str_len = len;
    new_obj->str.str_kind = kanji_flag;
    return(LTAG_STRING | sym_str_flag | SSERDDA(new_obj));
}


/*
  make a symbol object.
*/

unsigned mk_sym(name, kind)  /*  Yass. Jul. 24 '90  */
unsigned name, kind;
{ 
    ENTITYP new_obj;
    no_block1++;

    s_push(name);

    new_obj = (ENTITYP)memget(sizeof(SYMBOL));
    new_obj->sym.head         = LTAG_BLOCK1 | (unsigned)16;
    new_obj->sym.sym_val.obj  = unbound_obj.obj;
    new_obj->sym.sym_name.obj = s_pop();
    new_obj->sym.hash_lk.obj  = LTAG_NIL;
    new_obj->sym.proplist.obj = LTAG_NIL;
    return(SSERDDA(new_obj) | kind);
}

/*
  make a byte code closure object.
*/

unsigned mk_bcc(flag, cnst, fname, src, env, body, arg_info, st_addr)  /*  Yass. Jul. 24 '90  */
unsigned flag, cnst, fname, src, env, body;
int arg_info, st_addr;
{ 
    ENTITYP new_obj;

    s_push(body);
    s_push(env);
    s_push(src);
    s_push(fname);
    s_push(cnst);

    new_obj = (ENTITYP)memget(sizeof(BCCLOS));
    new_obj->bcc.head           = LTAG_BLOCK1 | (unsigned)32;
    new_obj->bcc.const_vec.obj  = s_pop();
    new_obj->bcc.fun_name.obj   = s_pop();
    new_obj->bcc.source.obj     = s_pop();
    new_obj->bcc.env.obj        = s_pop();
    new_obj->bcc.body.obj       = s_pop();
    new_obj->bcc.block.com      = LTAG_BLOCK2 | (unsigned)8;
    new_obj->bcc.arg_info       = arg_info;
    new_obj->bcc.start_addr     = st_addr;

    return(flag | SSERDDA(new_obj)); /* must use flag to be */
}

/*
  make a native code closure object.
*/

unsigned mk_ncc()
{                               /* by T.Komiya */
    ENTITYP new_obj;
    unsigned *entity, *weakpair;

    new_obj = (ENTITYP)memget(sizeof(NCCLOS));
    new_obj->ncc.head           = LTAG_BLOCK1 | (unsigned)32;
    new_obj->ncc.const_vec.obj  = LTAG_NIL;
    new_obj->ncc.fun_name.obj   = LTAG_NIL;
    new_obj->ncc.source.obj     = LTAG_NIL;
    new_obj->ncc.env.obj        = LTAG_NIL;
    new_obj->ncc.body.obj       = LTAG_NIL;
    new_obj->ncc.block.com      = LTAG_BLOCK2 | (unsigned)8;
    new_obj->ncc.arg_info       = NULL;
    new_obj->ncc.start_addr     = NULL;

    /* link to native-code-closure-list */
    reg1 = (LTAG_NCLOSURE | SSERDDA(new_obj));
    weakpair = (unsigned *)memget(20);
    new_obj = (ENTITYP)ADDRESS(reg1);
    *weakpair = LTAG_BLOCK1 | 16;
    *(weakpair + 1) = get_sval(ncclist.obj);
    *(weakpair + 2) = LTAG_BLOCK2 | 8;
    *(weakpair + 3) = reg1;
    *(weakpair + 4) = (unsigned)get_sval(wplist.obj);
    set_sval(wplist.obj, LTAG_WEAKPAIR | SSERDDA(weakpair));

    set_sval(ncclist.obj, LTAG_WEAKPAIR | SSERDDA(weakpair));
    reg1 = LTAG_NIL;

    return((unsigned)new_obj);
}

/*
  make a continuation object.
*/

#ifdef CTHREAD
unsigned mk_cont(body, opt)  /*  Yass. Jul. 9 '90  */
unsigned body, opt;
#else
unsigned mk_cont(body)  /*  Yass. Jul. 9 '90  */
unsigned body;
#endif
{ 
    ENTITYP new_obj;

    no_block1++;

#ifdef CTHREAD
    s_push(opt);
#endif
    s_push(body);

    new_obj = (ENTITYP)memget(sizeof(CONTIN));
    new_obj->cnt.head     = LTAG_BLOCK1 | (unsigned)(sizeof(CONTIN) - 4);
    new_obj->cnt.body.obj = s_pop();
#ifdef CTHREAD
    new_obj->cnt.opt.obj = s_pop();
#endif
#ifdef CALLIOC
    new_obj->cnt.count.obj = mk_fix(((unsigned *)stack_bottom)[5]);
#endif

    return(LTAG_CONTINUATION | SSERDDA(new_obj));
}

#ifdef CALLIOC
unsigned mk_ontcont(bcbody, bottom)
unsigned bcbody, bottom;
{
    ENTITYP new_obj;

    no_block1++;

    s_push(bcbody);
    new_obj = (ENTITYP)memget(sizeof(IOC));
    new_obj->ioc.head     = LTAG_BLOCK1 | (unsigned)(sizeof(IOC) -4);
    new_obj->ioc.bcbody.obj = s_pop();
    new_obj->ioc.bottom.obj = bottom;
    return(LTAG_IOC | SSERDDA(new_obj));
}
#endif

/*
 *  make a promis object.
 *  by Myama. 
 */
unsigned mk_promise(body, env, start_address)
/* SOBJ body, env; */
unsigned *body, *env;
int start_address;
{
    PROMISE * pro;

/*    s_push(env.obj);
    s_push(body.obj); */
    s_push(env);
    s_push(body);
    pro = (PROMISE * )memget(sizeof(PROMISE));
    *(((unsigned *)pro)) = LTAG_BLOCK1 | 12;
    pro->body_result.obj = s_pop();
    pro->start_addr.obj = mk_fix(start_address);
    pro->env.obj = s_pop();
    return(LTAG_PROMISE | SSERDDA(pro));
}


/*
  make a bignum object.
*/

unsigned mk_bign(init)  /*  Yass. Sep. 18 '90  */
int init;
{ 
    ENTITYP new_obj;

    no_block1++;
    no_block2++;

    new_obj = (ENTITYP)memget(sizeof(BIGNUM));
    new_obj->bnum.head      = LTAG_BLOCK1 | (unsigned)12;
    new_obj->bnum.next.obj  = LTAG_NIL;
    new_obj->bnum.block.obj = LTAG_BLOCK2 | 0x4;
    new_obj->bnum.val       = init;

    return(LTAG_BIGNUM | SSERDDA(new_obj));
}

/*
  make a short float or float object.
*/

#define LFLT_SIGN(obj)		(0x80000000 & (obj).i.h)
#define LFLT_EXP(obj)		(0x7ff00000 & (obj).i.h)
#define LFLT_MANT_H(obj)	(0x000ffff0 & (obj).i.h)
#define LFLT_MANT_M(obj)	(0x0000000f & (obj).i.h)
#define LFLT_MANT_L(obj)	((obj).i.l)

unsigned mk_flt(value)  /*  Yass. Sep. 7 '90  */
double  value;
{ 
    ENTITYP new_obj;
    SOBJ    sf_obj;
    FLT_TMP tmp;
    unsigned sign, exp, mant_h, mant_m, mant_l;

    if (value == 0.0) {
        sf_obj.sflt = LTAG_SFLOAT;
        return(sf_obj.obj);
    }

    tmp.d = value;
    sign = LFLT_SIGN(tmp);
    exp  = LFLT_EXP(tmp);
    mant_h = LFLT_MANT_H(tmp);
    mant_m = LFLT_MANT_M(tmp);
    mant_l = LFLT_MANT_L(tmp);
    if (mant_m == 0 && mant_l == 0 && 
        ((0x40000000 <= exp && exp <= 0x4ff00000)
         || (0x3ff00000 >= exp && exp >= 0x30100000))) { 
        if (0x40000000 <= exp && exp <= 0x4ff00000)
            exp = (exp & 0xff00000) | 0x10000000;
        else
            exp = exp & 0xff00000;
        sf_obj.sflt = LTAG_SFLOAT | (unsigned)(sign >> 4)
                                  | (unsigned)(exp >> 2)
                                  | (unsigned)(mant_h >> 2);
        return(sf_obj.obj);
    }

    sign =  sizeof(FLOAT);                 /* By T.Komiya */
    new_obj = (ENTITYP)memget(sign);
    new_obj->flt.head = LTAG_BLOCK2 | (unsigned)(sign - 4);

#if 0
    new_obj->flt.data = (sign - 1) >> 2;   /* for word alignment */
    new_obj->flt.gc   = 0;
#endif
#ifdef EIGHT_BYTE_ALIGNMENT_DOUBLE /* T.Komiya */
    {
	unaligned_double tmp;

	tmp.f = value;
	new_obj->flt.val.b = tmp.b;
    }
#else
    new_obj->flt.val  = value;
#endif

    return(LTAG_FLOAT | SSERDDA(new_obj));
}


/*
  make a fraction object.
*/

unsigned mk_frac(nume, deno)  /*  Yass. Jul. 9 '90  */
unsigned nume, deno;
{ 
    ENTITYP new_obj;

    s_push(deno);
    s_push(nume);

    new_obj = (ENTITYP)memget(sizeof(FRACTION));
    new_obj->frac.head     = LTAG_BLOCK1 | (unsigned)8;
    new_obj->frac.nume.obj = s_pop();
    new_obj->frac.deno.obj = s_pop();

    return(LTAG_FRACTION | SSERDDA(new_obj));
}

/*
  make a complex object.
*/

unsigned mk_cplx(real, imag)  /*  Yass. Jul. 9 '90  */
unsigned real, imag;
{ 
    ENTITYP new_obj;

    s_push(imag);
    s_push(real);

    new_obj = (ENTITYP)memget(sizeof(COMPLEX));
    new_obj->cplx.head     = LTAG_BLOCK1 | (unsigned)8;
    new_obj->cplx.real.obj = s_pop();
    new_obj->cplx.imag.obj = s_pop();

    return(LTAG_COMPLEX | SSERDDA(new_obj));
}


/*
  make a vector object.
    but entity is empty.
*/

unsigned mk_evec(len)  /*  Yass. Jul. 9 '90  */
int len;
{ 
    ENTITYP new_obj;

    no_block1++;

    if (len == 0)
        return(LTAG_NILVECTOR);
    new_obj = (ENTITYP)memget((len + 1) << 2);
    new_obj->vec.head = LTAG_BLOCK1 | (unsigned)(len << 2);

    return(LTAG_VECTOR | SSERDDA(new_obj));
}


/*
  make an entity pointer for a vector object.
    but entity is empty.
*/

ENTITYP mk_evecp(len)  /*  Yass. Jul. 9 '90  */
int len;
{ 
    ENTITYP new_obj;
    no_block1++;

    if (len == 0){
        bokkan("length must be more than zero. (mk_evecp())");
    }
    new_obj = (ENTITYP)memget((len + 1) << 2);
    new_obj->vec.head  = LTAG_BLOCK1 | (unsigned)(len << 2);

    return(new_obj);
}


/*
  make an entity pointer for a structure object.
    but entity is empty.
*/

ENTITYP mk_estructp(sym, len)
unsigned sym;
int len;
{
    ENTITYP new_obj;

    s_push(sym);
    new_obj = (ENTITYP)memget((len + 2) << 2);
    new_obj->struc.head = LTAG_BLOCK1 | (unsigned)((len + 1) << 2);
    new_obj->struc.type.obj = s_pop();

    return(new_obj);
}


/*
 * make a string port object.
 *
 */

unsigned mk_strport(kind, str)
int kind;
unsigned str;
{ 
    ENTITYP new_obj;

    s_push(str);
    new_obj = (ENTITYP)memget(sizeof(PORT));
    str = s_pop();
    new_obj->port.head           = LTAG_BLOCK1 | (unsigned)24;
    if (GETtag(*((unsigned *)ADDRESS(str))) == LTAG_BLOCK2)
        new_obj->port.slot.obj     = str;
    else
        new_obj->port.slot.obj     = *(((unsigned *)ADDRESS(str)) + 1);
    new_obj->port.block.com      = LTAG_BLOCK2 | (unsigned)16;
    if (kind == STRING_INPUT)
        new_obj->port.fp           = (FILE * )12;
    else
        new_obj->port.fp           = (FILE * )4;
    new_obj->port.kind           = kind;
    if (kind == STRING_OUTPUT) {
	new_obj->port.slot_size = 
            (int)IMM(*((unsigned *)ADDRESS(new_obj->port.slot.obj))) + 4;
    }

    return(SSERDDA(new_obj) | LTAG_PORT);
}
