/*
 * printer.c - 
 */

/*
 * $Id: printer.c,v 1.6 2014/10/28 02:22:55 komiya Exp $
 *
 *  -------
 *  PRINTER
 *  -------
 *
 *  File Name : printer.c
 *
 *  written by Mikio Yamamoto.  Feb. '90
 *
 *  extended to all numbers
 *    by Yass.  Aug. '90
 *
 */

static char *RCSid="$Id: printer.c,v 1.6 2014/10/28 02:22:55 komiya Exp $";

#include "scheme.h"

#ifdef THINK_C
#include <string.h>
#else
#include <strings.h>
#endif

#ifdef THINK_C
#include <signal.h>
#include <Events.h>
#endif

#ifdef TCPIP
#include "inet.h"
#endif

unsigned *PRINTstack_top, *PRINTstack_limit;		/* T.Komiya */

putc2(ch)
char	ch;
{
    PORT * port_obj;
    char    str[3];

    port_obj = (PORT * )ADDRESS(c_out_port.obj);
    if (transcript_flag == ON) {
        str[0] = ch;
        str[1] = '\0';
#ifdef TCPIP
	if (netportp (c_out_port.obj))
	  print_transcript (fdopen ((int) port_obj->fp, "w"), str);
	else
#endif
        print_transcript(port_obj->fp, str);
    }

    port_obj->notfirst = !(ch == '\n');

    switch (port_obj->kind) {
    case OUTPUT        :
#ifdef NIHONGO
	kputc(ch, port_obj);
#else
	putc(ch, port_obj->fp);
#endif
        break;
    case STRING_OUTPUT :
        putc_to_strport(ch, port_obj);
        break;
#ifdef TCPIP
    case TCP_STREAM:
    case UDP_DGRAM:
#ifdef NIHONGO
	kputc(ch, port_obj);
#else
	if (sendto ((int) port_obj->fp, &ch, 1, 0,
		    getnetaddr (c_out_port.obj),
		    sizeof (struct sockaddr_in)) < 0)
	  bokkan (";sendto failed (at putc2)");
#endif /* NIHONGO */
	break;
#endif
    case CLOSE:
        err_error("Broken Pipe.");
    default :
        printf("Internal error : putc2\n");
        break;
    }
}


putc_to_strport(ch, port_obj)
char    ch;
PORT *port_obj;
{
    int newsize, size;
    unsigned *new_block2;
    unsigned *cpp1, *cpp2;

    size = port_obj->slot_size;
    if ((int)port_obj->fp >= size) {
        s_push(SSERDDA(port_obj) | LTAG_PORT);
        if (size >= STRLEN_MAX)
            bokkan("cannot extend string.");
        if (size * 2 > STRLEN_MAX)
            newsize = STRLEN_MAX;
        else
            newsize = size * 2;
        new_block2 = (unsigned *)Pgetblock2(newsize);
        cpp2 = new_block2 + 1;
        port_obj = (PORT * )ADDRESS(s_pop());
	port_obj->slot_size = newsize;
        cpp1 = ((unsigned *)ADDRESS(port_obj->slot.obj)) + 1;
        for (size -= 4; size > 0; size -= 4)
            *(cpp2++) = *(cpp1++);
        port_obj->slot.obj = SSERDDA(new_block2) | LTAG_STRING;
    }
    *(((char *)ADDRESS(port_obj->slot.obj)) + (int)port_obj->fp) = ch;
    port_obj->fp = (FILE * )((int)(port_obj->fp) + 1);
}


printf2(str)
char    *str;
{
    PORT * port_obj;
    char    *strp;
    int	    i;

    port_obj = (PORT * )ADDRESS(c_out_port.obj);
    switch (port_obj->kind) {
    case OUTPUT        :
#ifndef NIHONGO /* putc2 to dabutterunode iranai */
        if (transcript_flag == ON)
            print_transcript(port_obj->fp, str);
#endif /* NIHONGO */

#ifdef NIHONGO
        for (strp = str; *strp != '\0'; strp++)
            putc2(*strp);
#else
        fprintf(port_obj->fp, "%s", str);
#endif
        break;
    case STRING_OUTPUT :
        for (strp = str; *strp != '\0'; strp++)
            putc2(*strp);
        break;
#ifdef TCPIP
    case TCP_STREAM:
    case UDP_DGRAM:
	/* write ((int) port_obj->fp, str, strlen (str)); */
#ifdef NIHONGO
	for (i = 0; i < strlen(str); i++)
		kputc(str[i], port_obj);
#else
	sendto ((int) port_obj->fp, str, strlen (str), 0,
		getnetaddr (c_out_port.obj), sizeof (struct sockaddr_in));
#endif /* NIHONGO */
	break;
#endif
    default :
        printf("Internal error : printf2\n");
        break;
    }
}


print_con(str)
char    *str;
{
    char    *strp;

#ifndef NIHONGO /* putc2 to dabutterunode iranai */
    if (transcript_flag == ON)
        fprintf(transcript_fp, "%s", str);
#endif /* NIHONGO */

#ifdef NIHONGO   
    s_push(c_out_port.obj);
    c_out_port.obj = stdout_port.obj;
    printf2(str);
    c_out_port.obj = s_pop();
#else
    printf(str);
#endif    
}


printobj_con(obj, flag, depth)
int obj, flag, depth;
{
    void printobj(int, int, int);
    s_push(c_out_port.obj);
    c_out_port.obj = stdout_port.obj;
#ifdef PVM3
    printobj(obj, flag, depth, OFF);
#else
    printobj(obj, flag, depth);
#endif
    c_out_port.obj = s_pop();
}


print_transcript(fp, str)
FILE *fp;
char    *str;
{
    if ((fp == stdin) || (fp == stdout))
        fprintf(transcript_fp, "%s", str);
}

#ifdef PVM3
printobj(print_obj, flag, depth, pvm_flag)
int print_obj, flag, depth, pvm_flag;
#else 
void printobj(print_obj, flag, depth)
int print_obj, flag, depth;
#endif
{
    SOBJ obj, tmp;
    char    ch, str[30];
    int kind, length, i, r;
    unsigned *block1p, *p;
    FILE * file;
    int str_obj;
#ifdef CTHREAD
    int touch_obj();
#endif

    double  flt_to_double();
    double  obj_to_double();

#ifdef THINK_C
    KeyMap mykey;

    GetKeys(mykey);
    if ((mykey[1] & 0x8000) && (mykey[1] & 0x800000))
        raise(SIGINT);
#endif

#ifdef PVM3
LOOP :
#endif
    s_push(obj.obj = print_obj);
    switch (GETtag(*top_val())) {
    case LTAG_CONS:		/* T.Komiya */
/*
        if (*top_val() == eof_obj.obj) {
            printf2("#<end-of-file>");
            break;
        }
*/
        if (*top_val() == unbound_obj.obj) {
            printf2("#<unbound symbol>");
            break;
        }

/*        tmp.obj = CARobj(*top_val()); */

	if (get_sval(print_circle_sym.obj) != LTAG_FALSE) {
	    for (p = PRINTstack_top - 2; p >= PRINTstack_limit; p -= 2)
		if (*top_val() == *p) {
		    if (p[1] != LTAG_NIL) {
			printf2("#");
			sprintf(str, "%d", (PRINTstack_top - (p+2))/2);
			printf2(str);
			printf2("#");
			s_pop();
			return;
		    } else {
			printf2("#");
			sprintf(str, "%d", (PRINTstack_top - (p+2))/2);
			printf2(str);
			printf2("=");
			p[1] = LTAG_T;
			break;
		    }
		}
	}
        if (CARobj(*top_val()) == quotesym.obj)
            if (GETtag(CDRobj(*top_val())) == LTAG_CONS
                && GETtag(CDRobj(CDRobj(*top_val()))) == LTAG_NIL) {
                printf2("'");
#ifdef PVM3
                printobj(CARobj(CDRobj(*top_val())), flag, depth, pvm_flag);
#else
                printobj(CARobj(CDRobj(*top_val())), flag, depth);
#endif
                break;
            }
        if (CARobj(*top_val()) == qquotesym.obj)
            if (GETtag(CDRobj(*top_val())) == LTAG_CONS
                && GETtag(CDRobj(CDRobj(*top_val()))) == LTAG_NIL) {
                printf2("`");
#ifdef PVM3
                printobj(CARobj(CDRobj(*top_val())), flag, depth, pvm_flag);
#else
                printobj(CARobj(CDRobj(*top_val())), flag, depth);
#endif
                break;
            }
        if (CARobj(*top_val()) == commasym.obj)
            if (GETtag(CDRobj(*top_val())) == LTAG_CONS
                && GETtag(CDRobj(CDRobj(*top_val()))) == LTAG_NIL) {
                printf2(",");
#ifdef PVM3
                printobj(CARobj(CDRobj(*top_val())), flag, depth, pvm_flag);
#else
                printobj(CARobj(CDRobj(*top_val())), flag, depth);
#endif
                break;
            }
        if (CARobj(*top_val()) == atsym.obj)
            if (GETtag(CDRobj(*top_val())) == LTAG_CONS
                && GETtag(CDRobj(CDRobj(*top_val()))) == LTAG_NIL) {
                printf2(",@");
#ifdef PVM3
                printobj(CARobj(CDRobj(*top_val())), flag, depth, pvm_flag);
#else
                printobj(CARobj(CDRobj(*top_val())), flag, depth);
#endif
                break;
            }

        if (depth <= 0)  /* normal pair */
            printf2("( ... )");
        else {
	    printf2("(");
	    while (1) {
                /*
		s_push(obj.obj);
		*/
#ifdef CTHREAD
#ifdef PVM3
		printobj(CARobj(touch_obj(*top_val())), flag, depth - 1, pvm_flag);
#else
		printobj(CARobj(touch_obj(*top_val())), flag, depth - 1);
#endif
#else
#ifdef PVM3
		printobj(CARobj(*top_val()), flag, depth - 1, pvm_flag);
#else
		printobj(CARobj(*top_val()), flag, depth - 1);
#endif
#endif
                /*
		obj.obj = CDRobj(s_pop());
		*/
#ifdef CTHREAD
		*top_val() = CDRobj(touch_obj(*top_val()));
#else
		*top_val() = CDRobj(*top_val());
#endif
#ifdef CTHREAD
		if (GETtag(touch_obj(*top_val())) != LTAG_CONS) {
		    if (GETtag(touch_obj(*top_val())) != LTAG_NIL) {
#else
		if (GETtag(*top_val()) != LTAG_CONS) {
		    if (GETtag(*top_val()) != LTAG_NIL) {
#endif
			printf2(" . ");
#ifdef PVM3
			printobj(*top_val(), flag, depth - 1, pvm_flag);
#else
			printobj(*top_val(), flag, depth - 1);
#endif
		    }
		    break;
		}
		if (get_sval(print_circle_sym.obj)!=LTAG_FALSE) {
		    for (p = PRINTstack_top - 2; p >= PRINTstack_limit; p -= 2)
			if (*top_val() == *p) {
			    if (p[1] != LTAG_NIL) {
				printf2(" . #");
				sprintf(str, "%d", (PRINTstack_top - (p+2))/2);
				printf2(str);
				printf2("#");
				goto RIGHT_PAREN;
			    } else {
				printf2(" . ");
#ifdef PVM3
				printobj(*top_val(), flag, depth - 1, pvm_flag);
#else
				printobj(*top_val(), flag, depth - 1);
#endif
				goto RIGHT_PAREN;
			    }
			}
		}
		printf2(" ");
	    }
  RIGHT_PAREN :
	    printf2(")");
	}
        break;
    case LTAG_BLOCK2 :
        printf2("#<block2>");
        break;
    case LTAG_BLOCK1 :
        printf2("#<block1>");
        break;
    case LTAG_GCFORWARD :
        printf2("#<gc-forward>");
        break;
    case LTAG_NIL:
        printf2("()");
        break;
    case LTAG_EOF:
        printf2("#<end-of-file>");
        break;
    case LTAG_LOSTOBJ0 :
    case LTAG_LOSTOBJ1 :
    case LTAG_LOSTOBJ2 :
        printf2("#<lost-object>");
        break;
    case LTAG_FIXNUM:
    case LTAG_FIXNUM1:
    case LTAG_FIXNUM2:
    case LTAG_FIXNUM3:
        sprintf(str, "%d", fix_to_int(*top_val()));
        printf2(str);
        break;
    case LTAG_SFLOAT:
    case LTAG_SFLOAT1:
    case LTAG_SFLOAT2:
    case LTAG_SFLOAT3:
/*        sprintf(str, "%lg", flt_to_double(*top_val())); */
        sprintf(str, "%.15g", flt_to_double(*top_val()));
        printf2(str);
        if (!strchr(str, '.') && !strchr(str, 'e'))
            printf2(".0");
        break;
    case LTAG_ACHAR:
        ch = (char)CH(obj.ch);
        if (flag == PRINC)
            putc2(ch);
        else
         {
            switch (ch) {
            case ' '  :
                printf2("#\\space");
                break;
            case '\n' :
                printf2("#\\newline");
                break;
            case '\r' :
                printf2("#\\return");
                break;
            case '\t' :
                printf2("#\\tab");
                break;
            case '\f' :
                printf2("#\\newpage");
                break;
            case '\033' :
                printf2("#\\escape");
                break;
            default :
                printf2("#\\");
                putc2(ch);
                break;
            }
        }
        s_pop();
        return;
    case LTAG_KCHAR:				/* Added by Ushijima */
	if (flag != PRINC)
		printf2("#\\");
	putc2((KCH(obj.kch) & 0xff00) >> 8);
	putc2((KCH(obj.kch) & 0x00ff));
        break;
    case LTAG_T:
        printf2("#t");
        break;
#ifdef USE_FALSE
    case LTAG_FALSE:
        printf2("#f");
        break;
#endif
   case LTAG_BCLOSURE :
#ifdef PVM3
        if(pvm_flag == ON){      /* By A243 */
            printf2("#c=");
	    tmp.obj = s_pop();
            s_push(tmp.obj);
            s_push(tmp.obj);
            s_push(tmp.obj);
            s_push(tmp.obj);
	    s_push(tmp.obj);
	    print_obj = 
	      mk_cons(((ENTITYP)ADDRESS(s_pop()))->bcc.fun_name.obj,
               mk_cons(((ENTITYP)ADDRESS(s_pop()))->bcc.env.obj,
                mk_cons(mk_fix(((ENTITYP)ADDRESS(s_pop()))->bcc.arg_info), 
	         mk_cons(mk_fix(((ENTITYP)ADDRESS(s_pop()))->bcc.start_addr), 
			 ((ENTITYP)ADDRESS(s_pop()))->bcc.source.obj))));
	    goto LOOP;
        }
        else{
#endif
            if ((tmp.obj = ((ENTITYP)ADDRESS(*top_val()))->bcc.fun_name.obj)
                == LTAG_NIL)
               printf2("#<function>");
            else {
               s_push(tmp.obj);
               printf2("#<function ");       
#ifdef PVM3
               printobj(s_pop(), PRINC, 1, pvm_flag); 
#else
               printobj(s_pop(), PRINC, 1);
#endif 
               printf2(">");            
            }
#ifdef PVM3
        }
#endif
        break;
    case LTAG_NCLOSURE :        /* T.Komiya */
        if ((tmp.obj = ((ENTITYP)ADDRESS(*top_val()))->ncc.fun_name.obj)
            == LTAG_NIL)
            printf2("#<function>");
        else {
            s_push(tmp.obj);
            printf2("#<function ");
#ifdef PVM3
            printobj(s_pop(), PRINC, 1, pvm_flag);
#else
            printobj(s_pop(), PRINC, 1);
#endif
            printf2(">");
        }
        break;
    case LTAG_SFUNCTION :
        printf2("#<function ");
#ifdef PVM3
        printobj(((ENTITYP)ADDRESS(*top_val()))->sfn.fun_name.obj, PRINC, 1, pvm_flag);
#else
        printobj(((ENTITYP)ADDRESS(*top_val()))->sfn.fun_name.obj, PRINC, 1);
#endif
        printf2(">");
        break;
    case LTAG_CONTINUATION :
        printf2("#<function>");
        break;
#ifdef CALLIOC
    case LTAG_IOC :
        printf2("#<function>");
        break;
#endif
    case LTAG_MBCLOSURE :
#ifdef PVM3
        if(pvm_flag == ON){      /* By A243 */
            printf2("#c=");
	    tmp.obj = *top_val();
            s_push(tmp.obj);
            s_push(tmp.obj);
            s_push(tmp.obj);
            s_push(tmp.obj);
	    s_push(tmp.obj);
	    print_obj = 
	      mk_cons(((ENTITYP)ADDRESS(s_pop()))->bcc.fun_name.obj,
               mk_cons(((ENTITYP)ADDRESS(s_pop()))->bcc.env.obj,
		mk_cons(mk_fix(((ENTITYP)ADDRESS(s_pop()))->bcc.arg_info), 
                 mk_cons(mk_fix(((ENTITYP)ADDRESS(s_pop()))->bcc.start_addr), 
			 ((ENTITYP)ADDRESS(s_pop()))->bcc.source.obj))));
/*            tmp.obj = ((ENTITYP)ADDRESS(*top_val()))->bcc.source.obj;  */
            printobj(tmp.obj, PRINC, depth, pvm_flag); 
        }
        else{
#endif
            printf2("#<macro-closure: ");
#ifdef PVM3
            printobj(((ENTITYP)ADDRESS(*top_val()))->mbcc.fun_name.obj, PRINC, 1, pvm_flag);
#else
            printobj(((ENTITYP)ADDRESS(*top_val()))->mbcc.fun_name.obj, PRINC, 1);
#endif
            printf2(">");
#ifdef PVM3
        }
#endif
	break;
    case LTAG_MNCLOSURE :       /* T.Komiya */
        printf2("#<macro-closure: ");
#ifdef PVM3
        printobj(((ENTITYP)ADDRESS(*top_val()))->mncc.fun_name.obj, PRINC, 1, pvm_flag);
#else
        printobj(((ENTITYP)ADDRESS(*top_val()))->mncc.fun_name.obj, PRINC, 1);
#endif
        printf2(">");
        break;
    case LTAG_MSFUNCTION :
        printf2("#<macro-sys-function: ");
#ifdef PVM3
        printobj(((ENTITYP)ADDRESS(*top_val()))->msfn.fun_name.obj, PRINC, 1, pvm_flag);
#else
        printobj(((ENTITYP)ADDRESS(*top_val()))->msfn.fun_name.obj, PRINC, 1);
#endif
        printf2(">");
        break;
    case LTAG_ORDINARY:
    case LTAG_SPECIAL:
        printsymname(sym_name(*top_val()), flag);
        break;
    case LTAG_NILVECTOR:
        printf2("#()");
        break;
    case LTAG_VECTOR:
        if (depth <= 0)
            printf2("#( ... )");
        else {
	    if (get_sval(print_circle_sym.obj) != LTAG_FALSE) {	/* T.Komiya */
		for (p = PRINTstack_top - 2; p >= PRINTstack_limit; p -= 2)
		    if (*top_val() == *p) {
			if (p[1] != LTAG_NIL) {
			    printf2("#");
			    sprintf(str, "%d", (PRINTstack_top - (p+2))/2);
			    printf2(str);
			    printf2("#");
			    s_pop();
			    return;
			} else {
			    printf2("#");
			    sprintf(str, "%d", (PRINTstack_top - (p+2))/2);
			    printf2(str);
			    printf2("=");
			    p[1] = LTAG_T;
			    break;
			}
		    }
	    }
            block1p = (unsigned *)ADDRESS(*top_val());
            length = IMM(((ENTITYP)block1p)->vec.head) >> 2;
            printf2("#(");
            if (length != 0) {
                block1p = (unsigned *)ADDRESS(*top_val());
#ifdef PVM3
                printobj(*(block1p + 1), flag, depth - 1, pvm_flag);
#else
                printobj(*(block1p + 1), flag, depth - 1);
#endif
            }
            for (i = 2 ; i <= length ; ++i) {
                printf2(" ");
                block1p = (unsigned *)ADDRESS(*top_val());
#ifdef PVM3
                printobj(*(block1p + i), flag, depth - 1, pvm_flag);
#else
                printobj(*(block1p + i), flag, depth - 1);
#endif
            }
            printf2(")");
        }
        break;
    case LTAG_STRUCTURE:
        if (depth <= 0)
            printf2("#s( ... )");
        else
         {
	    if (get_sval(print_circle_sym.obj) != LTAG_FALSE) {	/* T.Komiya */
		for (p = PRINTstack_top - 2; p >= PRINTstack_limit; p -= 2)
		    if (*top_val() == *p) {
			if (p[1] != LTAG_NIL) {
			    printf2("#");
			    sprintf(str, "%d", (PRINTstack_top - (p+2))/2);
			    printf2(str);
			    printf2("#");
			    s_pop();
			    return;
			} else {
			    printf2("#");
			    sprintf(str, "%d", (PRINTstack_top - (p+2))/2);
			    printf2(str);
			    printf2("=");
			    p[1] = LTAG_T;
			    break;
			}
		    }
	    }
            block1p = (unsigned *)ADDRESS(*top_val());
            length = IMM(((ENTITYP)block1p)->struc.head) >> 2;
            printf2("#s(");
            block1p = (unsigned *)ADDRESS(*top_val());                     
#ifdef PVM3
            printobj(*(block1p + 1), flag, depth - 1, pvm_flag);
#else
            printobj(*(block1p + 1), flag, depth - 1);
#endif
            for (i = 2 ; i <= length ; ++i) {
                printf2(" ");
                block1p = (unsigned *)ADDRESS(*top_val());                
#ifdef PVM3
                printobj(*(block1p + i), flag, depth - 1, pvm_flag);
#else
                printobj(*(block1p + i), flag, depth - 1);
#endif
            }
            printf2(")");
        }
        break;
    case LTAG_WEAKPAIR:
        if (depth <= 0)
            printf2("{ ... }");
        else
         {
            printf2("{");
            /*
    s_push(obj.obj);
*/
            /*     printobj(WPCARobj(obj.obj), flag, depth - 1); */
#ifdef PVM3
            printobj(*((unsigned *)ADDRESS(*top_val()) + 3), flag, depth - 1, pvm_flag);
#else
            printobj(*((unsigned *)ADDRESS(*top_val()) + 3), flag, depth - 1);
#endif
            /*
    obj.obj = CDRobj(s_pop());
*/
            /*            obj.obj = WPCDRobj(obj.obj); */
            *top_val() = *((unsigned *)ADDRESS(*top_val()) + 1);

            while (GETtag(*top_val()) == LTAG_WEAKPAIR) {
                printf2(" ");
                /*
      s_push(obj.obj);
*/
                /*                printobj(WPCARobj(obj.obj), flag, depth - 1); */
#ifdef PVM3
                printobj(*((unsigned *)ADDRESS(*top_val()) + 3), flag, depth - 1, pvm_flag);
#else
                printobj(*((unsigned *)ADDRESS(*top_val()) + 3), flag, depth - 1);
#endif
                /*
      obj.obj = CDRobj(s_pop());
*/
                /*                obj.obj = WPCDRobj(obj.obj); */
                *top_val() = *((unsigned *)ADDRESS(*top_val()) + 1);
            }
            if (GETtag(*top_val()) != LTAG_NIL) {
                printf2(" . ");
#ifdef PVM3
                printobj(*top_val(), flag, depth - 1, pvm_flag);
#else
                printobj(*top_val(), flag, depth - 1);
#endif
            }
            printf2("}");
        }
        break;
    case LTAG_PROMISE :
        printf2("#<promise>");
        break;
    case LTAG_PORT:
        kind = ((ENTITYP)ADDRESS(*top_val()))->port.kind;
        file = ((ENTITYP)ADDRESS(*top_val()))->port.fp;
        switch (kind) {
        case OUTPUT :
            if (file == stdout)
                printf2("#<console output port>");
            else
             {
                printf2("#<port to ");
                str_obj = ((ENTITYP)ADDRESS(*top_val()))->port.slot.obj;
                if (str_obj != LTAG_NIL)
                    printstr(str_obj, PRINC);
                else
                    bokkan("internal error: in printobj(LTAG_PORT).");
                printf2(">");
            }
            break;
        case INPUT :
            if (file == stdin)
                printf2("#<console input port>");
            else {
                printf2("#<port from ");
                str_obj = ((ENTITYP)ADDRESS(*top_val()))->port.slot.obj;
                if (str_obj != LTAG_NIL)
                    printstr(str_obj, PRINC);
                else
                    bokkan("internal error: in printobj(LTAG_PORT).");
                printf2(">");
            }
            break;
        case CLOSE :
            printf2("#<closed port>");
            break;
        case STRING_INPUT :
            printf2("#<string input port>");
            break;
        case STRING_OUTPUT :
            printf2("#<string output port>");
            break;
#ifdef TCPIP
	case TCP_STREAM:
	    printf2 ("#<tcp port>");
	    break;
	case UDP_DGRAM:
	    printf2 ("#<udp port>");
	    break;
	case TCP_BOUND:
	    printf2 ("#<bound tcp port>");
	    break;
#endif
        default :
            bokkan("internal error: in printobj(port).");
        }
        break;
    case LTAG_FRACTION:
        /*
      s_push(obj.obj);
*/
#ifdef PVM3
        printobj(((ENTITYP)ADDRESS(*top_val()))->frac.nume.obj, PRINC, 1, pvm_flag);
#else
        printobj(((ENTITYP)ADDRESS(*top_val()))->frac.nume.obj, PRINC, 1);
#endif
        printf2("/");
        /*
#ifdef PVM3
      printobj(((ENTITYP)ADDRESS(s_pop()))->frac.deno.obj, PRINC, 1, pvm_flag);
#else
      printobj(((ENTITYP)ADDRESS(s_pop()))->frac.deno.obj, PRINC, 1);
#endif
*/
#ifdef PVM3
        printobj(((ENTITYP)ADDRESS(*top_val()))->frac.deno.obj, PRINC, 1, pvm_flag);
#else
        printobj(((ENTITYP)ADDRESS(*top_val()))->frac.deno.obj, PRINC, 1);
#endif
        break;
    case LTAG_COMPLEX:
        /*
      s_push(obj.obj);
*/
        if (obj_to_double(((ENTITYP)ADDRESS(*top_val()))->cplx.real.obj) != 
            0.0)
#ifdef PVM3
            printobj(((ENTITYP)ADDRESS(*top_val()))->cplx.real.obj, PRINC, 1, pvm_flag);
#else
            printobj(((ENTITYP)ADDRESS(*top_val()))->cplx.real.obj, PRINC, 1);
#endif
        /*
      if(obj_to_double(((ENTITYP)ADDRESS(getsvt(0)))->cplx.imag.obj) > 0.0)
*/
        if (obj_to_double(((ENTITYP)ADDRESS(*top_val()))->cplx.imag.obj) >=
            0.0)
            printf2("+");
        /*
      if(obj_to_double(((ENTITYP)ADDRESS(getsvt(0)))->cplx.imag.obj) != 1.0)
      { if(obj_to_double(((ENTITYP)ADDRESS(getsvt(0)))->cplx.imag.obj) != -1.0)
#ifdef PVM3
      printobj(((ENTITYP)ADDRESS(getsvt(0)))->cplx.imag.obj, PRINC, 1, pvm_flag);
#else
      printobj(((ENTITYP)ADDRESS(getsvt(0)))->cplx.imag.obj, PRINC, 1);
#endif
*/
        if (obj_to_double(((ENTITYP)ADDRESS(*top_val()))->cplx.imag.obj)!=1.0) {
            if (obj_to_double(((ENTITYP)ADDRESS(*top_val()))->cplx.imag.obj)!= -1.0)
#ifdef PVM3
                printobj(((ENTITYP)ADDRESS(*top_val()))->cplx.imag.obj, PRINC, 1, pvm_flag);
#else
                printobj(((ENTITYP)ADDRESS(*top_val()))->cplx.imag.obj, PRINC, 1);
#endif
            else
                printf2("-");
        }
        /*
      s_pop();
*/
        printf2("i");
        break;
    case LTAG_BIGNUM:
        if (big_sign(*top_val()) < 0) {
            printf2("-");
            tmp.obj = minus_big(*top_val());
        } else
            tmp.obj = copy_big(*top_val());
        i = r = 0;
/*******
        while (!big_zerop(tmp.obj)) {
            tmp.obj = div_int_big(tmp.obj, 10, &r);
            s_push(mk_ch('\0', (char)(r + '0')));
            i++;
        }
        while (i > 0) {
            str[0] = (char)((s_pop() >> 16) & 0x000000ff);
            str[1] = '\0';
            printf2(str);
            i--;
        }
********/
        /* By T.Komiya */
        while (!big_zerop(tmp.obj)) {
            tmp.obj = div_int_big(tmp.obj, 10000000, &r);
            s_push(mk_fix(r));
            i++;
        }
	    sprintf(str, "%d", fix_to_int(s_pop()));
    	printf2(str);
    	i--;
        while (i > 0) {
	        sprintf(str, "%07d", fix_to_int(s_pop()));
    	    printf2(str);
            i--;
        }
        break;
    case LTAG_FLOAT:
/*        sprintf(str, "%lg", flt_to_double(*top_val())); */
        sprintf(str, "%.15g", flt_to_double(*top_val()));
        printf2(str);
        if (!strchr(str, '.') && !strchr(str, 'e'))
            printf2(".0");
        break;
    case LTAG_STRING :
    case LTAG_SSTRING :
        printstr(*top_val(), flag);
        break;
    case LTAG_LOCK :
	printf2("#<mutex object>");
	break;
/*
    case LTAG_FUTURE :
	printf2("#<future object>");
	break;
*/
#ifdef CTHREAD
# ifdef SHE
    case LTAG_FUTURE :
	if (((FUTURE *)ADDRESS(print_obj))->sstfr != NULL)
	    printf2("#<future object>");
	else
# else
    case LTAG_FUTURE :
	if (((FUTURE *)ADDRESS(print_obj))->status == NO_PROCESS)
	    printf2("#<future object>");
	else
# endif
#ifdef PVM3
	    printobj(touch_obj(print_obj), flag, depth, pvm_flag);
#else
	    printobj(touch_obj(print_obj), flag, depth);
#endif
	break;
#endif
    default :
        printf2("#<unknown-object>");
        break;
    }
    s_pop();
}


printsymname(sym_name, flag)
int sym_name, flag;
{
    void escprint(char *, int, int);
    char    *str;

    str = (char *)ADDRESS(sym_name);
    if (GETtag(*((unsigned *)str)) == LTAG_BLOCK1)
        str = (char *)ADDRESS(*(((unsigned *)str) + 1));
    if (*(((unsigned *)str) + 2) == K_STRING) {
        str = (char *)(ADDRESS(sym_name) + 12);		/* By Ushijima */
	escprint(str, 2, PRINC);			/* By Ushijima */
    } else
     {
        str = (char *)(ADDRESS(sym_name) + 12);
        if (flag == PRINC)
            escprint(str, 1, PRINC);
        else
         {
            if (checkesc(str, 1)) {
                printf2("|");
                escprint(str, 1, PRINT);
                printf2("|");
            } else
                printf2(str);
        }
    }
}


checkesc(strp, unit)
char    *strp;
int unit;
{
    int flag = FALSE;

    if (unit == 2)
        strp++;
    if (*strp == '#')
        return(TRUE);
    if (*strp == '\0')
        return(TRUE);
    if (str_to_num(strp, unit , NON) != LTAG_FALSE)
        return(TRUE);
    while (*strp != '\0') {
        if (*strp == '(' || *strp == ')' || *strp == '"'  ||  *strp == 
            '`' || *strp == ',' || *strp == '.' || *strp == '\'' ||
            *strp == ';' || *strp == '|' || *strp == '\\' ||
            (*strp >= '\1' && *strp <= ' ') ||
            (*strp >= 'A' && *strp <= 'Z'))
            return(TRUE);
        strp += unit;
    }
    return(FALSE);
}


void escprint(strp, unit, flag)
char    *strp;
int unit, flag;
{
    char    kanjibuf[3];		/* Fixed by Ushijima */

    kanjibuf[2] = (char)NULL;			/* Fixed by Ushijima */
    if (unit == 2) 
        strp++;

#ifdef NIHONGO
    if (((PORT *)ADDRESS(c_out_port.obj))->kanji_output_code == NOC_CODE) {
	    for(; *strp != '\0'; strp++)
		    putc2(*strp);

	    return;
    }
#endif

    while (*strp != '\0') {
        if (*strp & 0x80) {
            kanjibuf[0] = *(strp - 1);
            kanjibuf[1] = *strp;
            printf2(kanjibuf);
        } else if (flag != PRINC) {
            if (*strp == '|' || *strp == '\\' || *strp == '"') {
                putc2('\\');
                putc2(*strp);
/*          } else if (*strp >= 1 && *strp < ' ') {
                putc2('\\');
                putc2((*strp) + 0x40); */
            } else 
                putc2(*strp);
        } else 
            putc2(*strp);
        strp += unit;
    }
}


printstr(str_obj, flag)
int str_obj, flag;
{
    int unit = 1;
    char    *str;

    str = (char *)ADDRESS(str_obj);
    if (GETtag(*((unsigned *)str)) == LTAG_BLOCK1)
        str = (char *)ADDRESS(*(((unsigned *)str) + 1));
    if (*(((unsigned *)str) + 2) == K_STRING)
        unit = 2;
    str = str + 12;
    if (flag != PRINC) {
        printf2("\"");
        escprint(str, unit, PRINT);
        printf2("\"");
    } else
        escprint(str, unit, PRINC);
}

void travel_push_object(x)		/* T.Komiya */
unsigned x;
{
    int i;
    unsigned tag, *p;

 BEGIN:
    tag = GETtag(x);
    if (tag != LTAG_VECTOR && tag != LTAG_CONS && tag != LTAG_STRUCTURE)
	return;
    for (p = PRINTstack_top - 2;  p >= sp_reg;  p -= 2)
	if (x == *p) {
	    if (p[1] != LTAG_NIL)
		return;
	    p[1] = LTAG_T;
	    return;
	}
    if ((unsigned *)stack_top > sp_reg)
	bokkan_stack_overflow();
    s_push(LTAG_NIL);
    s_push(x);
    if (tag == LTAG_VECTOR)
	for (i = 1;  i <= IMM(((ENTITYP)ADDRESS(x))->vec.head) >> 2;  i++)
	    travel_push_object(*((unsigned *)(ADDRESS(x) + (i << 2))));
    else if (tag == LTAG_CONS) {
	travel_push_object(CARobj(x));
	x = CDRobj(x);
	goto BEGIN;
    } else if (tag == LTAG_STRUCTURE)
	for (i = 1;  i <= IMM(((ENTITYP)ADDRESS(x))->struc.head) >> 2;  i++)
	    travel_push_object(*((unsigned *)(ADDRESS(x) + (i << 2))));
}

#ifdef PVM3
travel_push_object_pvm(x)		/* By A243*/
unsigned x;
{
    int i;
    unsigned tag, *p;

 BEGIN:
    tag = GETtag(x);
    if (tag == LTAG_BCLOSURE || tag == LTAG_MBCLOSURE) {
	x = ((ENTITYP)ADDRESS(x))->bcc.source.obj;
	tag = GETtag(x);
    }
    if (tag != LTAG_VECTOR && tag != LTAG_CONS && tag != LTAG_STRUCTURE)
	return;
	
    for (p = PRINTstack_top - 2;  p >= sp_reg;  p -= 2)
	if (x == *p) {
	    if (p[1] != LTAG_NIL)
		return;
	    p[1] = LTAG_T;
	    return;
	}
    if ((unsigned *)stack_top > sp_reg)
	bokkan_stack_overflow();
    s_push(LTAG_NIL);
    s_push(x);
    if (tag == LTAG_VECTOR)
	for (i = 1;  i <= IMM(((ENTITYP)ADDRESS(x))->vec.head) >> 2;  i++)
	    travel_push_object_pvm(*((unsigned *)(ADDRESS(x) + (i<<2))));
    else if (tag == LTAG_CONS) {
	travel_push_object_pvm(CARobj(x));
	x = CDRobj(x);
	goto BEGIN;
    } else if (tag == LTAG_STRUCTURE)
	for (i = 1;  i <= IMM(((ENTITYP)ADDRESS(x))->struc.head) >> 2;  i++)
	    travel_push_object_pvm(*((unsigned *)(ADDRESS(x) + (i<<2))));
}
#endif
