/*
 * reader.c - 
 */

/*
 * $Id: reader.c,v 1.6 2016/02/20 05:17:36 komiya Exp $
 *
 * ------ READER ------
 * 
 * File Name : reader.c
 * 
 * written by Mikio Yamamoto.
 * 
 * extended to all numbers by Yass.
 * 
 */

static char *RCSid="$Id: reader.c,v 1.6 2016/02/20 05:17:36 komiya Exp $";

#include <math.h>
#include "scheme.h"

#ifdef THINK_C
#include <string.h>
#else
#include <strings.h>
#endif

#ifdef TCPIP
#include "inet.h"
extern struct sockaddr_in *getnetaddr ();
#endif

#define DELIM_p(ch)  (((ch) == ' ')  || ((ch) ==  '\t') || ((ch) ==  '\n') ||\
                      ((ch) == EOF)  || ((ch) == '(')   || ((ch) == ')')   ||\
		      ((ch) == ';')  || ((ch) == '"')   || ((ch) == ',')   ||\
		      ((ch) == '\'') || ((ch) == '`')   || ((ch) == '|')   ||\
		      ((ch) == '{')  || ((ch) == '}'))

SHARP_EQ_CONTEXT_STRUCT sharp_eq_context[SHARP_EQ_CONTEXT_SIZE]; /* T.Komiya */

int sharp_eq_context_max;	/* T.Komiya */
int symbol_sensitive;

#ifdef PVM3
int pvm_reader_ret();       /* By A243 */
#if defined(__CYGWIN32__) || defined(linux)
sigjmp_buf pvm_ret;
#else
jmp_buf pvm_ret;
#endif
#endif

double obj_to_double();

getc2()
{
    PORT * port_obj;
    char    str[2];
    int ch;
#ifdef TCPIP
    char c;
    struct sockaddr_in *addrp;
    int addrlen = 0;
    int *addrlenp = &addrlen;
#endif

    port_obj = (PORT * ) ADDRESS(c_in_port.obj);
    switch (port_obj->kind) {
    case INPUT:
        switch (port_obj->bufstatus) {
        case 0:
#ifdef NIHONGO
            ch = kgetc(port_obj);
#else
# ifdef TK
            ch = Getc(port_obj->fp);
# else
            ch = getc(port_obj->fp);
# endif
#endif

	    if (transcript_flag == ON) {
                str[0] = ch;
                str[1] = '\0';
                print_transcript(port_obj->fp, str);
            }
            break;
        case 1:
            ch = port_obj->buf1;
            port_obj->bufstatus = 0;
            break;
        case 2:
            ch = port_obj->buf2;
            port_obj->bufstatus = 1;
            break;
        default:
            printf("Internal error : getc2\n");
            break;
        }
        break;
    case STRING_INPUT:
        ch = getc_from_strport(port_obj);
        break;
#ifdef TCPIP
    case UDP_DGRAM:
	addrp = getnetaddr (c_in_port.obj);
	addrlen = sizeof (struct sockaddr_in);
    case TCP_STREAM:
        switch (port_obj->bufstatus) {
        case 0:
#ifdef NIHONGO
	    ch = kgetc(port_obj);
#else
	    switch (recvfrom ((int) port_obj->fp, &c, 1, 0, addrp, &addrlen)) {
	    case -1:
	    case 0:
		ch = EOF;
		break;
	    default:
		ch = (int) c;
	    }
#endif /* NIHONGO */
	    if (transcript_flag == ON) {
                str[0] = ch;
                str[1] = '\0';
                print_transcript(port_obj->fp, str);
            }
            break;
        case 1:
            ch = port_obj->buf1;
            port_obj->bufstatus = 0;
            break;
        case 2:
            ch = port_obj->buf2;
            port_obj->bufstatus = 1;
            break;
        default:
            printf("Internal error : getc2\n");
            break;
        }
	break;
#endif /* TCPIP */
    default:
        bokkan("Internal error : getc2\n");
        break;
    }
    return (ch);
}


int getc_from_strport(port_obj)
PORT *port_obj;
{
    int size;
    char    *strp;
    int val;

    strp = (char *) ADDRESS(port_obj->slot.obj);
    if (*(((unsigned *) strp) + 2) == A_STRING)
        size = *(((int *) strp) + 1) + 12;
    else
        size = (*(((int *) strp) + 1) * 2) + 12;

    if ((int) port_obj->fp >= size)
        return (EOF);

    val = (int) (*(strp + (int) port_obj->fp));
    port_obj->fp = (FILE * ) (((int) (port_obj->fp)) + 1);
    if (val != 0)
        return (val);
    val = (int) (*(strp + (int) port_obj->fp));
    port_obj->fp = (FILE * ) (((int) (port_obj->fp)) + 1);
    return (val);
}


ungetc2(ch)
int ch;
{
    void ungetc_to_strport(PORT *);
    PORT * port_obj;

    port_obj = (PORT * ) ADDRESS(c_in_port.obj);
    switch (port_obj->kind) {
    case INPUT:
#ifdef TCPIP
    case TCP_STREAM:
    case UDP_DGRAM:
#endif
        switch (port_obj->bufstatus) {
        case 0:
            port_obj->buf1 = ch;
            port_obj->bufstatus = 1;
            break;
        case 1:
            port_obj->buf2 = ch;
            port_obj->bufstatus = 2;
            break;
        default:
            printf("Internal error : ungetc2\n");
            break;
        }
        break;
    case STRING_INPUT:
        ungetc_to_strport(port_obj);
        break;
    default:
        printf("Internal error : ungetc2\n");
        break;
    }
}


void ungetc_to_strport(port_obj)
PORT *port_obj;
{
    int point;
    int ch;
    point = (int) port_obj->fp;
    if (point == 12)
        return;
    else {
        ch = *(((char *) ADDRESS(port_obj->slot.obj)) + point - 1);
        if (ch == 0)
            port_obj->fp = (FILE * ) (point - 2);
        else
            port_obj->fp = (FILE * ) (point - 1);
    }
}


peek()
{
    int ch;

    while ((ch = getc2()) == ' ' || ch == '\t' || ch == '\n' || ch == 
        ';') {
        if (ch == ';'){
            while ((ch = getc2()) != '\n' && ch != EOF)
                ;
	    if (ch != EOF)
		ungetc2(ch);
        }
    }
    if (ch != EOF)
        ungetc2(ch);
    return (ch);
}


peek2()
{
    int ch;

    while ((ch = getc2()) == ' ' || ch == '\t' || ch == ';') {
        if (ch == ';') {
            while ((ch = getc2()) != '\n' && ch != EOF)
                ;
	    if (ch != EOF)
		ungetc2(ch);
        }
    }
    if (ch != EOF)
        ungetc2(ch);
    return (ch);
}


int readexp()
{
    SOBJ read_obj;
    int  tmp; 				/*  By N.Watanabe  */

#ifdef PVM3
    set_sval(sharp_closure_pvm, LTAG_NIL);   /* By A243 */
#endif
    sharp_eq_context_max = 0;	/* T.Komiya */
    old_top = (unsigned *) top_val();
    old_top1 = old_top;
    tmp = readexp1();
    if (tmp == NULL ){			/* By N.Watanabe  */
	return NULL;
    }
    if ((read_obj.obj = tmp) != eof_obj.obj) /* T.Komiya */
        peek2();
    if (sharp_eq_context_max > 0) /* T.Komiya */
	read_obj.obj = patch_sharp(read_obj.obj);
#ifdef PVM3
    if(get_sval(sharp_closure_pvm) != LTAG_NIL)    /* By A243 */ 
	bctran_bcc_source();                
#endif
    return (read_obj.obj);
}

#ifdef PVM3
bctran_bcc_source()                 /* By A243 */
{
    SOBJ obj, bytesource;
    ENTITYP new_obj, old_obj;

    obj.obj = get_sval(sharp_closure_pvm);

    while(obj.obj != LTAG_NIL){
	bytesource.obj = ((ENTITYP)(ADDRESS(CARobj(obj.obj))))->bcc.source.obj;

#if defined(__CYGWIN32__) || defined(linux)
	if(sigsetjmp(pvm_ret, 1) == 0){
#else
	if(setjmp(pvm_ret) == 0){
#endif
	    s_push(CARobj(CDRobj(bytesource.obj)));
	    s_push(obj.obj);
	    open_frame2(pvm_reader_ret, LTAG_NIL, 0);
	    s_push(get_sval(bctran_exec_form_sym));
	    s_push(bytesource.obj);
	    s_push(bytesource.obj);
	    xcall();
	    while(1)
		((int (*)())(*(bcbody_reg + bcpc_reg)))();
	}
	
	if(GETtag(reg_reg) == LTAG_BCLOSURE)
	    new_obj = (ENTITYP)(ADDRESS(reg_reg));
	else
	    new_obj = (ENTITYP)(ADDRESS(get_sval(reg_reg)));

	obj.obj = s_pop();
	old_obj = (ENTITYP)(ADDRESS(CARobj(obj.obj)));
	old_obj->bcc.const_vec.obj = new_obj->bcc.const_vec.obj;
/*	old_obj->bcc.fun_name.obj  = new_obj->bcc.fun_name.obj; 
	old_obj->bcc.source.obj    = new_obj->bcc.source.obj;  
	old_obj->bcc.env.obj       = new_obj->bcc.env.obj; */
	old_obj->bcc.body.obj      = new_obj->bcc.body.obj;
/*	old_obj->bcc.arg_info      = new_obj->bcc.arg_info;
	old_obj->bcc.start_addr    = new_obj->bcc.start_addr; */

	obj.obj = CDRobj(obj.obj);
    }
    
    obj.obj = get_sval(sharp_closure_pvm);
    set_sval(sharp_closure_pvm, LTAG_NIL);

    while(obj.obj != LTAG_NIL){
	s_push(obj.obj);
	set_sval(sharp_closure_pvm,
		 mkcons(CARobj(obj.obj),get_sval(sharp_closure_pvm)));
	obj.obj = CDRobj(s_pop());
    }

    obj.obj = get_sval(sharp_closure_pvm);
    
    while(obj.obj != LTAG_NIL){
	set_sval(s_pop(), CARobj(obj.obj));
	obj.obj = CDRobj(obj.obj);
    }
} 

pvm_reader_ret()
{
      s_pop();
      s_pop();
#if defined(__CYGWIN32__) || defined(linux)
      siglongjmp(pvm_ret, 1);
#else
      longjmp(pvm_ret, 1);
#endif
}        
#endif

int readexp1()
{
    SOBJ obj;
    int  tmp;  				/* By N.Watanabe */

    s_push(old_top1);
    old_top1 = (unsigned *) top_val();
    tmp = readexp2();			/* By N.Watanabe */
    if ( tmp == NULL ){
	return NULL;
    }
    obj.obj = tmp ;
    c_strbuf = strbuf;
    old_top1 = (unsigned *) s_pop();
    return (obj.obj);
}



int readexp2()
{
    int ch, nest;

    switch (ch = peek()) {
    case '(':           /* ( ... )  */
        getc2();
        return (read_pair());
    case '{':           /* { ... }  */
        getc2();
        return (read_wpair());
    case '#':
        getc2();
        switch (ch = getc2()) {
        case 't':       /* #t  */
        case 'T':
            return (LTAG_T);
        case 'f':       /* #f  */
        case 'F':
            return (LTAG_FALSE);
        case '\\':      /* #\c  c:character  */
            return (read_char());
        case '(':       /* #( ... )  */
            return (read_vector());
        case 'b':       /* #bn...  n:number  */
        case 'B':
            return (read_atom(BINARY));
        case 'o':       /* #on...  n:number  */
        case 'O':
            return (read_atom(OCTAL));
        case 'd':       /* #dn...  n:number  */
        case 'D':
            return (read_atom(DECIMAL));
        case 'x':       /* #xn...  n:number  */
        case 'X':
            return (read_atom(HEX));
        case 'i':       /* #in...  n:number  */
        case 'I':
            return (read_atom(INEXACT));
        case 'e':       /* #en...  n:number  */
        case 'E':
            return (read_atom(EXACT));
        case 's':       /* #s(...) */
        case 'S':
            return(read_structure());
#ifdef PVM3
        case 'c':       /* #c=(...) */        /* By A243 */
        case 'C': 
            if(getc2() == '=')
               return(read_function());
            else
               bokkan("No such special reader macro.");
#endif
	case '|':
	    nest = 1;
	    while (nest > 0) {
		switch (getc2()) {
		case '#':
		    if (getc2() == '|')
			nest++;
		    break;
		case '|':
		    if (getc2() == '#')
			nest--;
		    break;
		}
	    }
	    return (readexp2());
	case '0' :		/* T.Komiya */
	case '1' :
	case '2' :
	case '3' :
	case '4' :
	case '5' :
	case '6' :
	case '7' :
	case '8' :
	case '9' :
        {
            int tmp;

            tmp = read_sharp_arg(ch);
	    s_push(tmp);
        }
	    switch (peek()) {
	    case '=' :
		if (GETnum_tag(*top_val()) != LTAG_NUMBER1)
		    bokkan("The #= readmacro requires an argument of fixnum.");
		getc2();
		return(sharp_eq_reader());
	    case '#' :
		if (GETnum_tag(*top_val()) != LTAG_NUMBER1)
		    bokkan("The ## readmacro requires an argument of fixnum.");
		getc2();
		return(sharp_sharp_reader());
	    default :
		bokkan("No such special reader macro.");
	    }
        default:
            bokkan("No such special reader macro.");
            break;
        }
        break;
    case '"':           /* " ... "  */
        getc2();
        return (read_string());
    case '\'':          /* 'a  a:atom  */
        getc2();
        return (read_cdr(quotesym.obj));
    case '`':           /* `a  a:atom  */
        getc2();
        return (read_cdr(qquotesym.obj));
    case ',':
        getc2();
        if (peek() == '@') {
            getc2();
            return (read_cdr(atsym.obj));
        } else
            return (read_cdr(commasym.obj));
    case '|':
        getc2();
        return (read_escsymbol());
    case EOF:
        return (eof_obj.obj);
    case ')':
    case '}':
        getc2();
        err_read_error("Too many closing parenthesis.");
	return NULL;
        break;
    default:
        return (read_atom(NON));
    }
}

#ifdef PVM3
int read_function()                  /* By A243 */
{
    SOBJ tmp, fun_name, env, stad, argi, source;
    int start_addr, arg_info;

    tmp.obj = readexp1();
    fun_name.obj = CARobj(tmp.obj);
    env.obj = CARobj(CDRobj(tmp.obj));
    argi.obj = CARobj(CDRobj(CDRobj(tmp.obj)));
    stad.obj = CARobj(CDRobj(CDRobj(CDRobj(tmp.obj))));
    source.obj = CDRobj(CDRobj(CDRobj(CDRobj(tmp.obj))));

    start_addr = fix_to_int(stad.obj);
    arg_info = fix_to_int(argi.obj);

    tmp.obj = mk_bcc(LTAG_BCLOSURE, LTAG_NIL, fun_name.obj, source.obj, 
		     env.obj, LTAG_NIL, arg_info, start_addr);
    s_push(tmp.obj);
    set_sval(sharp_closure_pvm,
	     mkcons(tmp.obj, get_sval(sharp_closure_pvm)));

    return(s_pop());
}
#endif

int read_pair()
{
    SOBJ obj;
    int firstflag;
    int ch;

    if (peek() == ')') {
        getc2();
        return (LTAG_NIL);
    }

    firstflag = TRUE;
    while ((ch = peek()) != ')' && ch != EOF) {
        switch (ch) {
        case '.':
            getc2();
            ch = getc2();
            ungetc2(ch);
            if (DELIM_p(ch)) {
                if (firstflag == TRUE)
                    bokkan("Improperly formed dotted-pair.");
                else {
                    obj.obj = readexp1();
                    set_cdr(s_pop(), obj.obj);
                    if (peek() == ')') {
                        getc2();
                        return (s_pop());
                    } else {
                        addtop(1);
                        bokkan("a strange dotted-pair.");
                    }
                }
            } else
                ungetc2('.');
        default:
            obj.obj = mk_cons(readexp1(), LTAG_NIL);
            if (firstflag == FALSE) {
                set_cdr(s_pop(), obj.obj);
                s_push(obj.obj);
            } else {
                firstflag = FALSE;
                s_push(obj.obj);
                s_push(obj.obj);
            }
            break;
        }
    }
    if (ch == EOF)
        bokkan("Incompleted pair.");
    getc2();
    s_pop();
    return (s_pop());
}

int read_wpair()		/* T.Komiya */
{
    SOBJ obj;
    int firstflag;
    int ch;

    if (peek() == '}') {
        getc2();
        return (LTAG_NIL);
    }

    firstflag = TRUE;
    while ((ch = peek()) != '}' && ch != EOF) {
        switch (ch) {
        case '.':
            getc2();
            ch = getc2();
            ungetc2(ch);
            if (DELIM_p(ch)) {
                if (firstflag == TRUE)
                    bokkan("Improperly formed dotted-weakpair.");
                else {
                    obj.obj = readexp1();
		    WPCDRobj(s_pop()) = obj.obj;
                    if (peek() == '}') {
                        getc2();
                        return (s_pop());
                    } else {
                        addtop(1);
                        bokkan("a strange dotted-weakpair.");
                    }
                }
            } else
                ungetc2('.');
        default:
            obj.obj = mk_wp(readexp1(), LTAG_NIL);
            if (firstflag == FALSE) {
		WPCDRobj(s_pop()) =  obj.obj;
                s_push(obj.obj);
            } else {
                firstflag = FALSE;
                s_push(obj.obj);
                s_push(obj.obj);
            }
            break;
        }
    }
    if (ch == EOF)
        bokkan("Incompleted weakpair.");
    getc2();
    s_pop();
    return (s_pop());
}

int read_char()
{
    int ch1, ch2, delimiter;
    char    buf[9];
    int i;

    ch1 = getc2();
    if (ch1 >= '!' && ch1 <= '~') {
        ch2 = getc2();
        if (DELIM_p(ch2)) {
            ungetc2(ch2);
            return (mk_ch('\0', ch1));
        } else {
            buf[0] = (char) ch1;
            buf[1] = (char) ch2;
            i = 2;
            ch2 = getc2();
            while (!DELIM_p(ch2)) {
                if (i >= 8)
                    bokkan("Illegal character.");
                buf[i++] = (char) ch2;
                ch2 = getc2();
            }
            ungetc2(ch2);
            buf[i] = '\0';
	    for (i = 0; buf[i]; i++)         /* T.Komiya */
		if ('A' <= buf[i] && buf[i] <= 'Z')
		    buf[i] += (char)('a' - 'A');
            if (!strcmp(buf, "newline"))
                return (mk_ch('\0', '\n'));
            if (!strcmp(buf, "space"))
                return (mk_ch('\0', ' '));
            if (!strcmp(buf, "tab"))
                return (mk_ch('\0', '\t'));
            if (!strcmp(buf, "newpage"))
                return (mk_ch('\0', '\f'));
            if (!strcmp(buf, "linefeed"))
                return (mk_ch('\0', '\n'));
            if (!strcmp(buf, "return"))
                return (mk_ch('\0', '\r'));
            if (!strcmp(buf, "escape"))
                return (mk_ch('\0', '\033'));
            bokkan("Illegal character.");
        }
    } else if (DELIM_p(ch1)) {
        ungetc2(ch1);
        return(mk_ch('\0', ' '));
    } else {
        if (KANJI_p(ch1)) {
            ch2 = getc2();
            delimiter = getc2();
            if (DELIM_p(delimiter)) {
                ungetc2(delimiter);
                return (mk_ch(ch1, ch2));
            } else
                bokkan("Illegal character.");
        } else
            bokkan("unknown character code.");
    }
}


int read_vector()
{
    int ch;
    SOBJP obj;
    int i, length = 0;
    unsigned tmp;

    while ((ch = peek()) != ')' && ch != EOF) {
        tmp = readexp1();
        s_push(tmp);
        length++;
    }
    ch = getc2();
    if (ch == EOF)
        bokkan("Incompleted vector.");
    if (length > 0) {
        obj = (SOBJP) mk_evecp(length);
        for (i = length; i > 0; i--)
            (obj + i)->obj = s_pop();
        return (LTAG_VECTOR | SSERDDA(obj));
    } else
        return(LTAG_NILVECTOR);
}

int read_structure()    /* By T.Komiya */
{
    int ch;
    SOBJ firstobj;
    SOBJP objp;
    int i, length = 0, size;

    if (getc2() != '(')
        bokkan("strange structure.");
    firstobj.obj = readexp1();
    s_push(firstobj.obj);
    while ((ch = peek()) != ')' && ch != EOF) {
        firstobj.obj = readexp1();
        s_push(firstobj.obj);
        length++;
    }
    if ((ch = getc2()) == EOF)
        bokkan("Incompleted structure.");
    firstobj.obj = getsvt(length);
    if (GETsym_tag(firstobj.obj) != LTAG_SYMBOL)
        bokkan("1st argument must be a symbol.");
    if ((size = struct_size(firstobj.obj)) < 0)
        bokkan("1st argument isn't defined as a structure name.");
    if (length != size)
        bokkan("Structure length and arguments length is mis-matched.");
    objp = (SOBJP)mk_estructp(firstobj.obj, length);
    for (i = length + 1; i > 1; i--)
        (objp + i)->obj = s_pop();
    s_pop();
    return (LTAG_STRUCTURE | SSERDDA(objp));
}

int read_string()
{
    int ch;
    char    *extbuf;        /* extended string buffer */
    int readchlen = 0,      /* the number of read characters */
    readbyte = 8, bufsize = STRBUFSIZE,     /* current string buffer size
                         * (byte order) */
    kanji_flag = FALSE,     /* kanji_flag is TRUE, if some Kanji
                 * characters are exist */
    i;

    c_strbuf = strbuf;

    while ((ch = getc2()) != '"' && ch != EOF) {
        if (bufsize < readbyte) {
            bufsize *= 2;
            extbuf = (char *) Pgetblock2(bufsize);
            for (i = 8; i < readbyte; i++)
                *(extbuf + i) = *(c_strbuf + i);
            c_strbuf = extbuf;
        }
        if ((char) ch == '\\') {
            ch = getc2();
/*          if (ch >= 'A' && ch <= '_') */
/*          if (ch >= 'A' && ch <= 'Z') */     /* by T.Komiya *//*
                *(c_strbuf + readbyte++) = (char) ((ch - 'A') + 1);
            else */
            *(c_strbuf + readbyte++) = (char) ch;
        } else {
            if (KANJI_p(ch)) {
                kanji_flag = TRUE;
                *(c_strbuf + readbyte++) = (char) ch;
                *(c_strbuf + readbyte++) = getc2();
            } else
                *(c_strbuf + readbyte++) = (char) ch;
        }
        readchlen++;
    }

    if (ch == '\n' || ch == EOF)
        bokkan("Incompeleted string.");
    if (kanji_flag)
        return (mk_str_gcok(ORDINARY_STRING, K_STRING, readchlen, c_strbuf, 8));
    else
        return (mk_str_gcok(ORDINARY_STRING, A_STRING, readchlen, c_strbuf, 8));
}


int read_cdr(carobj)
int carobj;
{
    SOBJ obj;

    obj.obj = mk_cons(carobj, LTAG_NIL);
    s_push(obj.obj);
    obj.obj = mk_cons(readexp1(), LTAG_NIL);
    set_cdr(getsvt(0), obj.obj);
    return (s_pop());
}


int read_escsymbol()
{
    int ch;
    char    *extbuf;        /* extended string buffer */
    int readchlen = 0,      /* the number of read chars + 4 */
    readbyte = 8, bufsize = STRBUFSIZE,     /* current string buffer size
                         * (byte order) */
    kanji_flag = FALSE,     /* kanji_flag is TRUE, if some Kanji
                 * characters are exist */
    i;

    c_strbuf = strbuf;

    while ((ch = getc2()) != '|' && ch != EOF) {
        if (bufsize < readbyte) {
            bufsize *= 2;
            extbuf = (char *) Pgetblock2(bufsize + 8);
            for (i = 8; i < readbyte; i++)
                *(extbuf + i) = *(c_strbuf + i);
            c_strbuf = extbuf;
        }
        if (ch == '\\') {
            ch = getc2();
            if (ch == '\\' || ch == '|')
                *(c_strbuf + readbyte++) = (char) ch;
            else
                bokkan("Illegal excape character in escape symbol like |...|.");
        } else {
            if (KANJI_p(ch)) {
                kanji_flag = TRUE;
                *(c_strbuf + readbyte++) = (char) ch;
                *(c_strbuf + readbyte++) = (char) getc2();
            } else
                *(c_strbuf + readbyte++) = (char) ch;
        }
        readchlen++;
    }

    if (ch == EOF)
        bokkan("Incompleted escape symbol.");
    if (kanji_flag)
        return (addsymbol(mk_str_gcok(SYMBOL_STRING, K_STRING, readchlen,
            c_strbuf, 8), LTAG_ORDINARY));
    else
        return (addsymbol(mk_str_gcok(SYMBOL_STRING, A_STRING, readchlen,
            c_strbuf, 8), LTAG_ORDINARY));
}


read_atom(num_info)
int num_info;
{
    SOBJ num;           /* number as scheme object is stored */
    int ch;
    char    *extbuf;        /* extended string buffer */
    int readchlen = 0,      /* the number of read chars + 4 */
    readbyte = 8, bufsize = STRBUFSIZE,     /* current buffer size */
    kanji_flag = FALSE,     /* kanji_flag = TRUE: Kanji chars are in
                 * string */
    esc_flag = FALSE,   /* identifier which has back slashes go
                 * symbol. */
    i;

    c_strbuf = strbuf;

    ch = getc2();
    while (!DELIM_p(ch)) {
        if (bufsize < readbyte) {
            bufsize = 2 * bufsize;
            extbuf = (char *) Pgetblock2(bufsize + 12);
            for (i = 8; i < readbyte; i++)
                *(extbuf + i) = *(c_strbuf + i);
            c_strbuf = extbuf;
        }
        if ((! symbol_sensitive) && ch >= 'A' && ch <= 'Z')
            *(c_strbuf + readbyte++) = (char) (ch + ('a' - 'A'));
        else {
            if (KANJI_p(ch)) {
                kanji_flag = TRUE;
                *(c_strbuf + readbyte++) = (char) ch;
                *(c_strbuf + readbyte++) = getc2();
            } else {
                if (ch == '\\') {
                    esc_flag = TRUE;
                    ch = getc2();
                    if (KANJI_p(ch)) {
                        kanji_flag = TRUE;
                        *(c_strbuf + readbyte++) = 
                            (char) ch;
                        *(c_strbuf + readbyte++) = 
                            getc2();
                    } else
                        *(c_strbuf + readbyte++) = 
                            (char) ch;
                } else
                    *(c_strbuf + readbyte++) = (char) ch;
            }
        }
        readchlen++;
        ch = getc2();
    }
    *(c_strbuf + readbyte) = '\0';
#ifdef TCPIP
/*    if (ch != EOF || netportp (c_in_port.obj))  --- ??? */
    if (ch != EOF)
#else
    if (ch != EOF)
#endif
        ungetc2(ch);

    if (!kanji_flag) {
        if (esc_flag == TRUE)
            return (addsymbol(mk_str_gcok(SYMBOL_STRING, A_STRING,
                readchlen, c_strbuf, 8), LTAG_ORDINARY));
        else {
            if ((num.obj = str_to_num(c_strbuf + 8, 1, num_info)) == 
                LTAG_FALSE) {
                if (num_info == NON)
                    return (addsymbol(mk_str_gcok(SYMBOL_STRING,
                        A_STRING, readchlen, c_strbuf, 8), LTAG_ORDINARY));
                else
                    bokkan("strange number.");
            } else
                return (num.obj);
        }
    } else
        return (addsymbol(mk_str_gcok(SYMBOL_STRING, K_STRING, readchlen,
            c_strbuf, 8), LTAG_ORDINARY));
}               /* readatom */



/* written by Yass. Aug. 24 '90  */

int str_to_num(buf, size, prefix)
char    *buf;
int size, prefix;
{
    SOBJ obj;
    int radix = DECIMAL, sign = 0, offset = 0;
    int ch;

    char    *str_to_real();

    if (size == 2)
        offset = 1;

    /* prefix */

    switch (prefix) {
    case BINARY:
    case OCTAL:
    case DECIMAL:
    case HEX:
        radix = prefix;
        if (*(buf + offset) == '#') {
            buf += size;
            ch = (int) (*(buf + offset));
            if (ch == 'i' || ch == 'e')
                buf += size;
            else
                return (LTAG_FALSE);
        }
        break;
    case INEXACT:
    case EXACT:
        if (*(buf + offset) == '#') {
            buf += size;
            switch (*(buf + offset)) {
            case 'b':
                radix = BINARY;
                break;
            case 'o':
                radix = OCTAL;
                break;
            case 'd':
                radix = DECIMAL;
                break;
            case 'x':
                radix = HEX;
                break;
            default:
                return (LTAG_FALSE);
                break;
            }
            buf += size;
        }
        break;
    default:
        break;
    }

    /* sign */

    if (*(buf + offset) == '+') {
        sign = 1;
        buf += size;
    } else {
        if (*(buf + offset) == '-') {
            sign = -1;
            buf += size;
        }
    }

    /* special case (+i or -i) */

    if (*(buf + offset) == 'i') {
        buf += size;
        if (*(buf + offset) != '\0' || sign == 0)
            return (LTAG_FALSE);
        else
            return (mk_cplx(SCOBJ_0, ((sign == 1) ? SCOBJ_1 : 
                SCOBJ_M1)));
    }

    buf = str_to_real(sign, radix, buf, size, offset);
    if (buf == (char *) NULL)
        return (s_pop());

    switch (*(buf + offset)) {
    case 'i':
        buf += size;
        if (*(buf + offset) != '\0' || sign == 0) {
            addtop(1);
            return (LTAG_FALSE);
        } else {
            if (obj_to_double(getsvt(0)) == 0.0) {
                s_pop();
                return (SCOBJ_0);
            } else
                return (mk_cplx(SCOBJ_0, s_pop()));
        }
        break;
        /*
     * case '@'  : buf += size; if (*(buf + offset) == '+') { sign = 1;
     * buf += size; } else { if (*(buf + offset) == '-') { sign = -1; buf
     * += size; } else sign = 0; } buf = str_to_real(sign, radix, buf,
     * size, offset); if (buf == (char *)NULL || *(buf + offset) != '\0')
     * { addtop(2); return(LTAG_FALSE); } else { ;;; make polar complex }
     * break;
     */
    case '+':
        buf += size;
        if (*(buf + offset) == 'i') {
            buf += size;
            if (*(buf + offset) != '\0') {
                addtop(1);
                return (LTAG_FALSE);
            } else
                return (mk_cplx(s_pop(), SCOBJ_1));
        } else {
            sign = 1;
            buf = str_to_real(sign, radix, buf, size, offset);
            if (buf == (char *) NULL || *(buf + offset) != 'i') {
                addtop(2);
                return (LTAG_FALSE);
            } else {
                buf += size;
                if (*(buf + offset) != '\0') {
                    addtop(2);
                    return (LTAG_FALSE);
                } else {
                    if (obj_to_double(getsvt(0)) == 0.0) {
                        s_pop();
                        return (s_pop());
                    } else {
                        obj.obj = s_pop();
                        return (mk_cplx(s_pop(), obj.obj));
                    }
                }
            }
        }
        break;
    case '-':
        buf += size;
        if (*(buf + offset) == 'i') {
            buf += size;
            if (*(buf + offset) != '\0') {
                addtop(1);
                return (LTAG_FALSE);
            } else
                return (mk_cplx(s_pop(), SCOBJ_M1));
        } else {
            sign = -1;
            buf = str_to_real(sign, radix, buf, size, offset);
            if (buf == (char *) NULL || *(buf + offset) != 'i') {
                addtop(2);
                return (LTAG_FALSE);
            } else {
                buf += size;
                if (*(buf + offset) != '\0') {
                    addtop(2);
                    return (LTAG_FALSE);
                } else {
                    if (obj_to_double(getsvt(0)) == 0.0) {
                        s_pop();
                        return (s_pop());
                    } else {
                        obj.obj = s_pop();
                        return (mk_cplx(s_pop(), obj.obj));
                    }
                }
            }
        }
        break;
    case '\0':
        return (s_pop());
        break;
    default:
        addtop(1);
        return (LTAG_FALSE);
        break;
    }
}


char    *str_to_real(sign, radix, buf, size, offset)
int sign, radix;
char    *buf;
int size, offset;
{
    SOBJ obj;
    int tag, val;

    char    *str_to_float();

    buf = str_to_float(sign, radix, buf, size, offset);
    if (buf == (char *) NULL) {
        addtop(1);
        s_push(LTAG_FALSE);
        return (NULL);
    }
    obj.obj = getsvt(0);
    if (*(buf + offset) == '/') {   /* case of fraction  */
        tag = GETtag(obj.obj);
        if (tag == LTAG_FIXNUM || tag == LTAG_FIXNUM1 || tag == 
            LTAG_FIXNUM2 || tag == LTAG_FIXNUM3 || tag == LTAG_BIGNUM) {
            buf += size;
            buf = str_to_float(1, radix, buf, size, offset);
            if (buf == (char *) NULL) {
                addtop(2);
                s_push(LTAG_FALSE);
                return (NULL);
            }
            obj.obj = getsvt(0);
            tag = GETtag(obj.obj);
            if (tag == LTAG_FIXNUM || tag == LTAG_FIXNUM1 || 
                tag == LTAG_BIGNUM) {
                if (tag == LTAG_FIXNUM && fix_to_int(obj.obj) == 
                    0) {
                    addtop(2);
                    bokkan("Illegal number.");
                }
                obj.obj = getsvt(1);
                if (GETtag(obj.obj) == LTAG_FIXNUM && fix_to_int(obj.obj) == 
                    0) {
                    addtop(1);
                    return (buf);
                } else {
		    unsigned tmp1, tmp2, tmp3;

		    tmp1 = getsvt(0);
		    tmp2 = getsvt(1);
                    tmp3 = gcd_obj(tmp1, tmp2);
                    s_push(tmp3);
                    setsvt(1, div_obj(getsvt(1), getsvt(0)));
                    setsvt(2, div_obj(getsvt(2), getsvt(0)));
                    addtop(1);
                    obj.obj = s_pop();
                    if (GETtag(obj.obj) == LTAG_FIXNUM && 
                        fix_to_int(obj.obj) == 1)
                        return (buf);
                    else {
			unsigned tmp, tmp2;

			tmp = s_pop();
                        tmp2 = mk_frac(tmp, obj.obj);
                        s_push(tmp2);
                        return (buf);
                    }
                }
            } else {
                addtop(2);
                s_push(LTAG_FALSE);
                return (NULL);
            }
        } else {
            addtop(1);
            s_push(LTAG_FALSE);
            return (NULL);
        }
    }
    return (buf);
}


char    *str_to_float(sign, radix, buf, size, offset)
int sign, radix;
char    *buf;
int size, offset;
{
    SOBJ obj;
    int ch;
    int first_period = FALSE, float_flag = FALSE, count = 0, exp = 0, sign_flag = 1, num, val_i;
    double  base = 10.0, val_r = 0.0;
    unsigned tmp;

    double  big_to_double();

    ch = (int) (*(buf + offset));   /* first character  */

    switch (ch) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
        num = ch - '0';
        break;
    case 'a':
    case 'b':
    case 'c':
    case 'd':
    case 'e':
    case 'f':
        num = ch - 'a' + 10;
        break;
    case '.':
        num = 0;
        float_flag = TRUE;
        first_period = TRUE;
        break;
    default:
        s_push(LTAG_FALSE);
        return (buf);
        break;
    }

    obj.obj = mk_bign(0);

    do {
        if (float_flag)
            break;
        if (num < radix) {
            obj.obj = mul_int_big(obj.obj, radix);
            obj.obj = add_int_big(obj.obj, num);
        } else {
            s_push(LTAG_FALSE);
            return (buf);
        }
        buf += size;
        ch = (int) (*(buf + offset));
        switch (ch) {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
            num = ch - '0';
            break;
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
            if (radix == DECIMAL)
                float_flag = TRUE;
            else
                num = ch - 'a' + 10;
            break;
        case '#':
            do {
                obj.obj = mul_int_big(obj.obj, radix);
                buf += size;
                ch = (int) (*(buf + offset));
            } while (ch == '#');
        default:
            float_flag = TRUE;
            break;
        }
    } while (1);

    float_flag = FALSE;
    val_r = big_to_double(obj.obj);

    if (ch == '.') {        /* for floating point  */
        if (radix != 10) {
            s_push(LTAG_FALSE);
            return (buf);
        }
        float_flag = TRUE;
        buf += size;
        ch = (int) (*(buf + offset));
        if (first_period && !(ch >= '0' && ch <= '9')) {
            s_push(LTAG_FALSE);
            return (buf);
        }
        while (ch >= '0' && ch <= '9') {
            val_r += (double) (ch - '0') / base;
            base *= 10.0;
            buf += size;
            ch = (int) (*(buf + offset));
        }
        while (ch == '#') {
            buf += size;
            ch = (int) (*(buf + offset));
        }
    }

    if (ch == 'e' || ch == 's' || ch == 'f' || ch == 'd' || ch == 'l') {    /* suffix  */
        float_flag = TRUE;
        buf += size;
        ch = (int) (*(buf + offset));
        if (ch == '-') {
            sign_flag = -1;
            buf += size;
        } else {
            if (ch == '+')
                buf += size;
        }
        ch = (int) (*(buf + offset));
        if (ch >= '0' && ch <= '9') {
            do {
                exp = exp * 10 + ch - '0';
                buf += size;
                ch = (int) (*(buf + offset));
            } while (ch >= '0' && ch <= '9');

            if (sign_flag == 1)
                val_r *= pow(10.0, (double) exp);
            else
                val_r *= pow(10.0, (double) (-exp));
        } else {
            s_push(LTAG_FALSE);
            return (buf);
        }
    }

    if (float_flag) {       /* short-float (not implement) or float  */
        if (sign < 0)
            s_push(mk_flt(-val_r));
        else
            s_push(mk_flt(val_r));
    } else {
        if (((ENTITYP) ADDRESS(obj.obj))->bnum.next.obj == LTAG_NIL) {
            val_i = ((ENTITYP) ADDRESS(obj.obj))->bnum.val;
            if (sign < 0) {
                val_i = -val_i;
                if (val_i < FIX_MIN) {   /* bignum  */
                    tmp = complement_big(obj.obj);
                    s_push(tmp);
                } else    /* fixnum  */
                    s_push(mk_fix(val_i));
            } else {
                if (val_i > FIX_MAX)    /* bignum  */
                    s_push(obj.obj);
                else    /* fixnum  */
                    s_push(mk_fix(val_i));
            }
        } else {            /* bignum  */
            if (sign < 0) {
                tmp = complement_big(obj.obj);
                s_push(tmp);
            } else
                s_push(obj.obj);
        }
    }
    return (buf);
}

read_sharp_arg(ch)		/* T.Komiya */
int ch;
{
    SOBJ num;
    int i;
    char    *extbuf;
    int readchlen = 0, readbyte = 8, bufsize = STRBUFSIZE;

    c_strbuf = strbuf;

    while (!(ch == '=' || ch == '#')) {
        if (bufsize < readbyte) {
            bufsize = 2 * bufsize;
            extbuf = (char *) Pgetblock2(bufsize + 12);
            for (i = 8; i < readbyte; i++)
                *(extbuf + i) = *(c_strbuf + i);
            c_strbuf = extbuf;
        }
	*(c_strbuf + readbyte++) = (char) ch;
        readchlen++;
        ch = getc2();
    }
    *(c_strbuf + readbyte) = '\0';
#ifdef TCPIP
/*    if (ch != EOF || netportp (c_in_port.obj))  --- ??? */
    if (ch != EOF)
#else
    if (ch != EOF)
#endif
        ungetc2(ch);

    if ((num.obj = str_to_num(c_strbuf + 8, 1, DECIMAL)) == LTAG_FALSE)
	bokkan("strange number.");
    else
	return (num.obj);
}

sharp_eq_reader()		/* T.Komiya */
{
    int i, tmp;
    char s[80];

    for (i = 0; i < sharp_eq_context_max; i++)
	if (eqv(sharp_eq_context[i].sharp_index.obj, *top_val())) {
	    sprintf(s, "Duplicate definitions for #%d=.",
		    fix_to_int(*top_val()));
	    s_pop();
	    bokkan(s);
	}
    if (sharp_eq_context_max >= SHARP_EQ_CONTEXT_SIZE) {
	s_pop();
	bokkan("Too many #= definitions.");
    }
    i = sharp_eq_context_max++;
    sharp_eq_context[i].sharp_index.obj = s_pop();
    sharp_eq_context[i].sharp_sharp.obj = LTAG_NIL;
    sharp_eq_context[i].sharp_eq.obj = LTAG_NIL;
    tmp = readexp1();
    sharp_eq_context[i].sharp_eq.obj = tmp;
    if (sharp_eq_context[i].sharp_eq.obj
	== sharp_eq_context[i].sharp_sharp.obj) {
	sprintf(s, "#%d# is defined by itself.",
		fix_to_int(sharp_eq_context[i].sharp_index.obj));
	bokkan(s);
    }
    return(sharp_eq_context[i].sharp_eq.obj);
}

sharp_sharp_reader()		/* T.Komiya */
{
    int i;
    char s[80];

    for (i = 0; ; i++)
	if (i >= sharp_eq_context_max) {
	    sprintf(s, "#%d# is undefined.", fix_to_int(*top_val()));
	    s_pop();
	    bokkan(s);
	} else if (eqv(sharp_eq_context[i].sharp_index.obj, *top_val()))
	    break;
    s_pop();
    if (sharp_eq_context[i].sharp_sharp.obj == LTAG_NIL)
	sharp_eq_context[i].sharp_sharp.obj
	    = mk_bcc(LTAG_SFUNCTION, LTAG_NIL, LTAG_NIL, LTAG_NIL, LTAG_NIL,
		     LTAG_NIL, 0, 0);
    return(sharp_eq_context[i].sharp_sharp.obj);
}

patch_sharp_cons(x)		/* T.Komiya */
unsigned x;
{
#ifndef SPECIAL_CONS_TAG
    x = ADDRESS(x);
#endif
    for (;;) {
	((ENTITYP)x)->cell.car.obj = patch_sharp(((ENTITYP)x)->cell.car.obj);
	if (GETtag(((ENTITYP)x)->cell.cdr.obj) == LTAG_CONS)
#ifdef SPECIAL_CONS_TAG
	    x = ((ENTITYP)x)->cell.cdr.obj;
#else
	    x = ADDRESS(((ENTITYP)x)->cell.cdr.obj);
#endif
	else {
	    ((ENTITYP)x)->cell.cdr.obj
		= patch_sharp(((ENTITYP)x)->cell.cdr.obj);
	    break;
	}
    }
}

patch_sharp(x)			/* T.Komiya */
unsigned x;
{
    switch (GETtag(x)) {
    case LTAG_SFUNCTION :
    {
	int i;

	for (i = 0; i < sharp_eq_context_max; i++)
	    if (sharp_eq_context[i].sharp_sharp.obj == x)
		return(sharp_eq_context[i].sharp_eq.obj);
	break;
    }
    case LTAG_CONS :
	patch_sharp_cons(x);
	break;
    case LTAG_VECTOR :
    {
	int i;

	for (i = 0; i < IMM(((ENTITYP)ADDRESS(x))->vec.head) >> 2; i++)
	    *((int *)ADDRESS(x) + 1 + i)
		= patch_sharp(*((int *)ADDRESS(x) + 1 + i));
	break;
    }
#ifdef PVM3
    case LTAG_BCLOSURE :
	patch_sharp_cons(((ENTITYP)ADDRESS(x))->bcc.source.obj);
        break;
#endif
    }
    return(x);
}
