/*
 * s_pvm3.c - 
 */

/*
 * $Id: s_pvm3.c,v 1.3 2004/06/24 09:18:43 komiya Exp $
 *
 *               pvm3 Scheme functions                       **
 *                                                           **
 *                            by A243                        **
 */

static char *RCSid="$Id: s_pvm3.c,v 1.3 2004/06/24 09:18:43 komiya Exp $";

#include "scheme.h"
#include "string.h"
#include "stdio.h"
#include "sys/time.h"
#include "/mntc/pvm3/include/pvmtev.h"

#define MAX_FIXNUM 33554431

#define  SCPOP()	(*(sp_reg++)) 
#define  SCPUSH(val)    *(--sp_reg)=(unsigned)(val)
#define  PCUP(n)        bcpc_reg+=(n)

extern int gstid;

extern int err_recover_get_gval();
extern int err_recover_push_gval();
extern int err_recover_set_gval();
extern int set_up_stack_epilogue();
extern int err_recover();

char **cons_to_pointer();
char **vector_to_pointer();
char *malloc();

int ret_recv_function();
int ret_reduce_function();
int ret_on_demand();
#if defined(__CYGWIN32__) || defined(linux)
sigjmp_buf ret_recv;
sigjmp_buf ret_reduce;
sigjmp_buf ret_demand;
#else
jmp_buf ret_recv;
jmp_buf ret_reduce;
jmp_buf ret_demand;
#endif

Spvm_addhosts()
{
    SOBJ obj_hosts, obj_nhost, obj_infos;
    char **hosts;
    int nhost, *infos, info, i;
    char *strobj_to_str();

    obj_hosts.obj = getarg(1);
    obj_nhost.obj = getarg(2);
    obj_infos.obj = getarg(3);

    if((GETtag(obj_hosts.obj) != LTAG_CONS) 
	&& (GETtag(obj_hosts.obj) != LTAG_VECTOR))
	err_illegal_argument("1st argument must be a list or a vector.");

    if(check_NUM(obj_nhost.obj))
	err_illegal_argument("2nd argument must be a number.");

    if((GETtag(obj_infos.obj) != LTAG_CONS) 
	&& (GETtag(obj_infos.obj) != LTAG_NIL)
	&& (GETtag(obj_infos.obj) != LTAG_VECTOR))
	err_illegal_argument("3rd argument must be a list , a vector or ().");

    if(GETtag(obj_hosts.obj) == LTAG_CONS)
	hosts = cons_to_pointer(obj_hosts.obj);
    else
	hosts = vector_to_pointer(obj_hosts.obj);
    nhost = fix_to_int(obj_nhost.obj);
    infos = (int *)malloc(sizeof(int) * nhost);
 
    if(GETtag(obj_hosts.obj) == LTAG_CONS)
	if(listlen(obj_hosts.obj) != nhost) 
	    err_illegal_argument("2nd argument does not match 1st argument."); 
    else if(GETtag(obj_hosts.obj) == LTAG_VECTOR)
	if(nonnil_vector_length(obj_hosts.obj) != nhost)
	    err_illegal_argument("2nd argument does not match 1st argument.");

    if(GETtag(obj_infos.obj) == LTAG_CONS)
	if(listlen(obj_infos.obj) != nhost) 
	    err_illegal_argument("2nd argument does not match 3rd argument."); 
    else if(GETtag(obj_infos.obj) == LTAG_VECTOR)
	if(nonnil_vector_length(obj_infos.obj) != nhost)
	    err_illegal_argument("2nd argument does not match 3rd argument.");

    info = pvm_addhosts(hosts, nhost, infos);

    free(hosts);

    if(GETtag(obj_infos.obj) == LTAG_CONS)
	for(i = 0; i < nhost; i++){
	    set_car(obj_infos.obj, mk_fix2(*(infos + i)));
	    obj_infos.obj = CDRobj(obj_infos.obj);
	}	
    else
	if(GETtag(obj_infos.obj) == LTAG_VECTOR)
	    for(i = 0; i < nhost; i++)
		set_vec(obj_infos.obj, i, mk_fix2(*(infos + i)));
	
    free(infos);   

    set_reg(mk_fix2(info));
}

/***
Spvm_advise()
{
    SOBJ obj_route;
    int route, info;

    obj_route.obj = getarg(1);

    if(check_NUM(obj_route.obj))
	err_illegal_argument("Argument must be a number.");

    route = fix_to_int(obj_route.obj);
    if((route < 1) || (route > 3))
	err_illegal_argument("Argument must be 1 or 2 or 3.");
	
    info = pvm_advise(route);

    set_reg(mk_fix2(info));
}
***/

Spvm_barrier()
{
    SOBJ obj_group, obj_count;
    char *group;
    int count, info;
    char *strobj_to_str();
 
    obj_group.obj = getarg(1);
    obj_count.obj = getarg(2);

    if(GETtag(obj_group.obj) != LTAG_STRING) 
	err_illegal_argument("1st argument must be a string.");

    if(check_NUM(obj_count.obj))
	err_illegal_argument("2nd argument must be a number.");

    group = strobj_to_str(obj_group.obj);
    count = fix_to_int(obj_count.obj);

    info = pvm_barrier(group, count);
 	
    set_reg(mk_fix2(info));
}

Spvm_bcast()
{
    SOBJ obj_group, obj_msgtag;
    char *group;
    int msgtag, info;
    char *strobj_to_str();
 
    obj_group.obj = getarg(1);
    obj_msgtag.obj = getarg(2);

    if(GETtag(obj_group.obj) != LTAG_STRING) 
	err_illegal_argument("1st argument must be a string.");

    if(check_NUM(obj_msgtag.obj))
	err_illegal_argument("2nd argument must be a number.");

    group = strobj_to_str(obj_group.obj);
    msgtag = fix_to_int(obj_msgtag.obj);

    info = pvm_bcast(group, msgtag);
 	
    set_reg(mk_fix2(info));
}

Spvm_bufinfo()
{
    SOBJ obj_bufid, obj_bytes, obj_msgtag, obj_tid;
    int bufid, bytes, msgtag, tid, info;

    obj_bufid.obj = getarg(1);
    obj_bytes.obj = getarg(2);
    obj_msgtag.obj = getarg(3);
    obj_tid.obj = getarg(4);

    if(check_NUM(obj_bufid.obj))
	err_illegal_argument("1st argument must be a number.");

    if((GETtag(obj_bytes.obj) != LTAG_CONS) 
	&& (GETtag(obj_bytes.obj) != LTAG_VECTOR)
	&& (GETtag(obj_bytes.obj) != LTAG_NIL))
	err_illegal_argument("2nd argument must be a pair , a vector or ().");

    if((GETtag(obj_msgtag.obj) != LTAG_CONS) 
	&& (GETtag(obj_msgtag.obj) != LTAG_VECTOR)
	&& (GETtag(obj_msgtag.obj) != LTAG_NIL))
	err_illegal_argument("3rd argument must be a pair , a vector or ().");

    if((GETtag(obj_tid.obj) != LTAG_CONS) 
	&& (GETtag(obj_tid.obj) != LTAG_VECTOR)
	&& (GETtag(obj_tid.obj) != LTAG_NIL))
	err_illegal_argument("4th argument must be a pair , a vector or ().");

    bufid = fix_to_int(obj_bufid.obj);

/*  printf("bufid=%d bytes=%d msgtag=%d tid=%d\n",bufid,&bytes,&msgtag,&tid);
*/
    info = pvm_bufinfo(bufid, &bytes, &msgtag, &tid);

    if(GETtag(obj_bytes.obj) == LTAG_CONS)
	set_car(obj_bytes.obj, mk_fix2(bytes));
    else
	if(GETtag(obj_bytes.obj) == LTAG_VECTOR)
	    set_vec(obj_bytes.obj, 0, mk_fix2(bytes));
    if(GETtag(obj_msgtag.obj) == LTAG_CONS)
	set_car(obj_msgtag.obj, mk_fix2(msgtag));
    else
	if(GETtag(obj_msgtag.obj) == LTAG_VECTOR)
	    set_vec(obj_msgtag.obj, 0, mk_fix2(msgtag));
    if(GETtag(obj_tid.obj) == LTAG_CONS)
	set_car(obj_tid.obj, mk_fix2(tid));
    else 
	if(GETtag(obj_tid.obj) == LTAG_VECTOR)
	    set_vec(obj_tid.obj, 0, mk_fix2(tid));

    set_reg(mk_fix2(info));
}

Spvm_catchout()
{
    SOBJ obj_port;
    int bufid, kind, onoff;
    FILE *fp;
    obj_port.obj = getarg(1);

    if((GETtag(obj_port.obj) != LTAG_PORT)
       && check_NUM(obj_port.obj))
	err_illegal_argument("Argument must be a port or a number.");

    if(GETtag(obj_port.obj) == LTAG_PORT){
	kind = ((ENTITYP)ADDRESS(obj_port.obj))->port.kind;
	fp = ((ENTITYP)ADDRESS(obj_port.obj))->port.fp;
	if(kind != OUTPUT)
	    err_illegal_argument("Port must be a output port");
	bufid = pvm_catchout(fp);
    }
    else{
	onoff = fix_to_int(obj_port.obj);

	if(onoff == 0)
	    bufid = pvm_catchout(0);
	else	
	    err_illegal_argument("Number must be 0.");
	}

    set_reg(LTAG_T);
}

Spvm_config()
{
    SOBJ obj_nhost, obj_narch, obj_hostp, obj_hostp_tmp;
    int nhost, narch, info, len, i;
    struct pvmhostinfo *hostp;

    obj_nhost.obj = getarg(1);
    obj_narch.obj = getarg(2);
    obj_hostp.obj = getarg(3);

    if((GETtag(obj_nhost.obj) != LTAG_CONS) 
	&& (GETtag(obj_nhost.obj) != LTAG_NIL)
	&& (GETtag(obj_nhost.obj) != LTAG_VECTOR))
	err_illegal_argument("1st argument must be a pair , a vector or ().");

    if((GETtag(obj_narch.obj) != LTAG_CONS)
	&& (GETtag(obj_narch.obj) != LTAG_NIL)
	&& (GETtag(obj_narch.obj) != LTAG_VECTOR)) 
	err_illegal_argument("2nd argument must be a pair , a vector or ().");

    if((GETtag(obj_hostp.obj) != LTAG_CONS) 
	&& (GETtag(obj_hostp.obj) != LTAG_NIL)
	&& (GETtag(obj_hostp.obj) != LTAG_VECTOR))
	err_illegal_argument("3rd argument must be a list , a vector or ().");
 
    info = pvm_config(&nhost, &narch, &hostp);

    if(GETtag(obj_nhost.obj) == LTAG_CONS)
	set_car(obj_nhost.obj, mk_fix2(nhost));
    else
	if(GETtag(obj_nhost.obj) == LTAG_VECTOR)
	    set_vec(obj_nhost.obj, 0, mk_fix2(nhost));

    if(GETtag(obj_narch.obj) == LTAG_CONS)
	set_car(obj_narch.obj, mk_fix2(narch));
    else
	if(GETtag(obj_narch.obj) == LTAG_VECTOR)
	    set_vec(obj_narch.obj, 0, mk_fix2(narch));

    if(GETtag(obj_hostp.obj) == LTAG_CONS){
	for(i = 0; i < nhost; i++){
	    obj_hostp_tmp.obj = CARobj(obj_hostp.obj);
	    if(GETtag(obj_hostp_tmp.obj) != LTAG_CONS) 
		err_illegal_argument("3rd argument must be a list include lists.");
	    if(listlen(obj_hostp_tmp.obj) != 4)
		err_illegal_argument("Illegal number of arguments of lists including 3rd argument.");

	    set_car(obj_hostp_tmp.obj, mk_fix2((*(hostp+i)).hi_tid));
	    obj_hostp_tmp.obj = CDRobj(obj_hostp_tmp.obj);
	    len = strlen((*(hostp+i)).hi_name);
	    set_car(obj_hostp_tmp.obj, 
                mk_str(ORDINARY_STRING, A_STRING, len, (*(hostp+i)).hi_name)); 
	    obj_hostp_tmp.obj = CDRobj(obj_hostp_tmp.obj);
	    len = strlen((*(hostp+i)).hi_arch);
	    set_car(obj_hostp_tmp.obj, 
		mk_str(ORDINARY_STRING, A_STRING, len, (*(hostp+i)).hi_arch)); 
	    obj_hostp_tmp.obj = CDRobj(obj_hostp_tmp.obj);
	    set_car(obj_hostp_tmp.obj, mk_fix2((*(hostp+i)).hi_speed));
	    obj_hostp.obj = CDRobj(obj_hostp.obj);
	    obj_hostp_tmp.obj = obj_hostp.obj;
	}
    }	
    else
	if(GETtag(obj_hostp.obj) == LTAG_VECTOR){
	    for(i = 0; i < nhost; i++){
		if(GETtag(get_vec(obj_hostp.obj, i)) != LTAG_VECTOR)
		    err_illegal_argument("3rd argument must be a list include lists.");
		if(nonnil_vector_length(get_vec(obj_hostp.obj, i)) != 4)
		    err_illegal_argument("Illegal number of arguments of lists including 3rd argument.");

	    set_vec(get_vec(obj_hostp.obj, i), 0, mk_fix2((*(hostp+i)).hi_tid));
	    len = strlen((*hostp).hi_name);
	    set_vec(get_vec(obj_hostp.obj, i), 1,
		mk_str(ORDINARY_STRING, A_STRING, len, (*(hostp+i)).hi_name));
	    len = strlen((*(hostp+i)).hi_arch);
	    set_vec(get_vec(obj_hostp.obj, i), 2,
         	mk_str(ORDINARY_STRING, A_STRING, len, (*(hostp+i)).hi_arch));
	    set_vec(get_vec(obj_hostp.obj, i), 3, 
		    mk_fix2((*(hostp+i)).hi_speed));
	    }
	}
    set_reg(mk_fix2(info));
}

Spvm_delete()  /* delete data in pvmd database */
{
    SOBJ obj_name, obj_index;
    char *name;
    int index, data, cc;
    char *strobj_to_str();

    obj_name.obj = getarg(1);
    obj_index.obj = getarg(2);

    if(GETtag(obj_name.obj) != LTAG_STRING)
	err_illegal_argument("1st argument must be a string.");

    if(check_NUM(obj_index.obj))
	err_illegal_argument("2nd argument must be a number.");

    name = strobj_to_str(obj_name.obj);
    index = fix_to_int(obj_index.obj);

    cc = pvm_delete(name, index);

    set_reg(mk_fix2(cc));
}

Spvm_delhosts()
{
    SOBJ obj_hosts, obj_nhost, obj_infos;
    char **hosts;
    int nhost, *infos, info, i;
    char *strobj_to_str();

    obj_hosts.obj = getarg(1);
    obj_nhost.obj = getarg(2);
    obj_infos.obj = getarg(3);

    if((GETtag(obj_hosts.obj) != LTAG_CONS) 
	&& (GETtag(obj_hosts.obj) != LTAG_VECTOR)) 
	err_illegal_argument("1st argument must be a list or a vector.");
       
    if(check_NUM(obj_nhost.obj))
	err_illegal_argument("2nd argument must be a number.");

    if((GETtag(obj_infos.obj) != LTAG_CONS) 
	&& (GETtag(obj_infos.obj) != LTAG_NIL)
	&& (GETtag(obj_infos.obj) != LTAG_VECTOR))
	err_illegal_argument("3rd argument must be a list , a vector or ().");
  
    if(GETtag(obj_hosts.obj) == LTAG_CONS)
	hosts = cons_to_pointer(obj_hosts.obj);
    else
	hosts = vector_to_pointer(obj_hosts.obj);
    nhost = fix_to_int(obj_nhost.obj);
    infos = (int *)malloc(sizeof(int) * nhost);

    if(GETtag(obj_hosts.obj) == LTAG_CONS)
	if(listlen(obj_hosts.obj) != nhost)
	    err_illegal_argument("2nd argument does not match 1st argument."); 
    else if(GETtag(obj_hosts.obj) == LTAG_VECTOR)
	if(nonnil_vector_length(obj_hosts.obj) != nhost)
	    err_illegal_argument("2nd argument does not match 1st argument.");
 
    if(GETtag(obj_infos.obj) == LTAG_CONS)
	if(listlen(obj_infos.obj) != nhost)
	    err_illegal_argument("2nd argument does not match 3rd argument."); 
    else if(GETtag(obj_infos.obj) == LTAG_VECTOR)
	if(nonnil_vector_length(obj_infos.obj) != nhost)
	    err_illegal_argument("2nd argument does not match 3rd argument."); 

    info = pvm_delhosts(hosts, nhost, infos);

    free(hosts);

    if(GETtag(obj_infos.obj) == LTAG_CONS)
	for(i = 0; i < nhost; i++){
	    set_car(obj_infos.obj, mk_fix2(*(infos + i)));
	    obj_infos.obj = CDRobj(obj_infos.obj);
	}	
    else
	if(GETtag(obj_infos.obj) == LTAG_VECTOR)
	    for(i = 0; i < nhost; i++)
		    set_vec(obj_infos.obj, i, mk_fix2(*(infos + i)));
	
    free(infos);   

    set_reg(mk_fix2(info));
}

Spvm_exit()
{
    int info;

    info = pvm_exit();

    set_reg(mk_fix2(info));
}

Spvm_freebuf()
{
    SOBJ obj_bufid;
    int bufid, info;

    obj_bufid.obj = getarg(1);

    if(check_NUM(obj_bufid.obj))
	err_illegal_argument("Argument must be a number.");

    bufid = fix_to_int(obj_bufid.obj);

    info = pvm_freebuf(bufid);

    set_reg(mk_fix2(info));
}

Spvm_getinst()
{
    SOBJ obj_group, obj_tid;
    char *group;
    int tid, info;
    char *strobj_to_str();
 
    obj_group.obj = getarg(1);
    obj_tid.obj = getarg(2);

    if(GETtag(obj_group.obj) != LTAG_STRING) 
	err_illegal_argument("1st argument must be a string.");

    if(check_NUM(obj_tid.obj))
	err_illegal_argument("2nd argument must be a number.");

    group = strobj_to_str(obj_group.obj);
    tid = fix_to_int(obj_tid.obj);

    info = pvm_getinst(group, tid);
 	
    set_reg(mk_fix2(info));
}

Spvm_getopt()
{
    SOBJ obj_what;
    int what, val;

    obj_what.obj = getarg(1);

    if(check_NUM(obj_what.obj))
	err_illegal_argument("Argument must be a number.");
    
    what = fix_to_int(obj_what.obj);

    if((what < 1) || (what > 9))
	err_illegal_argument("Argument is beyond the extent.");

    val = pvm_getopt(what);

    set_reg(mk_fix2(val));
}

Spvm_getrbuf()
{
    int bufid;

    bufid = pvm_getrbuf();

    set_reg(mk_fix2(bufid));
}

Spvm_getsbuf()
{
    int bufid;

    bufid = pvm_getsbuf();

    set_reg(mk_fix2(bufid));
}

Spvm_gettid()
{
    SOBJ obj_group, obj_inum;
    char *group;
    int inum, tid;
    char *strobj_to_str();
 
    obj_group.obj = getarg(1);
    obj_inum.obj = getarg(2);

    if(GETtag(obj_group.obj) != LTAG_STRING) 
	err_illegal_argument("1st argument must be a string.");
    if(check_NUM(obj_inum.obj))
	err_illegal_argument("2nd argument must be a number.");

    group = strobj_to_str(obj_group.obj);
    inum = fix_to_int(obj_inum.obj);

    tid = pvm_gettid(group, inum);
 	
    set_reg(mk_fix2(tid));
}

Spvm_gsize()
{
    SOBJ obj_group;
    char *group;
    int size;
    char *strobj_to_str();
 
    obj_group.obj = getarg(1);

    if(GETtag(obj_group.obj) != LTAG_STRING)
	err_illegal_argument("Argument must be a string.");

    group = strobj_to_str(obj_group.obj);
	
    size = pvm_gsize(group);
 	
    set_reg(mk_fix2(size));
}

Spvm_halt()
{
    int info;

    info = pvm_halt();

    set_reg(mk_fix2(info));
}

Spvm_hostsync()
{
    SOBJ obj_host, obj_clk, obj_delta;
    struct timeval clk, delta;
    int host, info;

    obj_host.obj = getarg(1);
    obj_clk.obj = getarg(2);
    obj_delta.obj = getarg(3);

    if(check_NUM(obj_host.obj))
	err_illegal_argument("1st argument must be a number.");

    if((GETtag(obj_clk.obj) != LTAG_CONS) 
       && (GETtag(obj_clk.obj) != LTAG_VECTOR))
	err_illegal_argument("2nd argument must be a list or a vector.");

    if((GETtag(obj_delta.obj) != LTAG_CONS) 
       && (GETtag(obj_delta.obj) != LTAG_VECTOR))
	err_illegal_argument("3rd argument must be a list or a vector.");

    host = fix_to_int(obj_host.obj);

    info = pvm_hostsync(host, &clk, &delta);

    if(GETtag(obj_clk.obj) == LTAG_CONS){
	if(listlen(obj_clk.obj) != 2)
	    err_illegal_argument("A list length of 2nd argument must be 2.");
	set_car(obj_clk.obj, mk_fix2(clk.tv_sec));
	set_car(CDRobj(obj_clk.obj), mk_fix2(clk.tv_usec));
    }
    else{
	if(nonnil_vector_length(obj_clk.obj) != 2) 
	    err_illegal_argument("A vector length of 2nd argument must be 2."); 
	    set_vec(obj_clk.obj, 0, mk_fix2(clk.tv_sec));
	    set_vec(obj_clk.obj, 1, mk_fix2(clk.tv_usec));
    }

    if(GETtag(obj_delta.obj) == LTAG_CONS){
	if(listlen(obj_delta.obj) != 2)
	    err_illegal_argument("A list length of 3rd argument must be 2.");
	set_car(obj_delta.obj, mk_fix2(delta.tv_sec));
	set_car(CDRobj(obj_delta.obj), mk_fix2(delta.tv_usec));
    }
    else{
	if(nonnil_vector_length(obj_delta.obj) != 2) 
	    err_illegal_argument("A vector length of 3rd argument must be 2."); 
	    set_vec(obj_delta.obj, 0, mk_fix2(delta.tv_sec));
	    set_vec(obj_delta.obj, 1, mk_fix2(delta.tv_usec));
    }

    set_reg(mk_fix2(info));
}

Spvm_initsend()
{
    SOBJ obj_encoding;
    int encoding, bufid;

    obj_encoding.obj = getarg(1);

    if(check_NUM(obj_encoding.obj))
	err_illegal_argument("Argument must be a number.");

    encoding = (fix_to_int(obj_encoding.obj));
    if((encoding < 0) || (encoding > 2))
	err_illegal_argument("Argument must be 0 , 1 or 2.");
	
    bufid = pvm_initsend(encoding);

    set_reg(mk_fix2(bufid));
}

Spvm_insert()  /* store data in pvmd database */
{
    SOBJ obj_name, obj_index, obj_data;
    char *name;
    int index, data, cc;
    char *strobj_to_str();

    obj_name.obj = getarg(1);
    obj_index.obj = getarg(2);
    obj_data.obj = getarg(3);

    if(GETtag(obj_name.obj) != LTAG_STRING)
	err_illegal_argument("1st argument must be a string.");

    if(check_NUM(obj_index.obj))
	err_illegal_argument("2nd argument must be a number.");

    if(check_NUM(obj_data.obj))
	err_illegal_argument("3rd argument must be a number.");

    name = strobj_to_str(obj_name.obj);
    index = fix_to_int(obj_index.obj);
    data = fix_to_int(obj_data.obj);

    cc = pvm_insert(name, index, data);

    set_reg(mk_fix2(cc));
}

Spvm_joingroup()
{
    SOBJ obj_group;
    char *group;
    int inum;
    char *strobj_to_str();
 
    obj_group.obj = getarg(1);

    if(GETtag(obj_group.obj) != LTAG_STRING)
	err_illegal_argument("Argument must be a string.");

    group = strobj_to_str(obj_group.obj);
	
    inum = pvm_joingroup(group);
 	
    set_reg(mk_fix2(inum));
}

Spvm_kill()
{
    SOBJ obj_tid;
    int tid, info;

    obj_tid.obj = getarg(1);

    if(check_NUM(obj_tid.obj))
	err_illegal_argument("Argument must be a number.");

    tid = fix_to_int(obj_tid.obj);

    info = pvm_kill(tid);

    set_reg(mk_fix2(info));
}

Spvm_lookup()  /* retrieve data from pvmd database */
{
    SOBJ obj_name, obj_index, obj_data;
    char *name;
    int index, data, cc;
    char *strobj_to_str();

    obj_name.obj = getarg(1);
    obj_index.obj = getarg(2);
    obj_data.obj = getarg(3);

    if(GETtag(obj_name.obj) != LTAG_STRING)
	err_illegal_argument("1st argument must be a string.");

    if(check_NUM(obj_index.obj))
	err_illegal_argument("2nd argument must be a number.");

    if((GETtag(obj_data.obj) != LTAG_CONS) 
	&& (GETtag(obj_data.obj) != LTAG_NIL)
	&& (GETtag(obj_data.obj) != LTAG_VECTOR))
	err_illegal_argument("3rd argument must be a list , a vector or ().");

    name = strobj_to_str(obj_name.obj);
    index = fix_to_int(obj_index.obj);

    cc = pvm_lookup(name, index, &data);

    if(GETtag(obj_data.obj) == LTAG_CONS)
       set_car(obj_data.obj, mk_fix2(data));
    else
	if(GETtag(obj_data.obj) == LTAG_VECTOR)
	    set_vec(obj_data.obj, 0, mk_fix2(data));

    set_reg(mk_fix2(cc));
}

Spvm_lvgroup()
{
    SOBJ obj_group;
    char *group;
    int info;
    char *strobj_to_str();
 
    obj_group.obj = getarg(1);

    if(GETtag(obj_group.obj) != LTAG_STRING)
	err_illegal_argument("Argument must be a string.");

    group = strobj_to_str(obj_group.obj);
	
    info = pvm_lvgroup(group);
 	
    set_reg(mk_fix2(info));
}

Spvm_mcast()
{
    SOBJ obj_tids, obj_ntask, obj_msgtag;
    int *tids, ntask, msgtag, info, i;

    obj_tids.obj = getarg(1);
    obj_ntask.obj = getarg(2);
    obj_msgtag.obj = getarg(3);

    if((GETtag(obj_tids.obj) != LTAG_CONS) 
	&& (GETtag(obj_tids.obj) != LTAG_VECTOR)) 
	err_illegal_argument("1st argument must be a list or a vector.");

    if(check_NUM(obj_ntask.obj))
	err_illegal_argument("2nd argument must be a number.");

    if(check_NUM(obj_msgtag.obj))
	err_illegal_argument("3rd argument must be a number.");

    ntask = fix_to_int(obj_ntask.obj);
    tids = (int *)malloc(sizeof(int) * ntask);
    msgtag = fix_to_int(obj_msgtag.obj);

    if(GETtag(obj_tids.obj) == LTAG_CONS)
	if(listlen(obj_tids.obj) < ntask) 
	    err_illegal_argument("2nd argument does not match 1st argument.");
    else
	if(GETtag(obj_tids.obj) == LTAG_VECTOR)
	   if(nonnil_vector_length(obj_tids.obj) < ntask)
	     err_illegal_argument("2nd argument does not match 1st argument.");

    if(GETtag(obj_tids.obj) == LTAG_CONS)
	for(i = 0; i < ntask; i++){
	    if(check_NUM(CARobj(obj_tids.obj)) == 0)
		*(tids + i) = fix_to_int(CARobj(obj_tids.obj));
	    obj_tids.obj = CDRobj(obj_tids.obj);
	}	
    else
	for(i = 0; i < ntask; i++)
	    if(check_NUM(get_vec(obj_tids.obj, i)) == 0)
		*(tids + i) = fix_to_int(get_vec(obj_tids.obj, i));

    info = pvm_mcast(tids, ntask, msgtag);
    
    free(tids);

    set_reg(mk_fix2(info));
}

Spvm_mkbuf()
{
    SOBJ obj_encoding;
    int encoding, bufid;

    obj_encoding.obj = getarg(1);

    if(check_NUM(obj_encoding.obj))
	err_illegal_argument("Argument must be a number.");

    encoding = fix_to_int(obj_encoding.obj);
    if((encoding < 0) || (encoding > 2))
	err_illegal_argument("Argument must be 0 , 1 or 2.");

    bufid = pvm_mkbuf(encoding);

    set_reg(mk_fix2(bufid));
}

Spvm_mstat()
{
    SOBJ obj_host;
    char *host;
    int mstat;
    char *strobj_to_str();
 
    obj_host.obj = getarg(1);

    if(GETtag(obj_host.obj) != LTAG_STRING)
	err_illegal_argument("Argument must be a string.");
    
    host = strobj_to_str(obj_host.obj);
	
    mstat = pvm_mstat(host);
 	
    set_reg(mk_fix2(mstat));
}

Spvm_mytid()
{
    int tid;

    tid = pvm_mytid();       

    set_reg(mk_fix2(tid));
}

Spvm_notify()
{
    SOBJ obj_what, obj_msgtag, obj_ntask, obj_tids;
    int what, msgtag, ntask, *tids, info ,i;

    obj_what.obj = getarg(1);
    obj_msgtag.obj = getarg(2);
    obj_ntask.obj = getarg(3);
    obj_tids.obj = getarg(4);

    if(check_NUM(obj_what.obj))
	err_illegal_argument("1st argument must be a number.");

    if(check_NUM(obj_msgtag.obj))
	err_illegal_argument("2nd argument must be a number.");

    if(check_NUM(obj_ntask.obj))
	err_illegal_argument("3rd argument must be a number.");

    if((GETtag(obj_tids.obj) != LTAG_CONS) 
	&& (GETtag(obj_tids.obj) != LTAG_VECTOR)
	&& (GETtag(obj_tids.obj) != LTAG_NIL))
	err_illegal_argument("4th argument must be a list, a vector or ().");

    what = fix_to_int(obj_what.obj);
    msgtag = fix_to_int(obj_msgtag.obj);
    ntask = fix_to_int(obj_ntask.obj);
    
    if(what != PvmHostAdd){
      if(GETtag(obj_tids.obj) == LTAG_CONS)
	if(listlen(obj_tids.obj) < ntask)
	   err_illegal_argument("3rd argument does not match 4th argument."); 
	else if(GETtag(obj_tids.obj) == LTAG_VECTOR)
	   if(nonnil_vector_length(obj_tids.obj) < ntask)
	     err_illegal_argument("3rd argument does not match 4th argument.");
    
	tids = (int *)malloc(sizeof(int) * ntask);	    
	if(GETtag(obj_tids.obj) == LTAG_CONS){
	    for(i = 0; i < ntask; i++){
		if(check_NUM(CARobj(obj_tids.obj)) == 0)
		    *(tids + i) = fix_to_int(CARobj(obj_tids.obj));
		obj_tids.obj = CDRobj(obj_tids.obj);
	    }	
	}
	else
	    for(i = 0; i < ntask; i++)
		if(check_NUM(get_vec(obj_tids.obj, i)) == 0)
		    *(tids + i) = fix_to_int(get_vec(obj_tids.obj, i));
    }
/* printf("what = %d, msgtag = %d, ntask = %d, tids = %d\n", what, msgtag, ntask, *tids); */
    info = pvm_notify(what, msgtag, ntask, tids);

    set_reg(mk_fix2(info));
}

Spvm_nrecv()
{
    SOBJ obj_tid, obj_msgtag;
    int bufid;

    obj_tid.obj = getarg(1);
    obj_msgtag.obj = getarg(2);

    if(check_NUM(obj_tid.obj))
	err_illegal_argument("1st argument must be a number.");

    if(check_NUM(obj_msgtag.obj))
	err_illegal_argument("2nd argument must be a number.");

    bufid = pvm_nrecv(fix_to_int(obj_tid.obj), fix_to_int(obj_msgtag.obj));

    set_reg(mk_fix2(bufid));
}

Spvm_parent()
{
    int tid;

    tid = pvm_parent();

    set_reg(mk_fix2(tid));
}

Spvm_perror()
{
    SOBJ obj_msg;
    char *msg;
    int info;
    char *strobj_to_str();
 
    obj_msg.obj = getarg(1);

    if(GETtag(obj_msg.obj) == LTAG_STRING){
	
 	msg = strobj_to_str(obj_msg.obj);
	
	info = pvm_perror(msg);
 	
	set_reg(mk_fix2(info));
    }
    else{
	if(GETtag(obj_msg.obj) == LTAG_NIL){
	    
	    info = pvm_perror();

	    set_reg(mk_fix2(info));
	}
	else
	    err_illegal_argument("Argument must be a string or ().");   
    }
}

Spvm_pkfloat()
{
    SOBJ obj_fp, obj_nitem, obj_stride;
    double *fp;
    int nitem, stride, info, i;
    double flt_to_double();
    
    obj_fp.obj = getarg(1);
    obj_nitem.obj = getarg(2);
    obj_stride.obj = getarg(3);

    if(GETtag(obj_fp.obj) != LTAG_CONS) 
	err_illegal_argument("1st argument must be a list.");

    if(check_NUM(obj_nitem.obj))
	err_illegal_argument("2nd argument must be a number.");

    if(check_NUM(obj_stride.obj))
	err_illegal_argument("3rd argument must be a number.");

    nitem = fix_to_int(obj_nitem.obj);
    fp = (double *)malloc(sizeof(double) * nitem);
    stride = fix_to_int(obj_stride.obj);

    if(listlen(obj_fp.obj) < nitem) 
	err_illegal_argument("2nd argument does not match 1st argument.");

    for(i = 0 ;i < nitem; i++){
	if((GETtag(CARobj(obj_fp.obj)) == LTAG_FLOAT)
	   || (GETtag(CARobj(obj_fp.obj)) == LTAG_SFLOAT))
	    *(fp + i) = (double)flt_to_double(CARobj(obj_fp.obj));
	else
	    if(check_NUM(GETtag(CARobj(obj_fp.obj))) == 0)
		*(fp + i) = (double)fix_to_int(CARobj(obj_fp.obj));
	obj_fp.obj = CDRobj(obj_fp.obj);
    }

    info = pvm_pkdouble(fp, nitem, stride);

    free(fp);       
	
    set_reg(mk_fix2(info));
}

Spvm_pkfloat2()
{
    SOBJ obj_fp, obj_nitem, obj_stride, obj_from;
    double *fp;
    int nitem, stride, info, i, from;
    double flt_to_double();
    
    obj_fp.obj = getarg(1);
    obj_nitem.obj = getarg(2);
    obj_stride.obj = getarg(3);
    obj_from.obj = getarg(4);

    if(GETtag(obj_fp.obj) != LTAG_VECTOR)
	err_illegal_argument("1st argument must be a vector.");

    if(check_NUM(obj_nitem.obj))
	err_illegal_argument("2nd argument must be a number.");

    if(check_NUM(obj_stride.obj))
	err_illegal_argument("3rd argument must be a number.");

    if(check_NUM(obj_from.obj))
	err_illegal_argument("4th argument must be a number.");

    nitem = fix_to_int(obj_nitem.obj);
    fp = (double *)malloc(sizeof(double) * nitem);
    stride = fix_to_int(obj_stride.obj);
    from = fix_to_int(obj_from.obj);

    if(nonnil_vector_length(obj_fp.obj) < nitem) 
	err_illegal_argument("2nd argument does not match 1st argument."); 

    for(i = 0; i < nitem; i++)
	if((GETtag(get_vec(obj_fp.obj, i)) == LTAG_FLOAT)
	   || (GETtag(get_vec(obj_fp.obj, i)) == LTAG_SFLOAT))
	    *(fp + i) = (double)flt_to_double(get_vec(obj_fp.obj, from + i));
	else
	    if(check_NUM(GETtag(CARobj(obj_fp.obj))) == 0)
		*(fp + i) = (double)fix_to_int(get_vec(obj_fp.obj), from + i);

    info = pvm_pkdouble(fp, nitem, stride);

    free(fp);       
	
    set_reg(mk_fix2(info));
}

Spvm_pkfix()
{
    SOBJ obj_ip, obj_nitem, obj_stride;
    int *ip, nitem, stride, info, i;
    
    obj_ip.obj = getarg(1);
    obj_nitem.obj = getarg(2);
    obj_stride.obj = getarg(3);

    if(GETtag(obj_ip.obj) != LTAG_CONS) 
	err_illegal_argument("1st argument must be a list.");

    if(check_NUM(obj_nitem.obj))
	err_illegal_argument("2nd argument must be a number.");

    if(check_NUM(obj_stride.obj))
	err_illegal_argument("3rd argument must be a number.");

    nitem = fix_to_int(obj_nitem.obj);
    ip = (int *)malloc(sizeof(int) * nitem);
    stride = fix_to_int(obj_stride.obj);

    if(listlen(obj_ip.obj) < nitem) 
	err_illegal_argument("2nd argument does not match 1st argument."); 

    for(i = 0; i < nitem; i++){
	if(check_NUM(CARobj(obj_ip.obj)) == 0)
	    *(ip + i) = fix_to_int(CARobj(obj_ip.obj));
	obj_ip.obj = CDRobj(obj_ip.obj);
    }

    info = pvm_pkint(ip, nitem, stride);

    free(ip);       
    set_reg(mk_fix2(info));
}

Spvm_pkfix2()
{
    SOBJ obj_ip, obj_nitem, obj_stride, obj_from;
    int *ip, nitem, stride, info, i, from;
    
    obj_ip.obj = getarg(1);
    obj_nitem.obj = getarg(2);
    obj_stride.obj = getarg(3);
    obj_from.obj = getarg(4);

    if(GETtag(obj_ip.obj) != LTAG_VECTOR)
	err_illegal_argument("1st argument must be a vector.");

    if(check_NUM(obj_nitem.obj))
	err_illegal_argument("2nd argument must be a number.");

    if(check_NUM(obj_stride.obj))
	err_illegal_argument("3rd argument must be a number.");

    if(check_NUM(obj_from.obj))
	err_illegal_argument("4th argument must be a number.");

    nitem = fix_to_int(obj_nitem.obj);
    ip = (int *)malloc(sizeof(int) * nitem);
    stride = fix_to_int(obj_stride.obj);
    from = fix_to_int(obj_from.obj);

    if(nonnil_vector_length(obj_ip.obj) < nitem) 
	err_illegal_argument("2nd argument does not match 1st argument.");

    for(i = 0; i < nitem; i++)
	if(check_NUM(get_vec(obj_ip.obj, i)) == 0)
	    *(ip + i) = fix_to_int(get_vec(obj_ip.obj, from + i));
	
    info = pvm_pkint(ip, nitem, stride);

    free(ip);       
    set_reg(mk_fix2(info));
}

Spvm_pkstr()
{
    SOBJ obj_sp;
    char *sp, *strobj_to_str();
    int len, info;

    obj_sp.obj = getarg(1);

    if(GETtag(obj_sp.obj) != LTAG_STRING)
	err_illegal_argument("Argument must be a string.");

    len = ((STRING *)ADDRESS(obj_sp.obj))->str_len;
    sp = malloc(sizeof(char) * len + 1);
    strncpy(sp, strobj_to_str(obj_sp.obj), len);
    *(sp + len) = '\0';

    info = pvm_pkstr(sp);

    free(sp);   
	
    set_reg(mk_fix2(info));
}

Spvm_precv()
{
    SOBJ obj_tid, obj_msgtag, obj_buf, obj_len, obj_datatype;
    SOBJ obj_atid, obj_atag, obj_alen, tmp;
    int tid, msgtag, len, datatype, atid, atag, alen, i, info, size;
    char *str, *t;
    void *buf;

    obj_tid.obj = getarg(1);
    obj_msgtag.obj = getarg(2);
    obj_buf.obj = getarg(3);
    obj_len.obj = getarg(4);
    obj_datatype.obj = getarg(5);
    obj_atid.obj = getarg(6);
    obj_atag.obj = getarg(7);
    obj_alen.obj = getarg(8);

    if(check_NUM(obj_tid.obj))
	err_illegal_argument("1st argument must be a number.");

    if(check_NUM(obj_msgtag.obj))
	err_illegal_argument("2nd argument must be a number.");

    if((GETtag(obj_buf.obj) != LTAG_CONS) 
       && (GETtag(obj_buf.obj) != LTAG_VECTOR))
	err_illegal_argument("3rd argument must be a list or a vector.");

    if(check_NUM(obj_len.obj))
	err_illegal_argument("4th argument must be a number.");

    if(check_NUM(obj_datatype.obj))
	err_illegal_argument("5th argument must be a number.");

    if((GETtag(obj_atid.obj) != LTAG_CONS) 
       && (GETtag(obj_atid.obj) != LTAG_VECTOR))
	err_illegal_argument("6th argument must be a list or a vector.");

    if((GETtag(obj_atag.obj) != LTAG_CONS) 
       && (GETtag(obj_atag.obj) != LTAG_VECTOR))
	err_illegal_argument("7th argument must be a list or a vector.");

    if((GETtag(obj_alen.obj) != LTAG_CONS) 
       && (GETtag(obj_alen.obj) != LTAG_VECTOR))
	err_illegal_argument("8th argument must be a list or a vector.");

    tid = fix_to_int(obj_tid.obj);
    msgtag = fix_to_int(obj_msgtag.obj);
    len = fix_to_int(obj_len.obj);
    datatype = fix_to_int(obj_datatype.obj);

    switch(datatype){
    case PVM_INT :
	buf = (int *)malloc(sizeof(int) * len);
	size = sizeof(int);
	break;

    case PVM_DOUBLE :
	buf = (double *)malloc(sizeof(double) * len);
	size = sizeof(double);
	break;

    default:
	err_illegal_argument("5th argument dose not match.");
    }

    info = pvm_precv(tid, msgtag, buf, len, datatype, &atid, &atag, &alen);

    alen = alen / size;

    if(GETtag(obj_atid.obj) == LTAG_CONS)
	set_car(obj_atid.obj, mk_fix2(atid));
    else
	if(GETtag(obj_atid.obj) == LTAG_VECTOR)
	    set_vec(obj_atid.obj, 0, mk_fix2(atid));

    if(GETtag(obj_atag.obj) == LTAG_CONS)
	set_car(obj_atag.obj, mk_fix2(atag));
    else
	if(GETtag(obj_atag.obj) == LTAG_VECTOR)
	    set_vec(obj_atag.obj, 0, mk_fix2(atag));

    if(GETtag(obj_alen.obj) == LTAG_CONS)
	set_car(obj_alen.obj, mk_fix2(alen));
    else
	if(GETtag(obj_alen.obj) == LTAG_VECTOR)
	    set_vec(obj_alen.obj, 0, mk_fix2(alen));

    switch(datatype){
    case PVM_INT :
	if(GETtag(obj_buf.obj) == LTAG_CONS)
	    for(i = 0; i < alen; i++){
		set_car(obj_buf.obj, mk_fix2(((int *)buf)[i]));
		obj_buf.obj = CDRobj(obj_buf.obj);
	    }
	else
	    for(i = 0; i < len; i++)
		set_vec(obj_buf.obj, i ,mk_fix2(((int *)buf)[i]));
	break;
	
    case PVM_DOUBLE :
	if(GETtag(obj_buf.obj) == LTAG_CONS)
        for(i = 0; i < alen; i++){
            s_push(obj_buf.obj);
            tmp.obj = mk_flt(((double *)buf)[i]);
            obj_buf.obj = s_pop();
            set_car(obj_buf.obj, tmp.obj);
            obj_buf.obj = CDRobj(obj_buf.obj);
        }
    else
        for(i = 0; i < alen; i++){
            s_push(obj_buf.obj);
            tmp.obj = mk_flt(((double *)buf)[i]);
            obj_buf.obj = s_pop();
            set_vec(obj_buf.obj, i ,tmp.obj);
        }

	break;

    default:
	err_illegal_argument("3rd argument dose not match.");
    }

    free(buf);   

    set_reg(mk_fix2(info));
}
    
Spvm_probe()
{
    SOBJ obj_tid, obj_msgtag;
    int bufid;

    obj_tid.obj = getarg(1);
    obj_msgtag.obj = getarg(2);

    if(check_NUM(obj_tid.obj))
	err_illegal_argument("1st argument must be a number.");

    if(check_NUM(obj_msgtag.obj))
	err_illegal_argument("2nd argument must be a number.");

    bufid = pvm_probe(fix_to_int(obj_tid.obj), fix_to_int(obj_msgtag.obj));

    set_reg(mk_fix2(bufid));
}

Spvm_psend()      
{
    SOBJ obj_tid, obj_msgtag, obj_buf, obj_len, obj_datatype;
    int tid, msgtag, len, datatype, i, info;
    char *strobj_to_str();
    void *buf;

    obj_tid.obj = getarg(1);
    obj_msgtag.obj = getarg(2);
    obj_buf.obj = getarg(3);
    obj_len.obj = getarg(4);
    obj_datatype.obj = getarg(5);

    if(check_NUM(obj_tid.obj))
	err_illegal_argument("1st argument must be a number.");

    if(check_NUM(obj_msgtag.obj))
	err_illegal_argument("2nd argument must be a number.");

    if(GETtag(obj_buf.obj) != LTAG_CONS) 
	err_illegal_argument("3rd argument must be a list.");

    if(check_NUM(obj_len.obj))
	err_illegal_argument("4th argument must be a number.");

    if(check_NUM(obj_datatype.obj))
	err_illegal_argument("5th argument must be a number.");

    tid = fix_to_int(obj_tid.obj);
    msgtag = fix_to_int(obj_msgtag.obj);
    len = fix_to_int(obj_len.obj);
    datatype = fix_to_int(obj_datatype.obj);

    switch(datatype){
    case PVM_INT :
	buf = (int *)malloc(sizeof(int) * len);
	for(i = 0; i < len; i++){
	    if(check_NUM(CARobj(obj_buf.obj)) == 0)
		((int *)buf)[i] = fix_to_int(CARobj(obj_buf.obj));
	    obj_buf.obj = CDRobj(obj_buf.obj);
	}
	break;

    case PVM_DOUBLE :
	buf = (double *)malloc(sizeof(double) * len);
	for(i = 0 ;i < len; i++){
	    if((GETtag(CARobj(obj_buf.obj)) == LTAG_FLOAT)
	       || (GETtag(CARobj(obj_buf.obj)) == LTAG_SFLOAT))
		((double *)buf)[i] = 
		    (double)flt_to_double(CARobj(obj_buf.obj));
	    else
		if(check_NUM(GETtag(CARobj(obj_buf.obj))) == 0)
		    ((double *)buf)[i] = 
			(double)fix_to_int(CARobj(obj_buf.obj));
	    obj_buf.obj = CDRobj(obj_buf.obj);
	}
	break;	

    default:
	err_illegal_argument("5th argument does not match.");
    }

    info = pvm_psend(tid, msgtag, buf, len, datatype);    
    free(buf);   

    set_reg(mk_fix2(info));
}
    
Spvm_psend2()      
{
    SOBJ obj_tid, obj_msgtag, obj_buf, obj_len, obj_datatype, obj_from;
    int tid, msgtag, len, datatype, i, info, from;
    char *strobj_to_str();
    void *buf;

    obj_tid.obj = getarg(1);
    obj_msgtag.obj = getarg(2);
    obj_buf.obj = getarg(3);
    obj_len.obj = getarg(4);
    obj_datatype.obj = getarg(5);
    obj_from.obj = getarg(6);

    if(check_NUM(obj_tid.obj))
	err_illegal_argument("1st argument must be a number.");

    if(check_NUM(obj_msgtag.obj))
	err_illegal_argument("2nd argument must be a number.");

    if(GETtag(obj_buf.obj) != LTAG_VECTOR)
	err_illegal_argument("3rd argument must be a vector.");

    if(check_NUM(obj_len.obj))
	err_illegal_argument("4th argument must be a number.");

    if(check_NUM(obj_datatype.obj))
	err_illegal_argument("5th argument must be a number.");

    if(check_NUM(obj_from.obj))
	err_illegal_argument("6th argument must be a number.");

    tid = fix_to_int(obj_tid.obj);
    msgtag = fix_to_int(obj_msgtag.obj);
    len = fix_to_int(obj_len.obj);
    datatype = fix_to_int(obj_datatype.obj);
    from = fix_to_int(obj_from.obj);

    switch(datatype){
    case PVM_INT :
	buf = (int *)malloc(sizeof(int) * len);
	for(i = 0; i < len; i++)
	    if(check_NUM(get_vec(obj_buf.obj, i)) == 0)
		((int *)buf)[i] = fix_to_int(get_vec(obj_buf.obj, from + i));
	break;

    case PVM_DOUBLE :
	buf = (double *)malloc(sizeof(double) * len);
	for(i = 0; i < len; i++)
            if((GETtag(get_vec(obj_buf.obj, i)) == LTAG_FLOAT)
               || (GETtag(get_vec(obj_buf.obj, i)) == LTAG_SFLOAT))
                ((double *)buf)[i] = 
		    (double)flt_to_double(get_vec(obj_buf.obj, from + i));
            else	
                if(check_NUM(GETtag(CARobj(obj_buf.obj))) == 0)
		    ((double *)buf)[i] = 
			(double)fix_to_int(get_vec(obj_buf.obj), from + i);
	break;	

    default:
	err_illegal_argument("5th argument does not match.");
    }

    info = pvm_psend(tid, msgtag, buf, len, datatype);    
    free(buf);   

    set_reg(mk_fix2(info));
}
    
Spvm_pstat()
{
    SOBJ obj_tid;
    int status;

    obj_tid.obj = getarg(1);

    if(check_NUM(obj_tid.obj))
	err_illegal_argument("Argument must be a number.");

    status = pvm_pstat(fix_to_int(obj_tid.obj));

    set_reg(mk_fix2(status));
}

Spvm_recv()
{
    SOBJ obj_tid, obj_msgtag;
    int bufid;

    obj_tid.obj = getarg(1);
    obj_msgtag.obj = getarg(2);

    if(check_NUM(obj_tid.obj))
	err_illegal_argument("1st argument must be a number.");

    if(check_NUM(obj_msgtag.obj))
	err_illegal_argument("2nd argument must be a number.");

    bufid = pvm_recv(fix_to_int(obj_tid.obj), fix_to_int(obj_msgtag.obj));

    set_reg(mk_fix2(bufid));
}

static int
new_recv_function(mid, tid, code)
int mid, tid, code;
{
#if defined(__CYGWIN32__) || defined(linux)
    if(sigsetjmp(ret_recv, 1) == 0){
#else
    if(setjmp(ret_recv) == 0){
#endif
	open_frame2(ret_recv_function, LTAG_NIL, 0);
	s_push(get_sval(pvm_recv_function));
	s_push(mk_fix(mid));
	s_push(mk_fix(tid));
	s_push(mk_fix(code));
	xcall();
	while(1)
	    ((int (*)())(*(bcbody_reg + bcpc_reg)))();
    }
    return(fix_to_int(reg_reg));
}

ret_recv_function()
{
#if defined(__CYGWIN32__) || defined(linux)
    siglongjmp(ret_recv, 1);
#else
    longjmp(ret_recv, 1);
#endif
}

Spvm_recvf()
{
    SOBJ obj_new, obj_old;

    obj_new.obj = getarg(1);

    if((GETtag(obj_new.obj) != LTAG_BCLOSURE) 
       && (obj_new.obj != SCOBJ_0))
	err_illegal_argument("Argument must be a closure or 0.");	

    obj_old.obj = get_sval(pvm_recv_function);
    set_sval(pvm_recv_function, obj_new.obj);

    if(GETtag(obj_new.obj) == LTAG_BCLOSURE)
	pvm_recvf(new_recv_function);
    else
	if(obj_new.obj == SCOBJ_0)
	    pvm_recvf(0);

    set_reg(obj_old.obj);	 
}

static void
new_reduce_function(datatype, x, y, num, info)
int *datatype, *num, *info;
void *x, *y;
{
    SOBJ obj_x, obj_y, tmp;
    int i;

    obj_x.obj = mk_evec(*num);
    s_push(obj_x.obj);
    obj_y.obj = mk_evec(*num);
    obj_x.obj = s_pop();

    if(datatype == PVM_INT)
	for(i = 0; i < *num; i++){
	    set_vec(obj_x.obj, i, mk_fix2(((int *)x)[i]));
	    set_vec(obj_y.obj, i, mk_fix2(((int *)y)[i]));
	}
    else
	if(datatype == PVM_DOUBLE)
	    for(i = 0; i < *num; i++){
		s_push(obj_y.obj);
		s_push(obj_x.obj);
		tmp.obj = mk_flt(((double *)x)[i]);
		obj_x.obj = s_pop();
		set_vec(obj_x.obj, i, tmp.obj);
		s_push(obj_x.obj);
		tmp.obj = mk_flt(((double *)y)[i]);
		obj_x.obj = s_pop();
		obj_y.obj = s_pop();
		set_vec(obj_y.obj, i, tmp.obj);
	    }

#if defined(__CYGWIN32__) || defined(linux)
    if(sigsetjmp(ret_reduce, 1) == 0){
#else
    if(setjmp(ret_reduce) == 0){
#endif
	open_frame2(ret_reduce_function, LTAG_NIL, 0);
	s_push(get_sval(pvm_reduce_function));
	s_push(mk_fix(datatype));
	s_push(obj_x.obj);
	s_push(obj_y.obj);
	xcall();
	while(1)
	    ((int (*)())(*(bcbody_reg + bcpc_reg)))();
    }
    if(datatype == PVM_INT)
	for(i = 0; i < *num; i++)
	    ((int *)y)[i] = fix_to_int(get_vec(obj_y.obj, i));
    else
	if(datatype == PVM_DOUBLE)
	    for(i = 0; i < *num; i++)
		((int *)y)[i] = flt_to_double(get_vec(obj_y.obj, i));    
}

ret_reduce_function()
{
#if defined(__CYGWIN32__) || defined(linux)
    siglongjmp(ret_reduce, 1);
#else
    longjmp(ret_reduce, 1);
#endif
}

Spvm_reduce()
{
    SOBJ obj_func, obj_data, obj_count, obj_datatype;
    SOBJ obj_msgtag, obj_group, obj_root, tmp_data;
    int func, count, datatype, msgtag, root, info, i;
    void *data;
    char *group, *strobj_to_str();

    obj_func.obj = getarg(1);
    obj_data.obj = getarg(2);
    obj_count.obj = getarg(3);
    obj_datatype.obj = getarg(4);
    obj_msgtag.obj = getarg(5);
    obj_group.obj = getarg(6);
    obj_root.obj = getarg(7);
    
    if((check_NUM(obj_func.obj))
       && (GETtag(obj_func.obj) != LTAG_BCLOSURE))
	err_illegal_argument("1st argument must be a number or a closure.");

    if((GETtag(obj_data.obj) != LTAG_CONS)
       && (GETtag(obj_data.obj) != LTAG_VECTOR))
	err_illegal_argument("2nd argument must be a list or a vector.");

    if(check_NUM(obj_count.obj))
	err_illegal_argument("3rd argument must be a number.");

    if(check_NUM(obj_datatype.obj))
	err_illegal_argument("4th argument must be a number.");

    if(check_NUM(obj_msgtag.obj))
	err_illegal_argument("5th argument must be a number.");

    if(GETtag(obj_group.obj) != LTAG_STRING)
	err_illegal_argument("6th argument must be a string.");

    if(check_NUM(obj_root.obj))
	err_illegal_argument("7th argument must be a number.");

    count = fix_to_int(obj_count.obj);
    datatype = fix_to_int(obj_datatype.obj);
    msgtag = fix_to_int(obj_msgtag.obj);
    group = strobj_to_str(obj_group.obj);
    root = fix_to_int(obj_root.obj);

    if(GETtag(obj_data.obj) == LTAG_CONS)
	if(listlen(obj_data.obj) < count) 
	    err_illegal_argument("2nd argument does not match 3rd argument."); 
    else if(GETtag(obj_data.obj) == LTAG_VECTOR)
	if(nonnil_vector_length(obj_data.obj) < count) 
	    err_illegal_argument("2nd argument does not match 3rd argument.");

    switch(datatype){
    case PVM_INT :
	data = (int *)malloc(sizeof(int) * count);
	if(GETtag(obj_data.obj) == LTAG_CONS){
	    tmp_data.obj = obj_data.obj;
	    for(i = 0; i < count; i++){
		if(check_NUM(CARobj(tmp_data.obj)) == 0)
		    ((int *)data)[i] = fix_to_int(CARobj(tmp_data.obj));
		tmp_data.obj = CDRobj(tmp_data.obj);
	    }
	}
	else
	    for(i = 0; i < count; i++)
		if(check_NUM(get_vec(obj_data.obj, i)) == 0)
		    ((int *)data)[i] = fix_to_int(get_vec(obj_data.obj, i));
	break;

    case PVM_DOUBLE :
	data = (double *)malloc(sizeof(double) * count);
	if(GETtag(obj_data.obj) == LTAG_CONS){
	    tmp_data.obj = obj_data.obj;
	    for(i = 0 ;i < count; i++){
		if((GETtag(CARobj(tmp_data.obj)) == LTAG_FLOAT)
		   || (GETtag(CARobj(tmp_data.obj)) == LTAG_SFLOAT))
		   ((double *)data)[i] = 
		       (double)flt_to_double(CARobj(tmp_data.obj));
		else
		    if(check_NUM(GETtag(CARobj(tmp_data.obj))) == 0)
		      ((double *)data)[i] = 
			  (double)fix_to_int(CARobj(tmp_data.obj));
		tmp_data.obj = CDRobj(tmp_data.obj);
	    }
	}
    else
	for(i = 0; i < count; i++)
	    if((GETtag(get_vec(obj_data.obj, i)) == LTAG_FLOAT)
	       || (GETtag(get_vec(obj_data.obj, i)) == LTAG_SFLOAT))
	       ((double *)data)[i] =
		   (double)flt_to_double(get_vec(obj_data.obj, i));
	    else
		if(check_NUM(GETtag(CARobj(obj_data.obj))) == 0)
		  ((double *)data)[i] =
		      (double)fix_to_int(get_vec(obj_data.obj), i);
	break;

    default:
	err_illegal_argument("4th argument does not match");
    }
    
    if(GETtag(obj_func.obj) == LTAG_BCLOSURE){
	set_sval(pvm_reduce_function, obj_func.obj);
	pvm_reduce(new_reduce_function, data, count, datatype,
		   msgtag, group, root);
    }
    else{
	func = fix_to_int(obj_func.obj);
	switch(func){
	case 1 : 
	    info = pvm_reduce(PvmMin, data, count, datatype,
			      msgtag, group, root);
	    break;
 
	case 2 : 
	    info = pvm_reduce(PvmMax, data, count, datatype,
			      msgtag, group, root);
	    break;

	case 3 : 
	    info = pvm_reduce(PvmSum, data, count, datatype,
			      msgtag, group, root);
	    break;

	case 4 : 
	    info = pvm_reduce(PvmProduct, data, count, datatype,
			      msgtag, group, root);
	    break;
    
	default:
	    err_illegal_argument("1st argument is illegal number.");
	}	
    }

    switch(datatype){
    case PVM_INT :
	if(GETtag(obj_data.obj) == LTAG_CONS)
	    for(i = 0; i < count; i++){
		set_car(obj_data.obj, mk_fix2(((int *)data)[i]));
		obj_data.obj = CDRobj(obj_data.obj);
	    }		
	else
	    if(GETtag(obj_data.obj) == LTAG_VECTOR)
		for(i = 0; i < count; i++)
		    set_vec(obj_data.obj, i ,mk_fix2(((int *)data)[i]));
	break;		

    case PVM_DOUBLE:
	if(GETtag(obj_data.obj) == LTAG_CONS)
	    for(i = 0; i < count; i++){
		s_push(obj_data.obj);
		tmp_data.obj = mk_flt(((double *)data)[i]);
		obj_data.obj = s_pop();
		set_car(obj_data.obj, tmp_data.obj);
		obj_data.obj = CDRobj(obj_data.obj);
	    }
	else
	    for(i = 0; i < count; i++){
		s_push(obj_data.obj);
		tmp_data.obj = mk_flt(((double *)data)[i]);
		obj_data.obj = s_pop();
		set_vec(obj_data.obj, i ,tmp_data.obj);
	    }
	break;

    default:
	err_illegal_argument("4th argument does not match");
    }

    free(data);
    set_reg(mk_fix2(info));
}

Spvm_reg_hoster()
{
    int info;

    info = pvm_reg_hoster();

    set_reg(mk_fix2(info));
}

Spvm_reg_tasker()
{
    int info;

    info = pvm_reg_tasker();

    set_reg(mk_fix2(info));
}

Spvm_send()
{
    SOBJ obj_tid, obj_msgtag;
    int  info;

    obj_tid.obj = getarg(1);
    obj_msgtag.obj = getarg(2);
    
    if(check_NUM(obj_tid.obj))
	err_illegal_argument("1st argument must be a number.");

    if(check_NUM(obj_msgtag.obj))
	err_illegal_argument("2nd argument must be a number.");

    info = pvm_send(fix_to_int(obj_tid.obj), fix_to_int(obj_msgtag.obj));

    set_reg(mk_fix2(info));
}

Spvm_sendsig()
{
    SOBJ obj_tid, obj_signum;
    int info;

    obj_tid.obj = getarg(1);
    obj_signum.obj = getarg(2);

    if(check_NUM(obj_tid.obj))
	err_illegal_argument("1st argument must be a number.");

    if(check_NUM(obj_signum.obj))
	err_illegal_argument("2nd argument must be a number.");

    info = pvm_sendsig(fix_to_int(obj_tid.obj), fix_to_int(obj_signum.obj));

    set_reg(mk_fix2(info));
}

/***
Spvm_serror()
{
    SOBJ obj_set;
    int oldset;

    obj_set.obj = getarg(1);

    if(check_NUM(obj_set.obj))
	err_illegal_argument("Argument must be a number.");

    oldset = pvm_serror(fix_to_int(obj_set.obj));

    set_reg(mk_fix2(oldset));
}
***/

Spvm_setopt()
{
    SOBJ obj_what, obj_val;
    int what, val, oldval;

    obj_what.obj = getarg(1);
    obj_val.obj = getarg(2);

    if(check_NUM(obj_what.obj))
	err_illegal_argument("1st argument must be a number.");

    what = fix_to_int(obj_what.obj);

    if((what < 1) || (what > 9))
        err_illegal_argument("1st argument is beyond the extent.");

    if(check_NUM(obj_val.obj))
	err_illegal_argument("2nd argument must be a number.");

    val = fix_to_int(obj_val.obj);

    oldval = pvm_setopt(what, val);

    set_reg(mk_fix2(oldval));
}

Spvm_setrbuf()
{
    SOBJ obj_bufid;
    int bufid, oldbuf;

    obj_bufid.obj = getarg(1);

    if(check_NUM(obj_bufid.obj))
	err_illegal_argument("Argument must be a number.");

    bufid = pvm_setrbuf(fix_to_int(obj_bufid.obj));
    
    set_reg(mk_fix2(bufid));
}

Spvm_setsbuf()
{
    SOBJ obj_bufid;
    int bufid, oldbuf;

    obj_bufid.obj = getarg(1);

    if(check_NUM(obj_bufid.obj))
	err_illegal_argument("Argument must be a number.");

    bufid = pvm_setsbuf(fix_to_int(obj_bufid.obj));

    set_reg(mk_fix2(bufid));
}

Spvm_set_gstid()
{
    SOBJ obj_tid;
    int tid;
    
    obj_tid.obj = getarg(1);
    
    if(check_NUM(obj_tid.obj))
      err_illegal_argument("Argument must be a number.");
     
    tid = gstid;
    gstid = fix_to_int(obj_tid.obj);
    
    set_reg(mk_fix2(tid));
}
    
Spvm_spawn()
{
    SOBJ obj_task, obj_argv, obj_flag, obj_where, obj_ntask, obj_tids;
    char *task, **argv, *where;
    int *tids, numt, flag, ntask;
    char *strobj_to_str();

    obj_task.obj = getarg(1);
    obj_argv.obj = getarg(2);
    obj_flag.obj = getarg(3);
    obj_where.obj = getarg(4);
    obj_ntask.obj = getarg(5);
    obj_tids.obj = getarg(6);

    if(GETtag(obj_task.obj) != LTAG_STRING)
	err_illegal_argument("1st argument must be a string.");

    if((GETtag(obj_argv.obj) != LTAG_CONS) 
	&& (GETtag(obj_argv.obj) != LTAG_NIL)
	&& (GETtag(obj_argv.obj) != LTAG_VECTOR))
	err_illegal_argument("2nd argument must be a list , a vector or ().");

    if(check_NUM(obj_flag.obj))
	err_illegal_argument("3rd argument must be a number.");

    if(GETtag(obj_where.obj) != LTAG_STRING) 
	err_illegal_argument("4th argument must be a string.");

    if(check_NUM(obj_ntask.obj))
	err_illegal_argument("5th argument must be a number.");

    if((GETtag(obj_tids.obj) != LTAG_CONS) 
	&& (GETtag(obj_tids.obj) != LTAG_NIL)
	&& (GETtag(obj_tids.obj) != LTAG_VECTOR))
	err_illegal_argument("6th argument must be a list , a vector or ().");
 
    task = strobj_to_str(obj_task.obj);
    if(GETtag(obj_argv.obj) == LTAG_NIL)
	argv = (char **)0;
    else{
	if(GETtag(obj_argv.obj) == LTAG_CONS)
	    argv = cons_to_pointer(obj_argv.obj);
	else
	    argv = vector_to_pointer(obj_argv.obj);
    }	
    flag = fix_to_int(obj_flag.obj);
    where = strobj_to_str(obj_where.obj);
    ntask = fix_to_int(obj_ntask.obj);
    tids = (int *)malloc(sizeof(int) * ntask);

    if(GETtag(obj_tids.obj) == LTAG_CONS)
	if(listlen(obj_tids.obj) < ntask)
	    err_illegal_argument("5th argument does not match 6th argument."); 
    else if(GETtag(obj_tids.obj) == LTAG_VECTOR)
	if(nonnil_vector_length(obj_tids.obj) < ntask)
	    err_illegal_argument("5th argument does not match 6th argument."); 

/*  printf("task=%s argv=%d flag=%d where=%s ntask=%d tids=%d\n",task, 
argv, flag, where, ntask, tids); */

    numt = pvm_spawn(task, argv, flag, where, ntask, tids); 
 	
    free(argv);

    if(GETtag(obj_tids.obj) == LTAG_CONS)
	pointer_to_cons(obj_tids.obj, tids, ntask);
    else
	if(GETtag(obj_tids.obj) == LTAG_VECTOR)
	    pointer_to_vector(obj_tids.obj, tids, ntask);

    free(tids);   

    set_reg(mk_fix2(numt));
}

Spvm_tasks()
{
    SOBJ obj_where, obj_ntask, obj_taskp, obj_taskp_tmp;
    int where, ntask, info, len, i;
    struct pvmtaskinfo *taskp;

    obj_where.obj = getarg(1);
    obj_ntask.obj = getarg(2);
    obj_taskp.obj = getarg(3);

    if(check_NUM(obj_where.obj))
	err_illegal_argument("1st argument must be a number.");

    if((GETtag(obj_ntask.obj) != LTAG_CONS)
	&& (GETtag(obj_ntask.obj) != LTAG_NIL)
	&& (GETtag(obj_ntask.obj) != LTAG_VECTOR))
	err_illegal_argument("2nd argument must be a pair , a vector or ().");

    if((GETtag(obj_taskp.obj) != LTAG_CONS) 
	&& (GETtag(obj_taskp.obj) != LTAG_NIL)
	&& (GETtag(obj_taskp.obj) != LTAG_VECTOR))
	err_illegal_argument("3rd argument must be a list , a vector or ().");
    
    where = fix_to_int(obj_where.obj);

    info = pvm_tasks(where, &ntask, &taskp);

    if(GETtag(obj_ntask.obj) == LTAG_CONS)
	set_car(obj_ntask.obj, mk_fix2(ntask));
    else
	if(GETtag(obj_ntask.obj) == LTAG_VECTOR)
	    set_vec(obj_ntask.obj, 0, mk_fix2(ntask));

    if(GETtag(obj_taskp.obj) == LTAG_CONS){
	for(i = 0; i < ntask; i++){
	    obj_taskp_tmp.obj = CARobj(obj_taskp.obj);
	    if(GETtag(obj_taskp_tmp.obj) != LTAG_CONS) 
		err_illegal_argument("3rd argument must be a list include lists.");
	    if(listlen(obj_taskp_tmp.obj) != 6)
		err_illegal_argument("Illegal number of arguments of lists including 3rd argument.");

	    set_car(obj_taskp_tmp.obj, mk_fix2((*(taskp+i)).ti_tid));
	    obj_taskp_tmp.obj = CDRobj(obj_taskp_tmp.obj);
	    set_car(obj_taskp_tmp.obj, mk_fix2((*(taskp+i)).ti_ptid));
	    obj_taskp_tmp.obj = CDRobj(obj_taskp_tmp.obj);
	    set_car(obj_taskp_tmp.obj, mk_fix2((*(taskp+i)).ti_host));
	    obj_taskp_tmp.obj = CDRobj(obj_taskp_tmp.obj);
	    set_car(obj_taskp_tmp.obj, mk_fix2((*(taskp+i)).ti_flag));
	    obj_taskp_tmp.obj = CDRobj(obj_taskp_tmp.obj);
	    len = strlen((*(taskp+i)).ti_a_out);
	    set_car(obj_taskp_tmp.obj, 
	        mk_str(ORDINARY_STRING, A_STRING, len, (*(taskp+i)).ti_a_out));
	    obj_taskp_tmp.obj = CDRobj(obj_taskp_tmp.obj);
	    set_car(obj_taskp_tmp.obj, mk_fix2((*(taskp+i)).ti_pid));
	    obj_taskp.obj = CDRobj(obj_taskp.obj);
	    obj_taskp_tmp.obj = obj_taskp.obj;
	}
    }	
    else
	if(GETtag(obj_taskp.obj) == LTAG_VECTOR){
	  for(i = 0; i < ntask; i++){
	    if(GETtag(get_vec(obj_taskp.obj, i)) != LTAG_VECTOR)
	        err_illegal_argument("3rd argument must be a list include lists.");
		if(nonnil_vector_length(get_vec(obj_taskp.obj, i)) != 6)
		    err_illegal_argument("Illegal number of arguments of lists including 3rd argument.");

	   set_vec(get_vec(obj_taskp.obj, i), 0, mk_fix2((*(taskp+i)).ti_tid));
	   set_vec(get_vec(obj_taskp.obj, i), 1, mk_fix2((*(taskp+i)).ti_ptid));
	   set_vec(get_vec(obj_taskp.obj, i), 2, mk_fix2((*(taskp+i)).ti_host));
	   set_vec(get_vec(obj_taskp.obj, i), 3, mk_fix2((*(taskp+i)).ti_flag));
	   len = strlen((*taskp).ti_a_out);
	   set_vec(get_vec(obj_taskp.obj, i), 4,
		mk_str(ORDINARY_STRING, A_STRING, len, (*(taskp+i)).ti_a_out));
	   set_vec(get_vec(obj_taskp.obj, i), 5, mk_fix2((*(taskp+i)).ti_pid));
	   }
	}
    set_reg(mk_fix2(info));
}

Spvm_tidtohost()
{
    SOBJ obj_tid;
    int dtid;

    obj_tid.obj = getarg(1);

    if(check_NUM(obj_tid.obj))
	err_illegal_argument("Argument must be a number.");

    dtid = pvm_tidtohost(fix_to_int(obj_tid.obj));

    set_reg(mk_fix2(dtid));
}

Spvm_trecv()
{
    SOBJ obj_tid, obj_msgtag, obj_time;
    struct timeval tmout;
    int tid, msgtag, bufid;

    obj_tid.obj = getarg(1);
    obj_msgtag.obj = getarg(2);
    obj_time.obj = getarg(3);

    if(check_NUM(obj_tid.obj))
	err_illegal_argument("1st argument must be a number.");

    if(check_NUM(obj_msgtag.obj))
	err_illegal_argument("2nd argument must be a number.");

    if((GETtag(obj_time.obj) != LTAG_CONS) 
       && (GETtag(obj_time.obj) != LTAG_VECTOR))
	err_illegal_argument("3rd argument must be a list or a vector.");

    tid = fix_to_int(obj_tid.obj);
    msgtag = fix_to_int(obj_msgtag.obj);
    
    if(GETtag(obj_time.obj) == LTAG_CONS){
	tmout.tv_sec = fix_to_int(CARobj(obj_time.obj));
	tmout.tv_usec = fix_to_int(CARobj(CDRobj(obj_time.obj)));
    }
    else{
	tmout.tv_sec = fix_to_int(get_vec(obj_time.obj), 0);
	tmout.tv_usec = fix_to_int(get_vec(obj_time.obj), 1);
    }

    bufid = pvm_trecv(tid, msgtag, &tmout);

    set_reg(mk_fix2(bufid));
}

Spvm_upkfloat()
{
    SOBJ obj_fp, obj_nitem, obj_stride, tmp;
    double *fp;
    int nitem, stride, info, num, i;

    obj_fp.obj = getarg(1);
    obj_nitem.obj = getarg(2);
    obj_stride.obj = getarg(3);

    if((GETtag(obj_fp.obj) != LTAG_CONS) 
	&& (GETtag(obj_fp.obj) != LTAG_VECTOR))
	err_illegal_argument("1st argument must be a list or a vector.");

    if(check_NUM(obj_nitem.obj))
	err_illegal_argument("2nd argument must be a number.");

    if(check_NUM(obj_stride.obj))
	err_illegal_argument("3rd argument must be a number.");

    nitem = fix_to_int(obj_nitem.obj);
    fp = (double *)malloc(sizeof(double) * nitem);
    stride = fix_to_int(obj_stride.obj);

    if(GETtag(obj_fp.obj) == LTAG_CONS)
	if(listlen(obj_fp.obj) < nitem) 
	    err_illegal_argument("2nd argument does not match 1st argument."); 
    else if(GETtag(obj_fp.obj) == LTAG_VECTOR)
	if(nonnil_vector_length(obj_fp.obj) < nitem) 
	    err_illegal_argument("2nd argument does not match 1st argument."); 

    info = pvm_upkdouble(fp, nitem, stride);

    if(GETtag(obj_fp.obj) == LTAG_CONS)
	for(i = 0; i < nitem; i++){
	    s_push(obj_fp.obj);
	    tmp.obj = mk_flt(*(fp + i));
	    obj_fp.obj = s_pop();
	    set_car(obj_fp.obj, tmp.obj);
	    obj_fp.obj = CDRobj(obj_fp.obj);
	}
    else
	for(i = 0; i < nitem; i++){
	    s_push(obj_fp.obj);
	    tmp.obj = mk_flt(*(fp + i));
	    obj_fp.obj = s_pop();
	    set_vec(obj_fp.obj, i ,tmp.obj);
	}

    free(fp);    

    set_reg(mk_fix2(info));
}

Spvm_upkfix()
{
    SOBJ obj_ip, obj_nitem, obj_stride;
    int *ip, nitem, stride, info, num, i;

    obj_ip.obj = getarg(1);
    obj_nitem.obj = getarg(2);
    obj_stride.obj = getarg(3);

    if((GETtag(obj_ip.obj) != LTAG_CONS) 
	&& (GETtag(obj_ip.obj) != LTAG_VECTOR))
	err_illegal_argument("1st argument must be a list or a vector.");

    if(check_NUM(obj_nitem.obj))
	err_illegal_argument("2nd argument must be a number.");

    if(check_NUM(obj_stride.obj))
	err_illegal_argument("3rd argument must be a number.");

    nitem = fix_to_int(obj_nitem.obj);
    ip = (int *)malloc(sizeof(int) * nitem);
    stride = fix_to_int(obj_stride.obj);

    if(GETtag(obj_ip.obj) == LTAG_CONS)
	if(listlen(obj_ip.obj) < nitem) 
	    err_illegal_argument("2nd argument does not match 1st argument."); 
    else if(GETtag(obj_ip.obj) == LTAG_VECTOR)
	if(nonnil_vector_length(obj_ip.obj) < nitem)
	    err_illegal_argument("2nd argument does not match 1st argument."); 

    info = pvm_upkint(ip, nitem, stride);
	
    if(GETtag(obj_ip.obj) == LTAG_CONS)
	for(i = 0; i < nitem; i++){
	    set_car(obj_ip.obj, mk_fix2(*(ip + i)));
	    obj_ip.obj = CDRobj(obj_ip.obj);
	}
    else
	for(i = 0; i < nitem; i++)
	    set_vec(obj_ip.obj, i ,mk_fix2(*(ip + i)));
    
    free(ip);    

    set_reg(mk_fix2(info));
}

Spvm_upkstr()
{
    SOBJ obj_sp;
    char *sp, *str, *t;
    int info, i, len;
    
    obj_sp.obj = getarg(1);

    if (GETtag(obj_sp.obj) != LTAG_STRING)
	err_illegal_argument("Argument must be a string.");

    len = ((STRING * )ADDRESS(obj_sp.obj))->str_len;
    sp = malloc(sizeof(char) * len + 1);

    info = pvm_upkstr(sp);

    str = (char *)ADDRESS(obj_sp.obj)+12;
    for (t = sp, i = 0; i <= len; i++)
	*str++ = *t++;
    free(sp);

    set_reg(mk_fix2(info));
}

Spvm_upkstr2()
{
    char *sp;
    int info, bytes, len;

    info = pvm_bufinfo(pvm_getrbuf(), &bytes, (int *)0, (int *)0);
 
    sp = malloc(sizeof(char) * bytes);

    info = pvm_upkstr(sp);

    len = strlen(sp);
   
    set_reg(mk_str(ORDINARY_STRING, A_STRING, len, sp));

    free(sp); 
}

Spvm_version()
{
    char *version;
    int len;
    
    version = pvm_version();
    len = strlen(version);
    set_reg(mk_str(ORDINARY_STRING, A_STRING, len ,version));
}


/***************************************************************************
  C function
***************************************************************************/

char **cons_to_pointer(cons_obj)
int cons_obj;
{
    char **pointer;
    int num, i = 0, len;

    num = listlen(cons_obj);
    pointer = (char **)malloc(sizeof(char *) * (num + 1));
    while (GETtag(cons_obj) == LTAG_CONS) {
	if(GETtag(CARobj(cons_obj)) == LTAG_STRING){
	    len = ((STRING * )ADDRESS(CARobj(cons_obj)))->str_len;
	    *(pointer + i) = malloc(sizeof(char) * len);
	    strcpy(*(pointer + i), strobj_to_str(CARobj(cons_obj)));
	    cons_obj = CDRobj(cons_obj);
	    i++;
	}
    }
    *(pointer + num) = 0;
    
    return(pointer);
}

char **vector_to_pointer(vec_obj)
int vec_obj;
{
    char **pointer;
    int num, len, i;

    num = nonnil_vector_length(vec_obj);
    pointer = (char **)malloc(sizeof(char *) * (num + 1));
    for(i = 0; i < num; i++)
	if(GETtag(get_vec(vec_obj, i)) == LTAG_STRING){
	    len = ((STRING *)ADDRESS(get_vec(vec_obj, i)))->str_len;
	    *(pointer + i) = malloc(sizeof(char) * len);
	    strcpy(*(pointer + i), strobj_to_str(get_vec(vec_obj, i)));
	}
    *(pointer + num) = 0;
    return(pointer);
}

pointer_to_cons(cons_obj, pointer, num)
int cons_obj, *pointer, num;
{
    int i = 0;

    while(GETtag(cons_obj) == LTAG_CONS){
	set_car(cons_obj, mk_fix2(*(pointer+i)));
	if(num == i++) {
	    set_cdr(cons_obj, LTAG_NIL);
	    return;
	}
	cons_obj = CDRobj(cons_obj);
    }
}

pointer_to_vector(vec_obj, pointer, num)
int vec_obj, *pointer, num;
{
    int i, len;

    len = nonnil_vector_length(vec_obj);

    for(i = 0; i < len; i++){
	if(i < num)
	    set_vec(vec_obj, i, mk_fix2(*(pointer+i)));
	else
	    set_vec(vec_obj, i, LTAG_FALSE);
    }
}	

check_NUM(obj)
int obj;
{
    switch (GETtag(obj)) {
    case LTAG_FIXNUM  :
    case LTAG_FIXNUM1 :
    case LTAG_FIXNUM2 :
    case LTAG_FIXNUM3 :
    case LTAG_BIGNUM :
	return(0);
    default :
	return(1);
    }
}

mk_fix2(num)
int num;
{
    if(num <= MAX_FIXNUM)
      return(mk_fix(num));
    else
      return(mk_bign(num));
}

Sxpvm_start()
{
  Pvmtmask trace_mask;
  int xpvm_tid;

  if((xpvm_tid = pvm_gettid("xpvm",0))>0) {

    pvm_setopt(PvmSelfTraceTid,xpvm_tid);
    pvm_setopt(PvmSelfTraceCode,666);
    pvm_setopt(PvmSelfOutputTid,xpvm_tid);
    pvm_setopt(PvmSelfOutputCode,667);

    pvm_setopt(PvmTraceTid,xpvm_tid);
    pvm_setopt(PvmTraceCode,666);
    pvm_setopt(PvmOutputTid,xpvm_tid);
    pvm_setopt(PvmOutputCode,667);

    TEV_INIT_MASK(trace_mask);
    TEV_SET_MASK(trace_mask,TEV_MCAST0);
    TEV_SET_MASK(trace_mask,TEV_SEND0);
    TEV_SET_MASK(trace_mask,TEV_RECV0);
    TEV_SET_MASK(trace_mask,TEV_NRECV0);

    pvm_settmask(PvmTaskSelf,trace_mask);

    pvm_settmask(PvmTaskChild,trace_mask);
  }
  else printf("XPVM not running,cannot trace\n");
}

pvm_err_unbound_obj2(sym)
int sym;
{
    error_prologue();
    open_frame2(err_recover_get_gval,
		LTAG_STRING | SSERDDA(bcbody_reg), bcpc_reg);
    active_reg = base_reg;
    s_push(get_sval(pvm_get_unbound_obj));
    s_push(sym);
    
    set_up_stack_epilogue();
}

pvm_err_unbound_obj3(sym)
int sym;
{
    error_prologue();
    open_frame2(err_recover_push_gval,
		LTAG_STRING | SSERDDA(bcbody_reg), bcpc_reg);
    active_reg = base_reg;
    s_push(get_sval(pvm_get_unbound_obj));
    s_push(sym);
    
    set_up_stack_epilogue();
}

pvm_err_unbound_obj4(sym)
int sym;
{
    error_prologue();
    open_frame2(err_recover_set_gval,
		LTAG_STRING | SSERDDA(bcbody_reg), bcpc_reg);
    active_reg = base_reg;
    s_push(get_sval(pvm_get_unbound_obj));
    s_push(sym);
    
    set_up_stack_epilogue();
}

/*
pvm_on_demand()
{
    if(setjmp(ret_demand) == 0){
	open_frame2(ret_on_demand, LTAG_NIL, 0); 
	s_push(get_sval(pvm_put_unbound_obj));
	xcall();
	while(1)
	    ((int (*)())(*(bcbody_reg + bcpc_reg)))(); 
    } 
} */

pvm_on_demand()
{
    unsigned int *tmp_base_reg;
    unsigned int *tmp_sp_reg;
    unsigned int tmp_reg_reg;
    unsigned int tmp_bcpc_reg;
    unsigned int *tmp_bcbody_reg;

    tmp_base_reg = base_reg;
    tmp_sp_reg = sp_reg;
    tmp_reg_reg = reg_reg;
    tmp_bcpc_reg = bcpc_reg;
    tmp_bcbody_reg = bcbody_reg;

#if defined(__CYGWIN32__) || defined(linux)
    if(sigsetjmp(ret_demand, 1) == 0){
#else
    if(setjmp(ret_demand) == 0){
#endif
	open_frame2(ret_on_demand, LTAG_NIL, 0);
	active_reg = base_reg;
	s_push(get_sval(pvm_put_unbound_obj));
	xcall();
	while(1)
	    ((int (*)())(*(bcbody_reg + bcpc_reg)))(); 
    }

    base_reg = tmp_base_reg;
    sp_reg = tmp_sp_reg;
    reg_reg = tmp_reg_reg;
    bcpc_reg = tmp_bcpc_reg;
    bcbody_reg = tmp_bcbody_reg;
}

ret_on_demand()
{
    s_pop();
    s_pop();
#if defined(__CYGWIN32__) || defined(linux)
    siglongjmp(ret_demand, 1);
#else
    longjmp(ret_demand, 1);
#endif
} 
