(define-condition pvm-tus-error (error)
  (message) "pvm-tus-error")

(define-condition PvmBadParam (pvm-tus-error)
  () 
  (lambda (condition stream)
    (format stream "PvmBadParam~%")
    (format stream "        bad parameter")))

(define-condition PvmMismatch (pvm-tus-error)
  () 
  (lambda (condition stream)
    (format stream "PvmMismatch~%")
    (format stream "        barrier count mismatch")))

(define-condition PvmNoData (pvm-tus-error)
  ()
  (lambda (condition stream) 
    (format stream "PvmNoData~%")
    (format stream "        read past end of buffer")))

(define-condition PvmNoHost (pvm-tus-error)
  () 
  (lambda (condition stream)
    (format stream "PvmNoHost~%")
    (format stream "        no such host")))

(define-condition PvmNoFile (pvm-tus-error)
  () 
  (lambda (condition stream)
    (format stream "PvmNoFile~%")
    (format stream "        no such executive" )))

(define-condition PvmNoMem (pvm-tus-error)
  () 
  (lambda (condition stream) 
    (format stream "PvmNoMem~%")
    (format stream "        can't get memory")))
            
(define-condition PvmBadMsg (pvm-tus-error)
  () 
  (lambda (condition stream) 
    (format stream "PvmBadMsg~%")
    (format stream "        can't decode received msg")))

(define-condition PvmSysErr (pvm-tus-error)
  () 
  (lambda (condition stream)
    (format stream "PvmSysErr~%")
    (format stream "        pvms not responding")))

(define-condition PvmNoBuf (pvm-tus-error)
  () 
  (lambda (condition stream)
    (format stream "PvmNoBuf~%")
    (format stream "        no current buffer")))

(define-condition PvmNoSuchBuf (pvm-tus-error)
  () 
  (lambda (condition stream)
    (format stream "PvmNoSuchBuf~%")
    (format stream "        bad message id")))

(define-condition PvmNullGroup (pvm-tus-error)
  () 
  (lambda (condition stream)
    (format stream "PvmNullGroup~%")
    (format stream "        null group name is illegal")))

(define-condition PvmDupGroup (pvm-tus-error)
  ()
  (lambda (condition stream)
    (format stream "PvmDupGroup~%")
    (format stream "        already in group")))

(define-condition PvmNoGroup (pvm-tus-error)
  ()
  (lambda (condition stream)
    (format stream "PvmNoGroup~%")
    (format stream "        not group with that name")))

(define-condition PvmNotInGroup (pvm-tus-error)
  ()
  (lambda (condition stream)
    (format stream "PvmNotInGroup~%")
    (format stream "        not in group")))

(define-condition PvmNoInst (pvm-tus-error)
  ()
  (lambda (condition stream)
    (format stream "PvmNoInst~%")
    (format stream "        no such instance in group")))

(define-condition PvmHostFail (pvm-tus-error)
  ()
  (lambda (condition stream)
    (format stream "PvmHostFail~%")
    (format stream "        host faild")))

(define-condition PvmNoParent (error)
  ()
  (lambda (condition stream)
    (format stream "PvmNoParent~%")
    (format stream "        no parent task")))

(define-condition PvmNotImpl (pvm-tus-error)
  ()
  (lambda (condition stream)
    (format stream "PvmNotImpl~%")
    (format stream "        function not implemented")))

(define-condition PvmDSysErr(pvm-tus-error)
  ()
  (lambda (condition stream)
    (format stream "PvmDSysErr~%")
    (format stream "        pvmd system error")))

(define-condition PvmBadVersion (pvm-tus-error)
  ()
  (lambda (condition stream)
    (format stream "PvmBadVersion~%")
    (format stream "        pvmd-pvmd protocol mismatch")))

(define-condition PvmOutOfRes (pvm-tus-error)
  ()
  (lambda (condition stream)
    (format stream "PvmOutOfRes~%")
    (format stream "        out of resources")))

(define-condition PvmDupHost (pvm-tus-error)
  ()
  (lambda (condition stream)
    (format stream "PvmDupHost~%")
    (format stream "        host already configured")))

(define-condition PvmCantStart (pvm-tus-error)
  ()
  (lambda (condition stream)
    (format stream "PvmCantStart~%")
    (format stream "        failed to exec new slave pvmd")))

(define-condition PvmAlready (pvm-tus-error)
  () 
  (lambda (condition stream)
    (format stream "PvmAlready~%")
    (format stream "        already doing operation")))

(define-condition PvmNoTask (pvm-tus-error)
  ()
  (lambda (condition stream)
    (format stream "PvmNoTask~%")
    (format stream "        no such task")))

(define-condition PvmNoEntry (pvm-tus-error)
  ()
  (lambda (condition stream)
    (format stream "PvmNoEntry~%")
    (format stream "        no such (group, instance)")))

(define-condition PvmDupEntry (pvm-tus-error)
  ()
  (lambda (condition stream)
    (format stream "PvmDupEntry~%")
    (format stream "        (group, instance) already exists")))

(define-condition PvmOtherError (pvm-tus-error)
  ()
  (lambda (condition stream)
    (format stream "PvmOtherError~%")
    (format stream "        other error")))
