(define-handler error
  (lambda (c)
    (let ((port (open-output-string)))
      ((caddr c) c #t)
      ((caddr c) c port)
      (interrupt-pvm-parent (get-output-string port) 
                            (slot-value c 'function)))))

(define-handler PvmBadParam
  (lambda (c)
    (format #t "condition : PvmBadParam.~%")
    (format #t "            Bad parameter.~%")
    (format #t "            In (~a).~%" (slot-value c 'function))   
    (interrupt-pvm-parent "Bad paremeter" (slot-value c 'function))))

(define-handler PvmMismatch
  (lambda (c)
    (format #t "condition : PvmMismatch.~%")
    (format #t "            Barrier count mismatch.~%")
    (format #t "            In (~a).~%" (slot-value c 'function))
    (interrupt-pvm-parent "Barrier count mismatch" (slot-value c 'function))))

(define-handler PvmNoData
  (lambda (c)
    (format #t "condition : PvmNoData.~%")
    (format #t "            Read past end of buffer.~%")
    (format #t "            In (~a).~%" (slot-value c 'function))
    (interrupt-pvm-parent "Read past end of buffer" 
                          (slot-value c 'function))))

(define-handler PvmNoHost
  (lambda (c)
    (format #t "condition : PvmNoHost.~%")
    (format #t "            No such host.~%")
    (format #t "            In (~a).~%" (slot-value c 'function))
    (interrupt-pvm-parent "No such host" (slot-value c 'function))))

(define-handler PvmNoFile
  (lambda (c) 
    (format #t "condition : PvmNoFile.~%")
    (format #t "            No such executable." )
    (format #t "            In (~a).~%" (slot-value c 'function))
    (interrupt-pvm-parent "No such executable" (slot-value c 'function))))

(define-handler PvmNoMem
  (lambda (c)
    (format #t "condition : PvmNoMem.~%")
    (format #t "            Can't get memory.~%")
    (format #t "            In (~a).~%" (slot-value c 'function))
    (interrupt-pvm-parent "Can't get memory" (slot-value c 'function))))
    
(define-handler PvmBadMsg
  (lambda (c)
    (format #t "condition : PvmBadMsg.~%")
    (format #t "            Can't decode received msg.~%")
    (format #t "            In (~a).~%" (slot-value c 'function))
    (interrupt-pvm-parent "Can't decode received msg"
                          (slot-value c 'function))))

(define-handler PvmSysErr
  (lambda (c) 
    (format #t "condition : PvmSysErr.~%")
    (format #t "            Pvmd not responding.~%")
    (format #t "            In (~a).~%" (slot-value c 'function))
    (interrupt-pvm-parent "Pvmd not responding" (slot-value c 'function))))

(define-handler PvmNoBuf
  (lambda (c)
    (format #t "condition : PvmNoBuf.~%")
    (format #t "            No current buffer.~%")
    (format #t "            In (~a).~%" (slot-value c 'function))
    (interrupt-pvm-parent "No current buffer" (slot-value c 'function))))

(define-handler PvmNoSuchBuf
  (lambda (c) 
    (format #t "condition : PvmNoSuchBuf.~%")
    (format #t "            Bad message id.~%")
    (format #t "            In (~a).~%" (slot-value c 'function))
    (interrupt-pvm-parent "Bad message id" (slot-value c 'function))))

(define-handler PvmNullGroup
  (lambda (c) 
    (format #t "condition : PvmNullGroup.~%")
    (format #t "            Null group name is illegal.~%")
    (format #t "            In (~a).~%" (slot-value c 'function))
    (interrupt-pvm-parent "Null group name is illegal"
                          (slot-value c 'function))))

(define-handler PvmDupGroup
  (lambda (c)
    (format #t "condition : PvmDupGroup.~%")
    (format #t "            Already in group.~%")
    (format #t "            In (~a).~%" (slot-value c 'function))
    (interrupt-pvm-parent "Already in group" (slot-value c 'function))))

(define-handler PvmNoGroup
  (lambda (c) 
    (format #t "condition : PvmNoGroup.~%")
    (format #t "            No group with that name.~%")
    (format #t "            In (~a).~%" (slot-value c 'function))
    (interrupt-pvm-parent "No group with that name" 
                          (slot-value c 'function))))

(define-handler PvmNotInGroup
  (lambda (c)
    (format #t "condition : PvmNotInGroup.~%")
    (format #t "            Not in group.~%")
    (format #t "            In (~a).~%" (slot-value c 'function))
    (interrupt-pvm-parent "Not in group" (slot-value c 'function))))

(define-handler PvmNoInst
  (lambda (c) 
    (format #t "condition : PvmNoInst.~%")
    (format #t "            No such instance in group.~%")
    (format #t "            In (~a).~%" (slot-value c 'function))
    (interrupt-pvm-parent "No such instance in group" 
                          (slot-value c 'function))))
                                                      
(define-handler PvmHostFail
  (lambda (c)
    (format #t "condition : PvmHostFail.~%")
    (format #t "            Host failed.~%")
    (format #t "            In (~a).~%" (slot-value c 'function))
    (interrupt-pvm-parent "Host failed" (slot-value c 'function))))

(define-handler PvmNoParent
  (lambda (c) 
    (format #t "condition : PvmNoParent.~%")
    (format #t "            No parent task.~%")
    (format #t "            In (~a).~%" (slot-value c 'function))
    (interrupt-pvm-parent "No parent task" (slot-value c 'function))))

(define-handler PvmNotImpl
  (lambda (c) 
    (format #t "condition : PvmNotImpl.~%")
    (format #t "            Function not implemented.~%")
    (format #t "            In (~a).~%" (slot-value c 'function))
    (interrupt-pvm-parent "Function not implemented" 
                          (slot-value c 'function))))

(define-handler PvmDSysErr
  (lambda (c) 
    (format #t "condition : PvmDSysErr.~%")
    (format #t "            Pvmd system error.~%")
    (format #t "            In (~a).~%" (slot-value c 'function))
    (interrupt-pvm-parent "Pvmd system error" (slot-value c 'function))))

(define-handler PvmBadVersion
  (lambda (c) 
    (format #t "condition : PvmBadVersion.~%")
    (format #t "            Pvmd-pvmd protocol mismatch.~%")
    (format #t "            In (~a).~%" (slot-value c 'function))
    (interrupt-pvm-parent "Pvmd-pvmd protocol mismatch" 
                          (slot-value c 'function))))

(define-handler PvmOutOfRes
  (lambda (c) 
    (format #t "condition : PvmOutOfRes.~%")
    (format #t "            Out of resources.~%")
    (format #t "            In (~a).~%" (slot-value c 'function))
    (interrupt-pvm-parent "Out of resouces" (slot-value c 'function))))

(define-handler PvmDupHost
  (lambda (c) 
    (format #t "condition : PvmDupHost.~%")
    (format #t "            Host already configured.~%")
    (format #t "            In (~a).~%" (slot-value c 'function))
    (interrupt-pvm-parent "Host already configured"
                          (slot-value c 'function))))

(define-handler PvmCantStart
  (lambda (c) 
    (format #t "condition : PvmCantStart.~%")
    (format #t "            Failed to exec new slave pvmd.~%")
    (format #t "            In (~a).~%" (slot-value c 'function))
    (interrupt-pvm-parent "Failed to exec new slave pvmd" 
                          (slot-value c 'function))))

(define-handler PvmAlready
  (lambda (c) 
    (format #t "condition : PvmAlready.~%")
    (format #t "            Already doing operation.~%")
    (format #t "            In (~a).~%" (slot-value c 'function))
    (interrupt-pvm-parent "Already doing operation"
                          (slot-value c 'function))))

(define-handler PvmNoTask
  (lambda (c)
    (format #t "condition : PvmNoTask.~%")
    (format #t "            No such task.~%")
    (format #t "            In (~a).~%" (slot-value c 'function))
    (interrupt-pvm-parent "No such task" (slot-value c 'function))))

(define-handler PvmNoEntry
  (lambda (c) 
    (format #t "condition : PvmNoEntry.~%")
    (format #t "            No such (group, instance).~%")
    (format #t "            In (~a).~%" (slot-value c 'function))
    (interrupt-pvm-parent "No such (group, instance)" 
                          (slot-value c 'function))))

(define-handler PvmDupEntry
  (lambda (c) 
    (format #t "condition : PvmDupEntry.~%")
    (format #t "            (Group, Instance) already exists.~%")
    (format #t "            In (~a).~%" (slot-value c 'function))
    (interrupt-pvm-parent "(Group, Instance) already exists"
                          (slot-value c 'function))))

(define-handler PvmOtherError   
  (lambda (c)
    (format #t "condition : PvmOtherError.~%")
    (format #t "            Other error.~%")
    (format #t "            In (~a).~%" (slot-value c 'function))
    (interrupt-pvm-parent "Other error" (slot-value c 'function))))

(define-handler unbound-symbol
  (lambda (c)
    (if (eq? (pvm-parent) 'PvmNoParent)
      (begin (format #t "~a is an unbound symbol.~&"
               (slot-value c 'object))
             (std-error-function-report c #t))
      (pvm-get-unbound-obj (slot-value c 'object)))))

(define-handler unbound-symbol-bci
  (lambda (c)
    (if (eq? (pvm-parent) 'PvmNoParent)
      (begin (format #t "~a is an unbound symbol.~&"
               (slot-value c 'object))
             (format #t "        in byte code instruction ~a.~&" 
               (slot-value c 'byte-code-function)))
      (pvm-get-unbound-obj (slot-value c 'object)))))

(define-handler not-ordinary-symbol 
  (lambda (c)
    (if (eq? (pvm-parent) 'PvmNoParent)
      (begin (format #t "~a is an unbound symbol.~&"
               (slot-value c 'object))
             (std-error-function-report c #t))
      (pvm-get-unbound-obj (slot-value c 'object)))))  
      
(define (kill-pvm-family-process)
  (format #t "kill-pvm-family-process done~%")
  (let* ((all-process (cdr (pvm-tasks 0)))
         (my-tid (mytid)))
    (for-each (lambda (child-id)
        (if (not (= child-id my-tid))
          (pvm-kill child-id)))
      (serch-kill-process all-process (list my-tid) '()))))

(define *pvm-error-tag* 33554431)

(define (interrupt-pvm-parent message function)
  (if (eq? (pvm-parent) 'PvmNoParent)
    (return-to-sctop)
    (let ((root-tid (serch-root-process (cdr (pvm-tasks 0)) (mytid)))
	  (bufid (pvm-mkbuf 0)))
      (pvm-joingroup "pvm_error_group")
      (pvm-setrbuf bufid)
      (pvm-sendsig root-tid SIGINT)
      (pvm-recv root-tid *pvm-error-tag*)
      (pvm-upkfix)
      (pvm-freebuf bufid)
      (set! function (if (symbol? function)
                       (string-append (string #\newline) "        In (" 
                                      (symbol->string function) ")."
                                      (string #\newline))
                       ""))
      (set! message (string-append "Error : " message "." function))
      (pvm-initsend 0)
      (pvm-pkfix (mytid))
      (pvm-pkstr *hostname*)
      (pvm-pkstr message)
      (pvm-send root-tid *pvm-error-tag*)
      (pvm-lvgroup "pvm_error_group")
      (do () (#f)))))

(define (serch-root-process data num)
  (let ((new #f))
    (for-each (lambda (child)
                (if (= (car child) num)
                  (if (equal? (car (cddddr child)) "pvmtus")
                    (set! new (cadr child))))) data)
    (if new
      (serch-root-process data new)
      num)))
                    
(define (serch-kill-process data num kill-process)
  (let ((new-kill-process '()))
    (for-each (lambda (parent)
        (for-each (lambda (child)
            (if (= (cadr child) parent)
              (set! new-kill-process (cons (car child) new-kill-process))))
          data)) num)
    (if (null? new-kill-process)
      kill-process
      (serch-kill-process data new-kill-process 
        (append kill-process new-kill-process)))))

