/*
 * SCHEME.h
 */

/*
 * $Id: scheme.h,v 1.39 2014/10/28 02:22:55 komiya Exp $
 *
 *  File Name : scheme.h
 *  Scince Mar.'90  by M.Yamamoto
 *
 *  Update    : Yass.  Sep. 18 '90
 *              Yass.  Sep. 17 '90
 *              Yass.  Sep. 14 '90
 *              Yass.  Sep.  7 '90
 *              Yass.  Sep.  6 '90
 *              Yass.  Jul. 26 '90
 *              Yass.  Jul. 20 '90
 *              Yass.  Jul. 19 '90
 *              Yass.  Jul. 18 '90
 *              Yass.  Jul. 17 '90
 *              Yass.  Jul.  2 '90
 *              Yass.  Jun. 26 '90
 *
 *    Scheme object definitions and most useful macros.
 *
 */

#ifndef __SCHEME_H__
#define __SCHEME_H__

#ifdef __MACH__
# define unix 1
#endif

/* including config.h */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef ED_MINE
#define KCL
#define kana
#endif

#if defined(__ELF__) && defined(i386)
#undef SPECIAL_CONS_TAG
#elif defined(__ELF__) && defined(mips)
#undef SPECIAL_CONS_TAG
#elif defined(__CYGWIN32__)
#undef SPECIAL_CONS_TAG
#endif

#ifdef CTHREAD
# ifdef SHE

#define SHE_ENV

# if 0                          /* debug */
# else
# ifdef SHE_ENV
#  define SEQ_MODE_EXEC() \
    if (par_constr(poped_sstfr) == FUTURE_CONST) { \
        open_frame2(iretaddrx_she_seq_fut, \
                    LTAG_STRING | SSERDDA(bcbody_reg), bcpc_reg); \
        s_push(poped_sstfr->func_obj.obj); \
        s_push(poped_sstfr->result.obj); \
        s_push(reg_reg); /* save reg_reg */ \
        copy_env_to_cstack(poped_sstfr); \
        if (poped_sstfr->env_list.obj != LTAG_NIL) \
            s_push(poped_sstfr->env_list.obj); \
        active_reg = base_reg; \
        bcpc_reg = poped_sstfr->pc1; \
        bcbody_reg \
            = (unsigned *)ADDRESS(((ENTITYP)ADDRESS(poped_sstfr->func_obj.obj))->bcc.body.obj); \
    } else { \
        open_frame2(iretaddrx_she_seq_st, \
                    LTAG_STRING | SSERDDA(bcbody_reg), bcpc_reg); \
        s_push(poped_sstfr->func_obj.obj); \
        s_push(LTAG_STEALABLE | SSERDDA(poped_sstfr)); \
        s_push(reg_reg); /* save reg_reg */ \
        copy_env_to_cstack(poped_sstfr); \
        if (poped_sstfr->env_list.obj != LTAG_NIL) \
            s_push(poped_sstfr->env_list.obj); \
        active_reg = base_reg; \
        bcpc_reg = poped_sstfr->pc1; \
        bcbody_reg \
            = (unsigned *)ADDRESS(((ENTITYP)ADDRESS(poped_sstfr->func_obj.obj))->bcc.body.obj); \
    }
# else
#  define SEQ_MODE_EXEC() \
    if (par_constr(poped_sstfr) == FUTURE_CONST) { \
        open_frame2(iretaddrx_she_seq_fut, \
                    LTAG_STRING | SSERDDA(bcbody_reg), bcpc_reg); \
        s_push(poped_sstfr->func_obj.obj); \
        s_push(poped_sstfr->result.obj); \
        s_push(reg_reg); /* save reg_reg */ \
        s_push(poped_sstfr->env_list.obj); \
        active_reg = base_reg; \
        bcpc_reg = poped_sstfr->pc1; \
        bcbody_reg \
            = (unsigned *)ADDRESS(((ENTITYP)ADDRESS(poped_sstfr->func_obj.obj))->bcc.body.obj); \
    } else { \
        open_frame2(iretaddrx_she_seq_st, \
                    LTAG_STRING | SSERDDA(bcbody_reg), bcpc_reg); \
        s_push(poped_sstfr->func_obj.obj); \
        s_push(LTAG_STEALABLE | SSERDDA(poped_sstfr)); \
        s_push(reg_reg); /* save reg_reg */ \
        s_push(poped_sstfr->env_list.obj); \
        active_reg = base_reg; \
        bcpc_reg = poped_sstfr->pc1; \
        bcbody_reg \
            = (unsigned *)ADDRESS(((ENTITYP)ADDRESS(poped_sstfr->func_obj.obj))->bcc.body.obj); \
    }
# endif

#  define WAITING_FOR(WAIT_COND, ACTION_AFTER_DETERMINED_1, REPLACE_ACTION) \
    if (thr_data[THR_STATUS] == SUBSIDIARY_S) { \
        if (thr_data[THR_STATE] == RUN) { \
            mutex_lock(pri_act.lock); \
            sub_act.active--; \
            mutex_unlock(pri_act.lock); \
        } \
    } else { \
        set_promote_sstfr(sstfr); \
        mutex_lock(pri_act.lock); \
        pri_act.active--; \
        mutex_unlock(pri_act.lock); \
    } \
    while ((WAIT_COND)) \
        condition_wait(sstfr->cond_obj, sstfr->frame_lock); \
    mutex_unlock(sstfr->frame_lock); \
    if (thr_data[THR_STATUS] == SUBSIDIARY_S) { \
        if (thr_data[THR_STATE] == RUN) { \
            mutex_lock(pri_act.lock); \
            sub_act.active++; \
            mutex_unlock(pri_act.lock); \
        } \
    } else { \
        mutex_lock(pri_act.lock); \
        pri_act.active++; \
        mutex_unlock(pri_act.lock); \
    } \
    (ACTION_AFTER_DETERMINED_1); \
    (REPLACE_ACTION);

#  define TRY_SEQ_MODE_EXEC(WAIT_COND, \
                            ACTION_AFTER_DETERMINED_1, REPLACE_ACTION, FADR) \
{ \
    sst_frame_t *poped_sstfr; \
    poped_sstfr = get_sst_frame_aux(sstfr, (FADR)); \
    if (poped_sstfr) { \
        SEQ_MODE_EXEC(); \
        return; \
    } else { \
        mutex_lock(sstfr->frame_lock); \
        WAITING_FOR((WAIT_COND), \
                    (ACTION_AFTER_DETERMINED_1), \
                    (REPLACE_ACTION)); \
    } \
}

/*
   We assume that the processor executes `membar #StoreLoad'
   after changing a status to DETERMINED or assigning NULL to
   fut->future.sstfr.
*/
#  define TOUCH(F, REPLACE_ACTION) \
    for (;;) { \
        if (GETtag((F)) == LTAG_FUTURE) { \
            ENTITYP fut = (ENTITYP)ADDRESS((F)); \
            sst_frame_t *sstfr = fut->future.sstfr; \
            if (sstfr == NULL) { \
                (F) = fut->future.value.obj; \
                (REPLACE_ACTION); \
                continue; \
            } \
            /* \
              Note that any SST-frame is always accesible even if it is \
              reclaimed by the TUTScheme system. \
            */ \
            mutex_lock(sstfr->frame_lock); \
            /* sstfr may already reclaimed (and may be used by another.) */ \
            if (fut->future.sstfr == NULL) { \
                mutex_unlock(sstfr->frame_lock); \
                (F) = fut->future.value.obj; \
                (REPLACE_ACTION); \
                continue; \
            } else if (sstfr_status(sstfr) == EXECUTING) { \
                WAITING_FOR((fut->future.sstfr != NULL), \
                            ((F) = fut->future.value.obj), \
                            (REPLACE_ACTION)); \
                continue; \
            } else { \
                /* sequential mode */ \
                mutex_unlock(sstfr->frame_lock); \
                TRY_SEQ_MODE_EXEC((fut->future.sstfr != NULL), \
                                  ((F) = fut->future.value.obj), \
                                  (REPLACE_ACTION), \
                                  fut); \
                continue; \
            } \
        } else if (GETtag((F)) == LTAG_STEALABLE) { \
            sst_frame_t *sstfr = (sst_frame_t *)ADDRESS((F)); \
            if (sstfr_status(sstfr) == DETERMINED) { \
                (F) = sstfr->result.obj; \
                free_sst_frame(sstfr); \
                (REPLACE_ACTION); \
                continue; \
            } \
            mutex_lock(sstfr->frame_lock); \
            if (sstfr_status(sstfr) == DETERMINED) { \
                mutex_unlock(sstfr->frame_lock); \
                (F) = sstfr->result.obj; \
                free_sst_frame(sstfr); \
                (REPLACE_ACTION); \
                continue; \
            } else if (sstfr_status(sstfr) == EXECUTING) { \
                WAITING_FOR((sstfr_status(sstfr) != DETERMINED), \
                            {(F) = sstfr->result.obj; \
                             free_sst_frame(sstfr);}, \
                            (REPLACE_ACTION)); \
                continue; \
            } else { \
                /* sequential mode */ \
                mutex_unlock(sstfr->frame_lock); \
                TRY_SEQ_MODE_EXEC((sstfr_status(sstfr) != DETERMINED), \
                                  {(F) = sstfr->result.obj; \
                                   free_sst_frame(sstfr);}, \
                                  (REPLACE_ACTION), \
                                  NULL); \
                continue; \
            } \
        } else \
            break; \
    }
# endif
# else
#  define TOUCH(F, REPLACE_ACTION) \
    if (GETtag((F)) == LTAG_FUTURE) { \
        ENTITYP fut; \
        do { \
            fut = (ENTITYP)ADDRESS((F)); \
            mutex_lock(fut->future.lock); \
            if (fut->future.status == DETERMINED) \
                (F) = fut->future.value.obj; \
            else { \
                while (fut->future.status != DETERMINED) \
                    condition_wait(fut->future.done, fut->future.lock); \
                (F) = fut->future.value.obj; \
            } \
            mutex_unlock(fut->future.lock); \
        } while (GETtag((F)) == LTAG_FUTURE); \
        (REPLACE_ACTION); \
    }
# endif
# ifdef PTHREAD
#  include <pthread.h>
#  ifdef FREEBSD
#  include <sched.h>
#  endif
#  if defined(PGCC) || defined(SUNSOL2) || defined(FREEBSD) || defined(LINUX)
    typedef void * any_t;
#  endif
   typedef pthread_t         mtus_thread_t;
   typedef pthread_t         cthread_t;         /* backword compatibility */
   typedef pthread_mutex_t * mutex_t;
   typedef pthread_cond_t  * condition_t;
#  if defined(SUNSOL2) || defined(FREEBSD) || defined(LINUX)
#   define cthread_init()        ;
#  else
#   define cthread_init()        pthread_init()
#  endif
   extern mutex_t mutex_alloc();
   extern void mutex_free();
   extern condition_t condition_alloc();
   extern void condition_free();
   extern int mutex_try_lock();
   extern cthread_t cthread_fork();
   extern mtus_thread_t mtus_thread_fork_secondary();
#  define cthread_exit(result)          pthread_exit((result))
#  define cthread_detach(thread)        pthread_detach((thread))
#  define cthread_self()                pthread_self() /* backword compati */
#  define mtus_thread_self()            pthread_self()
   extern pthread_key_t pthread_key;
#  define cthread_set_data(t,data)      pthread_setspecific(pthread_key,(data))
#   ifdef SUNSOL2
#    define cthread_data(t)             pthread_getspecific(pthread_key)
#   elif FREEBSD
#    define cthread_data(t)             pthread_getspecific(pthread_key)
#   else
     extern void *cthread_data();
#   endif
#  define mutex_lock(m)                  pthread_mutex_lock(m)
#  define mutex_aho_lock(m,s)              if (m == aho) printf("+[%s] by %d\n", s, cthread_self()); pthread_mutex_lock(m);
/* #  define mutex_try_lock(m)  pthread_mutex_trylock(&(m)) */
#  define mutex_unlock(m)                pthread_mutex_unlock(m)
#  define mutex_aho_unlock(m,s)            if (m == aho) printf("-[%s] by %d\n",s,cthread_self()); pthread_mutex_unlock(m);
#  define condition_signal(c)            pthread_cond_signal(c)
#  define condition_broadcast(c)         pthread_cond_broadcast(c)
#  define condition_wait(c,m)            pthread_cond_wait(c,m)
# else
#  include <cthreads.h>
# endif
# ifdef LTC
#  define CHILD_STACK_SIZE      0x80000
# else
#  define CHILD_STACK_SIZE      0x8000
# endif
# define CHILD_GETA_OF_STACK   0x400
#endif

#ifndef LUNA_MACH
#include <setjmp.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>


/*************************************/
/*                                   */
/*  Definitions for compile options  */
/*                                   */
/*************************************/

#define  COMPLEX_USE   /* Yass. Jul. 2 '90  */
#define  FRACTION_USE  /* Yass. Jul. 2 '90  */


/*****************************/
/*                           */
/*  A long word scheme data  */
/*                           */
/*****************************/

#if 0
typedef struct {
    unsigned    tag  : 6;
    unsigned    data : 24;
    unsigned    gc   : 2;
} COMMON;

typedef struct {
    unsigned    tag  : 4;
    unsigned    exac : 1;
    unsigned    val  : 25;
    unsigned    gc   : 2;
} FIXNUM;

typedef struct {
    unsigned    tag  : 6;
    unsigned    addr : 26; /* includes gc information bits(2bit). */
} BLOCK, CONS;

/* Modify Yass. Sep. 6 '90 */

typedef struct {
    unsigned    tag  : 4;
    unsigned    sign : 1;
    unsigned    exp  : 9;
    unsigned    mant : 16;
    unsigned    gc   : 2;
} SFLOAT;

/* End Yass. Sep. 6 '90 */

typedef struct {
    unsigned    tag  : 6;
    unsigned    dmy1 : 2;
    unsigned    ch   : 8;
    unsigned    dmy2 : 14;
    unsigned    gc   : 2;
} CHARACTER;

typedef struct {
    unsigned    tag  : 6;
    unsigned    dumy : 8;
    unsigned    kch  : 16;
    unsigned    gc   : 2;
} KANJI;

#endif

typedef union {
    unsigned com;     /* common basic format */
    unsigned blk;     /* object needing BLocK1 or BLocK2 */
    unsigned cons;    /* CONS */
    unsigned fix;     /* FIXnum */
    unsigned sflt;    /* Short FLoaT */
    unsigned ch;      /* ascii CHaracter */
    unsigned kch;     /* Kanji CHaracter */
    unsigned obj;     /* #T , #F , EOF and so on */
    union u_entity *entity; /* BLOCK1 , BLOCK2 and CONS */
} SOBJ;

typedef SOBJ *SOBJP;


/****************************************/
/*                                      */
/*  Some long word scheme data entitys  */
/*                                      */
/****************************************/

typedef struct {
    SOBJ car;
    SOBJ cdr;
} CARCDR;

typedef struct {
#if 0
    unsigned    tag  : 6;
    unsigned    data : 24;
    unsigned    gc   : 2;
#endif
    unsigned    head;
    SOBJ        cdr;
    SOBJ        block;
    SOBJ        car;
    SOBJ        link;
} WPCARCDR;

typedef struct {
#if 0
    unsigned    tag  : 6;
    unsigned    data : 24;
    unsigned    gc   : 2;
#endif
    unsigned    head;
    SOBJ      sym_val;
    SOBJ      sym_name;
    SOBJ      hash_lk;
    SOBJ        proplist;
} SYMBOL;

typedef struct {
#if 0
    unsigned    tag  : 6;
    unsigned    data : 24;
    unsigned    gc   : 2;
#endif
    unsigned    head;
    int str_len;
    int str_kind;
} STRING, KSTRING;

typedef struct {
#if 0
    unsigned    tag  : 6;
    unsigned    data : 24;
    unsigned    gc   : 2;
#endif
    unsigned    head;
    SOBJ      const_vec;
    SOBJ      fun_name;
    SOBJ      source;
    SOBJ      env;
    SOBJ      body;
    SOBJ      block;
    int arg_info;
    int start_addr;
} BCCLOS, MBCCLOS, NCCLOS, MNCCLOS;

/*  Not used SYAFUN and MSYSFUN structure in all C-lanbuage version. */
typedef struct {
#if 0
    unsigned    tag  : 6;
    unsigned    data : 24;
    unsigned    gc   : 2;
#endif
    unsigned    head;
    SOBJ      const_vec;
    SOBJ      fun_name;
    SOBJ      block;
    int arg_info;
    int (*entry_addr)();
} SYSFUN, MSYSFUN;

#ifdef CTHREAD
# ifdef CALLIOC
typedef struct {
    unsigned    head;
    SOBJ      body;
    SOBJ      count;
    SOBJ      opt;
} CONTIN;
# else
typedef struct {
    unsigned  head;
    SOBJ      body;
    SOBJ      opt;
} CONTIN;
# endif
#else /* CTHREAD */
# ifdef CALLIOC
typedef struct {
    unsigned    head;
    SOBJ      body;
    SOBJ      count;
} CONTIN;
# else
typedef struct {
    unsigned    head;
    SOBJ      body;
} CONTIN;
# endif
#endif

#ifdef CALLIOC
typedef struct {
    unsigned head;
    SOBJ bcbody;
    SOBJ bottom;
} IOC;
#endif

typedef struct {
#if 0
    unsigned    tag  : 6;
    unsigned    data : 24;
    unsigned    gc   : 2;
#endif
    unsigned    head;
    SOBJ      nume;
    SOBJ      deno;
} FRACTION;

typedef struct {
#if 0
    unsigned    tag  : 6;
    unsigned    data : 24;
    unsigned    gc   : 2;
#endif
    unsigned    head;
    SOBJ      real;
    SOBJ      imag;
} COMPLEX;

#ifdef EIGHT_BYTE_ALIGNMENT_DOUBLE /* T.Komiya */
typedef struct {
    char a[sizeof(double)];
} bdouble;

typedef union {
    double f;
    bdouble b;
} unaligned_double;
#endif

typedef struct {
#if 0
    unsigned    tag  : 6;
    unsigned    data : 24;
    unsigned    gc   : 2;
#endif
    unsigned    head;
#ifdef EIGHT_BYTE_ALIGNMENT_DOUBLE
    unaligned_double val;
#else
    double  val;
#endif
} FLOAT;

typedef struct {
#if 0
    unsigned    tag  : 6;
    unsigned    data : 24;
    unsigned    gc   : 2;
#endif
    unsigned    head;
    SOBJ        next;
    SOBJ        block;
    int val;
} BIGNUM;

typedef struct {
#if 0
    unsigned    tag  : 6;
    unsigned    data : 24;
    unsigned    gc   : 2;
#endif
    unsigned    head;
} VECTOR;

typedef struct {
#if 0
    unsigned    tag  : 6;
    unsigned    data : 24;
    unsigned    gc   : 2;
#endif
    unsigned    head;
    SOBJ      type;
} STRUCTURE;

typedef struct {
#if 0
    unsigned    tag  : 6;
    unsigned    data : 24;
    unsigned    gc   : 2;
#endif
    unsigned    head;
    SOBJ      body_result;
    SOBJ      start_addr;
    SOBJ      env;
} PROMISE;

#ifdef NIHONGO
typedef struct {
#if 0
    unsigned    tag  : 6;
    unsigned    data : 24;
    unsigned    gc   : 2;
#endif
    unsigned    head;
    SOBJ        slot;
    SOBJ        block;
    FILE      * fp;
    int kind;
    unsigned    bufstatus : 4;
    unsigned    shift : 1;                      /* shift flag for JIS */
    unsigned    notfirst : 1;                   /* first column flag  */
    unsigned    dummy : 2;                /* always 0 for string port */
    unsigned    buf2 : 8;
    unsigned    buf1 : 8;
    unsigned    kanji_input_code : 4;
    unsigned    kanji_output_code : 4;
    unsigned    slot_size;      /* for string-port */
} PORT;
#else
typedef struct {
#if 0
    unsigned    tag  : 6;
    unsigned    data : 24;
    unsigned    gc   : 2;
#endif
    unsigned    head;
    SOBJ        slot;
    SOBJ        block;
    FILE      * fp;
    int kind;
    unsigned    bufstatus : 8;
    unsigned    dummy : 4;
    unsigned    notfirst : 4;                   /* first column flag */
    unsigned    buf2 : 8;
    unsigned    buf1 : 8;
    unsigned    slot_size;      /* for string-port */
} PORT;
#endif  /* NIHONGO */

#ifdef CTHREAD

typedef struct {
#if 0
    unsigned    tag  : 6;
    unsigned    data : 24;
    unsigned    gc   : 2;
#endif
    unsigned    head;
    SOBJ        val;
    SOBJ        block;
    mutex_t     lock1;
    mutex_t     lock2;
    condition_t c1;
    condition_t c2;
} LOCK;

#ifdef SHE
typedef struct sst_frame {
  mutex_t      frame_lock;
  condition_t  cond_obj;
  SOBJ         func_obj;
  unsigned int pc1;
  unsigned int pc2;
  SOBJ         result;          /* == future object | value slot */
  unsigned int status;
  unsigned int narg;
  unsigned int pstack;          /* pointer to stack */

#ifdef SHE_ENV
  unsigned int *env_array;
#endif
  SOBJ         env_list;
  struct sst_frame  *link;
} sst_frame_t;

typedef struct {
    unsigned    head;
    SOBJ        value;
    SOBJ        block;
    sst_frame_t *sstfr;
} FUTURE;
#else
typedef struct {
    unsigned    head;
    SOBJ        body;
    SOBJ        start_addr;
    SOBJ        env;
    SOBJ        value;
    SOBJ        block;
    int         status;
    cthread_t   proc_id;
# ifdef PTHREAD
    int         dummy;
# else
    thread_t    thread_id;
# endif
    mutex_t     lock;
    condition_t done;
    jmp_buf     *catch;         /* not used */
} FUTURE;
#endif

typedef struct {
    unsigned int *_active_reg;
    unsigned int *_base_reg;
    unsigned int *_sp_reg;
    unsigned int _reg_reg;
    unsigned int _bcpc_reg;
    unsigned int *_bcbody_reg;
#if 0 /* (XXX) for future work ... by shige */
    unsigned int *_stack_top;
    unsigned int *_stack_bottom;
    unsigned int *_stack_area_bottom;
#else
    char *_stack_top;
    char *_stack_bottom;
    char *_stack_area_bottom;
#endif
    unsigned int *_old_top;
    unsigned int *_old_top1;
    unsigned int _reg1;
    unsigned int _reg2;
    unsigned int _reg3;
    SOBJ _call_cc_arg;
    SOBJ _top_of_aflk;
    SOBJ _end_of_aflk;
    SOBJ _af_tmp;
    SOBJ _more;
    SOBJ _optcnt;
} REGS;

#endif /* CTHREAD */

typedef union u_entity {
    CARCDR   cell;
    WPCARCDR wpcell;
    SYMBOL   sym;
    STRING   str;
    KSTRING  kstr;
    BCCLOS   bcc;
    MBCCLOS  mbcc;
    NCCLOS   ncc;
    MNCCLOS  mncc;
    SYSFUN   sfn;
    MSYSFUN  msfn;
    CONTIN   cnt;
#ifdef CALLIOC
    IOC      ioc;
#endif
    FRACTION frac;
    COMPLEX  cplx;
    FLOAT    flt;
    BIGNUM   bnum;
    VECTOR   vec;
    STRUCTURE struc;
    PROMISE  prms;
    PORT     port;
#ifdef CTHREAD
    LOCK     lock;
    FUTURE   future;
#endif
} ENTITY;

typedef ENTITY *ENTITYP;


/***********************************************************************/
/*                                                                     */
/*  Initial memory allocation sizes  for hash-tabel and string-buffer  */
/*                                                                     */
/***********************************************************************/

#define         HASH_SIZE          0x10000
#define         DEFAULT_HASH_B_M   0x3fff
#define         STRBUFSIZE         0x100


/*****************************************/
/*                                       */
/*  Hash table for byte code translator  */
/*                                       */
/*****************************************/

#define     BCHASH_SIZE 0x1000
#define     BCHASH_B_M  0x3ff

/*
 * Hash table for byte code specification
 */

#define     BCDATA_HASH_SIZE    0x400
#define     BCDATA_HASH_MASK    0xff


/**********************/
/*                    */
/*  Global constants  */
/*                    */
/**********************/

#define     SYMBOL_STRING       0x04000000
#define     ORDINARY_STRING     0x0
#define     A_STRING        0       
#define     K_STRING        1

#define     STR_EQUAL       0
#define     STR_PRECEDING       1
#define     STR_FOLLOWING       -1

#define     TRUE  1
#define     FALSE 0

#define     ON 1
#define     OFF 0

#define     PRINT  1
#define     PRINC  0
#define     SPRINT 2

#define     WITH_REST_MASK      0x3


/*  stream mode  */

#define     INPUT           0
#define     OUTPUT          1
#define         STRING_INPUT    2  /*  Yass. Jul. 20 '90  */
#define         STRING_OUTPUT   3  /*  Yass. Jul. 20 '90  */
#define     CLOSE          -1

#ifdef TCPIP
#define         TCP_STREAM      4
#define         UDP_DGRAM       5
#define         TCP_BOUND       6
#endif


/*  for transcript  */

#define     TRANSCRIPT_ON   1
#define     TRANSCRIPT_OFF  0

#define     KCHAR 2
#define     ACHAR 1

#define     UNKNOWN 0

#define     NON   0
#define         BINARY    2  /*  Yass. Jul. 20 '90  */
#define         OCTAL     8  /*  Yass. Jul. 20 '90  */
#define         DECIMAL  10  /*  Yass. Jul. 20 '90  */
#define         HEX      16  /*  Yass. Jul. 20 '90  */
#define     EXACT    20
#define     INEXACT  30


#define     MARK_AND_SWEEP_GC 0
#define     COPY_GC           1
#define         COMPACTION        2

#define         EXTRA_HEAP_SIZE    0x80000


/* byte code translater program */

#define     REST     0x2        /* T.Komiya */
#define     OBJECT   0x4
#define     NUMBER   0x8
#define     LABEL    0xc
#define     GETCONST 0


/* gc */

#define     HIGH    0
#define     LOW     1

/* future */

#ifndef SHE
#define     NO_PROCESS          0
#define     NOT_READY           1
#define     UNDETERMINED        2
#define     DETERMINED          3
#endif

/* debug */

#define     DEBUG   1


#define         KANJI_p(ch)     ((ch) & 0x80)

/*  STRto_p(sym)  */
#define     STRto_p(sym)    ( ((char *)((unsigned)sym & 0x03fffffc)) + 8 )

/* ADDRESS(obj) */
#ifdef HP
#define     ADDRESS(obj)    ((0x03fffffc & (unsigned)(obj)) | 0x40000000)
#define     SSERDDA(adr)    (0xbfffffff & (unsigned)(adr))
#elif defined(__ELF__) && defined(i386)
#define     ADDRESS(obj)    ((0x03fffffc & (unsigned)(obj)) | 0x8000000)
#define     SSERDDA(adr)    (0xf7ffffff & (unsigned)(adr))
#elif defined(__ELF__) && defined(mips)
#define     ADDRESS(obj)    ((0x03fffffc & (unsigned)(obj)) | 0x10000000)
#define     SSERDDA(adr)    (0xefffffff & (unsigned)(adr))
#elif defined(__CYGWIN32__)
# ifdef TK
#  define     ADDRESS(obj)    ((0x03fffffc & (unsigned)(obj)) | 0x10000000)
#  define     SSERDDA(adr)    (0xefffffff & (unsigned)(adr))
# else
#  define     ADDRESS(obj)    (0x03fffffc & (unsigned)(obj))
#  define     SSERDDA(adr)    ((unsigned)(adr))
# endif
//#define     ADDRESS(obj)    ((0x03fffffc & (unsigned)(obj)) | 0x8000000)
//#define     SSERDDA(adr)    (0xf7ffffff & (unsigned)(adr))
#else
#define     ADDRESS(obj)    (0x03fffffc & (unsigned)(obj))
#define     SSERDDA(adr)    ((unsigned)(adr))
#endif

#define     IMM(obj)    (0x03fffffc & (unsigned)(obj))
#define     IMMNUM(obj)     (0x0ffffffc & (unsigned)(obj))

#define         getarg(i)       (*(active_reg-i-1))
#define         setarg(i, obj)  *(active_reg-i-1)=obj
#define         EQ(a,b)         (((a) == (b)) ? TRUE : FALSE)


#ifdef SPECIAL_CONS_TAG
#define     CARobj(cons)    (((ENTITYP)cons)->cell.car.obj)
#define     CDRobj(cons)    (((ENTITYP)cons)->cell.cdr.obj)
#else
#define     CARobj(cons)    (((ENTITYP)ADDRESS(cons))->cell.car.obj)
#define     CDRobj(cons)    (((ENTITYP)ADDRESS(cons))->cell.cdr.obj)
#endif

#define     WPCARobj(wpcons)  (((ENTITYP)ADDRESS(wpcons))->wpcell.car.obj)
#define     WPCDRobj(wpcons)  (((ENTITYP)ADDRESS(wpcons))->wpcell.cdr.obj)


#define  LESST     1                   /*  Yass. Jul. 18 '90  */
#define  EQUAL     2                   /*  Yass. Jul. 18 '90  */
#define  GREATERT  4                   /*  Yass. Jul. 18 '90  */
#define  LESSE     (LESST | EQUAL)     /*  Yass. Jul. 18 '90  */
#define  NEQ       (LESST | GREATERT)  /*  Yass. Jul. 18 '90  */
#define  GREATERE  (GREATERT | EQUAL)  /*  Yass. Jul. 18 '90  */


#define     BLOCK_TABLE_SIZE    200

#if defined(__CYGWIN32__) || defined(linux)
  extern sigjmp_buf toplevel;
#else
  extern jmp_buf toplevel;
#endif
extern unsigned  *block_table[BLOCK_TABLE_SIZE];
extern unsigned  *big_block;


#define         FIX_MAX                 33554431    /* Yass. Jul. 17 '90 */
#define         FIX_MIN               (-33554432)   /* Yass. Jul. 17 '90 */
#define         BSIZE_MAX               16777216    /* by T.Komiya */
#define         STRLEN_MAX              33554428    /* by T.Komiya */
#define         INTEGER_MAX             2147483647  /* Yass. Sep. 17 '90 */
#define         INTEGER_MIN           (-2147483647-1) /* Yass. Sep. 17 '90 */
#define         INT_MASK                0x7fffffff  /* Yass. Aug. 23 '90 */
#define         CH_MASK                 0x000000ff  /* Yass. Sep. 14 '90 */

/*  Yass. Sep. 7 '90  */

#ifdef NIHONGO
#define         ESC_CODE        0x1b
#define         SHIFT_IN1       0x24
#define         SHIFT_IN2_OLD   0x40            /* JIS X 0208 - 1978 (Old JIS but ASCII) */
#define         SHIFT_IN2_NEW   0x42            /* JIS X 0208 - 1983 (New JIS)           */
#define         SHIFT_IN2       SHIFT_IN2_NEW
#define         SHIFT_OUT1      0x28
#define         SHIFT_OUT2      0x4a /* JIS X 0201 */
#define         SHIFT_OUT2_ASC  0x42 /* ASCII */
#define         EUC_CODE        0
#define         JIS_CODE        1
#define         SJIS_CODE       2
#define         NOC_CODE        3
#endif

typedef union {
    double  d;
#if 0
    struct cont { 
        unsigned int    sign   : 1 ;
        unsigned int    exp    : 11;
        unsigned int    mant_h : 16;
        unsigned int    mant_m : 4 ;
        unsigned int    mant_l : 32;
    } i;
#endif
#ifdef WORDS_BIGENDIAN
    struct {
        unsigned h;
        unsigned l;
    } i;
#else
    struct {
        unsigned l;
        unsigned h;
    } i;
#endif
} FLT_TMP;

#define FLT_SIGN(obj)           ((0x80000000 & (obj).i.h) >> 31)
#define FLT_EXP(obj)            ((0x7ff00000 & (obj).i.h) >> 20)
#define FLT_MANT_H(obj)         ((0x000ffff0 & (obj).i.h) >> 4)
#define FLT_MANT_M(obj)         (0x0000000f & (obj).i.h)
#define FLT_MANT_L(obj)         ((obj).i.l)

#define SFLT_SIGN(obj)          ((0x08000000 & (unsigned)(obj)) >> 27)
#define SFLT_EXP(obj)           ((0x07fc0000 & (unsigned)(obj)) >> 18)
#define SFLT_MANT(obj)          ((0x0003fffc & (unsigned)(obj)) >> 2)

/*  END  */

typedef struct bheader {                /* used by alloc.c */
    struct bheader *ptr;
    unsigned    size;
} HEADER;

/*  Yass. Sep. 18 '90  */

typedef struct {
    char    *opname;
    int op;
} BCTABLE;

/*  END  */

typedef struct { /* T.Komiya */
    SOBJ sharp_index;
    SOBJ sharp_eq;
    SOBJ sharp_sharp;
} SHARP_EQ_CONTEXT_STRUCT;

#define SHARP_EQ_CONTEXT_SIZE   4096 /* T.Komiya */

#ifdef CTHREAD

# ifdef PTHREAD
#  define MAX_THREAD_NO           1000
# else
#  define MAX_THREAD_NO           40
# endif

# ifdef USE_REG

/*  NOTE: if you change this definition, see also setup_child() (bci.c),    */
/*     bc_intrp_not_future2() (future.c), mk_future() (future.c).           */
/*     bc_interpreter() (bci.c), return_to_bc_interpreter() (err_handler.c) */

#   define active_reg   (main_thread_regs->_active_reg)
#   define base_reg     (main_thread_regs->_base_reg)
#   define sp_reg       (main_thread_regs->_sp_reg)
#   define reg_reg      (main_thread_regs->_reg_reg)
#   define bcpc_reg     (main_thread_regs->_bcpc_reg)
#   define bcbody_reg   (main_thread_regs->_bcbody_reg)
#   define stack_top     (main_thread_regs->_stack_top)
#   define stack_bottom  (main_thread_regs->_stack_bottom)
#   define stack_area_bottom (main_thread_regs->_stack_area_bottom)
#   define old_top       (main_thread_regs->_old_top)
#   define old_top1      (main_thread_regs->_old_top1)
#   define reg1          (main_thread_regs->_reg1)
#   define reg2          (main_thread_regs->_reg2)
#   define reg3          (main_thread_regs->_reg3)
#   define call_cc_arg   (main_thread_regs->_call_cc_arg)
#   define top_of_aflk   (main_thread_regs->_top_of_aflk)
#   define end_of_aflk   (main_thread_regs->_end_of_aflk)
#   define af_tmp        (main_thread_regs->_af_tmp)
#   define more          (main_thread_regs->_more)
#   define optcnt        (main_thread_regs->_optcnt)
# else  /* not USE_REG */
#  define main_thread_regs ((REGS *)cthread_data(cthread_self()))
#  define active_reg      (((REGS *)cthread_data(cthread_self()))->_active_reg)
#  define base_reg        (((REGS *)cthread_data(cthread_self()))->_base_reg)
#  define sp_reg          (((REGS *)cthread_data(cthread_self()))->_sp_reg)
#  define reg_reg               (((REGS *)cthread_data(cthread_self()))->_reg_reg)
#  define bcpc_reg      (((REGS *)cthread_data(cthread_self()))->_bcpc_reg)
#  define bcbody_reg    (((REGS *)cthread_data(cthread_self()))->_bcbody_reg)
#  define stack_top     (((REGS *)cthread_data(cthread_self()))->_stack_top)
#  define stack_bottom  (((REGS *)cthread_data(cthread_self()))->_stack_bottom)
#  define stack_area_bottom (((REGS *)cthread_data(cthread_self()))->_stack_area_bottom)
#  define old_top       (((REGS *)cthread_data(cthread_self()))->_old_top)
#  define old_top1      (((REGS *)cthread_data(cthread_self()))->_old_top1)
#  define reg1          (((REGS *)cthread_data(cthread_self()))->_reg1)
#  define reg2          (((REGS *)cthread_data(cthread_self()))->_reg2)
#  define reg3          (((REGS *)cthread_data(cthread_self()))->_reg3)
#  define call_cc_arg   (((REGS *)cthread_data(cthread_self()))->_call_cc_arg)
#  define top_of_aflk   (((REGS *)cthread_data(cthread_self()))->_top_of_aflk)
#  define end_of_aflk   (((REGS *)cthread_data(cthread_self()))->_end_of_aflk)
#  define af_tmp        (((REGS *)cthread_data(cthread_self()))->_af_tmp)
#  define more          (((REGS *)cthread_data(cthread_self()))->_more)
#  define optcnt        (((REGS *)cthread_data(cthread_self()))->_optcnt)
# endif /* USE_REG */

#else

#define active_reg              _active_reg
#define base_reg                _base_reg
#define sp_reg                  _sp_reg
#define reg_reg                 _reg_reg
#define bcpc_reg                _bcpc_reg
#define bcbody_reg              _bcbody_reg
#define stack_top               _stack_top
#define stack_bottom            _stack_bottom
#define stack_area_bottom       _stack_area_bottom
#define old_top                 _old_top
#define old_top1                _old_top1
#define reg1                    _reg1
#define reg2                    _reg2
#define reg3                    _reg3
#define call_cc_arg             _call_cc_arg
#define top_of_aflk             _top_of_aflk
#define end_of_aflk             _end_of_aflk
#define af_tmp                  _af_tmp
#define more                    _more

#endif

/* for a-aclink dummy */
#define getsv(off)  (*(base_reg+(int)(off)))
#define getsvt(off) (*(sp_reg+(int)(off)))
#define setsv(off,val)  *(base_reg+(int)(off))=(unsigned)(val)
#define setsvt(off,val) *(sp_reg+(int)(off))=(unsigned)(val)

#define addtop(n)   sp_reg+=(int)(n)
#define set_top(n)  sp_reg=(unsigned *)(n)
#define set_base(n) base_reg=(unsigned *)(n)
#define set_active(n)   active_reg=(unsigned *)(n)
#define set_pc(n)   bcpc_reg=(unsigned)(n)
#define set_reg(n)  reg_reg=(unsigned)(n)
#define set_a2(n)   bcbody_reg=(unsigned *)(n)

#define s_push(n)   *(--sp_reg)=(unsigned)(n)
#define s_pop()     (*(sp_reg++))

#define top_val()   sp_reg
#define base_val()  base_reg
#define active_val()    active_reg
#define a2_val()    bcbody_reg
#define reg_val()   reg_reg
#define d4_val()    bcpc_reg

#include "tagsystem.h"
#include "decext.h"

#ifdef PVM3
#include "pvm3.h"
#endif

#ifdef SHE
#include "she.h"
#endif

#define GETA_OF_STACK   0x400

/* some useful definitions */
#define SCPOP()                 (*(sp_reg++))
#define GETbcarg(n)             (*(bcbody_reg+bcpc_reg+(n)))
#define PCUP(n)                 bcpc_reg+=(n)
#define FETCH0(offset)          (*(base_reg+(int)(offset)))

#ifdef CALLIOC
#define     STACK_SIZE      0x60000
#else
#define     STACK_SIZE      0x10000
#endif

#endif /* __SCHEME_H__ */
