/*
 * sysfun.c - 
 */

/*
 * $Id: sysfun.c,v 1.13 2014/10/28 02:22:55 komiya Exp $
 *
 *  --------------------------------
 *  REGISTERATION of SYSTEM-FUNCTION
 *  --------------------------------
 *
 *  File Name : sysfun.c 
 *  Written by Myama., Yass. and Komiya. (1990)
 *  modified for SUN4 by Myama. Oct. '90 
 *
 */

static char *RCSid="$Id: sysfun.c,v 1.13 2014/10/28 02:22:55 komiya Exp $";

#include "scheme.h"


/**********************************************/
/*                                            */
/*  Global declearation for system functions  */
/*                                            */
/**********************************************/

void Snot();  /* boolean.c */
void Sbooleanp();


void Seq();  /* equuivalence.c */
void Seqv();
void Sequal();


void Spairp();  /* cons.c */
void Slistp();
void Scons();
void Scar();
void Scdr();
void Ssetcar();
void Ssetcdr();
void Scaar();
void Scadr();
void Scdar();
void Scddr();
void Scaaar();
void Scaadr();
void Scadar();
void Scaddr();
void Scdaar();
void Scdadr();
void Scddar();
void Scdddr();
void Scaaaar();
void Scaaadr();
void Scaadar();
void Scaaddr();
void Scadaar();
void Scadadr();
void Scaddar();
void Scadddr();
void Scdaaar();
void Scdaadr();
void Scdadar();
void Scdaddr();
void Scddaar();
void Scddadr();
void Scdddar();
void Scddddr();
void Snullp();
void Slist();
void Slength();
void Sappend();
void Sreverse();
void Smemq();
void Smemv();
void Smember();
void Sassq();
void Sassv();
void Sassoc();
void Sfind_if();

void Slista();
void Slist_tail();
void Slist_ref();
void Snthcdr();
void Snth();
void Slast();

void Satomp();


void Ssymbolp();  /* symbol.c */
void Ssymbolstring();
void Sstringsymbol();
void Sstringsymbol_no_intern();
void Sgetprop();
void Sputprop();
void Ssymbol_plist();
void Sboundp();
void Sunboundp();
void Ssysfunp();
void Ssymbol_sensitive();


void Snumberp();  /* number.c */
void Scomplexp();
void Srealp();
void Srationalp();
void Sintegerp();
void Sexactp();
void Sinexactp();
void S_exactp();
void S_inexactp();
void Seqeq();
void Slessthan();
void Sgreaterthan();
void Slep();
void Sgep();
void Szerop();
void Spositivep();
void Snegativep();
void Soddp();
void Sevenp();
void Smax();
void Smin();
void Sadd();
void Smul();
void Ssub();
void Sdiv();
void Sabs();
void Squotient();
void Sremainder();
void Smodulo();
void Sgcd();
void Slcm();
void Sfloor();
void Sceiling();
void Struncate();
void Sround();
void Snumber_to_string();
void Sstring_to_number();

void Snumerator();
void Sdenominator();
/*
void Srationalize();
*/
void Sexp();
void Slog();
void Ssin();
void Scos();
void Stan();
void Sasin();
void Sacos();
void Satan();
void Ssqrt();
void Sexpt();
void Smake_rectangular();
void Smake_polar();
void Sreal_part();
void Simag_part();
void Smagnitude();
void Sangle();
void Sexact_to_inexact();
void Sinexact_to_exact();
void S_exact_to_inexact();
void S_inexact_to_exact();

void Sadd1();
void Sadd2();
void Ssub1();
void Ssub2();
void Smul2();
void Srational_to_real();
void Sfixnump();


void Scharp();  /* char.c */
void Schareq();
void Scharlt();
void Schargt();
void Scharlte();
void Schargte();
void Schar_cieq();
void Schar_cilt();
void Schar_cigt();
void Schar_cilte();
void Schar_cigte();
void Schar_alphabetic();
void Schar_numeric();
void Schar_whitespace();
void Schar_upper_case();
void Schar_lower_case();
void Schar_to_integer();
void Sinteger_to_char();
void Schar_upcase();
void Schar_downcase();

#ifdef NIHONGO
void Skanjip();
#endif

void Sstrp();  /* string.c */
void Smakestring();
void Sstring();
void Sstringlength();
void Sstringref();
void Sstring_set();
void Sstringequal();
void Sstringequalci();
void Sstringlessthan();
void Sstringlessthanci();
void Sstringgreaterthan();
void Sstringgreaterthanci();
void Sstringlessthanequal();
void Sstringlessthanequalci();
void Sstringgreaterthanequal();
void Sstringgreaterthanequalci();
void Sstringappend();
void Ssubstring();


void Svectorp();  /* vector.c */
void Smakevector();
void Svector();
void Svectorlength();
void Svectorref();
void Svectorset();
void Svectorlist();


void Sstructp();        /* structure.c */
void Sstruct_type();
void Sdefstruct_type();
void Sstructure();
void Sstructref();
void Sstructset();


void Sprocp();  /* control.c */
void Sapply();
void Sforeach();
void Smap();
void Smapcan();
void Ssome();
void Severy();
void Snotany();
void Snotevery();
void Scall_cc();

#ifdef CALLIOC
void Scall_ioc();
#endif

void Sforce();
void Scontinuationp();
void Spromisep();


void Scwif();  /* io.c */
void Scwof();
void Sin_portp();
void Sout_portp();
void Scurrent_in_port();
void Scurrent_out_port();
void Sconsole_in_port();
void Sconsole_out_port();
void Swifp();
void Swotp();
void Sopen_in_file();
void Sopen_out_file();
void Sclose_in_port();
void Sclose_out_port();
void Stranscript_on();
void Stranscript_off();

void Sopen_input_string();
void Sopen_output_string();
void Sget_output_string();
void Sreset_output_string();

void Sread();
void Sreadch();
void Sreadbyte();
void Speekch();
void Seofp();
void Sfirstcolumnp();

void Swrite();
#ifdef PVM3
void Swrite_pvm();        /* By A243 */
#endif
void Sdisplay();
void Snewline();
void Swritech();
void Swriterawch();

void Sportp();
void Sstring_portp();
void Sfile_existsp();
void Sfile_is_directoryp();
void Sfile_is_readablep();
void Sfile_is_writablep();
void Sfile_is_executablep();
void Sflush_port();
void Sshow_port_list();

#ifdef NIHONGO
void Skanji_input_code();
void Skanji_output_code();
void Schange_kanji_input_code();
void Schange_kanji_output_code();
#endif

void Smine();

void Sweakpairp();  /* weakpair.c */
void Sweakcons();
void Sweakpaircarp();
void Sweakcar();
void Sweakcdr();
void Sweaksetcar();
void Sweaksetcdr();
void Slostobjp();


void Slogand();  /* logical.c */
void Slogior();
void Slognot();
void Slogshl();
void Slogshr();
void Slogxor();


void Sbcload();   /* others */
void Sbcload_with_cip();
void Sgettime();
void Sget_time();
void Sget_date();
void Sgetenv();
void Ssetenv();
#ifdef TK
void Sexectcl();
void Stkgetchar();
# ifndef __CYGWIN32__
void Sdelete_filehandler();
void Screate_filehandler();
# endif
#endif
void Sgetwd();
void Schdir();
void Sgetpwnam();
void Sspawn();
void Ssystem();
void Srun_process();
void Sgetsval();
void Sbye();
void Sexit_tus();
void Smacrofun();
void Sfreeze();
void Sfunc_def();                /* dekisokonai */

void Sfunc_arg();    /*  By N.Watanabe  Nov. 05, 1992  */

void Sback_trace();   /*  err_handerl.c     By N.Watanabe  Nov. 12, 1992  */
void Sreturn_sctop();

#ifdef GC_TIME
void Sgc_usage();
#endif

#ifdef HAVE_LIBREADLINE
void Sreadline();
void Saddhistory();
#endif

#ifndef SAVE_MEM
void Ssave_image();              /* macsave.c */
#endif

void Sstack_dump();
void Sgc();
void Sgc2();
void Sgoto_mark_and_sweep();
void Sgoto_copygc();
void Scopygc_trace_on();
void Scopygc_trace_off();
void Ssweeper_trace_on();
void Ssweeper_trace_off();
void Sbci_trace_on();
void Sbci_trace_off();
void Scopygc_state();
void Smemget_trace_on();
void Smemget_trace_off();

void Sset_trace_function();
void Sdetouch_trace_function();
void Sget_proc_name();
void Scopy_procedure();

#ifndef THINK_C
void Schar_readyp ();
#endif

#ifdef TCPIP
void Sbind_udp_port ();
void Sbind_tcp_port ();
void Sopen_udp_port ();
void Sopen_tcp_port ();
void Saccept ();
void Sbound_udp_port_p ();
void Sbound_tcp_port_p ();
void Sudp_port_p ();
void Stcp_port_p ();
void Sacceptable_p ();
void Sclose_b_udp_port ();
void Sclose_b_tcp_port ();
void Sclose_udp_port ();
void Sclose_tcp_port ();
void Sport_number ();
void Shost_name ();
void Speer ();
#ifdef SUNOS4
void Shost_up_p ();
void Suptime ();
#endif
void Sserv_to_portnum ();
void Sget_host_list ();
void Sselect ();
void Sread_fix ();
void Swrite_fix ();
void Sread ();
void Sreadch ();
void Sreadbyte();
void Speekch ();
#endif

#ifdef UNIXFASL                      /* unixfasl.c */
void Sfasload();
#endif

#ifdef CTHREAD                  /* future.c */
# ifndef SHE
void Stouch_setq();
void Suntouch();
# endif
void Ssuspend();
void Squit();
void Smutexp();
void Smake_mutex();
void Smutex_lock();
void Smutex_unlock();
void Swait();
void Ssignal();
void Sfuturep();
void Sdeterminedp();
void Sthe_num_of_current_thread();
void Sthread_id();
void Stouch();
#endif

#ifdef CONDITIONAL_FUTURE
void Ssuicide();
void Scurrent_stat();
void Spromote();
void Scancel();
#endif

#ifdef SHE                      /* she.c */
void Sprint_stat();
void Skill();
void Spromote();
#endif

#ifdef PVM3           /* Nov.30.1993, A243 */
void Spvm_addhosts();         /* s_pvm3.c */
/* void Spvm_advise(); */
void Spvm_barrier();
void Spvm_bcast();
void Spvm_bufinfo();
void Spvm_catchout();
void Spvm_config();
void Spvm_delete();
void Spvm_delhosts();
void Spvm_exit();
void Spvm_freebuf();
void Spvm_getinst();
void Spvm_getopt();
void Spvm_getrbuf();
void Spvm_getsbuf();
void Spvm_gettid();
void Spvm_gsize();
void Spvm_halt();
void Spvm_hostsync();
void Spvm_initsend();
void Spvm_insert();
void Spvm_joingroup();
void Spvm_kill();
void Spvm_lookup();
void Spvm_lvgroup();
void Spvm_mcast();
void Spvm_mkbuf();
void Spvm_mstat();
void Spvm_mytid();
void Spvm_notify();
void Spvm_nrecv();
void Spvm_parent();
void Spvm_perror();
void Spvm_pkfloat();
void Spvm_pkfloat2();
void Spvm_pkfix();
void Spvm_pkfix2();
void Spvm_pkstr();
void Spvm_precv();
void Spvm_probe();
void Spvm_psend();
void Spvm_psend2();
void Spvm_pstat();
void Spvm_recv();
void Spvm_recvf();
void Spvm_reduce();
void Spvm_reg_hoster();
void Spvm_reg_tasker();
void Spvm_send();
void Spvm_sendsig();
/* void Spvm_serror(); */
void Spvm_setopt();
void Spvm_setrbuf();
void Spvm_setsbuf();
void Spvm_set_gstid();
void Spvm_spawn();
void Spvm_tasks();
void Spvm_tidtohost();
void Spvm_trecv();
void Spvm_upkfloat();
void Spvm_upkfix();
void Spvm_upkstr();
void Spvm_upkstr2();
void Spvm_version();
void Sxpvm_start();
#endif

/*****************************************************/
/*                                                   */
/*  Global declearation for hidden system functions  */
/*                                                   */
/*****************************************************/

void Sbctran();
void Sbctran_bcbody();
void Sbctran_define_form();
void Sbctran_exec_form();
void Ssymbol_globalization();
void Serror_break();

void Schange_bci();                      /* closure.c A243 */
void Scheck_mac();
void Scheck_sys();
void Scheck_fun();
void Sclear_source();
void Sget_closure_source();
void Sput_closure_source();
void Sget_closure_name();
void Sput_closure_name();
void Sget_closure_env();
void Sput_closure_env();
void Sget_closure_stad();
void Sput_closure_stad();
void Sget_closure_arginfo();
void Sput_closure_arginfo();

void exec_sysfun();   /* special byte code */
void xreturn();

/*  Written by Myama.  Oct. '90 */
void sfun_entry(fun_name, fun_addr, arginfo, kind)
char    *fun_name;
void (*fun_addr)();
int arginfo, kind;
{ 
    SOBJ str, sym, sfun;
    unsigned *bcbody;

    str.obj = mk_str(SYMBOL_STRING, A_STRING, strlen(fun_name), fun_name);
    s_push(str.obj);
    sym.obj = addsymbol(str.obj, kind);
    str.obj = s_pop();
    s_push(sym.obj);
    s_push(str.obj);
    bcbody = (unsigned *)Pgetblock2(8);
    *(bcbody + 1) = (unsigned)exec_sysfun;
    *(bcbody + 2) = (unsigned)fun_addr;
    str.obj = s_pop();
    sfun.obj = mk_bcc(LTAG_SFUNCTION, LTAG_NIL, str.obj, LTAG_NIL, LTAG_NIL, 
        LTAG_STRING | SSERDDA(bcbody), arginfo, 1);
    set_sval(s_pop(), sfun.obj);
}


sfuninit()
{
    sfun_entry("not", Snot, 8, LTAG_SPECIAL);  /* boolean.c */
    sfun_entry("boolean?", Sbooleanp, 8, LTAG_SPECIAL);


    sfun_entry("eq?", Seq, 12, LTAG_SPECIAL);  /* equivalence.c */
    sfun_entry("eqv?", Seqv, 12, LTAG_SPECIAL);
    sfun_entry("equal?", Sequal, 12, LTAG_SPECIAL);


    sfun_entry("pair?", Spairp, 8, LTAG_SPECIAL);  /* cons.c */
    sfun_entry("list?", Slistp, 8, LTAG_SPECIAL);
    sfun_entry("cons", Scons, 12, LTAG_SPECIAL);
    sfun_entry("car", Scar, 8, LTAG_SPECIAL);
    sfun_entry("cdr", Scdr, 8, LTAG_SPECIAL);
    sfun_entry("set-car!", Ssetcar, 12, LTAG_SPECIAL);
    sfun_entry("set-cdr!", Ssetcdr, 12, LTAG_SPECIAL);
    sfun_entry("caar", Scaar, 8, LTAG_SPECIAL);
    sfun_entry("cadr", Scadr, 8, LTAG_SPECIAL);
    sfun_entry("cdar", Scdar, 8, LTAG_SPECIAL);
    sfun_entry("cddr", Scddr, 8, LTAG_SPECIAL);
    sfun_entry("caaar", Scaaar, 8, LTAG_SPECIAL);
    sfun_entry("caadr", Scaadr, 8, LTAG_SPECIAL);
    sfun_entry("cadar", Scadar, 8, LTAG_SPECIAL);
    sfun_entry("caddr", Scaddr, 8, LTAG_SPECIAL);
    sfun_entry("cdaar", Scdaar, 8, LTAG_SPECIAL);
    sfun_entry("cdadr", Scdadr, 8, LTAG_SPECIAL);
    sfun_entry("cddar", Scddar, 8, LTAG_SPECIAL);
    sfun_entry("cdddr", Scdddr, 8, LTAG_SPECIAL);
    sfun_entry("caaaar", Scaaaar, 8, LTAG_SPECIAL);
    sfun_entry("caaadr", Scaaadr, 8, LTAG_SPECIAL);
    sfun_entry("caadar", Scaadar, 8, LTAG_SPECIAL);
    sfun_entry("caaddr", Scaaddr, 8, LTAG_SPECIAL);
    sfun_entry("cadaar", Scadaar, 8, LTAG_SPECIAL);
    sfun_entry("cadadr", Scadadr, 8, LTAG_SPECIAL);
    sfun_entry("caddar", Scaddar, 8, LTAG_SPECIAL);
    sfun_entry("cadddr", Scadddr, 8, LTAG_SPECIAL);
    sfun_entry("cdaaar", Scdaaar, 8, LTAG_SPECIAL);
    sfun_entry("cdaadr", Scdaadr, 8, LTAG_SPECIAL);
    sfun_entry("cdadar", Scdadar, 8, LTAG_SPECIAL);
    sfun_entry("cdaddr", Scdaddr, 8, LTAG_SPECIAL);
    sfun_entry("cddaar", Scddaar, 8, LTAG_SPECIAL);
    sfun_entry("cddadr", Scddadr, 8, LTAG_SPECIAL);
    sfun_entry("cdddar", Scdddar, 8, LTAG_SPECIAL);
    sfun_entry("cddddr", Scddddr, 8, LTAG_SPECIAL);
    sfun_entry("null?", Snullp, 8, LTAG_SPECIAL);
    sfun_entry("list", Slist, 7, LTAG_SPECIAL);
    sfun_entry("length", Slength, 8, LTAG_SPECIAL);
    sfun_entry("append", Sappend, 7, LTAG_SPECIAL);
    sfun_entry("reverse", Sreverse, 8, LTAG_SPECIAL);
    sfun_entry("memq", Smemq, 12, LTAG_SPECIAL);
    sfun_entry("memv", Smemv, 12, LTAG_SPECIAL);
    sfun_entry("member", Smember, 12, LTAG_SPECIAL);
    sfun_entry("assq", Sassq, 12, LTAG_SPECIAL);
    sfun_entry("assv", Sassv, 12, LTAG_SPECIAL);
    sfun_entry("assoc", Sassoc, 12, LTAG_SPECIAL);
    sfun_entry("find-if", Sfind_if, 12, LTAG_SPECIAL);

    sfun_entry("list*", Slista, 7, LTAG_SPECIAL);
    sfun_entry("list-tail", Slist_tail, 12, LTAG_SPECIAL);
    sfun_entry("list-ref", Slist_ref, 12, LTAG_SPECIAL);
    sfun_entry("nthcdr", Snthcdr, 12, LTAG_SPECIAL);
    sfun_entry("nth", Snth, 12, LTAG_SPECIAL);
    sfun_entry("last", Slast, 8, LTAG_SPECIAL);

    sfun_entry("atom?", Satomp, 8, LTAG_SPECIAL);

    sfun_entry("symbol?", Ssymbolp, 8, LTAG_SPECIAL);  /* symbol.c */
    sfun_entry("symbol->string", Ssymbolstring, 8, LTAG_SPECIAL);
    sfun_entry("string->symbol", Sstringsymbol, 8, LTAG_SPECIAL);
    sfun_entry("str->sym-nointern", Sstringsymbol_no_intern, 8, LTAG_SPECIAL);
    sfun_entry("getprop", Sgetprop, 12, LTAG_SPECIAL);
    sfun_entry("putprop", Sputprop, 16, LTAG_SPECIAL);
    sfun_entry("symbol-plist", Ssymbol_plist, 8, LTAG_SPECIAL);
    sfun_entry("bound?", Sboundp, 8, LTAG_SPECIAL);
    sfun_entry("unbound?", Sunboundp, 8, LTAG_SPECIAL);
    sfun_entry("sysfun?", Ssysfunp, 8, LTAG_SPECIAL);
    sfun_entry("symbol-sensitive", Ssymbol_sensitive, 8, LTAG_SPECIAL);

    sfun_entry("number?", Snumberp, 8, LTAG_SPECIAL);  /* number.c */
    sfun_entry("complex?", Scomplexp, 8, LTAG_SPECIAL);
    sfun_entry("real?", Srealp, 8, LTAG_SPECIAL);
    sfun_entry("rational?", Srationalp, 8, LTAG_SPECIAL);
    sfun_entry("integer?", Sintegerp, 8, LTAG_SPECIAL);
    sfun_entry("exact?", Sexactp, 8, LTAG_SPECIAL);
    sfun_entry("inexact?", Sinexactp, 8, LTAG_SPECIAL);
    sfun_entry("_exact?", S_exactp, 8, LTAG_SPECIAL);
    sfun_entry("_inexact?", S_inexactp, 8, LTAG_SPECIAL);
    sfun_entry("=", Seqeq, 15, LTAG_SPECIAL);
    sfun_entry("<", Slessthan, 15, LTAG_SPECIAL);
    sfun_entry(">", Sgreaterthan, 15, LTAG_SPECIAL);
    sfun_entry("<=", Slep, 15, LTAG_SPECIAL);
    sfun_entry(">=", Sgep, 15, LTAG_SPECIAL);
    sfun_entry("zero?", Szerop, 8, LTAG_SPECIAL);
    sfun_entry("positive?", Spositivep, 8, LTAG_SPECIAL);
    sfun_entry("negative?", Snegativep, 8, LTAG_SPECIAL);
    sfun_entry("odd?", Soddp, 8, LTAG_SPECIAL);
    sfun_entry("even?", Sevenp, 8, LTAG_SPECIAL);
    sfun_entry("max", Smax, 11, LTAG_SPECIAL);
    sfun_entry("min", Smin, 11, LTAG_SPECIAL);
    sfun_entry("+", Sadd, 7, LTAG_SPECIAL);
    sfun_entry("*", Smul, 7, LTAG_SPECIAL);
    sfun_entry("-", Ssub, 11, LTAG_SPECIAL);
    sfun_entry("/", Sdiv, 11, LTAG_SPECIAL);
    sfun_entry("abs", Sabs, 8, LTAG_SPECIAL);
    sfun_entry("quotient", Squotient, 12, LTAG_SPECIAL);
    sfun_entry("remainder", Sremainder, 12, LTAG_SPECIAL);
    sfun_entry("modulo", Smodulo, 12, LTAG_SPECIAL);
    sfun_entry("gcd", Sgcd, 7, LTAG_SPECIAL);
    sfun_entry("lcm", Slcm, 7, LTAG_SPECIAL);
    sfun_entry("floor", Sfloor, 8, LTAG_SPECIAL);
    sfun_entry("ceiling", Sceiling, 8, LTAG_SPECIAL);
    sfun_entry("truncate", Struncate, 8, LTAG_SPECIAL);
    sfun_entry("round", Sround, 8, LTAG_SPECIAL);
    sfun_entry("number->string", Snumber_to_string, 11, LTAG_SPECIAL);
    sfun_entry("string->number", Sstring_to_number, 11, LTAG_SPECIAL);

    sfun_entry("numerator", Snumerator, 8, LTAG_SPECIAL);
    sfun_entry("denominator", Sdenominator, 8, LTAG_SPECIAL);
    /*
  sfun_entry("rationalize", Srationalize, 12, LTAG_SPECIAL);
*/
    sfun_entry("exp", Sexp, 8, LTAG_SPECIAL);
    sfun_entry("log", Slog, 8, LTAG_SPECIAL);
    sfun_entry("sin", Ssin, 8, LTAG_SPECIAL);
    sfun_entry("cos", Scos, 8, LTAG_SPECIAL);
    sfun_entry("tan", Stan, 11, LTAG_SPECIAL);
    sfun_entry("asin", Sasin, 8, LTAG_SPECIAL);
    sfun_entry("acos", Sacos, 8, LTAG_SPECIAL);
    sfun_entry("atan", Satan, 11, LTAG_SPECIAL);
    sfun_entry("sqrt", Ssqrt, 8, LTAG_SPECIAL);
    sfun_entry("_expt", Sexpt, 12, LTAG_SPECIAL);
    sfun_entry("make-rectangular", Smake_rectangular, 12, LTAG_SPECIAL);
    sfun_entry("make-polar", Smake_polar, 12, LTAG_SPECIAL);
    sfun_entry("real-part", Sreal_part, 8, LTAG_SPECIAL);
    sfun_entry("imag-part", Simag_part, 8, LTAG_SPECIAL);
    sfun_entry("magnitude", Smagnitude, 8, LTAG_SPECIAL);
    sfun_entry("angle", Sangle, 8, LTAG_SPECIAL);
    sfun_entry("exact->inexact", Sexact_to_inexact, 8, LTAG_SPECIAL);
    sfun_entry("inexact->exact", Sinexact_to_exact, 8, LTAG_SPECIAL);
    sfun_entry("_exact->inexact", S_exact_to_inexact, 8, LTAG_SPECIAL);
    sfun_entry("_inexact->exact", S_inexact_to_exact, 8, LTAG_SPECIAL);

    sfun_entry("1+", Sadd1, 8, LTAG_SPECIAL);
    sfun_entry("2+", Sadd2, 8, LTAG_SPECIAL);
    sfun_entry("1-", Ssub1, 8, LTAG_SPECIAL);
    sfun_entry("2-", Ssub2, 8, LTAG_SPECIAL);
    sfun_entry("2*", Smul2, 8, LTAG_SPECIAL);
    sfun_entry("rational->real", Srational_to_real, 8, LTAG_SPECIAL);
    sfun_entry("fixnum?", Sfixnump, 8, LTAG_SPECIAL);


    sfun_entry("char?", Scharp, 8, LTAG_SPECIAL);  /* char.c */
    sfun_entry("char=?", Schareq, 12, LTAG_SPECIAL);
    sfun_entry("char<?", Scharlt, 12, LTAG_SPECIAL);
    sfun_entry("char>?", Schargt, 12, LTAG_SPECIAL);
    sfun_entry("char<=?", Scharlte, 12, LTAG_SPECIAL);
    sfun_entry("char>=?", Schargte, 12, LTAG_SPECIAL);
    sfun_entry("char-ci=?", Schar_cieq, 12, LTAG_SPECIAL);
    sfun_entry("char-ci<?", Schar_cilt, 12, LTAG_SPECIAL);
    sfun_entry("char-ci>?", Schar_cigt, 12, LTAG_SPECIAL);
    sfun_entry("char-ci<=?", Schar_cilte, 12, LTAG_SPECIAL);
    sfun_entry("char-ci>=?", Schar_cigte, 12, LTAG_SPECIAL);
    sfun_entry("char-alphabetic?", Schar_alphabetic, 8, LTAG_SPECIAL);
    sfun_entry("char-numeric?", Schar_numeric, 8, LTAG_SPECIAL);
    sfun_entry("char-whitespace?", Schar_whitespace, 8, LTAG_SPECIAL);
    sfun_entry("char-upper-case?", Schar_upper_case, 8, LTAG_SPECIAL);
    sfun_entry("char-lower-case?", Schar_lower_case, 8, LTAG_SPECIAL);
    sfun_entry("char->integer", Schar_to_integer, 8, LTAG_SPECIAL);
    sfun_entry("integer->char", Sinteger_to_char, 8, LTAG_SPECIAL);
    sfun_entry("char-upcase", Schar_upcase, 8, LTAG_SPECIAL);
    sfun_entry("char-downcase", Schar_downcase, 8, LTAG_SPECIAL);

#ifdef NIHONGO
    sfun_entry("kanji?", Skanjip, 8, LTAG_SPECIAL);
#endif


    sfun_entry("string?", Sstrp, 8, LTAG_SPECIAL);  /* string.c */
    sfun_entry("make-string", Smakestring, 11, LTAG_SPECIAL);
    sfun_entry("string", Sstring, 7, LTAG_SPECIAL);
    sfun_entry("string-length", Sstringlength, 8, LTAG_SPECIAL);
    sfun_entry("string-ref", Sstringref, 12, LTAG_SPECIAL);
    sfun_entry("string-set!", Sstring_set, 16, LTAG_SPECIAL);
    sfun_entry("string=?", Sstringequal, 12, LTAG_SPECIAL);
    sfun_entry("string-ci=?", Sstringequalci, 12, LTAG_SPECIAL);
    sfun_entry("string<?", Sstringlessthan, 12, LTAG_SPECIAL);
    sfun_entry("string-ci<?", Sstringlessthanci, 12, LTAG_SPECIAL);
    sfun_entry("string>?", Sstringgreaterthan, 12, LTAG_SPECIAL);
    sfun_entry("string-ci>?", Sstringgreaterthanci, 12, LTAG_SPECIAL);
    sfun_entry("string<=?", Sstringlessthanequal, 12, LTAG_SPECIAL);
    sfun_entry("string-ci<=?", Sstringlessthanequalci, 12, LTAG_SPECIAL);
    sfun_entry("string>=?", Sstringgreaterthanequal, 12, LTAG_SPECIAL);
    sfun_entry("string-ci>=?", Sstringgreaterthanequalci, 12, LTAG_SPECIAL);
    sfun_entry("string-append", Sstringappend, 7, LTAG_SPECIAL);
    sfun_entry("substring", Ssubstring, 16, LTAG_SPECIAL);


    sfun_entry("vector?", Svectorp, 8, LTAG_SPECIAL);  /* vector.c */
    sfun_entry("make-vector", Smakevector, 11, LTAG_SPECIAL);
    sfun_entry("vector", Svector, 7, LTAG_SPECIAL);
    sfun_entry("vector-length", Svectorlength, 8, LTAG_SPECIAL);
    sfun_entry("vector-ref", Svectorref, 15, LTAG_SPECIAL);
    sfun_entry("vector-set!", Svectorset, 19, LTAG_SPECIAL);
    sfun_entry("vector->list", Svectorlist, 8, LTAG_SPECIAL);


    sfun_entry("structure?", Sstructp, 8, LTAG_SPECIAL);  /* structure.c */
    sfun_entry("structure-type", Sstruct_type, 8, LTAG_SPECIAL);
    sfun_entry("defstruct-type", Sdefstruct_type, 12, LTAG_SPECIAL);
    sfun_entry("structure", Sstructure, 11, LTAG_SPECIAL);
    sfun_entry("structure-ref", Sstructref, 16, LTAG_SPECIAL);
    sfun_entry("structure-set!", Sstructset, 20, LTAG_SPECIAL);


    sfun_entry("procedure?", Sprocp, 8, LTAG_SPECIAL);  /* control.c */
    sfun_entry("function?", Sprocp, 8, LTAG_SPECIAL);
    sfun_entry("apply", Sapply, 15, LTAG_SPECIAL);
    sfun_entry("for-each", Sforeach, 15, LTAG_SPECIAL);
    sfun_entry("map", Smap, 15, LTAG_SPECIAL);
    sfun_entry("mapcan", Smapcan, 15, LTAG_SPECIAL);
    sfun_entry("some?", Ssome, 15, LTAG_SPECIAL);
    sfun_entry("every?", Severy, 15, LTAG_SPECIAL);
    sfun_entry("notany?", Snotany, 15, LTAG_SPECIAL);
    sfun_entry("notevery?", Snotevery, 15, LTAG_SPECIAL);
    sfun_entry("call-with-current-continuation", Scall_cc, 8, LTAG_SPECIAL);
    sfun_entry("call/cc", Scall_cc, 8, LTAG_SPECIAL);
#ifdef CALLIOC
    sfun_entry("call-with-indefinite-one-time-continuation", Scall_ioc, 8, LTAG_SPECIAL);
    sfun_entry("call/ioc", Scall_ioc, 8, LTAG_SPECIAL);
#endif

    sfun_entry("force", Sforce, 8, LTAG_SPECIAL);
    sfun_entry("continuation?", Scontinuationp, 8, LTAG_SPECIAL);
    sfun_entry("promise?", Spromisep, 8, LTAG_SPECIAL);


    sfun_entry("_call-with-input-file", Scwif, 12, LTAG_ORDINARY);  /* io.c */
    sfun_entry("_call-with-output-file", Scwof, 12, LTAG_ORDINARY);
    sfun_entry("input-port?", Sin_portp, 8, LTAG_SPECIAL);
    sfun_entry("output-port?", Sout_portp, 8, LTAG_SPECIAL);
    sfun_entry("current-input-port", Scurrent_in_port, 4, LTAG_SPECIAL);
    sfun_entry("current-output-port", Scurrent_out_port, 4, LTAG_SPECIAL);
    sfun_entry("console-input-port", Sconsole_in_port, 4, LTAG_SPECIAL);
    sfun_entry("console-output-port", Sconsole_out_port, 4, LTAG_SPECIAL);
    sfun_entry("with-input-from-port", Swifp, 12, LTAG_SPECIAL);
    sfun_entry("with-output-to-port", Swotp, 12, LTAG_SPECIAL);
    sfun_entry("_open-input-file", Sopen_in_file, 8, LTAG_ORDINARY);
    sfun_entry("_open-output-file", Sopen_out_file, 8, LTAG_ORDINARY);
    sfun_entry("close-input-port", Sclose_in_port, 8, LTAG_SPECIAL);
    sfun_entry("close-output-port", Sclose_out_port, 8, LTAG_SPECIAL);
    sfun_entry("_transcript-on", Stranscript_on, 8, LTAG_ORDINARY);
    sfun_entry("_transcript-off", Stranscript_off, 4, LTAG_ORDINARY);

    sfun_entry("open-input-string", Sopen_input_string, 8, LTAG_SPECIAL);
    sfun_entry("open-output-string", Sopen_output_string, 7, LTAG_SPECIAL);
    sfun_entry("get-output-string", Sget_output_string, 8, LTAG_SPECIAL);
    sfun_entry("reset-output-string", Sreset_output_string, 8, LTAG_SPECIAL);

    sfun_entry("read", Sread, 7, LTAG_SPECIAL);
    sfun_entry("read-char", Sreadch, 7, LTAG_SPECIAL);
    sfun_entry("read-byte", Sreadbyte, 7, LTAG_SPECIAL);
    sfun_entry("peek-char", Speekch, 7, LTAG_SPECIAL);
    sfun_entry("eof-object?", Seofp, 8, LTAG_SPECIAL);
    sfun_entry("first-column?", Sfirstcolumnp, 8, LTAG_SPECIAL);

    sfun_entry("write", Swrite, 11, LTAG_SPECIAL);
#ifdef PVM3
    sfun_entry("write-pvm", Swrite_pvm, 11, LTAG_SPECIAL); /* By A243 */
#endif
    sfun_entry("display", Sdisplay, 11, LTAG_SPECIAL);
    sfun_entry("newline", Snewline, 7, LTAG_SPECIAL);
    sfun_entry("write-char", Swritech, 11, LTAG_SPECIAL);
    sfun_entry("write-raw-char", Swriterawch, 11, LTAG_SPECIAL);

    sfun_entry("port?", Sportp, 8, LTAG_SPECIAL);
    sfun_entry("string-port?", Sstring_portp, 8, LTAG_SPECIAL);
    sfun_entry("_file-exists?", Sfile_existsp, 8, LTAG_ORDINARY);
    sfun_entry("_file-is-directory?", Sfile_is_directoryp, 8, LTAG_ORDINARY);
    sfun_entry("_file-is-readable?", Sfile_is_readablep, 8, LTAG_ORDINARY);
    sfun_entry("_file-is-writable?", Sfile_is_writablep, 8, LTAG_ORDINARY);
    sfun_entry("_file-is-executable?", Sfile_is_executablep, 8, LTAG_ORDINARY);
    sfun_entry("flush-port", Sflush_port, 8, LTAG_SPECIAL);
    sfun_entry("show-port-list", Sshow_port_list, 4, LTAG_SPECIAL);

#ifdef NIHONGO
    sfun_entry("kanji-input-code", Skanji_input_code, 7, LTAG_SPECIAL);
    sfun_entry("kanji-output-code", Skanji_output_code, 7, LTAG_SPECIAL);
    sfun_entry("change-kanji-input-code", Schange_kanji_input_code, 11, LTAG_SPECIAL);
    sfun_entry("change-kanji-output-code", Schange_kanji_output_code, 11, LTAG_SPECIAL);
#endif

    sfun_entry("mine", Smine, 7, LTAG_SPECIAL);

    sfun_entry("weak-pair?", Sweakpairp, 8, LTAG_SPECIAL);  /* weakpair.c */
    sfun_entry("lost-object?", Slostobjp, 8, LTAG_SPECIAL);
    sfun_entry("weak-cons", Sweakcons, 12, LTAG_SPECIAL);
    sfun_entry("weak-pair/car?", Sweakpaircarp, 8, LTAG_SPECIAL);
    sfun_entry("weak-car", Sweakcar, 8, LTAG_SPECIAL);
    sfun_entry("weak-cdr", Sweakcdr, 8, LTAG_SPECIAL);
    sfun_entry("set-weak-car!", Sweaksetcar, 12, LTAG_SPECIAL);
    sfun_entry("set-weak-cdr!", Sweaksetcdr, 12, LTAG_SPECIAL);


    sfun_entry("logand", Slogand, 7, LTAG_SPECIAL);  /* logical.c */
    sfun_entry("logior", Slogior, 7, LTAG_SPECIAL);
    sfun_entry("lognot", Slognot, 8, LTAG_SPECIAL);
    sfun_entry("logshl", Slogshl, 12, LTAG_SPECIAL);
    sfun_entry("logshr", Slogshr, 12, LTAG_SPECIAL);
    sfun_entry("logxor", Slogxor, 7, LTAG_SPECIAL);


    sfun_entry("bcload", Sbcload, 8, LTAG_SPECIAL);  /* others */
    sfun_entry("bcload/current-input-port", Sbcload_with_cip, 8, LTAG_SPECIAL);
    sfun_entry("ptime", Sgettime, 4, LTAG_SPECIAL);
    sfun_entry("get-time", Sget_time, 4, LTAG_SPECIAL);
    sfun_entry("get-date", Sget_date, 4, LTAG_SPECIAL);
    sfun_entry("getenv", Sgetenv, 8, LTAG_SPECIAL);
    sfun_entry("setenv", Ssetenv, 8, LTAG_SPECIAL);
#ifdef TK
    sfun_entry("exectcl", Sexectcl, 8, LTAG_SPECIAL);
    sfun_entry("tk-getchar", Stkgetchar, 4, LTAG_SPECIAL);
# ifndef __CYGWIN32__
    sfun_entry("tcl-deletefilehandler", Sdelete_filehandler, 8, LTAG_SPECIAL);
    sfun_entry("tcl-createfilehandler", Screate_filehandler, 16, LTAG_SPECIAL);
# endif
#endif
    sfun_entry("getwd", Sgetwd, 4, LTAG_SPECIAL);
    sfun_entry("chdir", Schdir, 8, LTAG_SPECIAL);
    sfun_entry("getpwnam", Sgetpwnam, 8, LTAG_SPECIAL);
    sfun_entry("spawn", Sspawn, 12, LTAG_SPECIAL);
    sfun_entry("_run-process", Srun_process, 28, LTAG_SPECIAL);
    sfun_entry("system", Ssystem, 8, LTAG_SPECIAL);
    sfun_entry("get-symbol-value", Sgetsval, 8, LTAG_SPECIAL);
    sfun_entry("bye", Sbye, 4, LTAG_SPECIAL);
    sfun_entry("by", Sbye, 4, LTAG_SPECIAL);
    sfun_entry("exit-tus", Sexit_tus, 4, LTAG_SPECIAL);
    sfun_entry("macro-function", Smacrofun, 8, LTAG_SPECIAL);
    sfun_entry("function-definition", Sfunc_def, 8, LTAG_SPECIAL); /* dekisokonai */
    sfun_entry("function-arginfo", Sfunc_arg, 8, LTAG_SPECIAL); /* By N.Watanabe */
    sfun_entry("back-trace", Sback_trace, 4, LTAG_SPECIAL);     /* By N.Watanabe */
    sfun_entry("return-sctop", Sreturn_sctop, 4, LTAG_SPECIAL);     /* By N.Watanabe */

#ifdef GC_TIME
    sfun_entry("gc-usage", Sgc_usage, 4, LTAG_SPECIAL);
#endif

#ifdef HAVE_LIBREADLINE
    sfun_entry("readline", Sreadline, 8, LTAG_SPECIAL);
    sfun_entry("add-history", Saddhistory, 8, LTAG_SPECIAL);
#endif

#ifndef SAVE_MEM
    sfun_entry("save-image", Ssave_image, 4, LTAG_SPECIAL);
#endif

    sfun_entry("stack-dump", Sstack_dump, 8, LTAG_SPECIAL);
    sfun_entry("gc", Sgc, 4, LTAG_SPECIAL);
    sfun_entry("gc2", Sgc2, 4, LTAG_SPECIAL);
    sfun_entry("goto-msgc", Sgoto_mark_and_sweep, 4, LTAG_SPECIAL);
    sfun_entry("goto-copygc", Sgoto_copygc, 4, LTAG_SPECIAL);
    sfun_entry("gc-trace-on", Scopygc_trace_on, 4, LTAG_SPECIAL);
    sfun_entry("gc-trace-off", Scopygc_trace_off, 4, LTAG_SPECIAL);
    sfun_entry("sweeper-trace-on", Ssweeper_trace_on, 4, LTAG_SPECIAL);
    sfun_entry("sweeper-trace-off", Ssweeper_trace_off, 4, LTAG_SPECIAL);
    sfun_entry("bci-trace-on", Sbci_trace_on, 4, LTAG_SPECIAL);
    sfun_entry("bci-trace-off", Sbci_trace_off, 4, LTAG_SPECIAL);
    sfun_entry("copygc-state", Scopygc_state, 4, LTAG_SPECIAL);
    sfun_entry("memget-trace-on", Smemget_trace_on, 4, LTAG_SPECIAL);
    sfun_entry("memget-trace-off", Smemget_trace_off, 4, LTAG_SPECIAL);
    sfun_entry("set-trace-function", Sset_trace_function, 16, LTAG_SPECIAL);
    sfun_entry("detouch-trace-function", Sdetouch_trace_function, 8, LTAG_SPECIAL);
    sfun_entry("get-procedure-name", Sget_proc_name, 8, LTAG_SPECIAL);
    sfun_entry("copy-function", Scopy_procedure, 8, LTAG_SPECIAL);

#ifndef THINK_C
#ifndef __CYGWIN32__
    sfun_entry ("char-ready?",  Schar_readyp,   7, LTAG_SPECIAL);
#endif
#endif

#ifdef TCPIP
    sfun_entry ("bind-udp-port",        Sbind_udp_port,    8, LTAG_SPECIAL);
    sfun_entry ("bind-tcp-port",        Sbind_tcp_port,    8, LTAG_SPECIAL);
    sfun_entry ("open-udp-port",        Sopen_udp_port,   11, LTAG_SPECIAL);
    sfun_entry ("open-tcp-port",        Sopen_tcp_port,   11, LTAG_SPECIAL);
    sfun_entry ("accept",               Saccept,           8, LTAG_SPECIAL);
    sfun_entry ("bound-udp-port?",      Sbound_udp_port_p, 8, LTAG_SPECIAL);
    sfun_entry ("bound-tcp-port?",      Sbound_tcp_port_p, 8, LTAG_SPECIAL);
    sfun_entry ("udp-port?",            Sudp_port_p,       8, LTAG_SPECIAL);
    sfun_entry ("tcp-port?",            Stcp_port_p,       8, LTAG_SPECIAL);
    sfun_entry ("acceptable?",          Sacceptable_p,     8, LTAG_SPECIAL);
    sfun_entry ("close-bound-udp-port", Sclose_b_udp_port, 8, LTAG_SPECIAL);
    sfun_entry ("close-bound-tcp-port", Sclose_b_tcp_port, 8, LTAG_SPECIAL);
    sfun_entry ("close-udp-port",       Sclose_udp_port,   8, LTAG_SPECIAL);
    sfun_entry ("close-tcp-port",       Sclose_tcp_port,   8, LTAG_SPECIAL);
    sfun_entry ("port-number",          Sport_number,      8, LTAG_SPECIAL);
    sfun_entry ("host-name",            Shost_name,        8, LTAG_SPECIAL);
    sfun_entry ("peer",                 Speer,             8, LTAG_SPECIAL);
#ifdef SUNOS4
    sfun_entry ("host-up?",             Shost_up_p,        8, LTAG_SPECIAL);
    sfun_entry ("uptime",               Suptime,           7, LTAG_SPECIAL);
#endif
    sfun_entry ("service->port-number", Sserv_to_portnum, 12, LTAG_SPECIAL);
    sfun_entry ("get-host-list",        Sget_host_list,    4, LTAG_SPECIAL);
    sfun_entry ("select",               Sselect,           7, LTAG_SPECIAL);
    sfun_entry ("read-fixnum",          Sread_fix,         7, LTAG_SPECIAL);
    sfun_entry ("write-fixnum",         Swrite_fix,       11, LTAG_SPECIAL);
#endif

#ifdef SAVE_MEM
    sfun_entry ("freeze",               Sfreeze,           7, LTAG_SPECIAL);
#endif

#ifdef UNIXFASL
    sfun_entry ("fasload",              Sfasload,          8, LTAG_SPECIAL);
#endif

#ifdef CTHREAD
# ifndef SHE
    sfun_entry ("_touch-set!_",         Stouch_setq,      12, LTAG_SPECIAL);
    sfun_entry ("untouch",              Suntouch,          8, LTAG_SPECIAL);
# endif
    sfun_entry ("suspend",              Ssuspend,          4, LTAG_SPECIAL);
    sfun_entry ("quit",                 Squit,             4, LTAG_SPECIAL);
    sfun_entry ("mutex?",               Smutexp,           8, LTAG_SPECIAL);
    sfun_entry ("make-mutex",           Smake_mutex,       4, LTAG_SPECIAL);
    sfun_entry ("mutex-lock",           Smutex_lock,       8, LTAG_SPECIAL);
    sfun_entry ("mutex-unlock",         Smutex_unlock,     8, LTAG_SPECIAL);
    sfun_entry ("condition-wait",       Swait,             8, LTAG_SPECIAL);
    sfun_entry ("condition-signal",     Ssignal,          12, LTAG_SPECIAL);
    sfun_entry ("future?",              Sfuturep,          8, LTAG_SPECIAL);
    sfun_entry ("determined?",          Sdeterminedp,      8, LTAG_SPECIAL);
    sfun_entry ("the-number-of-current-thread", Sthe_num_of_current_thread, 4, LTAG_SPECIAL);
    sfun_entry ("thread-id",            Sthread_id,        4, LTAG_SPECIAL);
    sfun_entry ("touch",                Stouch,            8, LTAG_SPECIAL);
#endif

#ifdef CONDITIONAL_FUTURE
    sfun_entry ("suicide",              Ssuicide,          8, LTAG_SPECIAL);
    sfun_entry ("current-stat",         Scurrent_stat,     4, LTAG_SPECIAL);
    sfun_entry ("promote",              Spromote,          8, LTAG_SPECIAL);
    sfun_entry ("cancel",               Scancel ,          8, LTAG_SPECIAL);
#endif

#ifdef SHE
    sfun_entry ("print-stat",           Sprint_stat ,     12, LTAG_SPECIAL);
    sfun_entry ("kill",                 Skill,            11, LTAG_SPECIAL);
    sfun_entry ("promote",              Spromote,          7, LTAG_SPECIAL);
#endif

#ifdef PVM3           /* Nov.30.1993, A243 */
    sfun_entry("p-addhosts", Spvm_addhosts, 16, LTAG_SPECIAL);
/*    sfun_entry("p-advise", Spvm_advise, 8, LTAG_SPECIAL); */
    sfun_entry("p-barrier", Spvm_barrier, 12, LTAG_SPECIAL);
    sfun_entry("p-bcast", Spvm_bcast, 12, LTAG_SPECIAL);
    sfun_entry("p-bufinfo", Spvm_bufinfo, 20, LTAG_SPECIAL);
    sfun_entry("p-catchout", Spvm_catchout, 8, LTAG_SPECIAL);
    sfun_entry("p-config", Spvm_config, 16, LTAG_SPECIAL);
    sfun_entry("p-delete", Spvm_delete, 12, LTAG_SPECIAL);
    sfun_entry("p-delhosts", Spvm_delhosts, 16, LTAG_SPECIAL);
    sfun_entry("p-exit", Spvm_exit, 4, LTAG_SPECIAL);
    sfun_entry("p-freebuf", Spvm_freebuf, 8, LTAG_SPECIAL);
    sfun_entry("p-getinst", Spvm_getinst, 12, LTAG_SPECIAL);
    sfun_entry("pvm-getinst2", Spvm_getinst, 12, LTAG_SPECIAL);
    sfun_entry("p-getopt", Spvm_getopt, 8, LTAG_SPECIAL);
    sfun_entry("p-getrbuf", Spvm_getrbuf, 4, LTAG_SPECIAL);
    sfun_entry("p-getsbuf", Spvm_getsbuf, 4, LTAG_SPECIAL);
    sfun_entry("p-gettid", Spvm_gettid, 12, LTAG_SPECIAL);
    sfun_entry("p-gsize", Spvm_gsize, 8, LTAG_SPECIAL);
    sfun_entry("p-halt", Spvm_halt, 4, LTAG_SPECIAL);
    sfun_entry("p-hostsync", Spvm_hostsync, 16, LTAG_SPECIAL);
    sfun_entry("p-initsend", Spvm_initsend, 8, LTAG_SPECIAL);
    sfun_entry("p-insert", Spvm_insert, 16, LTAG_SPECIAL);
    sfun_entry("p-joingroup", Spvm_joingroup, 8, LTAG_SPECIAL);
    sfun_entry("pvm-joingroup2", Spvm_joingroup, 8, LTAG_SPECIAL);
    sfun_entry("p-kill", Spvm_kill, 8, LTAG_SPECIAL);
    sfun_entry("p-lookup", Spvm_lookup, 16, LTAG_SPECIAL);
    sfun_entry("p-lvgroup", Spvm_lvgroup, 8, LTAG_SPECIAL);
    sfun_entry("pvm-lvgroup2", Spvm_lvgroup, 8, LTAG_SPECIAL);
    sfun_entry("p-mcast", Spvm_mcast, 16, LTAG_SPECIAL);
    sfun_entry("p-mkbuf", Spvm_mkbuf, 8, LTAG_SPECIAL);
    sfun_entry("p-mstat", Spvm_mstat, 8, LTAG_SPECIAL);
    sfun_entry("p-mytid", Spvm_mytid, 4, LTAG_SPECIAL);
    sfun_entry("p-notify", Spvm_notify, 20, LTAG_SPECIAL);
    sfun_entry("p-nrecv", Spvm_nrecv, 12, LTAG_SPECIAL);
    sfun_entry("p-parent", Spvm_parent, 4, LTAG_SPECIAL);
    sfun_entry("p-perror", Spvm_perror, 8, LTAG_SPECIAL);
    sfun_entry("p-pkfloat", Spvm_pkfloat, 16, LTAG_SPECIAL);
    sfun_entry("p-pkfloat2", Spvm_pkfloat2, 20, LTAG_SPECIAL);
    sfun_entry("p-pkfix", Spvm_pkfix, 16, LTAG_SPECIAL);
    sfun_entry("p-pkfix2", Spvm_pkfix2, 20, LTAG_SPECIAL);
    sfun_entry("p-pkstr", Spvm_pkstr, 8, LTAG_SPECIAL);
    sfun_entry("p-precv", Spvm_precv, 36, LTAG_SPECIAL);
    sfun_entry("p-probe", Spvm_probe, 12, LTAG_SPECIAL);
    sfun_entry("p-psend", Spvm_psend, 24, LTAG_SPECIAL);
    sfun_entry("p-psend2", Spvm_psend2, 28, LTAG_SPECIAL);
    sfun_entry("p-pstat", Spvm_pstat, 8, LTAG_SPECIAL);
    sfun_entry("p-recv", Spvm_recv, 12, LTAG_SPECIAL);
    sfun_entry("p-recvf", Spvm_recvf, 8, LTAG_SPECIAL);
    sfun_entry("p-reduce", Spvm_reduce, 32, LTAG_SPECIAL);
    sfun_entry("p-reg-hoster", Spvm_reg_hoster, 4, LTAG_SPECIAL);
    sfun_entry("p-reg-tasker", Spvm_reg_tasker, 4, LTAG_SPECIAL);
    sfun_entry("p-send", Spvm_send, 12, LTAG_SPECIAL);
    sfun_entry("p-sendsig", Spvm_sendsig, 12, LTAG_SPECIAL);
/*    sfun_entry("p-serror", Spvm_serror, 8, LTAG_SPECIAL);  */
    sfun_entry("p-setopt", Spvm_setopt, 12, LTAG_SPECIAL);
    sfun_entry("p-setrbuf", Spvm_setrbuf, 8, LTAG_SPECIAL);
    sfun_entry("p-setsbuf", Spvm_setsbuf, 8, LTAG_SPECIAL);
    sfun_entry("pvm-set-gstid", Spvm_set_gstid, 8, LTAG_SPECIAL);
    sfun_entry("p-spawn", Spvm_spawn, 28, LTAG_SPECIAL);
    sfun_entry("p-tasks", Spvm_tasks, 16, LTAG_SPECIAL);
    sfun_entry("p-tidtohost", Spvm_tidtohost, 8, LTAG_SPECIAL);
    sfun_entry("p-trecv", Spvm_trecv, 16, LTAG_SPECIAL);
    sfun_entry("p-upkfloat", Spvm_upkfloat, 16, LTAG_SPECIAL);
    sfun_entry("p-upkfix", Spvm_upkfix, 16, LTAG_SPECIAL);
    sfun_entry("p-upkstr", Spvm_upkstr, 8, LTAG_SPECIAL);
    sfun_entry("p-upkstr2", Spvm_upkstr2, 4, LTAG_SPECIAL);
    sfun_entry("pvm-version", Spvm_version, 4, LTAG_SPECIAL);
    sfun_entry("xpvm-start", Sxpvm_start, 4, LTAG_SPECIAL);
#endif
}


sfuninit2()  /*  Yass. Sep. 7 '90  */
{
    sfun_entry("bctran", Sbctran, 15, LTAG_SPECIAL);
    sfun_entry("bctran-bcbody", Sbctran_bcbody, 20, LTAG_SPECIAL);
    sfun_entry("bctran-define-form", Sbctran_define_form, 8, LTAG_SPECIAL);
    sfun_entry("bctran-exec-form", Sbctran_exec_form, 12, LTAG_SPECIAL);
                                                 /* By A243  Nov, 1992 */
    sfun_entry("symbol-globalization", Ssymbol_globalization, 8, LTAG_SPECIAL);
    sfun_entry("error-break", Serror_break, 4, LTAG_SPECIAL);
           
/* closure.c A243 */
    sfun_entry("change-bci", Schange_bci, 12, LTAG_SPECIAL);
    sfun_entry("check-mac", Scheck_mac, 8, LTAG_SPECIAL);
    sfun_entry("check-sys", Scheck_sys, 8, LTAG_SPECIAL);
    sfun_entry("check-fun", Scheck_fun, 8, LTAG_SPECIAL);
    sfun_entry("clear-source", Sclear_source, 8, LTAG_SPECIAL);
    sfun_entry("get-source", Sget_closure_source, 8, LTAG_SPECIAL); 
    sfun_entry("put-source", Sput_closure_source, 12, LTAG_SPECIAL);
    sfun_entry("get-fun-name", Sget_closure_name, 8, LTAG_SPECIAL);
    sfun_entry("put-fun-name", Sput_closure_name, 12, LTAG_SPECIAL);
    sfun_entry("get-closure-env", Sget_closure_env, 8, LTAG_SPECIAL);
    sfun_entry("put-closure-env", Sput_closure_env, 12, LTAG_SPECIAL);
    sfun_entry("get-closure-stad", Sget_closure_stad, 8, LTAG_SPECIAL);
    sfun_entry("put-closure-stad", Sput_closure_stad, 12, LTAG_SPECIAL);
    sfun_entry("get-closure-arginfo", Sget_closure_arginfo, 8, LTAG_SPECIAL);
    sfun_entry("put-closure-arginfo", Sput_closure_arginfo, 12, LTAG_SPECIAL);
}

