/*
 * tagsystem.h
 */

/*
 * $Id: tagsystem.h,v 1.5 2004/10/22 04:52:48 komiya Exp $
 *
 *  File Name : tagsystem.h 
 *    designed for SUN by M.Yamamoto    Jun.'90
 *    applied for ATT3B2 by M.Yamamoto. Oct.'90
 *
 *  Update    : Yass.  Jul. 18 '90
 *              Yass.  Jul. 17 '90
 *              Yass.  Jul.  2 '90
 *
 *
 */

/****************/
/*              */
/*  Tag values  */
/*              */
/****************/


#define     TAG_CONS            000

#define     TAG_BLOCK2          001
#define     TAG_BLOCK1          002

#define     TAG_GCFORWARD       004

#define     TAG_NIL             010
#define     TAG_LOSTOBJ0        014
#define     TAG_LOSTOBJ1        016
#define     TAG_LOSTOBJ2        017

#define     TAG_FIXNUM          020  /* positive or zero */
#define     TAG_FIXNUM1         021  /* positive */
#define     TAG_FIXNUM2         022  /* negative */
#define     TAG_FIXNUM3         023  /* negative */
#define     TAG_SFLOAT          024  /* positive or zero */
#define     TAG_SFLOAT1         025  /* positive */
#define     TAG_SFLOAT2         026  /* negative */
#define     TAG_SFLOAT3         027  /* negative */

#define     TAG_ACHAR           030
#define     TAG_KCHAR           031
#define     TAG_T               032

#ifdef USE_FALSE
#define     TAG_FALSE           033
#else
#define     TAG_FALSE           010
#endif

#define         TAG_NILVECTOR           034

#define     TAG_BCLOSURE        040
#define     TAG_NCLOSURE        041
#define     TAG_SFUNCTION       042
#define     TAG_CONTINUATION    043
#define     TAG_MBCLOSURE       044
#define     TAG_MNCLOSURE       045 /* not used */
#define     TAG_MSFUNCTION      046 /* not used */
#define     TAG_IOC             047

#define     TAG_ORDINARY        050
#define     TAG_SPECIAL         051
#define     TAG_VECTOR          052
#define     TAG_WEAKPAIR        053
#define     TAG_PROMISE         054
#define     TAG_PORT            055
#define     TAG_STRUCTURE       056
#define     TAG_FUTURE          057

#define     TAG_BIGNUM          060
#define     TAG_FRACTION        061
#define     TAG_COMPLEX         062
#define     TAG_LOCK            063

#define     TAG_STRING          070
#define     TAG_SSTRING         071
#define     TAG_FLOAT           072


/***********************/
/*                     */
/*  Tag (long) values  */
/*                     */
/***********************/

#define     LTAG_CONS       0x00000000

#define     LTAG_BLOCK2         0x04000000
#define     LTAG_BLOCK1         0x08000000

#define     LTAG_GCFORWARD      0x10000000

#define     LTAG_ARG_MARK       0x14000000

#define     LTAG_NIL            0x20000000
#define     LTAG_EOF            0x24000000
#define     LTAG_LOSTOBJ0       0x30000000
#define     LTAG_LOSTOBJ1       0x38000000
#define     LTAG_LOSTOBJ2       0x3c000000

#define     LTAG_FIXNUM         0x40000000  /* positive or zero */
#define     LTAG_FIXNUM1        0x44000000  /* positive */
#define     LTAG_FIXNUM2        0x48000000  /* negative */
#define     LTAG_FIXNUM3        0x4c000000  /* negative */
#define     LTAG_SFLOAT         0x50000000  /* positive or zero */
#define     LTAG_SFLOAT1        0x54000000  /* positive */
#define     LTAG_SFLOAT2        0x58000000  /* negative */
#define     LTAG_SFLOAT3        0x5c000000  /* negative */

#define     LTAG_ACHAR          0x60000000
#define     LTAG_KCHAR          0x64000000
#define     LTAG_T              0x68000000

#ifdef USE_FALSE
#define     LTAG_FALSE          0x6c000000
#else
#define     LTAG_FALSE          0x20000000
#endif

#define         LTAG_NILVECTOR          0x70000000

#define     LTAG_STEALABLE      0x7c000000  /* add for she */

#define     LTAG_BCLOSURE       0x80000000
#define     LTAG_NCLOSURE       0x84000000
#define     LTAG_SFUNCTION      0x88000000
#define     LTAG_CONTINUATION   0x8c000000
#define     LTAG_MBCLOSURE      0x90000000
#define     LTAG_MNCLOSURE      0x94000000 /* not used */
#define     LTAG_MSFUNCTION     0x98000000 /* not used */
#define     LTAG_IOC            0x9c000000

#define     LTAG_ORDINARY       0xa0000000
#define     LTAG_SPECIAL        0xa4000000
#define     LTAG_VECTOR         0xa8000000
#define     LTAG_WEAKPAIR       0xac000000
#define     LTAG_PROMISE        0xb0000000
#define     LTAG_PORT           0xb4000000
#define     LTAG_STRUCTURE      0xb8000000
#define     LTAG_FUTURE         0xbc000000

#define     LTAG_BIGNUM         0xc0000000
#define     LTAG_FRACTION       0xc4000000
#define     LTAG_COMPLEX        0xc8000000
#define     LTAG_LOCK           0xcc000000

#define     LTAG_STRING         0xe0000000
#define     LTAG_SSTRING        0xe4000000
#define     LTAG_FLOAT          0xe8000000
#define     PORT_HEAD           0x08000018


/***************************/
/*                         */
/*  General tags or masks  */
/*                         */
/***************************/

#define     GETtag(obj)     (0xfc000000 & (unsigned)(obj))

#define     LTAG_SYMBOL     0xa0000000
#define     GETsym_tag(obj)     (0xf8000000 & (unsigned)(obj))

/* function? */
#define     LTAG_FUN        0x80000000

#define     FUNp(obj)       ((0xe0000000 & (unsigned)(obj)) == LTAG_FUN)

/* function? end */

#define     LTAG_MACRO      0x90000000
#define     LTAG_NFUN       0x80000000
/* #define     GETmacro_tag(obj)   (0xf0000000 & (unsigned)(obj)) */
#define     GETmacro_tag(obj)   (0xfc000000 & (unsigned)(obj)) /* for IOC */

#define     LTAG_STRING     0xe0000000
#define     GETstr_tag(obj)     (0xf8000000 & (unsigned)(obj))

#define     LTAG_NUMBER     0x40000000
#define     LTAG_NUMBER1        0x40000000 /* fixnum */
#define     LTAG_NUMBER2        0x50000000 /* s-float */
#define     LTAG_NUMBER3        0xc0000000 /* big,frac,cplx */
#define     GETnum_tag(obj)     (0xf0000000 & (unsigned)(obj))
#define     GETfix_tag(obj)     (0xf0000000 & (unsigned)(obj))

#define     LTAG_CHAR       0x60000000
#define     GETchar_tag(obj)    (0xf8000000 & (unsigned)(obj))

#define     LTAG_LOSTOBJ        0x30000000
#define     GETlo_tag(obj)      (0xf0000000 & (unsigned)(obj))

#define     CH(obj)		((0x00ff0000 & (unsigned)(obj)) >> 16)
#define     KCH(obj)		((0x0003fffc & (unsigned)(obj)) >> 2)

/**********************/
/*                    */
/*  Special purposes  */
/*                    */
/**********************/

#define     KANJI_BIT       0x04000000
#define     KANJI_BIT6      0x1
#define     SS_BIT          0x04000000
#define     SIGN_BIT        0x08000000


/**********************/
/*                    */
/*  Scheme constants  */
/*                    */
/**********************/

#define     SCOBJ_0         0x40000000
#define     SCOBJ_1         0x40000004
#define     SCOBJ_2         0x40000008
#define     SCOBJ_3         0x4000000c
#define     SCOBJ_8         0x40000020
#define     SCOBJ_10        0x40000028
#define     SCOBJ_16        0x40000040
#define     SCOBJ_M1        0x4ffffffc

/*  Yass. Sep. 10 '90  */

#define         SCOBJ_SF0               0x50000000
#define         SCOBJ_SF1               0x53fc0000
#define         SCOBJ_SFM1              0x5bfc0000

/*  END  */
