/*
 * unixsave.c - 
 */

/*
 * $Id: unixsave.c,v 1.2 1998/10/29 05:12:05 shige Exp $
 */

static char *RCSid="$Id: unixsave.c,v 1.2 1998/10/29 05:12:05 shige Exp $";

#include "scheme.h"

#ifdef SAVE_MEM
/*
(c) Copyright Taiichi Yuasa and Masami Hagiya, 1984.  All rights reserved.
Copying of this file is authorized to users who have executed the true and
proper "License Agreement for Kyoto Common LISP" with SIGLISP.
*/

/*
    unixsave.c
*/

#include <sys/file.h>

#ifdef LUNA
#define	PAGSIZ		(8 * 1024)
#define	SEGSIZ		(128 * 1024)
#define	TXTRELOC	0
#endif

#ifndef THINK_C
#include <a.out.h>
#endif

#ifdef TCPIP
#include "inet.h"
#endif

extern char tus_self[];

filecpy(to, from, n)
FILE *to, *from;
register int    n;
{
    char    buffer[BUFSIZ];

    for (; ; )
        if (n > BUFSIZ) {
            fread(buffer, BUFSIZ, 1, from);
            fwrite(buffer, BUFSIZ, 1, to);
            n -= BUFSIZ;
        } 
        else if (n > 0) {
            fread(buffer, 1, n, from);
            fwrite(buffer, 1, n, to);
            break;
        } 
        else
            break;
}


memory_save(original_file, save_file)
char    *original_file, *save_file;
{

#ifndef THINK_C
    struct exec header;
    int stsize;
#endif
    char    *data_begin, *data_end;
    int original_data;
    FILE * original, *save, *standard_error;
    register int    n;
    register char   *p;
    extern char *sbrk();
    extern char stdin_buf[BUFSIZ], stdout_buf[BUFSIZ];

    original = fopen(original_file, "r");
    if (stdin != original || original->_file != 0) {
        fprintf(stderr, "Can't open the original file.\n");
        exit(1);
    }
    setbuf(original, stdin_buf);
    unlink(save_file);
    n = open(save_file, O_CREAT | O_WRONLY, 0777);
    if (n != 1 || (save = fdopen(n, "w")) != stdout) {
        fprintf(stderr, "Can't open the save file.\n");
        exit(1);
    }
    setbuf(save, stdout_buf);
    n = dup(n);
    if (n != 2 || (standard_error = fdopen(n, "w")) != stderr) {
        fprintf(stderr, "Can't open stderr.\n");
        exit(1);
    }
    setbuf(standard_error, NULL);

    /*  alternative  by M.Yamamoto  */
    /*
    original = fopen(original_file, "r");
    unlink(save_file);
    n = open(save_file, O_CREAT|O_WRONLY, 0777);
    save = fdopen(n, "w");
    standard_error = fdopen(dup(n), "w");
*/
    /* alternative end  */

#ifndef THINK_C
    fread(&header, sizeof(header), 1, original);
#endif
#ifdef SUNOS4
    data_begin = (char *)N_DATADDR(header);
#endif
#ifdef LUNA
    data_begin
	= (char *)((TXTRELOC+header.a_text+(SEGSIZ-1)) & ~(SEGSIZ-1));
#endif


    /*
    data_end = core_end;
*/
    data_end = (char * )entity_fin;

    original_data = header.a_data;
    header.a_data = data_end - data_begin;
    /*
#ifdef ALLOCATE_INCREMENTALLY
    header.a_bss = 0;
#else
    header.a_bss = sbrk(0) - core_end;
#endif
*/
    header.a_bss = sbrk(0) - data_end;


    fwrite(&header, sizeof(header), 1, save);

#ifdef SUNOS4
    filecpy(save, original, header.a_text - sizeof(header));
#endif
#ifdef LUNA
	if (header.a_magic == ZMAGIC)
		filecpy(save, original, header.a_text - sizeof(header));
	else
		filecpy(save, original, header.a_text);
#endif

    for (n = header.a_data, p = data_begin; ; n -= BUFSIZ, p += BUFSIZ)
        if (n > BUFSIZ)
            fwrite(p, BUFSIZ, 1, save);
        else if (n > 0) {
            fwrite(p, 1, n, save);
            break;
        } 
        else
            break;

    fseek(original, original_data, 1);

#ifndef THINK_C
    filecpy(save, original, header.a_syms + header.a_trsize + header.a_drsize);
    fread(&stsize, sizeof(stsize), 1, original);
    fwrite(&stsize, sizeof(stsize), 1, save);
    filecpy(save, original, stsize - sizeof(stsize));
#endif

    fclose(original);
    fclose(save);
}


Sfreeze ()
{
  SOBJ obj;
  char *fnam;
  extern char *strobj_to_str ();

  switch (getargnum ())
    {
    case 0:
/*      fnam = FREEZE_FILE_NAME; */
#ifdef CTHREAD
      fnam = "saved_mtus";
#elif defined(LUNA)
      fnam = "saved_tus";
#else
      fnam = "saved_dtus";
#endif
      break;
    case 1:
      obj.obj = getarg (1);
      if (GETstr_tag (obj.obj) != LTAG_STRING)
	bokkan ("1st argument must be a string naming frozen file.");
      fnam = strobj_to_str (obj.obj);
      break;
    default:
      bokkan ("Too many arguments.");
      break;
    }

  _cleanup ();
  memory_save(tus_self, fnam);
  _exit (0);
  /* no return */
}

#endif
