(define aaa (protect-symbol ':host))
(define aaa (protect-symbol ':input))
(define aaa (protect-symbol ':output))
(define aaa (protect-symbol ':error))
(define aaa (protect-symbol ':pipe))
(define aaa (protect-symbol 'run-process))
(define aaa (protect-symbol 'process-pid))
(define aaa (protect-symbol 'process-input))
(define aaa (protect-symbol 'process-output))
(define aaa (protect-symbol 'process-error))
(define aaa (protect-symbol 'process-alive?))

(define :host ':host)
(define :input ':input)
(define :output ':output)
(define :error ':error)
(define :pipe ':pipe)

(defstruct process pid input output error)

(define (run-process com . rest)
  (let ((host #f) (ipipe? #f) (opipe? #f) (epipe? #f))
    (let loop ((r rest) (rargs '()))
      (if (null? r)
          (let ((v (_run-process host com
                                 (apply string-append (nreverse rargs))
                                 ipipe? opipe? epipe?)))
            (make-process :pid (vector-ref v 0)
                          :input (vector-ref v 1)
                          :output (vector-ref v 2)
                          :error (vector-ref v 3)))
          (case (car r)
            ((:host)
             (let ((h (cadr r)))
               (cond ((string? h) (set! host h))
                     ((symbol? h)
                      (let ((x (symbol->string h)))
                        (if (char=? (string-ref x 0) #\:)
                            (error "No argument after keyword :host.")
                            (set! host x))))
                     (else (error "Host name must be a string or symbol."))))
             (loop (cddr r) rargs))
            ((:input)
             (if (eq? (cadr r) :pipe)
                 (begin
                   (set! ipipe? #t)
                   (loop (cddr r) rargs))
                 (error "Argument of :input must be keyword :pipe.")))
            ((:output)
             (if (eq? (cadr r) :pipe)
                 (begin
                   (set! opipe? #t)
                   (loop (cddr r) rargs))
                 (error "Argument of :output must be keyword :pipe.")))
            ((:error)
             (if (eq? (cadr r) :pipe)
                 (begin
                   (set! epipe? #t)
                   (loop (cddr r) rargs))
                 (error "Argument of :error must be keyword :pipe.")))
            (else
              (loop (cdr r) (cons " " (cons (car r) rargs)))))))))

(define (exec cl)
  (define (aux)
    (let ((n (string-length cl)))
      (let loop ((s 0) (t 0) (x '()))
        (if (>= t n)
            (nreverse
              (list* :pipe :output
                     (if (= s t)
                         (if (null? x) '("") x)
                         (cons (substring cl s t) x))))
            (if (= s t)
                (if (char-whitespace? (string-ref cl t))
                    (loop (1+ s) (1+ t) x)
                    (loop s (1+ t) x))
                (if (char-whitespace? (string-ref cl t))
                    (loop (1+ t) (1+ t) (cons (substring cl s t) x))
                    (loop s (1+ t) x)))))))
  (let ((in (process-output
              (apply run-process (aux))))
        (out (open-output-string)))
    (if (not in)
        #f
        (let loop ((x (read-char in)))
          (if (eof-object? x)
              (get-output-string out)
              (begin
                (write-char x out)
                (loop (read-char in))))))))

(define (process-alive? p)
  (let ((p (open-input-string
             (exec (format #f "/bin/sh -c 'ps ~a | wc -l'" (process-pid p))))))
    (if (= (read p) 2) #t #f)))
