;; by T.Komiya

(define *frame-scale* 512)      ; ե졼μ¥(dots)  [桼]
(define *canvas-w* 512)         ; ޷Х(dots)
(define *canvas-h* 512)         ; ޷Хι⤵(dots)
(define *canvas* #f)            ; 褹륭Х̾
(define *line-color* 'black)    ; ο                    [桼]
(define *bg-color* 'white)      ; طʤο                  [桼]

;; segments->painter ƤӽФ draw-line  Tk
(define (draw-line from to)
  ((get-symbol-value *canvas*)
   'create 'line (* *frame-scale* (xcor-vect from))
                 (- *canvas-h* (* *frame-scale* (ycor-vect from)))
                 (* *frame-scale* (xcor-vect to))
                 (- *canvas-h* (* *frame-scale* (ycor-vect to)))
                 :fill *line-color*))

;; Ϳե졼˹äХκ
;; ǤդΥե졼ˤбԲĤʼȴǡ
(define make-canvas
  (let ((n 0))
    (lambda (frame)
      (define (gen-canvas-name)
        (set! n (+ n 1))
        (string->symbol (string-append ".c" (number->string n))))
      (set! *canvas-w* (* *frame-scale*
                          (+ (xcor-vect (edge1-frame frame))
                             (xcor-vect (edge2-frame frame)))))
      (set! *canvas-h* (* *frame-scale* (ycor-vect (edge2-frame frame))))
      (let ((canvas-name (gen-canvas-name)))
        (canvas canvas-name :height *canvas-h* :width *canvas-w*)
        (pack canvas-name)
        (set! *canvas* canvas-name)
        (clear)))))

;; ߤΥХ
(define (forget-canvas) (pack 'forget *canvas*))

;; Х򥯥ꥢ
(define (clear)
  ((get-symbol-value *canvas*) 'create 'rectangle 0 0 *canvas-w* *canvas-h*
                               :fill *bg-color*)
  (tk:update))

;; Хγ PostScript եؽ
(define (output-canvas filename)
  ((get-symbol-value *canvas*) 'postscript :file filename))

;;
;; GIF/PPM/PGM to painter
;;
;; ¡
;; ե졼ˤб
;; ǤդνĲΥե졼бǤʤ
;;   - ܤγ礫1/ ܤν̾Τ߲ǽĲΰ
;;     礷Ʊ¾̾뤳ȤϤǤʤ
;;   - ȿžϡܤ̾Τ߲ǽ
;; ­
;;   ե졼μ¥ʥǥեȤǤ512x512ɥåȡˤѹǽǤ롥
;;   make-canvas Ѥˡѿ *frame-scale* ͡ʽͤ512ˤ
;;   ѤФ褤

(define (pgm-file->painter file)
  (define genname
    (let ((n 0))
      (lambda ()
        (set! n (+ n 1))
        (string->symbol (string-append "img" (number->string n))))))
  (let ((oimg (genname)))
    (image 'create 'photo oimg :file file)
    (lambda (frame)
      (let* ((p ((frame-coord-map frame) (make-vect 0 0)))
             (q ((frame-coord-map frame) (make-vect 1 1)))
             (fw (- (xcor-vect q) (xcor-vect p)))
             (fh (- (ycor-vect q) (ycor-vect p)))
             (xscale (* fw (/ *frame-scale*
                              (string->number (image 'width oimg)))))
             (yscale (* fh (/ *frame-scale*
                              (string->number (image 'height oimg)))))
             (display-x (min (* *frame-scale* (xcor-vect p))
                             (* *frame-scale* (xcor-vect q))))
             (display-y (min (- *canvas-h* (* *frame-scale* (ycor-vect p)))
                             (- *canvas-h* (* *frame-scale* (ycor-vect q)))))
             (img (genname)))
        (image 'create 'photo img)
        ;; ȴ "image" μʤΤ exetcl Ȥ
        (exectcl (apply format #f "~a copy ~a ~a ~a ~a" img oimg
                         (if (and (>= xscale 1) (>= yscale 1))
                             ;; Tk λ;塤硤¾̾ϤǤʤ
                             ;; ޤx/yɸȿžϽ̾Τ߲ǽ
                             (list "-zoom" (ceiling xscale) (ceiling yscale))
                             (list "-subsample" (ceiling (/ 1 xscale))
                                                (ceiling (/ 1 yscale))))))
        ((get-symbol-value *canvas*) 'create 'image display-x display-y
                                     :image img :anchor 'nw)))))

;; ݥꥴ
(define (draw-polygon vects smooth step color)
  (apply (get-symbol-value *canvas*) 'create 'polygon
         (append (mapcan (lambda (v)
                           (list
                            (* *frame-scale* (xcor-vect v))
                            (- *canvas-h* (* *frame-scale* (ycor-vect v)))))
                         vects)
                 (list :fill color
                       :smooth (if smooth 'true 'false)
                       :splinesteps step))))

;; ݥꥴڥ󥿤
(define (vects->painter vect-list smooth step color)
  (lambda (frame)
    (draw-polygon
     (map (lambda (v) ((frame-coord-map frame) v)) vect-list)
     smooth step color)))
